<?php
require_once('conf/conf.inc.php');
if(version_compare(PHP_VERSION, '5.1.0', '>=')){
	date_default_timezone_set('Europe/Berlin');
}
if(TKSWIM_DEBUG){
    function microtime_float(){
        if(version_compare(PHP_VERSION, '5.0.0', '>=')){
            return microtime(true);
        }
        list($usec, $sec) = explode(' ', microtime());
        return ((float)$usec + (float)$sec);exit;
    }
	$startzeit = microtime_float();
	error_reporting(E_ALL);
    require_once('func/printr.inc.php');
}
else{
	error_reporting(E_ALL ^ E_NOTICE);
}

# Einstellungen, Klassen und Funktionen laden
require_once('conf/select.inc.php');
require_once('class/db.inc.php');
require_once('class/tktemplate.inc.php');
require_once('func/weiterleiten.inc.php');
require_once('func/text_format.inc.php');
require_once('func/prueferechte.inc.php');
require_once('func/tkswim_fehlerbehandlung.inc.php');

# Konstante ROOT setzen
if((strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST']) and isset($_SERVER['HTTPS'])) or isset($_SERVER['HTTP_X_FORWARDED_HOST'])){
    define('ROOT', ROOT_HTTPS);
    if(strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST'])){
        #$_SERVER['PHP_SELF'] = '/'.substr(ROOT_HTTP,7).$_SERVER['PHP_SELF'];
        ini_set('session.cookie_path', '/'.substr(ROOT_HTTP,7).'/');
    }
}
else{
    define('ROOT',ROOT_HTTP);
    if(ROOT != 'http://'.$_SERVER['HTTP_HOST']){
        ini_set('session.cookie_path', substr(ROOT_HTTP,strlen('http://'.$_SERVER['HTTP_HOST'])).'/');
    }
}

# Smarty starten und Variablen zuweisen
$_tmpl = new tktemplate;
$_tmpl->register_function('pruefeRechte','pruefeRechte');
$_tmpl->compile_check = TKSWIM_DEBUG;
$_tmpl->assign('jsdateien','');

# Fehlerbehandlung starten, Session starten
set_error_handler('tkswim_fehlerbehandlung');
session_start();

# Datenbankklasse starten und Verbindung oeffnen
$_inh = '';
$_db = new db;
$_db->tmpl = &$_tmpl;
$_db->schreibschutz = TKSWIM_SCHREIBSCHUTZ;
if(TKSWIM_SCHREIBSCHUTZ){
	$_tmpl->assign('dauerhinweis','Achtung! tkswim ist gegen Schreibzugriffen geschtzt, es knnen momentan keine Daten verndert werden!');
}
$_db->setzeDbParameter();
$_db->verbindeMitDb();

# globale Einstellungen laden
$_gleinst = parse_ini_file(PFAD_INCLUDE.'conf/einstellungen.ini', true);

if(isset($_SESSION['eingelogt'])){
	# Einstellungen laden
	if(file_exists(PFAD_INIDATEIEN.'userconf_'.$_SESSION['user']['id'].'.ini')){
	    $_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_'.$_SESSION['user']['id'].'.ini',true);
	}
	else{
	    $_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_default.ini',true);
	}

    $_rauswerfen = array(
    	'aktion' => false,
        'ausnahmen' => array(148)
    );

    # Zeitpunkt der letzten Aktivitaet speichern
	$timeout = TKSWIM_DEBUG?TKSWIM_TIMEOUT*300:TKSWIM_TIMEOUT;
    if((time() - $_SESSION['user']['letzterzugriff']) > $timeout){
    	$vergangen = time() - $_SESSION['user']['letzterzugriff'];
        $_SESSION = array();
        if($vergangen <= ($timeout+21600)){
        	# Meldung nur anzeigen wenn die letzte Aktion ber 6 Stunden+$timeout her ist
        	$_SESSION['fehler'] = 'Die Sitzung ist abgelaufen, bitte neu anmelden.';
        }
	    $_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_default.ini',true);
    }
    elseif($_rauswerfen['aktion'] and !in_array($_SESSION['user']['id'],$_rauswerfen['ausnahmen'])){
        $_SESSION = array();
        $_SESSION['fehler'] = 'Wegen Wartungsarbeiten wurden alle Mitglieder abgemeldet.';
    }
    else{
    	$_SESSION['user']['letzterzugriff'] = time();
    }
	if($_einst['globaleeinstellungen']['sicherheitsabfragenabschalten']){
	    $_GET['sicher'] = 1;
	}
}
else{
	#$_tmpl->tk_append_string('onload',"document.forms[0].elements['loginanmeldename'].focus();");
}
$_tmpl->assign('cssstyle',isset($_einst)?$_einst['globaleeinstellungen']['style']:'screen_original.css');
# EOF
?>