<?php
class einstellungen{

var $einstdatei;   # Name (mit Pfad) der xml/php-Datei mit den Einstellungen
var $userconfpfad; # Pfad in dem die Dateien mit den Usereinstellungen liegen
var $userdatei;    # Dateiname des aktuellen Users
var $globaldatei;  # Dateiname (mit Pfad) der Datei mit den globalen Einstellungen
var $daten;        # die ausgelesenen Daten aus der xml-Datei
var $_speicher;    # Zwischenspeicher
var $_db;           # Datenbankklasse

function einstellungen($einstdat, $userconfpfad, $userdatei=NULL){
    $this->einstdatei = $einstdat;
    if(is_null($userdatei)){ # globale Einstellungen
    	$this->globaldatei = $userconfpfad;
    }
    else{ # Usereinstellungen
    	$this->userconfpfad = $userconfpfad;
    	$this->userdatei = $userdatei;
    }
}

function benachrichtigungLoeschen($id, $art){
/*
Parameter:
 $id:  die ID der zu entfernenden Benachrichtigungen
 $art: die Art der zu entfernenden Benachrichtigung
Rueckgabewerte:
 true: Wert geloescht
 -1:   ungueltige ID angegeben
 -2:   ungueltige Art angegeben
 -3:   Benachrichtigung war nicht vorhanden
*/
	if(is_array($id) and count($id) > 0){
    	foreach($id as $i){
        	if(empty($i) or !ctype_digit($i)){
            	continue;
            }
            $this->benachrichtigungLoeschen($i,$art);
        }
    }
	switch($art){
	case 'person':
    	if(empty($id) or !ctype_digit($id)){
        	return -1;
        }
        $query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($id,'db')."'";
        $this->db->holeDaten($query);
        if($this->db->ergebnis['anzahl'] != 1){
        	return -1;
        }
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
    	list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
        list(,$pids) = explode(':',$personen);
        if(empty($pids)){
        	return -3;
        }
        else{
        	$ids = explode(',',$pids);
            if(!in_array($id,$ids)){
            	return -3;
            }
            $tmp = $ids;
            $ids = array();
            foreach($tmp as $i){
            	if($i == $id){
                	continue;
                }
                $ids[] = $i;
            }
			$pids = implode(',',$ids);
        }
        $datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = $termine.'|'.$gruppen.'|personen:'.$pids;
		require_once('func/schreibe_ini_datei.inc.php');
    	schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
        $this->cronjobEinstellungenEinlesen();
        return true;
    case 'gruppe':
        require_once('func/holeTrainingsgruppen.inc.php');
        $erlaubte = array_keys(holeTrainingsgruppen(false));
        $erlaubte[] = 'uebungsleiter';
        $erlaubte[] = 'kampfrichter';
        $erlaubte[] = 'vorstand';
    	if(empty($id) or !in_array($id, $erlaubte)){
        	return -1;
        }
        if(!in_array($id,$erlaubte)){
        	return -1;
        }
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
    	list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
        list(,$gids) = explode(':',$gruppen);
        if(empty($gids)){
        	return -3;
        }
        else{
        	$ids = explode(',',$gids);
            if(!in_array($id,$ids)){
            	return -3;
            }
            $tmp = $ids;
            $ids = array();
            foreach($tmp as $i){
            	if($i == $id){
                	continue;
                }
                $ids[] = $i;
            }
			$gids = implode(',',$ids);
        }
        $datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = $termine.'|gruppen:'.$gids.'|'.$personen;
		require_once('func/schreibe_ini_datei.inc.php');
    	schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
        $this->cronjobEinstellungenEinlesen();
        return true;
    	break;
    case 'termin':
    	if(empty($id) or !ctype_digit($id)){
        	return -1;
        }
        $query = "SELECT id FROM ".DB_PREFIX."termine WHERE id = '".text_format($id,'db')."'";
        $this->db->holeDaten($query);
        if($this->db->ergebnis['anzahl'] != 1){
        	return -1;
        }
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
    	list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
        list(,$tids) = explode(':',$termine);
        if(empty($tids)){
        	return -3;
        }
        else{
        	$ids = explode(',',$tids);
            if(!in_array($id,$ids)){
            	return -3;
            }
            $tmp = $ids;
            $ids = array();
            foreach($tmp as $i){
            	if($i == $id){
                	continue;
                }
                $ids[] = $i;
            }
			$tids = implode(',',$ids);
        }
        $datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = 'termine:'.$tids.'|'.$gruppen.'|'.$personen;
		require_once('func/schreibe_ini_datei.inc.php');
    	schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
        $this->cronjobEinstellungenEinlesen();
        return true;
	default:
    	return -2;
    }
}


function benachrichtigungHinzufuegen($id, $art){
/*
Parameter:
 $id:  die ID der hinzuzufuegenden Benachrichtigungen
 $art: die Art der hinzuzufuegenden Benachrichtigung
Rueckgabewerte:
 true: Wert gespeichert
 -1:   ungueltige ID angegeben
 -2:   ungueltige Art angegeben
 -3:   Benachrichtigung war bereits vorhanden
*/
	switch($art){
	case 'person':
    	if(empty($id) or !ctype_digit($id)){
        	return -1;
        }
        $query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($id,'db')."'";
        $this->db->holeDaten($query);
        if($this->db->ergebnis['anzahl'] != 1){
        	return -1;
        }
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
    	list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
        list(,$pids) = explode(':',$personen);
        if(empty($pids)){
			$pids = $id;
        }
        else{
        	$ids = explode(',',$pids);
            if(in_array($id,$ids)){
            	return -3;
            }
			$pids .= ','.$id;
        }
        $datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = $termine.'|'.$gruppen.'|personen:'.$pids;
		require_once('func/schreibe_ini_datei.inc.php');
    	schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
        $this->cronjobEinstellungenEinlesen();
        return true;
    case 'gruppe':
    	if(!is_array($id)){
        	return -1;
        }
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
    	list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
        $datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = $termine.'|gruppen:'.implode(',',$id).'|'.$personen;
		require_once('func/schreibe_ini_datei.inc.php');
    	schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
        $this->cronjobEinstellungenEinlesen();
        return true;
    	break;
    case 'termin':
    	if(empty($id) or !ctype_digit($id)){
        	return -1;
        }
        $query = "SELECT id FROM ".DB_PREFIX."termine WHERE id = '".text_format($id,'db')."'";
        $this->db->holeDaten($query);
        if($this->db->ergebnis['anzahl'] != 1){
        	return -1;
        }
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
    	list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
        list(,$tids) = explode(':',$termine);
        if(empty($tids)){
			$tids = $id;
        }
        else{
        	$ids = explode(',',$tids);
            if(in_array($id,$ids)){
            	return -3;
            }
			$tids .= ','.$id;
        }
        $datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = 'termine:'.$tids.'|'.$gruppen.'|'.$personen;
		require_once('func/schreibe_ini_datei.inc.php');
    	schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
        $this->cronjobEinstellungenEinlesen();
        return true;
	default:
    	return -2;
    }
}


function holeBenachrichtigungen(){
	$einst = parse_ini_file($this->userconfpfad.$this->userdatei,true);
    list($termine, $gruppen, $personen) = explode('|',$einst['emailbenachrichtigung']['terminbenachrichtigungen'],3);
    $rueckgabe = array('termine'=>array(),'gruppen'=>array(),'personen'=>array());
    # Termine holen
    list(,$ids) = explode(':',$termine);
    if(!empty($ids)){
    	$query = "SELECT id, CONCAT(DATE_FORMAT(datum,'%d.%m.%Y'),': ',titel) as titel FROM ".DB_PREFIX."termine WHERE id IN (".$ids.") ORDER BY datum";
        $this->db->holeDaten($query);
        $rueckgabe['termine'] = $this->db->baueArray('titel','id');
    }
    # Gruppen holen
    list(,$ids) = explode(':',$gruppen);
    if(!empty($ids)){
        $teile = explode(',',$ids);
        $ids = array();
        $uebungsleiter = $kampfrichter = $vorstand = false;
        foreach($teile as $teil){
        	if($teil == 'uebungsleiter'){
            	$uebungsleiter = true;
            }
        	elseif($teil == 'kampfrichter'){
            	$kampfrichter = true;
            }
        	elseif($teil == 'vorstand'){
            	$vorstand = true;
            }
            else{
            	$ids[] = $teil;
            }
        }
        if(count($ids)>0){
    		$query = "SELECT id, TIME_FORMAT(anfangszeit,'%H:%i') as zeit, wochentag FROM ".DB_PREFIX."trainingsgruppen
                        WHERE id IN (".implode(',',$ids).") ORDER BY wochentag, anfangszeit";
        	$this->db->holeDaten($query);
            $daten = $this->db->ergebnis['daten'];
            global $_wochentage;
            foreach($daten as $key => $row){
            	$rueckgabe['gruppen'][$row['id']] = $_wochentage[$row['wochentag']].' '.$row['zeit'];
            }
        }
        if($vorstand){
            $rueckgabe['gruppen']['vorstand'] = 'Vorstand';
        }
        if($uebungsleiter){
        	$rueckgabe['gruppen']['uebungsleiter'] = 'bungsleiter';
        }
        if($kampfrichter){
        	$rueckgabe['gruppen']['kampfrichter'] = 'Kampfrichter';
        }
    }
    # Personen holen
    list(,$ids) = explode(':',$personen);
    if(!empty($ids)){
    	$query = "SELECT id, CONCAT(nachname,', ',vorname,' (',DATE_FORMAT(gebdatum,'%d.%m.%Y'),')') as name
                    FROM ".DB_PREFIX."mitglieder WHERE id IN (".$ids.") ORDER BY nachname, vorname";
        $this->db->holeDaten($query);
        $rueckgabe['personen'] = $this->db->baueArray('name','id');
    }
    return $rueckgabe;
}



function cronjobEinstellungenEinlesen(){
	$datinh = parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true);
    if($datinh['flags']['userconfeinlesen'] == 1){
    	return true;
    }
    $datinh['flags']['userconfeinlesen'] = 1;
    require_once('func/schreibe_ini_datei.inc.php');
    schreibe_ini_datei(PFAD_INCLUDE.'conf/cronjob.ini',$datinh,true);
    return true;
}

function erzeugeIniBaum(){
	$eingelesen = $this->daten;
    $ausgabe = array();
    foreach($eingelesen as $mid => $modul){
    	$ausgabe[$mid] = array();
        foreach($modul['optionen'] as $oid => $option){
        	$ausgabe[$mid][$oid] = $option['standard'];
        }
    }
    return $ausgabe;
}

function aktualisiereGlobalIniDatei(){
	# Einstellungen laden
    require($this->einstdatei);

    # vorhandene ini-Datei einlesen
    $vorhandene = parse_ini_file($this->globaldatei, true);

    $geaendert = false;
    # prfen ob neue Einstellungen vorhanden sind
    foreach($_einstellungen as $modul => $tmp){
    	if(!isset($vorhandene[$modul])){
        	$vorhandene[$modul] = array();
            $geaendert = true;
        }
    	foreach($tmp as $einst => $werte){
        	if(!isset($vorhandene[$modul][$einst])){
            	$vorhandene[$modul][$einst] = $werte['standard'];
                $geaendert = true;
            }
        }
    }

    # prfen ob Einstellungen gelscht wurden
    foreach($vorhandene as $modul => $tmp){
    	if(!isset($_einstellungen[$modul])){
        	unset($vorhandene[$modul]);
            $geaendert = true;
        }
    	foreach($tmp as $einst => $werte){
        	if(!isset($_einstellungen[$modul][$einst])){
            	unset($vorhandene[$modul][$einst]);
                $geaendert = true;
            }
        }
    }

    # ggf. genderte ini-Datei schreiben
	if($geaendert){
    	require_once('func/schreibe_ini_datei.inc.php');
    	schreibe_ini_datei($this->globaldatei, $vorhandene, true);
    }
    return true;
}


function aktualisiereUserinidateien(){
	$neu = $this->erzeugeIniBaum();
    $dh = opendir($this->userconfpfad);
    $dateien = array();
    while(false !== ($file = readdir($dh))){
        if($file == '.' or $file == '..' or substr($file,0,9) != 'userconf_' or is_dir($file) or substr($file,-4) != '.ini'){
            continue;
        }
        $dateien[] = $file;
    }
    closedir($dh);
    require_once('func/schreibe_ini_datei.inc.php');
    foreach($dateien as $datei){
		$datinh = parse_ini_file($this->userconfpfad.$datei,true);
        $datinh_neu = $neu;
		foreach($datinh_neu as $mid => $modul){
        	if(!isset($datinh[$mid])){
				continue;
            }
        	foreach($modul as $oid => $option){
            	if(isset($datinh[$mid][$oid])){
                	$datinh_neu[$mid][$oid] = $datinh[$mid][$oid];
                }
            }
        }
        schreibe_ini_datei($this->userconfpfad.$datei,$datinh_neu,true);
    }
    # Cronjob sagen, dass Usereinstellungen neu eingelesen werden muessen
    $this->cronjobEinstellungenEinlesen();
    return true;
}

function erzeugeAnzeigenDaten($usereinst){
    $daten = array();
    foreach($this->daten as $mid => $modul){
    	$daten[$mid] = array(
        	'recht'        => $modul['recht'],
        	'ueberschrift' => $modul['ueberschrift'],
            'beschreibung' => $modul['beschreibung'],
            'optionen'     => array()
        );
        foreach($modul['optionen'] as $oid => $option){
        	if($option['art'] == 'datei'){
            	$fh = fopen($option['verzeichnis'].$usereinst[$mid][$oid],'r');
                $anfang = fread($fh,200);
                fclose($fh);
                preg_match('~\[\[sichtbar=(1|0)\|name=(.*?)\]\]~',$anfang,$match);
                $wert = $match[2];
            }
            elseif($option['art'] == 'select'){
            	global ${$option['variable']};
                $wert = ${$option['variable']}[$usereinst[$mid][$oid]];
            }
            elseif($option['art'] == 'bool'){
            	$wert = $usereinst[$mid][$oid]==1?'ja':'nein';
            }
            elseif($option['art'] == 'text'){
            	$wert = $usereinst[$mid][$oid];
            }
            else{
            	$wert = '';
            }
        	$daten[$mid]['optionen'][$oid] = array(
            	'beschreibung' => $option['beschreibung'],
            	'titel' => $option['titel'],
            	'wert' => $wert,
                'recht' => $option['recht']
            );
        }
    }
    return $daten;
}

function erzeugeBearbeitenDaten($usereinst = array()){
    $daten = array();
    $werte = $usereinst==$daten?'default':'user';
    foreach($this->daten as $mid => $modul){
    	$daten[$mid] = array(
        	'recht'        => $modul['recht'],
        	'ueberschrift' => $modul['ueberschrift'],
            'beschreibung' => $modul['beschreibung'],
            'optionen'     => array()
        );
        foreach($modul['optionen'] as $oid => $option){
        	if($option['recht'] != '*' and !prueferechte($option['recht'])){
            	continue;
            }
        	if($option['art'] == 'datei'){
                $fh = opendir($option['verzeichnis']);
                $tmp_dateien = array();
                while(false !== ($file = readdir($fh))){
                	if($file == '.' or $file == '..' or is_dir($file)){
                    	continue;
                    }
                    $tmp_dateien[] = $file;
                }
                closedir($fh);
                $dateien = array();
                foreach($tmp_dateien as $datei){
                	$fh = fopen($option['verzeichnis'].$datei,'r');
                    $anfang = fread($fh,200);
                    fclose($fh);
                    preg_match('~\[\[sichtbar=(1|0)\|name=(.*?)\]\]~',$anfang,$match);
                    if($match[1] == 1){
                    	$dateien[$datei] = $match[2];
                    }
                }
                $feld = $this->_baueSelect($dateien,$werte=='user'?$usereinst[$mid][$oid]:$option['standard'],$mid.'['.$oid.']',$mid.'_'.$oid,0);
            }
            elseif($option['art'] == 'select'){
            	global ${$option['variable']};
                $feld = $this->_baueSelect(${$option['variable']},$werte=='user'?$usereinst[$mid][$oid]:$option['standard'],$mid.'['.$oid.']',$mid.'_'.$oid,$option['multiple']);
            }
            elseif($option['art'] == 'bool'){
            	$feld = '<input type="hidden" name="'.$mid.'['.$oid.']'.'" value="0" /><input type="checkbox" name="'.$mid.'['.$oid.']'.'" id="'.$mid.'_'.$oid.'" value="1"'.(($werte=='user'?$usereinst[$mid][$oid]:$option['standard'])==1?' checked="checked"':'').' />';
            }
            elseif($option['art'] == 'text'){
            	$feld = '<input type="text" id="'.$mid.'_'.$oid.'" name="'.$mid.'['.$oid.']'.'"'.text_format($werte=='user'?$usereinst[$mid][$oid]:$option['standard'],'value').' />';
            }
            else{
            	$feld = '';
            }
        	$daten[$mid]['optionen'][$oid] = array(
            	'beschreibung' => $option['beschreibung'],
            	'titel' => $option['titel'],
            	'feld'  => $feld,
                'recht' => $option['recht']
            );
        }
    }
    return $daten;
}

function _baueSelect($optionen,$selected,$name,$id,$multiple = 0){
	if(!is_array($selected)){
    	$selected = array($selected);
    }
    $s = '<select name="'.$name.'" id="'.$id.'"'.($multiple==1?'multiple="multiple" size="5"':'size="1"').'>';
    foreach($optionen as $key => $option){
    	$s .= '<option value="'.$key.'"'.(in_array($key,$selected)?' selected="selected"':'').'>'.$option.'</option>';
    }
    $s .= '</select>';
    return $s;
}

function einlesen(){
	$xml_parser = xml_parser_create();
	xml_set_object($xml_parser,$this);
	xml_set_element_handler($xml_parser, '_startelement', '_endelement');
	xml_set_character_data_handler($xml_parser, '_elementinhalt');
    $fh = fopen($this->einstdatei, 'r');
    if($fh === false){
    	die('could not open XML input');
    }
    while($data = fread($fh, 4096)){
    	if(!xml_parse($xml_parser, $data, feof($fh))){
      		die(sprintf("XML error: %s at line %d",
              xml_error_string(xml_get_error_code($xml_parser)),
              xml_get_current_line_number($xml_parser)));
    	}
  	}
    fclose($fh);
	xml_parser_free($xml_parser);
}

function _startelement($parser, $name, $attrs){
    $name = strtolower($name);
    $this->_speicher['element'] = $name;
    switch($name){
    case 'conf':
    	$this->daten = array();
        break;
    case 'modul':
        $this->_speicher['modul'] = array();
        $this->_speicher['modul']['name'] = $attrs['NAME'];
        $this->_speicher['modul']['recht'] = $attrs['RECHT'];
        if(version_compare(PHP_VERSION,'5.0.0','>')){
            $this->_speicher['modul']['ueberschrift'] = utf8_decode($attrs['UEBERSCHRIFT']);
        }
        else{
            $this->_speicher['modul']['ueberschrift'] = $attrs['UEBERSCHRIFT'];
        }
        $this->_speicher['modul']['beschreibung'] = '';
        $this->_speicher['modul']['optionen'] = array();
        break;
    case 'option':
        $this->_speicher['option'] = array();
        $this->_speicher['option']['beschreibung'] = '';
        $this->_speicher['option']['fehler'] = '';
        $this->_speicher['option']['form'] = '';
        $this->_speicher['option']['name'] = $attrs['NAME'];
        if(version_compare(PHP_VERSION,'5.0.0','>')){
            $this->_speicher['option']['titel'] = utf8_decode($attrs['TITEL']);
        }
        else{
            $this->_speicher['option']['titel'] = $attrs['TITEL'];
        }
        $this->_speicher['option']['art'] = $attrs['ART'];
        $this->_speicher['option']['recht'] = isset($attrs['RECHT'])?$attrs['RECHT']:'*';
        if(isset($attrs['VERZEICHNIS']) and !empty($attrs['VERZEICHNIS'])){
        	$v = $attrs['VERZEICHNIS'];
        	# Konstanten ersetzen
        	$anz = preg_match('~[A-Z_]+~', $v, $match);
            if($anz > 0){
            	foreach($match as $m){
                	if(!defined($m)){
                    	continue;
                    }
                    else{
                    	$v = str_replace($m, constant($m), $v);
                    }
                }
            }
            $this->_speicher['option']['verzeichnis'] = $v;
        }
        else{
        	$this->_speicher['option']['verzeichnis'] = '';

        }
        $this->_speicher['option']['variable'] = isset($attrs['VARIABLE'])?$attrs['VARIABLE']:'';
        $this->_speicher['option']['multiple'] = (isset($attrs['MULTIPLE']) and $attrs['MULTIPLE'] == 1)?$attrs['MULTIPLE']:'0';
        $this->_speicher['option']['pfad'] = isset($attrs['PFAD'])?$attrs['PFAD']:'';
        $this->_speicher['option']['standard'] = $attrs['STANDARD'];
        break;
    case 'beschreibung':
    	break;
    default:
        break;
    }
}

function _elementinhalt($parser, $daten){
	if(version_compare(PHP_VERSION,'5.0.0','>')){
    	$daten = utf8_decode($daten);
    }
    if(trim($daten) == ''){
    	$this->_speicher['element'] = '';
    }
	switch($this->_speicher['element']){
    case 'beschreibung':
    	if(isset($this->_speicher['option'])){
        	$this->_speicher['option']['beschreibung'] .= trim($daten);
        }
        else{
        	$this->_speicher['modul']['beschreibung'] .= trim($daten);
        }
    	break;
    case 'fehler':
    	$this->_speicher['option']['fehler'] .= trim($daten);
        break;
    case 'form':
    	$this->_speicher['option']['form'] .= trim($daten);
        break;
    default:
    	break;
    }
}

function _endelement($parser,$name){
    $name = strtolower($name);
    switch($name){
    case 'modul':
    	$tmp = $this->_speicher['modul']['name'];
        unset($this->_speicher['modul']['name']);
    	$this->daten[$tmp] = $this->_speicher['modul'];
        $this->_speicher['modul'] = array();
        break;
    case 'option':
    	$tmp = $this->_speicher['option']['name'];
        unset($this->_speicher['option']['name']);
        $this->_speicher['modul']['optionen'][$tmp] = $this->_speicher['option'];
        unset($this->_speicher['option']);
    	break;
    default:
        break;
    }
}

} # Ende der Klasse, EOF
?>