<?php

class stundennachweise {

var $user;
var $datenpfad;
var $dateiname;
var $datei;
var $daten;
var $kal;
var $db;
var $datengeaendert = false;

function stundennachweise(){
	$this->user = $_SESSION['user']['id'];
    $this->datenpfad = PFAD_INIDATEIEN;
    $this->dateiname = 'stundennachweis_'.$this->user.'.ini';
    $this->datei = $this->datenpfad.$this->dateiname;
    $this->leseDaten();
}

function holeHalbjahre($art='vorhandene',$htmloptions=false){
/* Werte fuer $art:
 - vorhandene (Standard): gib die vorhandenen aus
 - fehlende: gibt die fehlenden aus*
 - alle: gibt alle Halbjahre aus* + ggf. schon vorhande

 *alle sind jeweils die beiden Halbjahre des aktuellen und des naechsten und des letzten Jahres
*/
    $daten = array();
    switch($art){
    case 'alle':
    	$halbjahre = array_keys($this->daten);
    	foreach($halbjahre as $h){
        	$tmp = array();
        	list($tmp['j'],$tmp['h']) = explode('_',$h,2);
        	$daten[$h] = $tmp;
    	}
    	$jahr = date('Y');
        $daten[($jahr-1).'_1'] = array('h'=>1, 'j'=>$jahr-1);
        $daten[($jahr-1).'_2'] = array('h'=>2, 'j'=>$jahr-1);
        $daten[$jahr.'_1']     = array('h'=>1, 'j'=>$jahr);
        $daten[$jahr.'_2']     = array('h'=>2, 'j'=>$jahr);
        $daten[($jahr+1).'_1'] = array('h'=>1, 'j'=>$jahr+1);
        $daten[($jahr+1).'_2'] = array('h'=>2, 'j'=>$jahr+1);
        ksort($daten);
        break;
    case 'fehlende':
    	$jahr = date('Y');
        $daten[($jahr-1).'_1'] = array('h'=>1, 'j'=>$jahr-1);
        $daten[($jahr-1).'_2'] = array('h'=>2, 'j'=>$jahr-1);
        $daten[$jahr.'_1']     = array('h'=>1, 'j'=>$jahr);
        $daten[$jahr.'_2']     = array('h'=>2, 'j'=>$jahr);
        $daten[($jahr+1).'_1'] = array('h'=>1, 'j'=>$jahr+1);
        $daten[($jahr+1).'_2'] = array('h'=>2, 'j'=>$jahr+1);
        $halbjahre = array_keys($this->daten);
        foreach($halbjahre as $h){
        	if(isset($daten[$h])){
        		unset($daten[$h]);
            }
        }
        ksort($daten);
        break;
    case 'vorhanden':
    default:
    	$halbjahre = array_keys($this->daten);
    	foreach($halbjahre as $h){
        	$tmp = array();
        	list($tmp['j'],$tmp['h']) = explode('_',$h,2);
        	$daten[$h] = $tmp;
    	}
        ksort($daten);
    	break;
    }
    if($htmloptions){
    	foreach($daten as $key => $halbj){
        	$daten[$key] = $halbj['h'].'. Halbjahr '.$halbj['j'];
        }
    }
    return $daten;
}

function loescheHalbjahr($key){
	if(!isset($this->daten[$key])){
    	return -1;
    }
    unset($this->daten[$key]);
    $this->datengeaendert = true;
	$this->schreibeDaten();
    return true;
}

function legeNeuesHalbjahrAn($halbjahr,$jahr){
    # allgemeine Einstellungen holen
    global $_einst;
    $conf = $_einst['stundennachweis'];
    $key = $jahr.'_'.$halbjahr;
    if(!ctype_digit($jahr) or $jahr < 2000 or $jahr > 2100){
    	return -1; # Jahr ungltig
    }
    if($halbjahr != 1 and $halbjahr != 2){
    	return -1; # Halbjahr ungltig
    }
    if(isset($this->daten[$key])){
    	return -2; # Datensatz existiert bereits
    }

    # Trainingstage
    require_once('class/kalender.inc.php');
    $this->kal = new kalender;
    $this->kal->db = &$this->db;

    # Ist der User Trainer?
    $query = "SELECT trainerbis FROM ".DB_PREFIX."uebungsleiter WHERE mitgliedid = ".$_SESSION['user']['id']."";
    $this->db->holeDaten($query);
    $_trainer = !is_null($this->db->holeWert());

    # Trainingstage des Users holen
    $query = "SELECT t.wochentag, TIME_FORMAT(t.anfangszeit,'%H:%i') as anfang, TIME_FORMAT(t.endzeit,'%H:%i') as ende
                FROM ".DB_PREFIX."trainingsgruppen as t, ".DB_PREFIX."trainingsgruppen_uebungsleiter as tu, ".DB_PREFIX."uebungsleiter as u
                WHERE u.mitgliedid = ".$_SESSION['user']['id']." AND u.id = tu.uebungsleiterid AND tu.trainingsgruppenid = t.id
                ORDER BY t.wochentag, t.anfangszeit";
    $this->db->holeDaten($query);
    #$wochentage = $this->db->baueArray('wochentag','wochentag');
    $stunden = $this->db->baueArray('*','#');
    # Termine pro Woche zusammenbauen
    $tmp = array(
    	'wtag'   => -1,
        'anfang' => '00:00',
        'ende'   => ''
    );
    $termine = array();
    foreach($stunden as $stunde){
        if($tmp['wtag'] != $stunde['wochentag']){ # Tag unterschiedlich -> neuen Termin beginnen
        	if($tmp['wtag'] != -1){
            	$termine[] = $tmp;
            }
        	$tmp['wtag'] = $stunde['wochentag'];
            $tmp['anfang'] = $stunde['anfang'];
            $tmp['ende'] = $stunde['ende'];
        }
        else{ # Tag ist identisch mit dem gespeicherten
        	if($tmp['ende'] == $stunde['anfang']){ # Anfang stimmt mit dem Ende der Gruppe vorher berein -> fortfhren
            	$tmp['ende'] = $stunde['ende'];
            }
            else{ # Lcke zwischen zwei Stunden -> neuer Termin am gleichen Tag
                if($tmp['wtag'] != -1){
                    $termine[] = $tmp;
                }
                $tmp['wtag'] = $stunde['wochentag'];
                $tmp['anfang'] = $stunde['anfang'];
                $tmp['ende'] = $stunde['ende'];
            }
        }
    }
    if($tmp['wtag'] != -1){
    	$termine[] = $tmp;
    }
	$stunden = array();
    foreach($termine as $term){
    	if(!isset($stunden[$term['wtag']])){
        	$stunden[$term['wtag']] = array();
        }
        $stunden[$term['wtag']][] = array('anfang' => $term['anfang'], 'ende' => $term['ende']);
    }
    $param = array();
    $param['von'] = ($halbjahr==1?1:7).' '.$jahr;
    $param['bis'] = ($halbjahr==1?6:12).' '.$jahr;
	$trainingstage = array();
    $ende = '|'.($_trainer?'T':'U').'|'.str_replace('|','',$conf['taetigkeit']).'|1|'.str_replace('|','',$conf['bemerkung']);
    foreach($stunden as $wtag => $training){
    	$trainingsmonate = $this->kal->holeTrainingstage($wtag,$param['von'],$param['bis']);
        foreach($trainingsmonate as $t){
        	foreach($t['t'] as $t2){
            	foreach($training as $tr){
                	$teile = explode(':',$tr['anfang']);
                	$trainingstage[mktime($teile[0], $teile[1], 0, $t['m'], $t2, $t['j'])] = $tr['ende'].$ende;
                }
            }
        }
    }
    $this->daten[$key] = $trainingstage;
    $this->datengeaendert = true;
    return true;
}


function generierePdfDatei($id,$_inhomeverzeichnis=false){
	require_once('class/pdf.inc.php');
    $pdf = new tkpdf;
    $_schriftgroesse = 12;
    $leer = (substr($id,0,4)=='leer')?true:false;
    if($leer){
    	$leertyp = substr($id,5);
    }
    # Einstellungen holen
    $conf = array();
    if($leer){
    	$conf['leertyp'] = $leertyp;
		$conf['jahr'] = '';
        $conf['_einst'] = array(
        	'name'    => '',
            'kontonr' => '',
            'blz'     => ''
        );
    }
    else{
    	list($conf['jahr'],$conf['halbjahr']) = explode('_',$id,2);
    	global $_einst;
    	$conf['_einst'] = $_einst['stundennachweis'];
    }
    $conf['zeitraumvon'] = $leer?'__.__.____':'01.0'.($conf['halbjahr']==1?'1.':'7.').$conf['jahr'];
	$conf['zeitraumbis'] = $leer?'__.__.____':($conf['halbjahr']==1?'30.06.':'31.12.').$conf['jahr'];
    $conf['leer'] = $leer;
    $conf['schriftgroesse'] = $_schriftgroesse;
    $daten = array();
    if($leer){
    	if($leertyp == 'trainer'){
    		$this->_pdfseite_trainer($pdf, $conf, $daten);
    		$pdf->tk_titel = 'leerer Stundennachweiszettel (Trainer)';
        }
        else{
    		$this->_pdfseite_uebungsleiter($pdf, $conf, $daten);
    		$pdf->tk_titel = 'leerer Stundennachweiszettel (bungsleiter)';
        }
    }
    else{

		# Daten holen
        $ini = parse_ini_file($this->datenpfad.$this->dateiname,true);
        $ini = $ini[$id];

        # Daten aufbereiten, Anzahl der Stunden berechnen
        foreach($ini as $key => $werte){
        	$tmp = explode('|',$werte);
            $zeile = array(
            	'datum' => date('d.m.Y',$key),
                'anfangszeit' => date('H:i',$key),
                'endzeit' => $tmp[0],
                'tu' => $tmp[1],
                'taetigkeit' => $tmp[2],
                'anzahl' => $tmp[3],
                'bemerkung' => $tmp[4]
            );
            list($a_s, $a_m) = explode(':', $zeile['anfangszeit']);
            list($e_s, $e_m) = explode(':', $zeile['endzeit']);
            $a_insg = $a_s+($a_m/60);
            $e_insg = $e_s+($e_m/60);
            $zeile['stunden'] = round(($e_insg-$a_insg)*60/45,0);
        	$ini[$key] = $zeile;
        }
        # Daten in Trainer/bungsleiter trennen
        $daten = array('t'=>array(),'u'=>array());
        foreach($ini as $key => $werte){
        	$daten[strtolower($werte['tu'])][$key] = $werte;
        }
        # Daten auf die Seiten verteilen und PDF-Daten erzeugen
        $seitevoll = false;
        $sm = $conf['_einst']['eineseitepromonat']==1?true:false;
        if(count($daten['t'])>0){ # Trainerzettel erzeugen
        	$seite = array();
            $i = 0;
            $monat = 0;
        	foreach($daten['t'] as $key => $row){
            	if($monat != 0 and $monat != date('n',$key)){
                	$this->_pdfseite_trainer($pdf, $conf, $seite);
                    $seitevoll = true;
                }
            	if($seitevoll){
                	$i = 0;
                	$pdf->ezNewPage();
                    $seitevoll = false;
                    $seite = array();
                }
                $seite[] = array(
                    'datum'        => $row['datum'],
                    'zeit'         => $row['anfangszeit'].'-'.$row['endzeit'],
                    'stunden'      => $row['stunden'],
                    'sportart'     => $row['taetigkeit'],
                    'anzahl'       => $row['anzahl'],
                    'sportstaette' => $row['bemerkung']
                );
                $i++;
                $monat = date('n',$key);
                if($i >= 22){
                	$this->_pdfseite_trainer($pdf, $conf, $seite);
                    $seitevoll = true;
                }
            }
            if($i > 0){
            	$this->_pdfseite_trainer($pdf, $conf, $seite);
            	$seitevoll = true;
            }
        }
        if(count($daten['u'])>0){ # bungsleiterzettel erzeugen
        	global $_wochentage;
        	$seite = array();
            $i = 0;
        	foreach($daten['u'] as $key => $row){
            	if($seitevoll){
                	$i = 0;
                	$pdf->ezNewPage();
                    $seitevoll = false;
                    $seite = array();
                }
                $seite[] = array(
                    'wtag'       => substr($_wochentage[date('w',$key)],0,2),
                    'datum'      => date('d.m.Y',$key),
                    'taetigkeit' => $row['taetigkeit'],
                    'stunden'    => $row['stunden'],
                    'bemerkung'  => $row['bemerkung']
                );
                $i++;
                if($i >= 46){
                	$this->_pdfseite_uebungsleiter($pdf, $conf, $seite);
                    $seitevoll = true;
                }
            }
            if($i > 0){
            	$this->_pdfseite_uebungsleiter($pdf, $conf, $seite);
            	$seitevoll = true;
            }
        }
    	$pdf->tk_titel = 'Stundennachweis fr das '.$conf['halbjahr'].'. Halbjahr '.$conf['jahr'].' von '.$_SESSION['user']['realname'];
    }
    $pdf->tk_autor = $_SESSION['user']['realname'];
    # raus damit
    $dateiname = 'stundennachweis_'.($leer?'leer':$_SESSION['user']['name']).'.pdf';
    $pdf->tkstream($dateiname, $_inhomeverzeichnis?'Stundennachweis fr das '.$conf['halbjahr'].'. Halbjahr '.$conf['jahr']:false);
}


function _pdfseite_trainer(&$pdf, $conf, $daten){
    # Name
    $pdf->line(54,800,475,800);
    $pdf->line(54,772,475,772);
    $pdf->line(54,800,54,772);
    $pdf->line(475,800,475,772);
    $pdf->addText(65.3,780.5,$conf['schriftgroesse']+3,'Name des bungsleiters:');
    $pdf->line(238,777.7,460,777.7);
    if(!$conf['leer']){
    	$pdf->addText(245,780,$conf['schriftgroesse']+3, $conf['_einst']['name']);
    }
    # Logo
    if(file_exists(PFAD_INCLUDE.'export/bilder/trainerabrechnung_logo.png')){
        $tmp = getImageSize(PFAD_INCLUDE.'export/bilder/trainerabrechnung_logo.png');
        $breite = round($tmp[0]/1.5);
        $hoehe  = round($tmp[1]/1.5);
        $pdf->addPngFromFile(PFAD_INCLUDE.'export/bilder/trainerabrechnung_logo.png', 485, 705, $breite, $hoehe);
    }
    # Hinweistext
    $pdf->addText(56, 754,   $conf['schriftgroesse']-1.8, 'Die unten aufgefhrten bungsstunden wurden von mir selbst gem den Richtlinien');
    $pdf->addText(56, 740.8, $conf['schriftgroesse']-1.8, 'fr die Gewhrung von Zuwendungen des Freistaates Bayern fr den Einsatz von');
    $pdf->addText(56, 727.6, $conf['schriftgroesse']-1.8, 'bungsleitern im Sportvereinen abgehalten. <i>Die Richtlinien sind mir bekannt.</i>');
    $pdf->addText(56, 714.4, $conf['schriftgroesse']-1.8, '<i>(Umseitigen Auszug aus den Richtlinien beachten!).</i>');
    # Kasten ber Tabelle
    $pdf->line(54,703,558,703);
    $pdf->line(54,675,558,675);
    $pdf->line(54,703,54,675);
    $pdf->line(558,703,558,675);
    $pdf->addText(65.3,683.5,$conf['schriftgroesse']+3,'bersicht ber die abgehaltenen bungsstunden des Jahres '.(!$conf['leer']?'<b>'.$conf['jahr'].'</b>':''));

    # Tabelle mit den Daten
    $y = 666;
    $pdf->line(54,$y,558,$y); # oberste Linie
      # senkrechte Linien
    $pdf->line(54, 666, 54, 135.3);
    $pdf->line(129, 666, 129, 135.3);
    $pdf->line(206.8, 666, 206.8, 135.3);
    $pdf->line(298.8, 666, 298.8, 135.3);
    $pdf->line(412, 666, 412, 135.3);
    $pdf->line(468.6, 666, 468.6, 135.3);
    $pdf->line(557.8, 666, 557.8, 135.3);
      # Texte
    $pdf->ezSetY(666);
    $pdf->ezText('Tag',$conf['schriftgroesse']-2,array('aleft'=>54,'aright'=>129,'justification'=>'center'));
    $pdf->ezSetY(666);
    $pdf->ezText("bungszeit  \nvon - bis",$conf['schriftgroesse']-2,array('aleft'=>129,'aright'=>206.8,'justification'=>'center'));
    $pdf->ezSetY(666);
    $pdf->ezText("bungsstunden  \ngem   \nNr. B 3.1.1 der RL\n(1 Std. = 45 Min.)",$conf['schriftgroesse']-2.3,array('aleft'=>206.8,'aright'=>298.8,'justification'=>'center','leading'=>10));
    $pdf->ezSetY(666);
    $pdf->ezText('Sportart',$conf['schriftgroesse']-2,array('aleft'=>298.8,'aright'=>412,'justification'=>'center'));
    $pdf->ezSetY(666);
    $pdf->ezText("Anzahl\nTeilnehmer",$conf['schriftgroesse']-2,array('aleft'=>412,'aright'=>468,6,'justification'=>'center'));
    $pdf->ezSetY(666);
    $pdf->ezText('Sportsttte',$conf['schriftgroesse']-2,array('aleft'=>468,6,'aright'=>557.8,'justification'=>'center'));

    $y -= 42.5;
    for($i=0;$i<=22;$i++){
    	$pdf->line(54,$y,558,$y);
        $y -= 22.2;
    }
    $y = 623.5-$conf['schriftgroesse']*1.5;
    $summe = 0;
    foreach($daten as $row){
    	$pdf->addText(54+4, $y, $conf['schriftgroesse'], $row['datum']);
    	$pdf->addText(129+4, $y, $conf['schriftgroesse'], $row['zeit']);
    	$pdf->addText(206.8+40, $y, $conf['schriftgroesse'], $row['stunden']);
        $summe += $row['stunden'];
    	$pdf->addText(298.8+4, $y, $conf['schriftgroesse'], $row['sportart']);
    	$pdf->addText(412+20, $y, $conf['schriftgroesse'], $row['anzahl']);

    	$pdf->addText(468.6+4, $y, $conf['schriftgroesse'], $row['sportstaette']);
        $y -= 22.2;
    }
    # Summe der Stunden
    $pdf->line(129,135.3,129,113.1);
    $pdf->line(206.8,135.3,206.8,113.1);
    $pdf->line(298.8,135.3,298.8,113.1);
    $pdf->line(129,113.1,298.8,113.1);
    $pdf->addText(133, 117, $conf['schriftgroesse']+1, '<b>Summe:</b>');
    if(!$conf['leer']){
    	$pdf->addText(206.8+40, 117, $conf['schriftgroesse']+1, '<b>'.$summe.'</b>');
    }
    # Fusstext, Unterschriftzeilen
    $pdf->addText(54,91,$conf['schriftgroesse'],'Die Richtigkeit der obigen Eintragungen wird hiermit besttigt:');
    $pdf->line(54,48,167,48);
    $pdf->line(181,48,323,48);
    $pdf->line(337,48,549,48);
    $pdf->addText(98,38,$conf['schriftgroesse']-3,'(Datum)');
    $pdf->addText(182,38,$conf['schriftgroesse']-3,'(Besttigung des Abteilungsleiters)');
    $pdf->addText(378,38,$conf['schriftgroesse']-3,'(Unterschrift des bungsleiters)');
    return;
}

function _pdfseite_uebungsleiter(&$pdf, $conf, $daten){
    # Kopf
    $pdf->addText(60,800,$conf['schriftgroesse']+4,'Stundennachweis fr bungsleiterzuwendungen');
    $pdf->addText(444,808,$conf['schriftgroesse'],'Eingang:');
    $pdf->addText(60,777,$conf['schriftgroesse'],'Fr die Zeit vom '.$conf['zeitraumvon'].' bis '.$conf['zeitraumbis']);
    $pdf->addText(60,751,$conf['schriftgroesse'],'Name: '.$conf['_einst']['name']);
    $pdf->addText(60,729,$conf['schriftgroesse'],'Sparte: Schwimmen');
    $pdf->addText(355,751,$conf['schriftgroesse'],'Bankverb.');
    $pdf->addText(415,751,$conf['schriftgroesse'],'Kontonr: '.$conf['_einst']['kontonr']);
    $pdf->addText(415,739,$conf['schriftgroesse'],'BLZ: '.$conf['_einst']['blz']);
    $pdf->addText(355,727,$conf['schriftgroesse'],'b.l.Ausw.Nr.');
    $pdf->line(60,791,431,791);
    $pdf->line(431,821,431,768);
    $pdf->line(60,768,595,768);
    $pdf->line(60,721,595,721);
    $pdf->line(352,768,352,721);

    # Hauptteil
    $pdf->line(91,715,91,139);
    $pdf->line(156,715,156,139);
    $pdf->line(380,715,380,53);
    $pdf->line(415,715,415,53);
    $start = 139;
    for($i=1;$i<=47;$i++){
    	$pdf->line(60,$start,585,$start);
        $start += 12.2;
    }
    $pdf->line(60,113,595,113);
    $pdf->line(60,88,595,88);
    $pdf->line(60,53,595,53);
    $pdf->line(60,28,595,28);
    $pdf->addText(60,706,$conf['schriftgroesse'],'W-Tg');
    $pdf->addText(105,706,$conf['schriftgroesse'],'Datum');
    $pdf->addText(250,706,$conf['schriftgroesse'],'Ttigkeit');
    $pdf->addText(382,706,$conf['schriftgroesse'],'Std.');
    $pdf->addText(450,706,$conf['schriftgroesse'],'Bemerkung');
      # Daten
    $start = 690;
    $stunden = 0;
    foreach($daten as $row){
    	$pdf->addText(62,  $start, $conf['schriftgroesse']-2, $row['wtag']); # Wochentag
    	$pdf->addText(94,  $start, $conf['schriftgroesse']-2, $row['datum']); # Datum
    	$pdf->addText(160, $start, $conf['schriftgroesse']-2, $row['taetigkeit']); # Ttigkeit
    	$pdf->addText(384, $start, $conf['schriftgroesse']-2, $row['stunden']); # Stunden
        $stunden += $row['stunden'];
    	$pdf->addText(418, $start, $conf['schriftgroesse']-2, $row['bemerkung']); # Bemerkung
        $start -= 12.2;
    }

    # Seitenfuss
    $pdf->addText(61,118,$conf['schriftgroesse'],'Fr die Zeit vom '.$conf['zeitraumvon'].' bis '.$conf['zeitraumbis']);
    if(!$conf['leer']){
    	$pdf->addText(384,118,$conf['schriftgroesse'], $stunden); # Gesamtstunden
    }
    $pdf->addText(61,92,$conf['schriftgroesse'],'Fr die Zeit vom __.__.____ bis __.__.____');
    $pdf->addText(384,92,$conf['schriftgroesse'],'  /');
    $pdf->addText(418,92,$conf['schriftgroesse'],'siehe Rckseite!');

    $pdf->addText(290,66,$conf['schriftgroesse'],'Gesamtstunden:');
    if(!$conf['leer']){
    	$pdf->addText(384,66,$conf['schriftgroesse'], $stunden); # Gesamtstunden
    }
    $pdf->addText(417,79,$conf['schriftgroesse']-2,'Datum u. Unterschrift');
    $pdf->addText(61,42,$conf['schriftgroesse'],'Auszahlung:');
    $pdf->addText(61,16,$conf['schriftgroesse'],'Kopie bzw. bertrag auf Liste f. 1.Kassier erledigt am:');
}


function leseDaten(){
	if(!file_exists($this->datei)){
		if(!$this->_legeDateiAn($this->dateiname)){
			return false;
        }
    }
	if(!is_readable($this->datei)){
		return false;
    }
    $this->daten = parse_ini_file($this->datei,true);
	return true;
}

function schreibeDaten(){
	if(!$this->datengeaendert){
    	return false;
    }
    foreach($this->daten as $key => $halbjahr){
    	ksort($halbjahr);
        $this->daten[$key] = $halbjahr;
    }
    ksort($this->daten);

	require_once('func/schreibe_ini_datei.inc.php');
    schreibe_ini_datei($this->datei,$this->daten,true);
}

function _legeDateiAn($dateiname){
	if(TKSWIM_SCHREIBSCHUTZ){
    	trigger_error('[tkswim][class/stundennachweis/_legedateian] Die Datei konnten wegen aktivierem Schreibschutz nicht angelegt werden.', E_USER_ERROR);
    }
    if(empty($this->user) or empty($this->datenpfad)){
        return false;
    }
    if(!is_writable($this->datenpfad)){
        return false;
    }
    $fh = fopen($this->datei,'w');
    fclose($fh);
    chmod($this->datei, 0666);
    return true;
}

} # Ende der Klasse, EOF
?>