<?php

/*
 Methoden der Klasse "wettkaempfe":
_altersklasse2jahrgaenge
_formatiereGeldbetrag
_formatiereJahrgang
_interpoliereZeit
_jahrgangInJahrgangsbereich
_suchebesteundletztezeit
ermittleSchnellsteLagenstaffelkombinationen
generiereMeldezettel
holeAbschnitte
holeAktuelleZeitenFuerMitglied
holePflichtzeitenfuerAbschnitt
holePflichtzeitjahrgaenge
holePflichtzeitenFuerJahrgangGeschlecht
holeSelectOptionen
holeWettkampfdaten
holeWettkampfjahrgaenge
holeWettkampfliste
jahrg2query
meldezeitInPflichtzeit
parseMeldegeld
schwimmerFuerPflichtzeit
sucheStreckenzeitenfuerMitglied
sucheVorhandenZeiten
verschiebeJahrgang
wettkaempfeFuerSchwimmer
*/

class wettkaempfe{

var $daten; # ausgelesene Wettkampfdaten
var $_tmpl; # Template-Objekt
var $db;    # Datenbank-Objekt
var $_tmp;  # temporrer Zwischenspeicher
var $conf;  # Konfiguration (Schwimmlagen, Wettkampfarten)
var $wettkampfjahr; # Jahr des Wettkampfes


function holeWettkampfauswertung($wkid, $conf = array()){
	# Standardeinstellungen setzen
	if(!isset($conf['rekordeverlinken'])){
    	$conf['rekordeverlinken'] = true;
    }
	if(!isset($conf['zusammenfassenbis'])){
    	$conf['zusammenfassenbis'] = 9999;
    }
	if(!isset($conf['statistik'])){
    	$conf['statistik'] = true;
    }
	if(!isset($conf['rekordversuche'])){
    	$conf['rekordversuche'] = false;
    }

    # Zeiten holen
    $query = "SELECT z.id as zid, m.id as mid, m.nachname, m.vorname, m.mw, YEAR(m.gebdatum) as jg, z.disziplin, z.streckenlaenge, z.zeit,
                  ms.teilnehmerid, ms.meldezeit, z.platz, z.platzvon, z.bemerkung, sz.staffelid, sz.schwimmernr,
                  DATE_FORMAT(z.datum, '%d.%m.%Y') as datum
                FROM ((".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid)
                  LEFT JOIN ".DB_PREFIX."meldungen_starts as ms ON z.id=ms.zeitid)
                  LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id
                WHERE wettkampfid = ".$wkid."
                ORDER BY z.disziplin, z.streckenlaenge, m.nachname, m.vorname";
    $this->db->holeDaten($query);
    $zeiten = $this->db->baueArray('*', 'zid');

    # Staffeln holen
    $query = "SELECT s.id, s.disziplin, s.anzahl, s.laenge, s.mw, s.gesamtzeit, s.platz, s.platzvon, s.bemerkung,
                  DATE_FORMAT(z.datum, '%d.%m.%Y') as datum
                FROM (".DB_PREFIX."staffeln as s LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON s.id=sz.staffelid)
                  LEFT JOIN ".DB_PREFIX."zeiten as z ON sz.zeitid=z.id
                WHERE s.wettkampfid = ".$wkid." GROUP BY s.id";
    $this->db->holeDaten($query);
    $staffeln = $this->db->baueArray('*', 'id');

    # Rekordvermerke holen
    $query = "SELECT zeitid, art, laenge, FIELD(art, 'VR', 'VJR', 'PB', 'PB25', 'PB50', 'HoF', 'HoF11') AS sort
                FROM ".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id
                WHERE wettkampfid = ".$wkid." AND LEFT(zr.art,1) != 'a' ORDER BY sort";
    $this->db->holeDaten($query);
    $rekorde = $this->db->baueArray('*', '#');

    # Zwischenzeiten holen
    $query = "SELECT zz.zeitid, zz.streckenlaenge, zz.zeit
                FROM ".DB_PREFIX."zwischenzeiten as zz LEFT JOIN ".DB_PREFIX."zeiten as z ON zz.zeitid=z.id
                WHERE wettkampfid = ".$wkid." AND zz.bestenliste = 1
                ORDER BY zeitid, streckenlaenge";
    $this->db->holeDaten($query);
    $zwischenzeiten = $this->db->baueArray('*', '#');

    # Rekorde zuweisen
    $rekordlinks = array(
    	'VR'    => ROOT.'/zeiten/bestenlisten.html',
        'VJR'   => ROOT.'/zeiten/bestenlisten.html?jahrgangsrekorde=%s',
        'HoF'   => ROOT.'/zeiten/bestenlisten.html?lage=%s&laenge=%s',
        'HoF11' => ROOT.'/zeiten/bestenlisten.html?lage=%s&laenge=%s&maxalter=11'
    );
    foreach($rekorde as $rekord){
        if(!isset($zeiten[$rekord['zeitid']])){
            continue;
        }
        if(!isset($zeiten[$rekord['zeitid']]['_sonstiges'])){
            $zeiten[$rekord['zeitid']]['_sonstiges'] = array();
        }

        $ausgabe = $rekord['art'];
        if(!is_null($rekord['laenge'])){
        	$ausgabe .= ' ('.$rekord['laenge'].'m)';
        }
        if($conf['rekordeverlinken'] and isset($rekordlinks[$rekord['art']])){
        	switch($rekord['art']){
            case 'VJR':
        		$url = sprintf($rekordlinks[$rekord['art']], $zeiten[$rekord['zeitid']]['streckenlaenge'].'_'.$zeiten[$rekord['zeitid']]['disziplin']);
                break;
            case 'HoF':
            case 'HoF11':
        		$url = sprintf($rekordlinks[$rekord['art']], $zeiten[$rekord['zeitid']]['disziplin'], $zeiten[$rekord['zeitid']]['streckenlaenge']);
            	break;
            default:
            	$url = $rekordlinks[$rekord['art']];
                break;
            }
        	$ausgabe = '<a href="'.$url.'">'.$ausgabe.'</a>';
        }
        $zeiten[$rekord['zeitid']]['_sonstiges'][] = $ausgabe;
    }

    # Zwischenzeiten zuweisen
    $zwzeiten = array();
	foreach($zwischenzeiten as $zwzeit){
    	if(!isset($zwzeiten[$zwzeit['zeitid']])){
        	$zwzeiten[$zwzeit['zeitid']] = array();
        }
        $zwzeiten[$zwzeit['zeitid']][] = $zwzeit['streckenlaenge'].'m: '.text_format($zwzeit['zeit'], 'schwimmzeit');
    }
    foreach($zwzeiten as $zid => $zwzeit){
    	if(!isset($zeiten[$zid]['_sonstiges'])){
        	$zeiten[$zid]['_sonstiges'] = array();
        }
        $zeiten[$zid]['_sonstiges'][] = 'Zwzeit: '.implode(', ', $zwzeit);
    }

    # Staffelstarts aussortieren, Anzahl der Starter pro Disziplin zhlen
    $staffelzeiten = array();
    $anzahl = array();
    foreach($zeiten as $zid => $row){
        if(!is_null($row['staffelid'])){
            $staffelzeiten[$zid] = $row;
            unset($zeiten[$zid]);
            continue;
        }
        $anzkey = $row['disziplin'].'_'.$row['streckenlaenge'].'_'.$row['mw'];
        if(!isset($anzahl[$anzkey])){
            $anzahl[$anzkey] = 0;
        }
        if((int)$row['platz'] > 0 or is_null($row['platz'])){
            $anzahl[$anzkey]++;
        }
    }

    # festlegen welche Strecken angezeigt werden
    $strecken = array();
    foreach($anzahl as $key => $anz){
        $anderes = substr($key,0,-1).(substr($key,-1)=='w'?'m':'w');
        if($anz > $conf['zusammenfassenbis']){ # Anzahl der Schwimmer zu gro, berprfen ob anderes Geschlecht hinzugefgt werden muss
            if(!isset($anzahl[$anderes])){ # anderes Geschlecht existiert nicht
                $strecken[$key] = array($key);
                unset($anzahl[$key]);
                continue;
            }
            if($anzahl[$anderes] > $conf['zusammenfassenbis']){ # Anzahl des anderen Geschlechts ebenfalls zu gro
                $strecken[$key] = array($key);
                $strecken[$anderes] = array($anderes);
            }
            else{
                $strecken[substr($key,0,-1).'mw'] = array($key, $anderes);
            }
        }
        else{ # Anzahl der Schwimmer ist zu klein, berprfen ob anderes Geschlecht existiert (zum zusammenfhren)
            if(!isset($anzahl[$anderes])){ # anderes Geschlecht existiert nicht
                $strecken[$key] = array($key);
                unset($anzahl[$key]);
            }
            else{
                $strecken[substr($key,0,-1).'mw'] = array($key, $anderes);
            }
        }
    }

    # Funktion zum Sortieren der Reihenfolge der Strecken (Einzel und Staffel)
    function streckensort($a, $b){
    	if($a['sort']==$b['sort']){
        	return 0;
        }
        else{
        	return $a['sort']>$b['sort']?1:-1;
        }
    }

    # Zeitenarray vorbereiten
    $einzelzeiten = array();
    $key2strecke = array();
    foreach($strecken as $key => $inh){
        foreach($inh as $i){
            $key2strecke[$i] = $key;
        }
        list($d, $s, $g) = explode('_', $key);
        $einzelzeiten[$key] = array(
            'disziplin'  => $d,
            'strecke'    => $s,
            'geschlecht' => $g,
            'sort'       => $d.str_pad($s,4,'0',STR_PAD_LEFT).($g=='mw'?'2':($g=='m'?'1':'0')),
            '_titel'     => $s.'m '.$this->conf['lagen'][$d].' '.($g=='mw'?'':$this->conf['geschlechter'][$g]),
            '_ids'       => array(),
            '_zeiten'    => array(),
            '_na'        => array(),
            '_ds'        => array(),
            '_ab'        => array(),
            '_au'        => array(),
            '_meldezeiten' => 0,
            '_plaetze'     => 0,
            '_sonstiges'   => 0,

        );
        $einzelzeiten[$key]['_ids'][0] = 'e'.$s.'_'.strtolower($this->conf['lagen'][$d][0]).'_'.$g;
        if($g == 'mw'){
            $einzelzeiten[$key]['_ids'][1] = 'e'.$s.'_'.strtolower($this->conf['lagen'][$d][0]).'_w';
            $einzelzeiten[$key]['_ids'][2] = 'e'.$s.'_'.strtolower($this->conf['lagen'][$d][0]).'_m';
        }
    }
    uasort($einzelzeiten, 'streckensort');

    # Zeiten zuweisen
    foreach($zeiten as $zid => $row){
        $key = $row['disziplin'].'_'.$row['streckenlaenge'].'_'.$row['mw'];
        if(in_array($row['platz'], array('NA','DS','AB','AU'))){
            $einzelzeiten[$key2strecke[$key]]['_'.strtolower($row['platz'])][] = $row;
        }
        else{
            if(!is_null($row['platz'])){
                $einzelzeiten[$key2strecke[$key]]['_plaetze'] = 1;
            }
            if(is_null($row['meldezeit'])){
            	if(is_null($row['teilnehmerid'])){
                	$row['meldezeit'] = '?';
                }
                else{
                	$row['meldezeit'] = '-';
                }
            }
            else{
                $einzelzeiten[$key2strecke[$key]]['_meldezeiten'] = 1;
                $diff = abs($row['zeit']-$row['meldezeit']);
                $pre = ($row['zeit']<$row['meldezeit'])?'-':'+';
                $row['differenzzurmeldezeit'] = $pre.text_format($diff,'schwimmzeit').' (='.str_replace('.',',',round(($diff/$row['meldezeit'])*100,1)).'%)';
            }
            if($conf['rekordversuche']){
            	if(!isset($row['_sonstiges'])){
                	$row['_sonstiges'] = array();
                }
            	$row['_sonstiges'][] = 'Datum: '.$row['datum'];
            }
            if(isset($row['_sonstiges'])){
                $row['_sonstiges'] = implode(', ', $row['_sonstiges']);
                $einzelzeiten[$key2strecke[$key]]['_sonstiges'] = 1;
            }
            $einzelzeiten[$key2strecke[$key]]['_zeiten'][] = $row;
        }
    }

    # Staffeln
    # Zeiten den Staffeln zuordnen
    foreach($staffelzeiten as $row){
    	if(!isset($staffeln[$row['staffelid']]['_schwimmer'])){
        	$staffeln[$row['staffelid']]['_schwimmer'] = array();
        }
        $row['zeitsumme'] = '';
        $staffeln[$row['staffelid']]['_schwimmer'][$row['schwimmernr']] = $row;
        if(isset($row['_sonstiges'])){
        	if(!isset($staffeln[$row['staffelid']]['_sonstiges'])){
            	$staffeln[$row['staffelid']]['_sonstiges'] = array();
            }
            $anhang = ' ('.($row['schwimmernr']==1?'Startschwimmer':$row['schwimmernr'].'. Schwimmer').($row['mw']=='w'?'in':'').')';
            if($conf['rekordeverlinken']){
            	$anhang = '<span class="rekordbemerkung">'.$anhang.'</span>';
            }
            $staffeln[$row['staffelid']]['_sonstiges'][] = implode(', ',$row['_sonstiges']).$anhang;
        }
    }
    foreach($staffeln as $key => $st){
    	ksort($staffeln[$key]['_schwimmer']);
    }
    # Zeiten je Staffel aufsummieren
    foreach($staffeln as $key => $st){
    	$summe = 0;
        foreach($st['_schwimmer'] as $nr => $schw){
        	if(is_null($schw['zeit'])){
            	$staffeln[$key]['_schwimmer'][$nr]['zeitsumme'] = false;
            }
            else{
        		$summe += $schw['zeit'];
            	$staffeln[$key]['_schwimmer'][$nr]['zeitsumme'] = $summe;
            }
        }
    }

    # ermitteln welche Staffelarten vorhanden sind
    $anzahl = array();
    foreach($staffeln as $key => $staffel){
        $anzkey = $staffel['disziplin'].'_'.$staffel['anzahl'].'x'.$staffel['laenge'].'_'.$staffel['mw'];
        if(!isset($anzahl[$anzkey])){
        	$anzahl[$anzkey] = 0;
        }
        if((int)$staffel['platz'] > 0 or is_null($staffel['platz'])){
            $anzahl[$anzkey]++;
        }
    }

    # festlegen welche Strecken angezeigt bzw. zusammengefasst werden
    $strecken = array();
    foreach($anzahl as $key => $anz){
    	$arten = array(
        	1 => substr($key,0,-1).'m',
        	2 => substr($key,0,-1).'w',
        	3 => substr($key,0,-1).'x'
        );
        $anz = array(1=>1000, 2=>1000, 3=>1000);
        if(isset($anzahl[$arten[1]])){
        	$anz[1] = $anzahl[$arten[1]];
            unset($anzahl[$arten[1]]);
        }
        if(isset($anzahl[$arten[2]])){
        	$anz[2] = $anzahl[$arten[2]];
            unset($anzahl[$arten[2]]);
        }
        if(isset($anzahl[$arten[3]])){
        	$anz[3] = $anzahl[$arten[3]];
            unset($anzahl[$arten[3]]);
        }

        if(($anz[1]<$conf['zusammenfassenbis'] or $anz[2]<$conf['zusammenfassenbis'] or $anz[3]<$conf['zusammenfassenbis'])){
        	# mindestens eine Anzahl ist kleiner -> zusammenfassen
            $st = array();
            if($anz[1] < 1000){
            	$st[] = $arten[1];
            }
            if($anz[2] < 1000){
            	$st[] = $arten[2];
            }
            if($anz[3] < 1000){
            	$st[] = $arten[3];
            }
            if(count($st)>1){
            	$strecken[substr($key,0,-1).'mwx'] = $st;
            }
            else{
            	$strecken[$key] = $st;
            }
        }
        else{
            if($anz[1] < 1000){
            	$strecken[$key] = array($arten[1]);
            }
            if($anz[2] < 1000){
            	$strecken[$key] = array($arten[2]);
            }
            if($anz[3] < 1000){
            	$strecken[$key] = array($arten[3]);
            }
        }
    }

    # Zeitenarray vorbereiten
    $staffelzeiten = array();
    $key2strecke = array();
    foreach($strecken as $key => $inh){
        foreach($inh as $i){
            $key2strecke[$i] = $key;
        }
        list($d, $s, $g) = explode('_', $key);
        list($s_a, $s_l) = explode('x', $s);
        $ids = array('e'.$s.'_'.strtolower($this->conf['lagen'][$d][0]).'_'.$g);
        if(isset($inh[1])){
            foreach($inh as $i){
                $ids[] = 'e'.$s.'_'.strtolower($this->conf['lagen'][$d][0]).'_'.substr($i,-1);
            }
        }
        $staffelzeiten[$key] = array(
            'disziplin'  => $d,
            'strecke'    => $s,
            'geschlecht' => $g,
            'sort'       => $d.str_pad($s_l,4,'0',STR_PAD_LEFT).str_pad($s_a,2,'0',STR_PAD_LEFT).(($g=='mw' or $g=='x')?'2':($g=='m'?'1':'0')),
            '_titel'     => $s.'m '.$this->conf['lagen'][$d].' '.($g=='mwx'?'':$this->conf['geschlechter'][$g]),
            '_ids'       => array(),
            '_zeiten'    => array(),
            '_na'        => array(),
            '_ds'        => array(),
            '_ab'        => array(),
            '_au'        => array(),
            '_meldezeiten' => 0,
            '_plaetze'     => 0,
            '_sonstiges'   => 0,

        );
        $staffelzeiten[$key]['_ids'] = $ids;
    }
    uasort($staffelzeiten, 'streckensort');

    # Staffeln zuweisen
    foreach($staffeln as $sid => $row){
        $key = $row['disziplin'].'_'.$row['anzahl'].'x'.$row['laenge'].'_'.$row['mw'];
        if(in_array($row['platz'], array('NA','AB','AU'))){
            $staffelzeiten[$key2strecke[$key]]['_'.strtolower($row['platz'])][] = $row;
        }
        else{
            if(!is_null($row['platz'])){
                $staffelzeiten[$key2strecke[$key]]['_plaetze'] = 1;
            }
            if($conf['rekordversuche']){
            	if(!isset($row['_sonstiges'])){
                	$row['_sonstiges'] = array();
                }
            	$row['_sonstiges'][] = 'Datum: '.$row['datum'];
            }
            if(isset($row['_sonstiges'])){
                $row['_sonstiges'] = implode(', ', $row['_sonstiges']);
                $staffelzeiten[$key2strecke[$key]]['_sonstiges'] = 1;
            }
            $staffelzeiten[$key2strecke[$key]]['_zeiten'][] = $row;
        }
    }

    # Staffeln nach Zeit sortieren
    function staffelnsort($a, $b){
    	if($a['gesamtzeit'] == $b['gesamtzeit']){
        	return 0;
        }
        else{
        	if(is_null($a['gesamtzeit'])){
            	return 1;
            }
        	elseif(is_null($b['gesamtzeit'])){
            	return -1;
            }
            else{
        		return $a['gesamtzeit']>$b['gesamtzeit']?1:-1;
            }
        }
    }
    foreach($staffelzeiten as $sid => $row){
    	uasort($staffelzeiten[$sid]['_zeiten'], 'staffelnsort');
    }

    # Disqualifikationsbegrndungen einbauen
    foreach($staffelzeiten as $sid => $row){
        $dsnr = 1;
        foreach($row['_zeiten'] as $id => $staffel){
        	if($staffel['platz'] != 'DS'){
            	continue;
            }
            $staffelzeiten[$sid]['_zeiten'][$id]['_dsnr'] = $dsnr;
            $staffelzeiten[$sid]['_ds'][$dsnr] = $staffel['bemerkung'];
            $dsnr++;
        }
    }

    # Statistik holen
    if($conf['statistik'] and !$conf['rekordversuche']){
        $statistik = array(
            'VR' => 0,
            'VJR' => 0,
            'PB' => 0,
            'HoF' => 0,
            'schwimmer' => 0,
            'startsproschwimmer' => 0,
            'einzelstarts' => 0,
            'staffelstarts' => 0,
            'staffelteilnehmer' => 0
        );
        # Anzahl der Rekorde
        $query = "SELECT art, COUNT(art) as anz
                    FROM ".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id
                    WHERE wettkampfid = ".$wkid." GROUP BY art";
        $this->db->holeDaten($query);
        $stat = $this->db->baueArray('anz', 'art');
        foreach($stat as $art => $anz){
            if(in_array($art, array('VR','VJR','HoF','PB'))){
                $statistik[$art] += $anz;
            }
            elseif(in_array($art, array('PB25','PB50'))){
                $statistik['PB'] += $anz;
            }
            elseif($art == 'HoF11'){
                $statistik['HoF'] += $anz;
            }
        }
        # Anzahl der Teilnehmer
        $query = "SELECT z.mitgliedid, COUNT(mitgliedid) as anz
                    FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid
                    WHERE wettkampfid = ".$wkid." AND (zeit IS NOT NULL OR platz = 'DS' OR sz.staffelid IS NOT NULL)
                    GROUP BY mitgliedid";
        $this->db->holeDaten($query);
        $stat = $this->db->baueArray('anz', 'mitgliedid');
        $statistik['schwimmer'] = $this->db->holeAnzahl();
        $anz = 0;
        foreach($stat as $a){
            $anz += $a;
        }
        $statistik['startsproschwimmer'] = number_format($anz/$this->db->holeAnzahl(),1,',','.');
        # Anzahl der Starts
        $query = "SELECT z.id, COUNT(z.id) as anz
                    FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid
                    WHERE wettkampfid = ".$wkid." AND (zeit IS NOT NULL OR platz = 'DS') AND sz.staffelid IS NULL
                    GROUP BY z.id";
        $this->db->holeDaten($query);
        $statistik['einzelstarts'] = $this->db->holeAnzahl();
        $query = "SELECT id FROM ".DB_PREFIX."staffeln WHERE wettkampfid = ".$wkid."";
        $this->db->holeDaten($query);
        $statistik['staffelstarts'] = $this->db->holeAnzahl();

        $query = "SELECT z.id FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid
                    WHERE wettkampfid = ".$wkid." AND sz.staffelid IS NOT NULL";
        $this->db->holeDaten($query);
        $statistik['staffelteilnehmer'] = $this->db->holeAnzahl();
    }
    else{
    	$statistik = false;
    }

    return array(
    	'einzel' => $einzelzeiten,
        'staffel' => $staffelzeiten,
        'statistik' => $statistik
    );
}

function werteWettkampfAus($wkid){
	# Zeiten des Wettkampfes holen
	$query = "SELECT z.mitgliedid as mid, CONCAT(z.id,'_',0) as zid, z.zeit, z.disziplin, z.streckenlaenge, m.mw,
                  IF(YEAR(z.datum)-YEAR(gebdatum)>=20,CONCAT('ak',FLOOR((YEAR(z.datum)-YEAR(gebdatum))/5)*5),YEAR(z.datum)-YEAR(gebdatum)) as ak
                FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."mitglieder as m ON m.id=z.mitgliedid
                WHERE z.wettkampfid = ".$wkid." AND zeit IS NOT NULL AND bestenliste = 1";
    $this->db->holeDaten($query);
    $zeiten = $this->db->baueArray('*','zid');

    # Zwischenzeiten holen
    $query = "SELECT z.mitgliedid as mid, CONCAT(z.id,'_',zz.streckenlaenge) as zid, zz.zeit, z.disziplin, zz.streckenlaenge, m.mw,
                  IF(YEAR(z.datum)-YEAR(gebdatum)>=20,CONCAT('ak',FLOOR((YEAR(z.datum)-YEAR(gebdatum))/5)*5),YEAR(z.datum)-YEAR(gebdatum)) as ak
                FROM ".DB_PREFIX."zwischenzeiten as zz LEFT JOIN (".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."mitglieder as m ON m.id=z.mitgliedid) ON zz.zeitid=z.id
                WHERE z.wettkampfid = ".$wkid." AND zz.zeit IS NOT NULL AND zz.bestenliste = 1 AND z.disziplin != 5 AND (zz.streckenlaenge = 50 OR zz.streckenlaenge%100=0)";
    $this->db->holeDaten($query);
    $zwzeiten = $this->db->baueArray('*','zid');
    foreach($zwzeiten as $zid => $row){
    	$zeiten[$zid] = $row;
    }

    # Zeiten auf Rekorde prfen
    $rekorde = array();
    $nurschnellste = array();
    require_once('class/zeiten.inc.php');
    $z = new zeiten;
    $z->db = &$this->db;
    foreach($zeiten as $zid => $row){
    	$ergebnis = $z->zeitIstRekord($row['zeit'], $row['streckenlaenge'], $row['disziplin'], $row['mw'], $row['ak'], $row['mid'], $wkid);
        $rkey = $row['disziplin'].'_'.$row['streckenlaenge'].'_'.$row['mw'];
        foreach($ergebnis as $e){
            if($e == 'VR' or $e == 'VR(1)'){
                if(in_array('VR(1)',$ergebnis)){
                    if(!isset($nurschnellste[$rkey])){
                        $nurschnellste[$rkey] = array();
                    }
                    if(!isset($nurschnellste[$rkey]['*'])){
                        $nurschnellste[$rkey]['*'] = array();
                    }
                    $nurschnellste[$rkey]['*'][] = $zid;
                }
                else{
                    $rekorde[] = array($zid,'VR');
                }
            }
            elseif($e == 'VJR' or $e == 'VJR(1)'){
                if(in_array('VJR(1)',$ergebnis)){
                    if(!isset($nurschnellste[$rkey])){
                        $nurschnellste[$rkey] = array();
                    }
                    if(!isset($nurschnellste[$rkey][$row['ak']])){
                        $nurschnellste[$rkey][$row['ak']] = array();
                    }
                    $nurschnellste[$rkey][$row['ak']][] = $zid;
                }
                else{
                    $rekorde[] = array($zid,'VJR');
                }
            }
            else{
                $rekorde[] = array($zid,$e);
            }
        }
    }

    # wenn eine Strecke von mehreren Schwimmern das erste mal geschwommen wird, bekommt nur der jeweils schnellste den V(J)R-Vermerk
    foreach($nurschnellste as $strecke => $aks){
    	foreach($aks as $ak => $ids){
        	$art = $ak=='*'?'VR':'VJR';
        	if(count($ids)==1){
            	$rekorde[] = array($ids[0], $art);
            }
            else{
            	$test = array();
            	foreach($ids as $id){
                	$test[$id] = $zeiten[$id]['zeit'];
                }
                asort($test);

                $tmpzeit = 999999999;
                foreach($test as $id => $zeit){
                	if($zeit<$tmpzeit){
                    	$tmpzeit = $zeit;
                    }
                    if($zeit == $tmpzeit){
            			$rekorde[] = array($id, $art);
                    }
                }
            }
        }
    }

    # ermittelte Rekorde in der Datenbank speichern
    $queryteile = array();
    foreach($rekorde as $rekord){
    	list($zid, $laenge) = explode('_', $rekord[0]);
    	$queryteile[] = "(".$zid.", '".$rekord[1]."', ".($laenge>0?$laenge:'NULL').")";
    }
    $query = "INSERT INTO ".DB_PREFIX."zeiten_rekorde VALUES ".implode(', ', $queryteile)."";
    $this->db->fuehreQueryAus($query);

    # fertig
    return true;
}


function holePflichtzeitenFuerJahrgangGeschlecht($jahr, $jg, $mw){
	$pflichtid = $_SESSION['wk_abwickeln']['pflichtzeiten'];
    $query = "SELECT id, jahrgang FROM ".DB_PREFIX."pflichtzeiten_jahrgaenge WHERE pflichtzeitenid = ".$pflichtid."";
    $this->db->holeDaten($query);
    $jahrgaenge = $this->db->baueArray('jahrgang','id');
    foreach($jahrgaenge as $id => $jahrgang){
    	if(preg_match('~^([0-9]{1,2})(\+|-)?$~',$jahrgang,$match)){
            $jahrgang = $jahr-$match[1];
            if(isset($match[2])){
            	$jahrgang .= $match[2];
            }
            $jahrgaenge[$id] = $jahrgang;
        }
        if($this->_jahrgangInJahrgangsbereich($jg, $jahrgang)){
            $query = "SELECT zeit, CONCAT(laenge,'_',disziplin) as strecke
                        FROM ".DB_PREFIX."pflichtzeiten_zeiten as pz, ".DB_PREFIX."pflichtzeiten_strecken as ps
                        WHERE pz.streckenid = ps.id AND jahrgangid = ".$id." AND ps.mw = '".$mw."'";
            $this->db->holeDaten($query);
            return $this->db->baueArray('zeit','strecke');
        }
    }
    return false;
}


function ermittleSchnellsteLagenstaffelkombinationen($zeiten,$mwx,$xbedingung){
	if(count($zeiten[1]) < 1 or count($zeiten[2]) < 1 or count($zeiten[3]) < 1 or count($zeiten[4]) < 1){
    	return false;
    }
    # Geschlechter holen
    $schwimmer = array_merge(array_keys($zeiten[1]),array_keys($zeiten[2]),array_keys($zeiten[3]),array_keys($zeiten[4]));
    $schwimmer = array_unique($schwimmer);
    $query = "SELECT id, mw FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$schwimmer).")";
    $this->db->holeDaten($query);
    $mw = $this->db->baueArray('mw','id');
    $m = $w = array();
    foreach($mw as $mid => $geschl){
        if($geschl == 'w'){
            $w[] = $mid;
        }
        else{
            $m[] = $mid;
        }
    }
	$benoetigte = array();
    for($i=1;$i<=4;$i++){
    	$j = 1;
        $manz = $wanz = 0;
    	foreach($zeiten[$i] as $mid => $zeit){
            if($wanz == 4 and in_array($mid,$w)){
            	continue;
            }
            if($manz == 4 and in_array($mid,$m)){
            	continue;
            }
        	$benoetigt[$i][$mid] = $zeit;
            if(in_array($mid,$w)){
            	$wanz++;
            }
            if(in_array($mid,$m)){
            	$manz++;
            }
            if($wanz == 4 and $manz == 4){
            	break;
            }
        }
    }

    $summen = array();
    foreach($benoetigt[1] as $mid1 => $zeit1){
        foreach($benoetigt[2] as $mid2 => $zeit2){
        	if($mid1 == $mid2){
            	continue;
            }
        	foreach($benoetigt[3] as $mid3 => $zeit3){
        		if($mid2 == $mid3 or $mid1 == $mid3){
            		continue;
            	}
        		foreach($benoetigt[4] as $mid4 => $zeit4){
        			if($mid3 == $mid4 or $mid2 == $mid4 or $mid1 == $mid4){
            			continue;
            		}
                    $summen[] = array(
                    	'geszeit' => $zeit1+$zeit2+$zeit3+$zeit4,
                        'schwimmer' => array(
                        	1 => $mid1,
                        	2 => $mid2,
                            3 => $mid3,
                            4 => $mid4
                        )
                    );
        		}
        	}
        }
    }
    $sort = array();
    foreach($summen as $key => $daten){
    	$sort[$key] = $daten['geszeit'];
    }
    asort($sort);

    $tmp = $summen;
    $summen = array();
    foreach($sort as $key => $s){
    	$summen[] = $tmp[$key];
    }
    if($mwx == 'x'){
        $tmp = $summen;
        $summen = array();
        foreach($tmp as $daten){
        	$mda = $wda = 0;
        	foreach($daten['schwimmer'] as $schw){
            	if(in_array($schw,$w)){
                	$wda++;
                }
            	if(in_array($schw,$m)){
                	$mda++;
                }
            }
            if($xbedingung == 1 and ($wda != 0 and $mda != 0)){
            	$summen[] = $daten;
            }
            if($xbedingung == 2 and ($wda == 2 and $mda == 2)){
            	$summen[] = $daten;
            }
        }
    }
    return $summen;
}



function meldezeitInPflichtzeit($meldezeit, $wkid, $schwimmerjg){
	$rueckgabe = array(
    	'bestanden' => '+',
        'offiziell' => 1,
        'richtpflicht' => 'p',
        'pflichtzeit' => ''
    );
	if(!isset($this->daten['meldezeitinpflichtzeit']) or $_SESSION['wk_abwickeln']['id'] != $this->daten['meldezeitinpflichtzeit']['wettkampfid']){
    	$this->daten['meldezeitinpflichtzeit'] = array(
        	'inhalt' => 'pflichtzeiten',
            'wettkampfid' => $_SESSION['wk_abwickeln']['id'],
            'daten' => array()
        );
        $dat = &$this->daten['meldezeitinpflichtzeit']['daten'];
		$wettkampfid = $this->daten['meldezeitinpflichtzeit']['wettkampfid'];
        $query = "SELECT w.id as wkid, pj.jahrgang, pz.zeit, p.offiziell, p.richtpflicht
                    FROM ".DB_PREFIX."pflichtzeiten as p, ".DB_PREFIX."pflichtzeiten_strecken as ps, ".DB_PREFIX."pflichtzeiten_jahrgaenge as pj,
                      ".DB_PREFIX."pflichtzeiten_zeiten as pz, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
                    WHERE ps.disziplin=w.disziplin AND ps.laenge=w.laenge AND ps.mw=w.mw AND w.abschnittid=a.id AND pz.streckenid=ps.id AND
                      p.id=ps.pflichtzeitenid AND p.id=pj.pflichtzeitenid AND pz.jahrgangid=pj.id AND
                      p.id = ".$_SESSION['wk_abwickeln']['pflichtzeiten']." AND a.wettkampfid = ".$wettkampfid."";
        $this->db->holeDaten($query);
        if($this->db->ergebnis['anzahl'] == 0){
        	return $rueckgabe;
        }
        foreach($this->db->ergebnis['daten'] as $row){
        	if(!isset($dat[$row['wkid']])){
            	$dat[$row['wkid']] = array();
            }
            $dat[$row['wkid']][$row['jahrgang']] = $row;
        }
    }
    else{
        $dat = &$this->daten['meldezeitinpflichtzeit']['daten'];
    }
    if(!in_array($wkid, array_keys($dat))){
    	return $rueckgabe;
    }
    $wettkampf = $dat[$wkid];
    $pflichtzeitdat = array();
    foreach($wettkampf as $jahrgang => $zeit){
        if($jahrgang == $schwimmerjg or ((strlen($jahrgang)!=4 or !ctype_digit($jahrgang)) and $this->_jahrgangInJahrgangsbereich($schwimmerjg, $jahrgang))){
        	$pflichtzeitdat = $zeit;
        }
    }
    if(count($pflichtzeitdat) == 0){
    	return $rueckgabe;
    }
    $zeit = $pflichtzeitdat;
    $rueckgabe['offiziell'] = $zeit['offiziell'];
    $rueckgabe['pflichtzeit'] = $zeit['zeit'];
    $rueckgabe['richtpflicht'] = $zeit['richtpflicht'];
    $toleranz = $this->conf['_gleinst']['wettkaempfe_abwickeln'][($zeit['richtpflicht']=='p'?'pflichtzeitabstand':'richtzeittoleranz')];

    $prozent = substr($toleranz,-1)=='%';
    if($prozent){
    	$toleranz = $zeit['zeit']*substr($toleranz,0,-1)*0.01;
    }
    else{
    	$toleranz *= 100;
    }
    if($zeit['richtpflicht'] == 'r'){ # Richtzeit
    	if($meldezeit > $zeit['zeit']+$toleranz){
        	$rueckgabe['bestanden'] = '-';
        }
        elseif($meldezeit > $zeit['zeit']){
        	$rueckgabe['bestanden'] = '0';
        }
        else{
        	$rueckgabe['bestanden'] = '+';
        }
    }
    else{ # Pflichtzeit
    	if($meldezeit > $zeit['zeit'] or is_null($meldezeit)){
        	$rueckgabe['bestanden'] = '-';
        }
        elseif($meldezeit > $zeit['zeit']-$toleranz){
        	$rueckgabe['bestanden'] = '0';
        }
        else{
        	$rueckgabe['bestanden'] = '+';
        }
    }
    return $rueckgabe;
}

function schwimmerFuerPflichtzeit($conf){
    $conf['wkid'] = $_SESSION['wk_abwickeln']['id'];
    $conf['pflichtzeitid'] = $_SESSION['wk_abwickeln']['pflichtzeiten'];
    $conf['wkdatum'] = $_SESSION['wk_abwickeln']['wettkampfdatum'];
	# Pflichtzeiten holen
    $query = "SELECT zeit, jahrgang
                FROM ".DB_PREFIX."pflichtzeiten_zeiten as pz, ".DB_PREFIX."pflichtzeiten_jahrgaenge as pj
                WHERE streckenid = ".$conf['id']." AND pz.jahrgangid=pj.id";
	$this->db->holeDaten($query);
    $zeiten = $this->db->baueArray('*','#');
    # Wettkampfjahr setzen
    $this->wettkampfjahr = substr($_SESSION['wk_abwickeln']['wettkampfdatum'],0,4);
    # Mitglieder suchen
    $mitglieder = array();
    foreach($zeiten as $row){
        $jahrgang = $this->jahrg2query($row['jahrgang'],$this->wettkampfjahr);
    	$prozent = substr($conf['toleranz'],-1)=='%';
    	if($prozent){
    		$toleranz = $row['zeit']*substr($conf['toleranz'],0,-1)*0.01;
    	}
    	else{
    		$toleranz = $conf['toleranz']*100;
    	}
        $zeitsort = $conf['richtpflicht']=='r'?$row['zeit']+$toleranz:$row['zeit']-$toleranz;
		$query = "SELECT m.id as mid, CONCAT(nachname,', ',vorname) as name, YEAR(gebdatum) as jahrg, dsvid,
                      m.mw, zeit as zeit, z.id as zid, '".$row['zeit']."' as pflichtzeit,
                      DATE_FORMAT(z.datum, '%d.%m.%Y') as datum, w.titel, w.kurztitel
                    FROM ".DB_PREFIX."zeiten AS z, ".DB_PREFIX."mitglieder AS m, ".DB_PREFIX."wettkaempfe as w
                    WHERE
                      m.mw = '".$conf['mw']."' AND z.disziplin = ".$conf['disziplin']." AND z.streckenlaenge = '".$conf['laenge']."' AND
                      ".$jahrgang." AND
                      m.ausgetreten IS NULL AND z.mitgliedid = m.id AND
                      (z.zeit < ".$zeitsort.") AND
                      (z.datum > DATE_SUB('".$conf['wkdatum']."',INTERVAL ".$conf['maxzeitalter']." MONTH)) AND
                      z.wettkampfid = w.id AND z.wettkampfid != 2 AND z.bestenliste = 1
                    ORDER BY name, zeit DESC";
        $this->db->holeDaten($query);
        if($this->db->ergebnis['anzahl'] < 1){
        	continue;
        }
        foreach($this->db->ergebnis['daten'] as $row){
        	$mitglieder[$row['mid']] = $row;
        }
    }
    # Mitglieder nach Name sortieren
    $tmp = array();
	foreach($mitglieder as $row){
    	$tmp[$row['mid']] = $row['name'];
    }
    asort($tmp);
    foreach($tmp as $mid => $name){
    	$tmp[$mid] = $mitglieder[$mid];
    }
    $mitglieder = $tmp;
    # und raus damit
    return $mitglieder;
}

function generiereMeldezettel($wettkampfid, $mitgliederids = '', $_art = ''){
	require_once('class/pdf.inc.php');
    $pdf = new tkpdf();

    #### Konfiguration ####################################################################################################################
    $_mitglieder = false;
    if(is_array($mitgliederids) and count($mitgliederids)>0){
    	$_mitglieder = true;
    }
    $conf = array(
    	'schriftgroesse' => 12,
        'logo' => array(
        	'breite' => 0,
            'hoehe'  => 0
        ),
        'rand' => array(
        	'links'  => 60,
            'oben'   => 45,
            'unten'  => 55,
            'rechts' => 40
        ),
        'seite' => array(
        	'hoehe'  => 842,
            'breite' => 595
        )
    );
    $_logo = false;
    if(file_exists(PFAD_INCLUDE.'export/bilder/meldezettel_logo.png')){
    	$tmp = getImageSize(PFAD_INCLUDE.'export/bilder/meldezettel_logo.png');
        $conf['logo']['breite'] = round($tmp[0]/1.5);
        $conf['logo']['hoehe']  = round($tmp[1]/1.5);
        $_logo = true;
    }
    $conf['punkte'] = array(
    	'kopf' => array( # Kopfkasten, Ecke links oben
            'x' => $_logo?$conf['rand']['links']+$conf['logo']['breite']+30:$conf['rand']['links'],
        	'y' => $conf['seite']['hoehe']-$conf['rand']['oben']-5
        ),
        'ruecklauf' => array( # Ruecklaufzettel, Ecke oben links
        	'x' => $conf['rand']['links'],
            'y' => 270
        )
    );
    $conf['rueckwaerts'] = isset($_POST['optionen']['rueckwaerts'])?true:false;
    $conf['zeilenabstand'] = $conf['schriftgroesse']+3;
    $tmp = parse_ini_file(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],true);
    $conf['ini'] = $tmp['meldezettel'];
    $conf['wettkampftitel'] = $tmp['wettkampfdaten']['titel'];

    # Flags
    if(isset($conf['ini']['flags'])){
        if(strpos($conf['ini']['flags'],';')!==false){
            $flags = explode(';',$conf['ini']['flags']);
        }
        else{
            $flags = array($conf['ini']['flags']);
        }
        $conf['ini']['flags'] = $flags;
    }
    else{
    	$conf['ini']['flags'] = array();
    }
    $conf['autor'] = $_SESSION['user']['realname'];
    $conf['texte'] = $this->conf['gleinst']['wettkaempfe_abwickeln_meldezettel'];
    /*
    $conf['texte'] = array(
    	# Texte zum Ersetzen der Schluesselwoerter
        'keinewertsachen'     => 'Bitte keine Wertsachen mitnehmen!',
        'rueckmeldezettelbis' => 'Bitte bis sptestens %s die Rckmeldezettel bei euren Trainern abgeben.',
        'beinichtteilnahme'   => 'Bei Nichtteilnahme sofort bei %s abmelden!',
        'staffelwarnung'      => '<b>Achtung:</b> Du kannst auch noch in der Staffel eingesetzt werden.',
        'freibadhinweis'      => '<i>Hinweis:</i> der Wettkampf findet in einem Freibad statt, nimm deswegen bei schlechtem Wetter'.
                                 ' einen Trainingsanzug o.. und Wechselsachen mit.',
        'gemeinsamefahrt'     => 'Wir treffen uns alle am Palm Beach und fahren gemeinsam %s, nach'.
                                 ' dem Wettkampf fahren wir wieder gemeinsam zurck zum Palm Beach.',
        'dmsjhinweis'         => 'Bedenke bitte, dass die DMS-J ein Mannschaftswettkampf ist (d.h. es gibt nur Staffeln) -'.
                                 ' wenn du also gemeldet bist, komme bitte auch, da sonst u.U. die ganze Mannschaft nicht starten kann!',
        'meldegeldhinweis'    => 'Das Meldegeld von %sEUR pro Start zahlt der Verein. Bei unentschuldigtem Fehlen msst ihr'.
                                 ' die Kosten selbst tragen!',
        # sonstige Texte
        'unterschriftstext'  => 'Ich besttige hiermit, dass mein Kind die Sportgesundheit durch ein rztliches Zeugnis nachweisen kann.',
        'freieplaetze'        => 'ich fahre selbst vom Palm Beach zum Schwimmbad und habe noch ___ Pltze frei',
        'mitfahrgelegenheit'  => 'ich bentige noch eine Mitfahrgelegenheit'
    );
    */
    # Meldegeld, Sonstiges
    $query = "SELECT meldegeld FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$wettkampfid."";
    $this->db->holeDaten($query);
    $mgld = $this->parseMeldegeld($this->db->holeWert(),'db','array');
    $conf['meldegeld'] = $mgld['einzel'];
    # Mitglieder mit Staffelhinweisen
    if(isset($conf['ini']['staffelmitglieder']) and !empty($conf['ini']['staffelmitglieder'])){
    	$conf['ini']['staffelmitglieder'] = explode(',',$conf['ini']['staffelmitglieder']);
    }

    ### Mitgliederdaten holen #############################################################################################################
	if($_mitglieder){
        $query = "SELECT id, nachname, vorname, YEAR(gebdatum) as jg FROM ".DB_PREFIX."mitglieder
                    WHERE id IN (".implode(',',$mitgliederids).")
                    ORDER BY nachname ".($conf['rueckwaerts']?'DESC':'ASC').", vorname ".($conf['rueckwaerts']?'DESC':'ASC')."";
        $this->db->holeDaten($query);
        $mitglieder = array();
        foreach($this->db->ergebnis['daten'] as $m){
            $mitglieder[$m['id']] = $m;
            $mitglieder[$m['id']]['_wks'] = array();
        }
        # Wettkampfids fuer die Mitglieder
        $query = "SELECT mid, wkid FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."wks as w
                    WHERE ms.teilnehmerid = mt.id AND mid IN (".implode(',',$mitgliederids).") AND
                      w.id = ms.wkid AND mt.wettkampfid = ".$wettkampfid."
                    ORDER BY mid, w.wknr";
        $this->db->holeDaten($query);
        foreach($this->db->ergebnis['daten'] as $row){
            $mitglieder[$row['mid']]['_wks'][] = $row['wkid'];
        }
        $wkids = $this->db->baueArray('wkid');
        $wkids = array_unique($wkids);
    }
    else{
    	$mitglieder = array(1); # damit die Mitgliederschleife genau einmal durchlaufen wird
    }

    ### Abschnit- und Wettkampfdaten ######################################################################################################
    $query = "SELECT nr, DATE_FORMAT(datum,'%e.%c.') as datum, IF(DATE_FORMAT(datum,'%w')=0,7,DATE_FORMAT(datum,'%w')) as wtag
                FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$wettkampfid." ORDER BY nr";
    $this->db->holeDaten($query);
    $abschnitte = array();
    foreach($this->db->ergebnis['daten'] as $row){
        $abschnitte[$row['nr']] = $row;
        $abschnitte[$row['nr']]['_wks'] = array();
    }
    if($_mitglieder and count($wkids) > 0){
        # Wettkampfdaten
        $query = "SELECT w.id, wknr, laenge, disziplin, a.nr FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
                    WHERE w.id IN (".implode(',',$wkids).") AND a.id = w.abschnittid ORDER BY wknr";
        $this->db->holeDaten($query);
        foreach($this->db->ergebnis['daten'] as $row){
            $abschnitte[$row['nr']]['_wks'][$row['id']] = $row;
        }
    }
    # Anzahl der Tage / Abschnitte pro Tag
    $query = "SELECT IF(DATE_FORMAT(datum,'%w')=0,7,DATE_FORMAT(datum,'%w')) as wtag,COUNT(datum) as anz
                FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$wettkampfid."
                GROUP BY wtag ORDER BY wtag";
    $this->db->holeDaten($query);
    $tageszahl = $this->db->baueArray('anz','wtag');
    # Wettkampftermin(e)
    $query = "SELECT DATE_FORMAT(datum,'%d.%m.%Y') as datum, COUNT(datum) as anzahl,
                IF(DATE_FORMAT(datum,'%w')=0,7,DATE_FORMAT(datum,'%w')) as wt
                FROM ".DB_PREFIX."abschnitte
                WHERE wettkampfid = ".$wettkampfid."
                GROUP BY datum ORDER BY ".DB_PREFIX."abschnitte.datum";
    $this->db->holeDaten($query);
    $conf['wettkampf']['termine'] = $this->db->ergebnis['daten'];

    ### Seiten zusammbenbauen #############################################################################################################
    $erste = true;
    foreach($mitglieder as $m){
        if(!$erste){ $pdf->newPage(); }else{ $erste = false; }# Hack fuer das korrekte Einsetzen einer neuen Seite

        # Kopf
          # Name rechts oben
        if($_mitglieder){
        	$name = $m['nachname'].', '.$m['vorname'];
        	$breite = $pdf->tkgetTextWidth($conf['schriftgroesse']-3, $name)+7;
        	$pdf->addText($conf['seite']['breite']-$breite-20, $conf['seite']['hoehe']-($conf['schriftgroesse']-3)-18, $conf['schriftgroesse']-3, $name);
        }
          # Logo
        if($_logo){
        	$pdf->addPngFromFile(
        	    PFAD_INCLUDE.'export/bilder/meldezettel_logo.png',
        	    $conf['rand']['links'], $conf['seite']['hoehe']-($conf['rand']['oben']+$conf['logo']['hoehe']),
        	    $conf['logo']['breite'], $conf['logo']['hoehe']
        	);
        }
          # Titel
        $verfbreite = $conf['seite']['breite']-$conf['punkte']['kopf']['x']-$conf['rand']['rechts'];
        $schriftgroesse = $conf['schriftgroesse']+6;
        $titel = $conf['wettkampftitel'];
        $textbreite = $pdf->tkgetTextWidth($schriftgroesse,$titel);
        while($textbreite > $verfbreite){
            $schriftgroesse--;
        	$textbreite = $pdf->tkgetTextWidth($schriftgroesse,$titel);
        }
        $titel = $pdf->addText($conf['punkte']['kopf']['x'], $conf['punkte']['kopf']['y']-$schriftgroesse, $schriftgroesse, $titel);
          # Termin
        $y = $conf['punkte']['kopf']['y']-($conf['schriftgroesse']+30);
        $pdf->addText($conf['punkte']['kopf']['x'],$y,$conf['schriftgroesse'],'Termin:');
        $termine = array();
        foreach($conf['wettkampf']['termine'] as $t){
        	if(count($tageszahl) > 2){ # bei mehr als zwei Tagen Wochentagkurzform verwenden
            	$termine[] = substr($this->conf['wochentage'][$t['wt']],0,2).' '.$t['datum'];
            }
            else{
            	$termine[] = $this->conf['wochentage'][$t['wt']].', '.$t['datum'];
            }
        }
        $termin = '';
        $anz = count($termine);
        for($i=0;$i<$anz;$i++){
            if($i == $anz-1){ # letzter
                $termin .= '<b>'.$termine[$i].'</b>';
            }
            elseif($i == $anz-2){ # vorletzter
                $termin .= '<b>'.substr($termine[$i],0,-4).'</b>';
                $termin .= ' und ';
            }
            else{
                $termin .= '<b>'.substr($termine[$i],0,-4).'</b>';
                $termin .= ', ';
            }
        }
        $pdf->addText($conf['punkte']['kopf']['x']+50, $y, $conf['schriftgroesse'], $termin);
          # Ort
        $y -= $conf['zeilenabstand'];
        $pdf->addText($conf['punkte']['kopf']['x'],$y,$conf['schriftgroesse'],'Ort:');
        $verfbreite = $conf['seite']['breite']-($conf['punkte']['kopf']['x']+50)-$conf['rand']['rechts'];
        $ort = $conf['ini']['ort'];
        while($ort !=''){
            $ort = $pdf->addTextWrap($conf['punkte']['kopf']['x']+50, $y, $verfbreite, $conf['schriftgroesse'], $ort);
        	$y -= $conf['zeilenabstand'];
        }
          # Einlass
        $pdf->addText($conf['punkte']['kopf']['x'],$y,$conf['schriftgroesse'],'Einlass:');
        $einlass = $conf['ini']['einlass'];
        if(strpos($einlass,'|')===false){
            $pdf->addText($conf['punkte']['kopf']['x']+50, $y, $conf['schriftgroesse'], $einlass.' Uhr');
        }
        else{
            $teile = explode('|',$einlass);
            $tmp_e = array();
            foreach($teile as $t){
                list($wtag,$zeit) = explode(';',$t);
                $tmp_e[] = $wtag.': '.$zeit.(count($tageszahl)>2?'':' Uhr'); # bei mehr als zwei Tagen 'Uhr' weglassen
            }
            $pdf->addText($conf['punkte']['kopf']['x']+50, $y, $conf['schriftgroesse'], implode(', ',$tmp_e).(count($tageszahl)>2?' Uhr':''));
        }
          # Beginn
        $y -= $conf['zeilenabstand'];
        $pdf->addText($conf['punkte']['kopf']['x'],$y,$conf['schriftgroesse'],'Beginn:');
        $beginn = $conf['ini']['beginn'];
        if(strpos($beginn,'|')===false){
            $pdf->addText($conf['punkte']['kopf']['x']+50, $y, $conf['schriftgroesse'], $beginn.' Uhr');
        }
        else{
            $teile = explode('|',$beginn);
            $tmp_b = array();
            foreach($teile as $t){
                list($wtag, $zeit) = explode(';',$t);
                $tmp_b[] = $wtag.': '.$zeit.(count($tageszahl)>2?'':' Uhr'); # bei mehr als zwei Tagen 'Uhr' weglassen
            }
            $pdf->addText($conf['punkte']['kopf']['x']+50, $y, $conf['schriftgroesse'], implode(', ',$tmp_b).(count($tageszahl)>2?' Uhr':''));
        }
          # Treffpunkte
        foreach($conf['ini'] as $key => $wert){
            if(substr($key,0,10) != 'treffpunkt'){
                continue;
            }
        	$y -= $conf['zeilenabstand'];
            list($wtag,$_inh) = explode('|',$wert,2);
            $_inh = '<b>'.$_inh.'</b>';
            $mehr = (count($tageszahl)>1)?true:false; # mehrere Tage?
            $pdf->addText($conf['punkte']['kopf']['x'],$y,$conf['schriftgroesse'],'Treffpunkt '.substr($key,11).'. Abschnitt'.($mehr?' ('.$wtag.')':'').':');
            if($mehr){
            	$verfbreite = $conf['seite']['breite']-($conf['punkte']['kopf']['x']+155)-$conf['rand']['rechts'];
            	$_inh = $pdf->addTextWrap($conf['punkte']['kopf']['x']+155,$y,$verfbreite,$conf['schriftgroesse'],$_inh);
            	$verfbreite += 115;
            }
            else{
            	$verfbreite = $conf['seite']['breite']-($conf['punkte']['kopf']['x']+125)-$conf['rand']['rechts'];
            	$_inh = $pdf->addTextWrap($conf['punkte']['kopf']['x']+125,$y,$verfbreite,$conf['schriftgroesse'],$_inh);
            	$verfbreite += 85;
            }
            while($_inh !=''){
        		$y -= $conf['zeilenabstand'];
                $_inh = $pdf->addTextWrap($conf['punkte']['kopf']['x']+40,$y,$verfbreite,$conf['schriftgroesse'],$_inh);
            }
        }
        $y -= $conf['zeilenabstand']*2;
        if($y>$conf['seite']['hoehe']-$conf['logo']['hoehe']-$conf['rand']['oben']-20){ # $y hochsetzen falls zu klein
			$y = ($conf['seite']['hoehe']-$conf['logo']['hoehe']-$conf['rand']['oben'])-20;
        }

        # Hauptteil
          # Anrede
        if($_mitglieder){
        	$pdf->addText($conf['rand']['links'],$y,$conf['schriftgroesse'],'Hallo '.$m['vorname'].', du schwimmst folgende Strecken:');
        }
        else{
        	$pdf->addText($conf['rand']['links'],$y,$conf['schriftgroesse'],'Hallo ');
            $pdf->setLineStyle(1,'round','',array(0,5));
            $pdf->line($conf['rand']['links']+33, $y, $conf['rand']['links']+200, $y);
            $pdf->addText($conf['rand']['links']+203,$y,$conf['schriftgroesse'],', du schwimmst folgende Strecken:');
        }
        $y -= $conf['zeilenabstand']*1.5;

          # Strecken
        $pdf->setLineStyle(1,'round','',array(0,5));
		$kurz = array();
        if(count($tageszahl)==1){ # nur ein Tag
        	$y = $y-($conf['schriftgroesse']+3);
        	foreach($abschnitte as $abschn){
            	$punktelinks = 0;
            	if(count($abschnitte)>1){
                    $punktelinks = 70;
                	$pdf->addText($conf['rand']['links'],$y,$conf['schriftgroesse'],$abschn['nr'].'. Abschnitt:');
                }
                $pdf->line($conf['rand']['links']+$punktelinks, $y-1, $conf['seite']['breite']-$conf['rand']['rechts'], $y-1);
        		$y -= $conf['zeilenabstand']*1.8;
                $pdf->line($conf['rand']['links'], $y-1, $conf['seite']['breite']-$conf['rand']['rechts'], $y-1);
        		$y -= $conf['zeilenabstand']*1.8;
                if($_mitglieder){
                	# Wettkaempfe sammeln
                    $tmp = array();
                    foreach($m['_wks'] as $w){
                        if(in_array($w,array_keys($abschn['_wks']))){
                            $wettk = $abschn['_wks'][$w];
                            $tmp[] = '<b>'.$wettk['laenge'].' '.$this->conf['lagen'][$wettk['disziplin']] .'</b> (WK: '.$wettk['wknr'].')';
                            $kurz[] = $wettk['laenge'].substr($this->conf['lagen'][$wettk['disziplin']],0,1).'-'.$abschn['nr'].'/'.$wettk['wknr'];
                        }
                    }
                    $wettkaempfe = implode(', ',$tmp);
                    $verfbreite = $conf['seite']['breite']-$conf['rand']['rechts']-$conf['rand']['links']-$punktelinks;
        			$y += $conf['zeilenabstand']*3.6;
                    $wettkaempfe = $pdf->addTextWrap($conf['rand']['links']+$punktelinks, $y, $verfbreite, $conf['schriftgroesse'], $wettkaempfe);
                    while($wettkaempfe !=''){
        				$y -= $conf['zeilenabstand']*1.8;
                    	$wettkaempfe = $pdf->addTextWrap($conf['rand']['links']+10, $y, $verfbreite, $conf['schriftgroesse'], $wettkaempfe);
        				$y += $conf['zeilenabstand']*1.8;
                    }
        			$y -= $conf['zeilenabstand']*3.6;
                }
            }
            if($_mitglieder){
                # Zusammenfassung unten auf dem Ruecklaufzettel
                $kurzfassung = implode(',',$kurz);
                $breite = $pdf->tkgetTextWidth($conf['schriftgroesse']-5,$kurzfassung)+7;
                $pdf->addText($conf['seite']['breite']-$breite-20, 18, $conf['schriftgroesse']-5, $kurzfassung);
            }
        }
        elseif(count($tageszahl)>1){ # mehrere Tage
            $aktuell = '';
            foreach($abschnitte as $abschn){
                if($aktuell != $abschn['datum']){
                    $aktuell = $abschn['datum'];
                    $pdf->addText($conf['rand']['links'],$y,$conf['schriftgroesse'],$this->conf['wochentage'][$abschn['wtag']].', '.$abschn['datum'].':');
                    $y = $y-($conf['schriftgroesse']+3);
                }
                $pdf->addText($conf['rand']['links']+15,$y,$conf['schriftgroesse'],$abschn['nr'].'. Abschnitt:');
                $pdf->line($conf['rand']['links']+85, $y-1, $conf['seite']['breite']-$conf['rand']['rechts'], $y-1);

                if($_mitglieder){
                    # Wettkaempfe sammeln
                    $tmp = array();
                    foreach($m['_wks'] as $w){
                        if(in_array($w,array_keys($abschn['_wks']))){
                            $wettk = $abschn['_wks'][$w];
                            $tmp[] = '<b>'.$wettk['laenge'].' '.$this->conf['lagen'][$wettk['disziplin']] .'</b> (WK: '.$wettk['wknr'].')';
                            $kurz[] = $wettk['laenge'].substr($this->conf['lagen'][$wettk['disziplin']],0,1).'-'.$abschn['nr'].'/'.$wettk['wknr'];
                        }
                    }
                    $wettkaempfe = implode(', ',$tmp);
                    $verfbreite = $conf['seite']['breite']-$conf['rand']['rechts']-$conf['rand']['links']-85;
                    $wettkaempfe = $pdf->addTextWrap($conf['rand']['links']+85,$y,$verfbreite,$conf['schriftgroesse'],$wettkaempfe);
                    while($wettkaempfe !=''){
        				$y -= $conf['zeilenabstand'];
                        $wettkaempfe = $pdf->addTextWrap($conf['rand']['links']+85,$y,$verfbreite,$conf['schriftgroesse'],$wettkaempfe);
                        $pdf->line($conf['rand']['links']+85, $y-1, $conf['seite']['breite']-$conf['rand']['rechts'], $y-1);
        				$y += $conf['zeilenabstand'];
                    }
                }
        		$y -= $conf['zeilenabstand']*2;
            }

            if($_mitglieder){
            	# Zusammenfassung unten auf dem Ruecklaufzettel
            	$kurzfassung = implode(',',$kurz);
            	$breite = $pdf->tkgetTextWidth($conf['schriftgroesse']-5,$kurzfassung)+7;
            	$pdf->addText($conf['seite']['breite']-$breite-20, 18, $conf['schriftgroesse']-5, $kurzfassung);
            }
        }
        $y += $conf['zeilenabstand']*1.1;
        $pdf->setLineStyle(1,'','',array(1,0));

        # Hinweistexte
        $y -= $conf['zeilenabstand']*0.5;
        $verfbreite = $conf['seite']['breite']-$conf['rand']['links']-$conf['rand']['rechts'];
        $text = str_replace('[br]','',$conf['ini']['text']);
        $schluesselworte = array(
            'keinewertsachen',
            'rueckmeldezettelbis',
            'beinichtteilnahme',
            'staffelwarnung',
            'freibadhinweis',
            'gemeinsamefahrt',
            'dmsjhinweis',
            'meldegeldhinweis'
        );
        # Platzhalter ersetzen
        preg_match_all('~\{([a-z]+)(?:=([^}]+))?\}~',$text,$match);
        foreach($match[1] as $key => $schluesselwort){
        	if($schluesselwort == 'br'){
            	continue;
            }
            switch($schluesselwort){
            case 'rueckmeldezettelbis':
            	$text = str_replace($match[0][$key],sprintf($conf['texte']['rueckmeldezettelbis'],$conf['ini']['rueckgabebis']),$text);
                break;
            case 'beinichtteilnahme':
            	$dat = (strpos($conf['ini']['abmeldenbei'],'|')===false)?array():explode('|',$conf['ini']['abmeldenbei']);
                $abbei = array();
                foreach($dat as $b){
                    $abbei[] = explode(';',$b);
                }
                $abmeldenbei = '';
                $anz = count($abbei);
                $i = 1;
                foreach($abbei as $bei){
                    $abmeldenbei .= $bei[0]. ' (Tel: '.$bei[1].')';
                    if($i==$anz-1){
                        $abmeldenbei .= ' oder ';
                    }
                    elseif($i<$anz-1){
                        $abmeldenbei .= ', ';
                    }
                    $i++;
                }
                $text = str_replace($match[0][$key],sprintf($conf['texte']['beinichtteilnahme'],$abmeldenbei),$text);
                break;
            case 'gemeinsamefahrt':
            	$ort = empty($match[2][$key])?'zum Schwimmbad':'nach '.$match[2][$key];
                $text = str_replace($match[0][$key],sprintf($conf['texte']['gemeinsamefahrt'],$ort),$text);
                break;
            case 'meldegeldhinweis':
            	$text = str_replace($match[0][$key],sprintf($conf['texte']['meldegeldhinweis'],$conf['meldegeld']),$text);
            	break;
            case 'staffelwarnung':
            	$staffel = true;
                if(empty($match[2][$key])){
                    $match[2][$key] = 'einzelne';
                }
            	if(!$_mitglieder and $match[2][$key]=='einzelne'){ # bei leeren Zetteln nicht
                	$staffel = false;
                }
                if(!isset($conf['ini']['staffelmitglieder'])){
                	$conf['ini']['staffelmitglieder'] = array();
                }
                if($match[2][$key] == 'einzelne' and !in_array($m['id'],$conf['ini']['staffelmitglieder'])){
                	$staffel = false;
                }
                # keine Staffelwarnung einbauen -> Text, und {br} davor bzw. danach (wenn {stafffelwarnung ganz vorne steht) entfernen
                #   ({br} aber nur wenn br!=tab)
                if(!$staffel){
                	$entfernen = '';
                	if($key != 0 and $match[1][$key-1] == 'br' and $match[2][$key-1] != 'tab'){
                    	$entfernen .= $match[0][$key-1];
                    }
                    $entfernen .= $match[0][$key];
                    if($key == 0 and $match[1][$key+1] == 'br' and $match[2][$key+1] != 'tab'){
                        $entfernen .= $match[0][$key+1];
                    }
                    $text = str_replace($entfernen,'',$text);
                }
                else{
                    $text = str_replace($match[0][$key],$conf['texte']['staffelwarnung'],$text);
                }
            	break;
            default:
            	if(isset($conf['texte'][$schluesselwort])){
                	$text = str_replace($match[0][$key],$conf['texte'][$schluesselwort],$text);
                }
                break;
            }
        }
        # Texte und Zeilenumbrueche auftrennen
        $erg = preg_split('~\{br(?:=([^}]+))?\}~',$text,-1,PREG_SPLIT_OFFSET_CAPTURE);
        $texte = array();
        $pos = 0;#$laenge = 0;
        $laenge = strlen($text);
        $untenzeilen = 0;
        $unten = false;
        foreach($erg as $key => $t){
        	if($t[1] != 0){ # br vorhanden
            	$pos_anfang = $pos;
                $pos_ende = $erg[$key][1];
            	$br = substr($text,$pos_anfang,$pos_ende-$pos_anfang);
                $pos += strlen($br);
                if(strpos($br,'=')!==false){
                    $anz = str_replace(',','.',substr($br,4,-1));
                    if($anz == 'tab'){
                    	$unten = true;
                    }
                    if($anz != 'tab' and !preg_match('~^[0-9]+(\.[0-9]+)?$~D',$anz)){
                    	$anz = 1;
                    }
                    $wert = $anz;
                }
                else{
                	$wert = 1;
                    $anz = $wert;
                }
                if($unten and $anz != 'tab'){
                	$untenzeilen += $wert-1;
                }
                $texte[] = array('art'=>'br','wert'=>$wert);
            }
            if(!empty($t[0])){ # der Text ist leer
            	$texte[] = array('art'=>'text','wert'=>$t[0]);
                if($unten){
            		$breite = $pdf->tkgetTextWidth($conf['schriftgroesse'],$t[0]);
            		$untenzeilen += ceil($breite/$verfbreite);
                }
            	$pos += strlen($t[0]);
            }
        }
        # Texte schreiben
        foreach($texte as $eintrag){

        	if($eintrag['art'] == 'text'){
            	$text = $eintrag['wert'];
            	while($text != ''){
            	    $text = $pdf->addTextWrap($conf['rand']['links'],$y,$verfbreite,$conf['schriftgroesse'],$text);
                    if(!empty($text)){
            	    	$y -= $conf['zeilenabstand'];
                    }
            	}
            }
        	if($eintrag['art'] == 'br'){
                if($eintrag['wert'] == 'tab'){
            		$y = ($conf['zeilenabstand']*($untenzeilen-1))+$conf['punkte']['ruecklauf']['y']+10;
                }
                else{
            		$y -= $conf['zeilenabstand']*$eintrag['wert'];
                }
            }
        }

        # Ruecklaufzettel
          # Trennlinie
        $pdf->addPngFromFile(PFAD_INCLUDE.'export/bilder/schere.png', $conf['punkte']['ruecklauf']['x']-32, $conf['punkte']['ruecklauf']['y']-6.5, 15);
        $pdf->setLineStyle(1,'','',array(5));
        $pdf->line($conf['punkte']['ruecklauf']['x']-20, $conf['punkte']['ruecklauf']['y'],
            $conf['seite']['breite']-$conf['rand']['rechts']+13, $conf['punkte']['ruecklauf']['y']);
          # Ueberschrift
        $y = $conf['punkte']['ruecklauf']['y']-20;
        $ueberschrift = 'Rckmeldung fr '.$conf['ini']['rueckmeldungfuer'];
        $pdf->addText($conf['rand']['links'],$y,$conf['schriftgroesse']+2,$ueberschrift);
        $y -= $conf['zeilenabstand']*1.5;
          # Ankreuzkaestchen
        $pdf->addText($conf['rand']['links'],$y,$conf['schriftgroesse'],'Mein Kind nimmt am Wettkampf teil:');
        $anz = count($tageszahl);
        if($anz == 1 or in_array('teilnahmenurjanein',$conf['ini']['flags'])){ # ein Tag -> ja+nein
            $pdf->tksquare(320,$y-2,12);
            $pdf->addText(338,$y,$conf['schriftgroesse'],'ja');
            $pdf->tksquare(400,$y-2,12);
            $pdf->addText(418,$y,$conf['schriftgroesse'],'nein');
        }
        else{ # mehrere Tage -> ja alle+nein+fuer jeden Tag ein ja
            $text = 'ja, '.($anz==2?'beide':'alle').' Tage';
            $pdf->tksquare(280, $y-2, 13);
            $pdf->addText(300, $y, $conf['schriftgroesse'], $text);
            $pdf->tksquare(280, $y-$conf['zeilenabstand']*1.4-2, 12);
            $pdf->addText(300, $y-$conf['zeilenabstand']*1.4, $conf['schriftgroesse'], 'nein');
            ksort($tageszahl);
            $i = 0;
            $text = 'ja, '.($anz==2?'nur':'').' ';
            foreach($tageszahl as $key => $tag){
                $pdf->tksquare(400,$y-$conf['zeilenabstand']*1.4*$i-2,12);
                $pdf->addText(420,$y-$conf['zeilenabstand']*1.4*$i,$conf['schriftgroesse'],$text.$this->conf['wochentage'][$key]);
                $i++;
            }
        }

		$at = isset($conf['sonstiges']['alternativtreffpunkt'])?$conf['sonstiges']['alternativtreffpunkt']:'';
        $y -= ($conf['zeilenabstand']+2)*(!empty($at)?2:3)+2;

        if(!in_array('keinefahrtkaestchen',$conf['ini']['flags'])){
              # Mitfahrgelegenheiten
            $pdf->tksquare($conf['rand']['links'], $y-2, 12);
            $pdf->addText($conf['rand']['links']+17, $y, $conf['schriftgroesse'], $conf['texte']['freieplaetze']);
            $y -= $conf['zeilenabstand'];
            if(!empty($at)){
                $links = $conf['rand']['links']+17*2;
                $pdf->addText($links, $y, $conf['schriftgroesse'], 'ich komme zum Treffpunkt:');
                $pdf->addPngFromFile(PFAD_INCLUDE.'export/bilder/pfeil.png', $links-8, $y, 4.5);
                $breite = $pdf->tkgetTextWidth($conf['schriftgroesse'], 'ich komme zum Treffpunkt: ');
                $links += $breite+8;
                $punkte = explode(',',$at);
                $pdf->tksquare($links, $y-2, 12);
                $links += 15;
                $pdf->addText($links, $y, $conf['schriftgroesse'], trim($punkte[0]));
                $breite = $pdf->tkgetTextWidth($conf['schriftgroesse'], trim($punkte[0]));
                $links += $breite+13;
                $pdf->tksquare($links, $y-2, 12);
                $links += 15;
                $pdf->addText($links, $y, $conf['schriftgroesse'], trim($punkte[1]));
                $y -= $conf['zeilenabstand']+2;
            }
            $pdf->tksquare($conf['rand']['links'], $y-2, 12);
            $pdf->addText($conf['rand']['links']+17, $y, $conf['schriftgroesse'], $conf['texte']['mitfahrgelegenheit']);
            $y -= $conf['zeilenabstand']*2.3;
        }
        else{
            $y -= $conf['zeilenabstand']*3.3;
        }
          # Name/Jahrgang
        $pdf->setLineStyle(1,'round','',array(0,5));
        $pdf->addText($conf['rand']['links'], $y, $conf['schriftgroesse'], 'Name:');
        $pdf->line(100,$y-1,420,$y-1);
        $pdf->addText(430, $y, $conf['schriftgroesse'], 'Jahrgang:');
        $pdf->line(488,$y-1,540,$y-1);
        if($_mitglieder){
        	$pdf->addText(110, $y, $conf['schriftgroesse'], $m['vorname'].' '.$m['nachname']);
       		$pdf->addText(495, $y, $conf['schriftgroesse'], $m['jg']);
        }
        $y -= $conf['zeilenabstand']*1.7;
          # Bestaetigung
        $verfbreite = $conf['seite']['breite']-$conf['rand']['links']-$conf['rand']['rechts'];
        $bestaetigung = $conf['texte']['unterschriftstext'];
        while($bestaetigung != ''){
            $bestaetigung = $pdf->addTextWrap($conf['rand']['links'],$y,$verfbreite,$conf['schriftgroesse'],$bestaetigung);
        	$y -= $conf['zeilenabstand'];
        }
          # Unterschrift der Eltern/Tel
        $y -= $conf['zeilenabstand']*0.5;
        $pdf->addText($conf['rand']['links'], $y, $conf['schriftgroesse'], 'Unterschrift der Eltern:');
        $pdf->line(184,$y-1,420,$y-1);
        $pdf->addText(430, $y, $conf['schriftgroesse'], 'Tel:');
        $pdf->line(455,$y-1,540,$y-1);
    } # Ende der Mitgliederschleife
    $pdf->tk_autor = $conf['autor'];
    $pdf->tk_titel = 'Meldezettel fr '.$conf['ini']['rueckmeldungfuer'];

    if(((isset($_GET['ziel']) and $_GET['ziel']=='dateisystem') or (isset($_POST['ziel']) and $_POST['ziel']=='dateisystem')) and isset($_SESSION['wk_abwickeln']['verzeichnisid'])){
    	require_once('class/dateien.inc.php');
        $dat = new dateien($this->db,$this->tmpl);
        $dateiname = 'meldezettel_'.($_mitglieder?'ausgefuellt':'leer').'.pdf';
    	$daten = $pdf->tkstream($dateiname,'rueckgabe');
        if($dat->legeDateiInWettkampfvereichnisAn($_SESSION['wk_abwickeln']['verzeichnisid'], $dateiname, 'pdf', $daten, ($_mitglieder?'ausgefuellter':'leerer').' Meldezettel',false)){
            weiterleiten('/wettkaempfe/abwickeln.html'.($_mitglieder?'?aktion=pdf_meldezettelgenerieren':''),'der/die Meldezettel wurde(n) im Dateisystem abgelegt');
        }
    }
    $pdf->tkstream('meldezettel_'.($_mitglieder?'ausgefuellt':'leer').'.pdf');
}

function holeWettkampfjahrgaenge($wkid, $wkdatum = ''){
	$jahrgaenge = array();
    if($wkdatum == ''){
		$query = "SELECT YEAR(datum) as jahr FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$wkid."";
		$this->db->holeDaten($query);
		$this->wettkampfjahr = $this->db->holeWert();
    }
	else{
		$this->wettkampfjahr = substr($wkdatum,0,4);
	}
    $einst = $this->conf['altersklassen'];

	# Jahrgaenge holen
	$query = "SELECT DISTINCT jahrgang FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
	            WHERE a.id = w.abschnittid AND a.wettkampfid = ".$wkid." AND
                  SUBSTRING(w.laenge,2,1) != 'x' AND SUBSTRING(w.laenge,3,1) != 'x'
				ORDER BY jahrgang";
	$this->db->holeDaten($query);
	$tmp_jahrg = $this->db->baueArray('jahrgang','#');
	$jahrg = array();
	foreach($tmp_jahrg as $jg){
        # Array aus Variable machen und Leerzeichen entfernen
        if(strpos($jg,',') === false){
            $jahrg[] = trim($jg);
        }
        else{
            $tmp = explode(',',$jg);
			foreach($tmp as $t){
				$jahrg[] = $t;
			}
        }
	}
    $jahrg = array_map('trim',$jahrg);
    if(in_array('*',$jahrg) or in_array('ak95-',$jahrg)){
	    # bei * und ak95- gleich den kompletten Zeitraum zurueckgeben
    	return range($this->wettkampfjahr-140, $this->wettkampfjahr);
    }

	foreach($jahrg as $jg){
		$tmp = array();
		if(preg_match('~^[0-9+-]+$~',$jg)){ # nur Jahrgaenge
			if(substr($jg,-1) == '-'){ # 1991-
				$tmp = range(substr($jg,0,-1), $this->wettkampfjahr);
			}
			elseif(substr($jg,-1) == '+'){ # 1991+
				$tmp = range($this->wettkampfjahr-140, substr($jg,0,-1));
			}
            elseif(strpos($jg,'-') !== false){ # 1988-1991
            	list($anfang,$ende) = explode('-',$jg);
                if($anfang > $ende){
                	$tmp = $anfang;
                    $anfang = $ende;
                    $ende = $tmp;
                }
				$tmp = range($anfang, $ende);
            }
			else{ # 1991
				$tmp[] = $jg;
			}
		}
		else{ # akXX und jX
			if(substr($jg,-1) == '-'){ # akXX-
				$jgs = $this->_altersklasse2jahrgaenge(substr($jg,0,-1));
                $min = is_array($jgs)?min($jgs):$jgs;
				$tmp = range($min, $this->wettkampfjahr);
			}
			elseif(substr($jg,-1) == '+'){ # akxx+
				$jgs = $this->_altersklasse2jahrgaenge(substr($jg,0,-1));
                $max = is_array($jgs)?max($jgs):$jgs;
				$tmp = range($max, $this->wettkampfjahr-140);
			}
            elseif(strpos($jg,'-') !== false){ # akXX-akYY
            	list($anfang,$ende) = explode('-',$jg);
				$jgs_a = $this->_altersklasse2jahrgaenge($anfang);
				$jgs_e = $this->_altersklasse2jahrgaenge($ende);
				$jgs = array_merge($jgs_a, $jgs_e);
                $max = max($jgs);
                $min = min($jgs);
				$tmp = range($min, $max);
            }
			else{ # akXX
				$tmp = $this->_altersklasse2jahrgaenge($jg);
			}
		}
        if(count($tmp) == 0){
        	continue;
        }
		foreach($tmp as $t){
			$jahrgaenge[] = $t;
		}
	}
	$jahrgaenge = array_unique($jahrgaenge);
    sort($jahrgaenge);
	return $jahrgaenge;
}

function jahrg2query($jahrg,$wettkampfjahr='heute',$datumfeld = 'm.gebdatum'){
	if($wettkampfjahr == 'heute'){
    	$wettkampfjahr = date('Y');
    }
    $einst = $this->conf['altersklassen'];
	# Array aus Variable machen und Leerzeichen entfernen
    $tmp = $jahrg;
	if(strpos($tmp,',') === false){
    	$jahrg = array(trim($tmp));
    }
    else{
    	$jahrg = explode(',',$jahrg);
        $jahrg = array_map('trim',$jahrg);
    }
    if(in_array('*',$jahrg)){ # bei * gleich 1 zurueckgeben
		return '1';
    }

    $or = array();
    foreach($jahrg as $jg){
    	if(preg_match('~^(?:([0-9]{4})\s*(-)\s*([0-9]{4}))|(?:([0-9]{4})(-|\+)?)$~',$jg,$match)){ # Jahrgaenge
            unset($match[0]);
			if(isset($match[5]) and $match[5] == '+'){ # Jahrgang+
            	$or[] = "YEAR(".$datumfeld.") <= ".$match[4];
            }
			elseif(isset($match[5]) and $match[5] == '-'){ # Jahrgang-
            	$or[] = "YEAR(".$datumfeld.") >= ".$match[4];
            }
			elseif(isset($match[4]) and !isset($match[5])){ # Jahrgang
            	$or[] = "YEAR(".$datumfeld.") = ".$match[4];
            }
            else{ # Jahrgang-Jahrgang
            	$tmp = array($match[1],$match[3]);
            	$von = min($tmp);
            	$bis = max($tmp);
            	$or[] = "YEAR(".$datumfeld.") BETWEEN ".$von." AND ".$bis;
            }
        }
        elseif(preg_match('~^(?:(ak[2-9][05])\s*(-)\s*(ak[2-9][05]))|(?:(ak[2-9][05])(-|\+)?)$~',$jg,$match)){ # AK
            unset($match[0]);
            if(isset($match[5]) and $match[5] == '+'){ # AK+
                if($match[4] == 'ak95'){
                    $or[] = "YEAR(".$datumfeld.") <= ".($wettkampfjahr-95);
                    continue;
                }
                $alter = explode(',',$einst[$match[4]]);
                $alter = $alter[0];
                $or[] = "YEAR(".$datumfeld.") <= ".($wettkampfjahr-$alter);
            }
            elseif(isset($match[5]) and $match[5] == '-'){ # AK-
                if($match[4] == 'ak95'){
                    return '1'; # AK95- entspricht *
                    continue;
                }
                $alter = explode(',',$einst[$match[4]]);
                $alter = $alter[4];
                $or[] = "YEAR(".$datumfeld.") >= ".($wettkampfjahr-$alter);
            }
            elseif(isset($match[4]) and !isset($match[5])){ # AK
                if($match[4] == 'ak95'){
                    $or[] = "YEAR(".$datumfeld.") <= ".($wettkampfjahr-95);
                    continue;
                }
                $alter = explode(',',$einst[$match[4]]);
                foreach($alter as $key => $a){
                    $alter[$key] = $wettkampfjahr-$a;
                }
                $or[] = "YEAR(".$datumfeld.") IN (".implode(',',$alter).")";
            }
            else{ # AK-AK
                $tmp = array($match[1],$match[3]);
                rsort($tmp);
                if($tmp[0] == 'ak95'){
                    $alter = explode(',',$einst[$tmp[1]]);
                    $or[] = "YEAR(".$datumfeld.") <= ".($wettkampfjahr-$alter[0]);
                    continue;
                }
                $alter1 = explode(',',$einst[$tmp[0]]);
                $alter1 = $alter1[4];
                $alter2 = explode(',',$einst[$tmp[1]]);
                $alter2 = $alter2[0];
                $or[] = "YEAR(".$datumfeld.") BETWEEN ".($wettkampfjahr-$alter1)." AND ".($wettkampfjahr-$alter2);
            }
        }
    	elseif(preg_match('~^(?:([0-9]{1,2})\s*(-)\s*([0-9]{1,2}))|(?:([0-9]{1,2})(-|\+)?)$~',$jg,$match)){ # Altersangaben
            unset($match[0]);
			if(isset($match[5]) and $match[5] == '+'){ # Alter+
            	$or[] = $wettkampfjahr."-YEAR(".$datumfeld.") >= ".$match[4];
            }
			elseif(isset($match[5]) and $match[5] == '-'){ # Alter-
            	$or[] = $wettkampfjahr."-YEAR(".$datumfeld.") <= ".$match[4];
            }
			elseif(isset($match[4]) and !isset($match[5])){ # Alter
            	$or[] = $wettkampfjahr."-YEAR(".$datumfeld.") = ".$match[4];
            }
            else{ # Alter-Alter
            	$tmp = array($match[1],$match[3]);
            	$von = min($tmp);
            	$bis = max($tmp);
            	$or[] = $wettkampfjahr."-YEAR(".$datumfeld.") BETWEEN ".$von." AND ".$bis;
            }
        }
        elseif(preg_match('~^(?:(j[a-e]|junioren)\s*(-)\s*(j[a-e]|junioren))|(?:(j[a-e]|junioren)(-|\+)?)$~',$jg,$match)){ # Jugend
            unset($match[0]);
			if(isset($match[5]) and $match[5] == '+'){ # Jugend+
            	$alter = explode(',',$einst[$match[4]]);
                $alter = $alter[0];
            	$or[] = "YEAR(".$datumfeld.") <= ".($wettkampfjahr-$alter);
            }
			elseif(isset($match[5]) and $match[5] == '-'){ # Jugend-
            	$alter = explode(',',$einst[$match[4]]);
                $alter = $alter[1];
            	$or[] = "YEAR(".$datumfeld.") >= ".($wettkampfjahr-$alter);
            }
			elseif(isset($match[4]) and !isset($match[5])){ # Jugend
            	$alter = explode(',',$einst[$match[4]]);
            	$or[] = "YEAR(".$datumfeld.") IN (".($wettkampfjahr-$alter[0]).",".($wettkampfjahr-$alter[1]).")";
            }
            else{ # Jugend-Jugend
            	if(in_array('junioren',$match)){
                	if($match[1] == 'junioren'){
                    	$tmp = array('junioren',$match[3]);
                    }
                    else{
                    	$tmp = array('junioren',$match[1]);
                    }
                }
                else{
            		$tmp = array($match[1],$match[3]);
                	sort($tmp);
                }
            	$alter1 = explode(',',$einst[$tmp[0]]);
                $alter1 = $alter1[1];
            	$alter2 = explode(',',$einst[$tmp[1]]);
                $alter2 = $alter2[0];
            	$or[] = "YEAR(".$datumfeld.") BETWEEN ".($wettkampfjahr-$alter1)." AND ".($wettkampfjahr-$alter2);
            }
        }
        else{
        	$or[] = '1=2';
        }
    }
    return '(('.implode(') OR (',$or).'))';
}

function _suchebesteundletztezeit($zeiten){
	foreach($zeiten as $z){
    	$tmp_zeit[$z['zid']] = $z['zeit'];
        $tmp_datum[$z['zid']] = $z['sortdatum'];
    }
    asort($tmp_zeit);
    reset($tmp_zeit);
    arsort($tmp_datum);
    reset($tmp_datum);
	$rueckgabe = array();
    # letzte Zeit speichern
    list($id,) = each($tmp_datum);
    $rueckgabe['l'] = $id;
    # Bestzeit speichern
    list($id,) = each($tmp_zeit);
    $rueckgabe['b'] = $id;
    return $rueckgabe;
}

function _interpoliereZeit($wklaenge, $wkdisziplin, $mid){
    $moeglichkeiten = array(
    	25   => array(50),
        50   => array(25,100,200),
        100  => array(50,200,400),
        200  => array(50,100,400,800,1500),
        400  => array(100,200,800,1500),
        800  => array(200,400,1500),
        1500 => array(200,400,800)
    );
	$query = "SELECT z.id as zid, DATE_FORMAT(z.datum,'%d.%m.%Y') as datum, z.datum as sortdatum, z.zeit, streckenlaenge,
                  IF(".$wklaenge."-streckenlaenge<0,streckenlaenge-".$wklaenge.",".$wklaenge."-streckenlaenge) as differenz
                FROM ".DB_PREFIX."zeiten as z
                WHERE z.mitgliedid = ".$mid." AND z.datum > DATE_SUB('".$_SESSION['wk_abwickeln']['wettkampfdatum']."',
                  INTERVAL ".$this->conf['_gleinst']['wettkaempfe_abwickeln']['maxzeitalter']." MONTH) AND z.disziplin = ".$wkdisziplin." AND
                  z.streckenlaenge IN (".implode(',',$moeglichkeiten[$wklaenge]).") AND zeit IS NOT NULL
                ORDER BY differenz, z.datum DESC, bestenliste DESC, zeit";

    $this->db->holeDaten($query);
    if($this->db->ergebnis['anzahl'] < 1){
    	return false;
    }
    $zeiten = $this->db->baueArray('*','#');
    # Interpolieren
    $a_zeit = $zeiten[0]['zeit'];
    $a_laenge = $zeiten[0]['streckenlaenge'];
    $z_laenge = $wklaenge;
    $richtung = $a_laenge>$z_laenge?'runter':'hoch';
    $faktor = $this->conf['_gleinst']['wettkaempfe_abwickeln']['interplationsfaktor'.$richtung];
    if($richtung == 'hoch'){
    	$faktor *= $z_laenge/$a_laenge;
    }
    else{
    	$faktor /= $a_laenge/$z_laenge;
    }
    $z_zeit = $faktor*$a_zeit;
    return array(
        'zeit' => round($z_zeit,0),
        'vonstrecke' => $a_laenge
    );
}

function sucheVorhandenZeiten($wkdat,$mid){
/* holt alle zu einer Disziplin vorhandenen aktuellen Zeiten fuer ein Mitglied
	$wkdat = array mit disziplin und laenge
    $mid   = id des Mitglieds
*/
    $query = "SELECT id,DATE_FORMAT(datum,'%d.%m.%Y') as anzeigedatum, datum, zeit, wettkampfid
                FROM ".DB_PREFIX."zeiten
                WHERE
                  mitgliedid = ".$mid." AND
                  (datum > DATE_SUB('".$_SESSION['wk_abwickeln']['wettkampfdatum']."',
				    INTERVAL ".$this->conf['_gleinst']['wettkaempfe_abwickeln']['maxzeitalter']." MONTH)) AND
                  disziplin = ".$wkdat['disziplin']." AND
                  streckenlaenge = ".$wkdat['laenge']."
                ORDER BY streckenlaenge, disziplin, datum";
    $this->db->holeDaten($query);
    if($this->db->ergebnis['anzahl'] < 1){
    	return array();
    }
    $_dbzeiten = $this->db->ergebnis['daten'];
    $rueckgabe = array();
    $tmp_zeiten = array('t'=>array(),'i'=>array(),'s'=>array());
    foreach($_dbzeiten as $zeit){
    	switch($zeit['wettkampfid']){
        case 3:
        	$tmp_zeiten['t'][] = $zeit;
            break;
        case 2:
        	$tmp_zeiten['i'][] = $zeit;
            break;
        default:
        	$tmp_zeiten['s'][] = $zeit;
            break;
        }
    }

    # interpolierte Zeiten
    if(count($tmp_zeiten['i']) > 0){
    	$zeit = $tmp_zeiten['i'][0];
        $zeit['datum'] = $zeit['anzeigedatum'];
        unset($zeit['anzeigedatum'],$zeit['wettkampfid']);
        $rueckgabe[$zeit['id']] = $zeit;
        $rueckgabe[$zeit['id']]['art'] = 'i';
    }

    # Trainingszeiten
    if(count($tmp_zeiten['t']) > 0){
    	$zeit = $tmp_zeiten['t'][0];
        $zeit['datum'] = $zeit['anzeigedatum'];
        unset($zeit['anzeigedatum'],$zeit['wettkampfid']);
        $rueckgabe[$zeit['id']] = $zeit;
        $rueckgabe[$zeit['id']]['art'] = 't';
    }

    # sonstige Zeiten
    if(count($tmp_zeiten['s']) == 1){
    	$zeit = $tmp_zeiten['s'][0];
        $zeit['datum'] = $zeit['anzeigedatum'];
        unset($zeit['anzeigedatum'],$zeit['wettkampfid']);
        $rueckgabe[$zeit['id']] = $zeit;
        $rueckgabe[$zeit['id']]['art'] = 'l';
    }
    elseif(count($tmp_zeiten['s']) > 1){ # mehrere Zeiten -> beste und letzte raussuchen
    	$tmp = $this->_suchebesteundletztezeit($tmp_zeiten['s']);
        $rueckgabe[$tmp['l']['id']] = $tmp['l'];
        $rueckgabe[$tmp['l']['id']]['art'] = 'l';
        if(isset($tmp['b'])){
        	$rueckgabe[$tmp['b']['id']] = $tmp['b'];
        	$rueckgabe[$tmp['b']['id']]['art'] = 'b';
        }
    }
    return $rueckgabe;
}


function sucheStreckenzeitenfuerMitglied($wks,$mid,$optionen=array()){
/* sucht Meldezeiten fuer ein Mitglied
    $wks: Array mit den Wettkampfids
    $mid: ID des Mitglieds
    $optionen: verschiedene Einstellungen
*/
	$optionen['allezeiten'] = (isset($optionen['allezeiten']) and $optionen['allezeiten']==1)?true:false;
    $query = "SELECT w.id as wkid, zeit, DATE_FORMAT(z.datum,'%d.%m.%Y') as datum, wk.bahnlaenge, wk.kurztitel, schwimmernr
                FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id = sz.zeitid, ".DB_PREFIX."wks as w,
                  ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."wettkaempfe as wk
                WHERE z.wettkampfid = wk.id AND z.mitgliedid = m.id AND z.disziplin = w.disziplin AND z.streckenlaenge = w.laenge
                  AND (m.mw = w.mw OR w.mw='x') AND zeit IS NOT NULL AND mitgliedid = ".$mid." AND
                  (z.datum > DATE_SUB('".$_SESSION['wk_abwickeln']['wettkampfdatum']."',
                  INTERVAL ".$this->conf['_gleinst']['wettkaempfe_abwickeln']['maxzeitalter']." MONTH))
                  ".($optionen['allezeiten']?'':"wettkampfid > 5 AND")." AND w.id IN (".implode(',',$wks).")
                ORDER BY w.id, zeit";
    $this->db->holeDaten($query);
    $_dbzeiten = $this->db->ergebnis['daten'];
    $rueckgabe = array();
    foreach($wks as $wkid){
    	$rueckgabe[$wkid] = array();
    }
    foreach($_dbzeiten as $zeit){
    	$rueckgabe[$zeit['wkid']][] = $zeit;
    }
    return $rueckgabe;
}


function holeAktuelleZeitenFuerMitglied($mid,$datum='',$_zid = true){
    $maxaltervorinterpolation = 5; # Wenn alle Zeiten fr eine Strecke lter als x Monate sind, wird sie interpoliert
    $wkdatum = !empty($datum)?$datum:(isset($_SESSION['wk_abwickeln']['wettkampfdatum'])?"'".$_SESSION['wk_abwickeln']['wettkampfdatum']."'":'NOW()');

	$query = "SELECT id, disziplin, streckenlaenge, zeit, datum, ROUND((TO_DAYS(".$wkdatum.")-TO_DAYS(datum))/30) as alt
                FROM ".DB_PREFIX."zeiten as z
                WHERE mitgliedid = '".text_format($mid,'db')."' AND zeit IS NOT NULL AND wettkampfid != 2 AND
                  (datum > DATE_SUB(".$wkdatum.", INTERVAL ".$this->conf['_gleinst']['wettkaempfe_abwickeln']['maxzeitalter']." MONTH))
                ORDER BY disziplin, streckenlaenge, zeit";
    $this->db->holeDaten($query);
    if($this->db->ergebnis['anzahl'] < 1){
    	return array();
    }
    $zeiten = $this->db->baueArray('*','id');
    $aktuellstezeiten = array();
    foreach($zeiten as $zid => $zeit){
    	$key = $zeit['streckenlaenge'].'_'.$zeit['disziplin'];
    	if(!isset($aktuellstezeiten[$key])){
        	$aktuellstezeiten[$key] = array(
            	'zeit'  => $zeit['zeit'],
            	'datum' => $zeit['datum'],
                'alter' => $zeit['alt'],
                'id'    => $zid
            );
        }
        elseif($aktuellstezeiten[$key]['datum'] < $zeit['datum']){
        	$aktuellstezeiten[$key] = array(
            	'zeit'  => $zeit['zeit'],
            	'datum' => $zeit['datum'],
                'alter' => $zeit['alt'],
                'id'    => $zid
            );
        }
    }

    $strecken = array(
    	'50_1', '100_1', '200_1', '400_1', '800_1', '1500_1', # Freistil
        '50_2', '100_2', '200_2', # Brust
        '50_3', '100_3', '200_3', # Rcken
        '50_4', '100_4', '200_4', # Schmetterling
        '100_5', '200_5', '400_5' # Lagen
    );
    $moeglichkeiten = array(
        50   => array(100,25,200),
        100  => array(50,200,400),
        200  => array(100,400,800,50,1500),
        400  => array(200,800,100,1500),
        800  => array(400,1500,200),
        1500 => array(800,400,200)
    );
    $ausgang = array();

    foreach($strecken as $strecke){
    	# aktuelle Zeit vorhanden?
    	if(isset($aktuellstezeiten[$strecke]) and $aktuellstezeiten[$strecke]['alter'] <= $maxaltervorinterpolation){
        	$ausgang[$strecke] = ($_zid?$aktuellstezeiten[$strecke]['id'].'_':'').$aktuellstezeiten[$strecke]['zeit'];
            continue;
        }

        # Zeit interpolieren (nur von Strecken die neuer sind als die gesuchte und die nur von der doppelten/halben Streckenlaenge kommen)
        list($z_laenge,$lage) = explode('_',$strecke);
        $i = 1;
        foreach($moeglichkeiten[$z_laenge] as $a_laenge){
        	if($i > 2){
            	break;
            }
    		if(isset($aktuellstezeiten[$a_laenge.'_'.$lage]) and isset($aktuellstezeiten[$strecke]) and
               $aktuellstezeiten[$a_laenge.'_'.$lage]['alter'] < $aktuellstezeiten[$strecke]['alter']){
            	$a_zeit = $aktuellstezeiten[$a_laenge.'_'.$lage]['zeit'];
                $richtung = $a_laenge>$z_laenge?'runter':'hoch';
                $faktor = $this->conf['_gleinst']['wettkaempfe_abwickeln']['interplationsfaktor'.$richtung];
                $q = $z_laenge/$a_laenge;
                $faktor = pow($faktor,abs(log($q,2)))*$q;
                $z_zeit = $faktor*$a_zeit;
                $ausgang[$strecke] = ($_zid?$aktuellstezeiten[$a_laenge.'_'.$lage]['id'].'_':'').round($z_zeit);
                continue 2;
            }
            $i++;
        }
        # falls beim obigen Versuch keine Zeit ermittelt werden konnte, die ltere verwenden (sofern vorhanden)
    	if(isset($aktuellstezeiten[$strecke])){
        	$ausgang[$strecke] = ($_zid?$aktuellstezeiten[$strecke]['id'].'_':'').$aktuellstezeiten[$strecke]['zeit'];
            continue;
        }
        # Zeit interpolieren sofern mglich
        foreach($moeglichkeiten[$z_laenge] as $a_laenge){
    		if(isset($aktuellstezeiten[$a_laenge.'_'.$lage])){
            	$a_zeit = $aktuellstezeiten[$a_laenge.'_'.$lage]['zeit'];
                $richtung = $a_laenge>$z_laenge?'runter':'hoch';
                $faktor = $this->conf['_gleinst']['wettkaempfe_abwickeln']['interplationsfaktor'.$richtung];
                $q = $z_laenge/$a_laenge;
                $faktor = pow($faktor,abs(log($q,2)))*$q;
                $z_zeit = $faktor*$a_zeit;
                $ausgang[$strecke] = ($_zid?$aktuellstezeiten[$a_laenge.'_'.$lage]['id'].'_':'').round($z_zeit);
                continue 2;
            }
        }
    }
    return $ausgang;
}




function wettkaempfeFuerSchwimmer($wkid, $mid){
/*
  $wkid = ID des Wettkampfes
  $mid  = ID des Mitgliedes
*/
	# Jahrgang und Geschlecht des Schwimmers holen
    $query = "SELECT YEAR(gebdatum) as jg, mw FROM ".DB_PREFIX."mitglieder WHERE id = ".$mid."";
    $this->db->holeDaten($query);
    $conf['s_mw'] = $this->db->holeWert('mw');
    $conf['s_jg'] = $this->db->holeWert('jg');

    $abschnitte = $this->holeAbschnitte($wkid,true);
    $query = "SELECT wkid FROM ".DB_PREFIX."meldungen_starts as s, ".DB_PREFIX."meldungen_teilnehmer as t
                WHERE s.teilnehmerid=t.id AND t.mid = ".$mid." AND wettkampfid = ".$wkid."";
    $this->db->holeDaten($query);
    $vorhandene = $this->db->baueArray('wkid','#');
    $wks = array();
    foreach($abschnitte as $abschnitt){
    foreach($abschnitt['_wks'] as $wk){
    	if(($wk['details']['mw'] != $conf['s_mw']) and ($wk['details']['mw'] != 'x')){ # falsches Geschlecht
        	continue;
        }
        if($wk['details']['wkart'] != 'e' and $wk['details']['wkart'] != 'v'){ # falsche Wettkampfart
        	continue;
        }
        if($wk['details']['laenge']{1} == 'x' or (strlen($wk['details']['laenge']) > 2 and $wk['details']['laenge']{2} == 'x')){
            # Wettkampf ist eine Staffel
        	continue;
        }
        if(!$this->_jahrgangInJahrgangsbereich($conf['s_jg'],$wk['details']['jahrgang'])){ # falscher Jahrgang
            continue;
        }
        $wks[] = $wk['wkid'];
    }
    }

    $rueckgabe = array(
    	'wks'        => $wks,
        'vorhandene' => $vorhandene
    );

    return $rueckgabe;
}

function holeWettkampfliste($alle=false,$richtung='neu',$einschraenkungen=''){
/*
Holt eine Liste der Wettkaempfe
 - $alle: bei true wird das Flag "wkabwickeln" ignoriert, bei false werden nur
     Datensaetze mit dem Flag angezeigt
 - $richtung: bei 'neu' sind die neuesten Wettkmpfe oben, bei 'alt'
     die ltesten
*/
    $query = "SELECT id, CONCAT(titel, ' - ', DATE_FORMAT(datum,'%e. %M %Y')) as wk FROM ".DB_PREFIX."wettkaempfe WHERE 1";
    if(!empty($einschraenkungen)){
    	if(strpos($einschraenkungen, ' ')===false){
        	$einschr = array($einschraenkungen);
        }
        else{
        	$einschr = explode(' ',$einschraenkungen);
        }
    	$where = '';
        foreach($einschr as $e){
    		switch($e){
        	case 'vergangene':
        		$where .= ' AND datum < NOW()';
        		break;
        	case 'nurwettkaempfe':
        		$where .= ' AND id >= 10';
        		break;
            }
        }
        if(!in_array('interpoliertetraining', $einschr)){
        	$where .= ' AND (id >= 10 OR id < 5)';
        }
        $query .= $where;
    }
    $query .= " ORDER BY datum ".($richtung=='neu'?'DESC':'ASC');
    $this->db->holeDaten($query);
    $wettkaempfe = $this->db->baueArray('wk','id');
    if(!$alle){
    	$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'w' AND eigenschaft = 'wkabwickeln'";
    	$this->db->holeDaten($query);
        if($this->db->ergebnis['anzahl'] == 0){
        	return array();
        }
        $ids = $this->db->baueArray('artid','#');
        foreach($wettkaempfe as $id => $wk){
        	if(!in_array($id, $ids)){
            	unset($wettkaempfe[$id]);
            }
        }
    }
    return $wettkaempfe;
}

function holeWettkampfdaten($wkid, $ausgabe = false){
    if(!ctype_digit($wkid)){
        return false;
    }
    $query = "SELECT id, titel, kurztitel, ort, DATE_FORMAT(datum,'".($ausgabe?'%e. %M %Y':'%d.%m.%Y')."') as datum,
                  DATE_FORMAT(meldeschluss,'".($ausgabe?'%e. %M %Y':'%d.%m.%Y').", %H:%i') as meldeschluss,
                  DATE_FORMAT(meldeschluss,'".($ausgabe?'%e. %M %Y':'%d.%m.%Y')."') as meldeschluss_datum,
                  DATE_FORMAT(meldeschluss,'%H:%i') as meldeschluss_zeit, meldegeld, meldeadresse, sonstiges, verzeichnisid, bahnlaenge
                FROM ".DB_PREFIX."wettkaempfe
                WHERE id = '".$wkid."'
                ORDER BY ".DB_PREFIX."wettkaempfe.datum DESC";
    $this->db->holeDaten($query);
    if($this->db->holeAnzahl() != 1){
    	return false;
    }
    require_once('func/parsesonstigesfeld.inc.php');
    $daten = $this->db->holeZeile();
    $daten['meldegeld_formular'] = $this->parseMeldegeld($daten['meldegeld'],'db','formular');
    $daten['meldegeld_array'] = $this->parseMeldegeld($daten['meldegeld'],'db','array');
    $meldeadresse = !empty($daten['meldeadresse']);
	$daten['meldeadresse'] = parsesonstigesfeld($daten['meldeadresse']);
    $daten['meldeadresse']['vorhanden'] = $meldeadresse;
    return $daten;
}

function holePflichtzeitenfuerAbschnitt($abschnittid){
	$query = "SELECT wettkampfid FROM ".DB_PREFIX."abschnitte WHERE id = '".text_format($abschnittid,'db')."'";
    $this->db->holeDaten($query);
    if($this->db->holeAnzahl() != 1){
    	return false;
    }
    # Wettkampfjahr setzen
    $query = "SELECT YEAR(datum) as jahr FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$this->db->holeWert()."";
    $this->db->holeDaten($query);
    $this->wettkampfjahr = $this->db->holeWert();

    $rueckgabe = array();

    # Wettkaempfe holen
    $query = "SELECT id, wknr, mw, laenge, disziplin, jahrgang, wkart FROM ".DB_PREFIX."wks
                WHERE abschnittid = ".$abschnittid." AND (wkart = 'e' OR wkart = 'v')
                ORDER BY wknr";
    $this->db->holeDaten($query);
    if($this->db->ergebnis['anzahl'] == 0){
    	$wks = array();
    }
    else{
    	$wks = $this->db->ergebnis['daten'];
    }
    foreach($wks as $wk){
    	$rueckgabe['wks'][$wk['id']] = $wk['wknr'].' - '.$wk['laenge'].'m '.$this->conf['lagen'][$wk['disziplin']]{0}.' '.$wk['mw'];
    }

    # Jahrgaenge holen
    $query = "SELECT id, jahrgang FROM ".DB_PREFIX."pflichtzeiten_jahrgaenge WHERE abschnittid = ".$abschnittid." ORDER BY pos";
    $this->db->holeDaten($query);
    if($this->db->ergebnis['anzahl'] == 0){
    	$jahrg = array();
    }
    else{
    	$jahrg = $this->db->baueArray('jahrgang','id');
    }
    $rueckgabe['jahrgaenge'] = $jahrg;

    # Pflichtzeiten holen
    $query = "SELECT pz.id, pz.jahrgangid, pz.wkid, pz.zeit
                FROM ".DB_PREFIX."pflichtzeiten_zeiten as pz, ".DB_PREFIX."wks as w
                WHERE pz.wkid = w.id AND w.abschnittid = ".$abschnittid."";
    $this->db->holeDaten($query);
    if($this->db->ergebnis['anzahl'] == 0){
    	$pz = array();
    }
    else{
    	$pz = $this->db->ergebnis['daten'];
    }
    foreach($pz as $p){
    	$rueckgabe['pflichtzeiten'][$p['id']] = $p['zeit'];
    }

    foreach($wks as $wkid => $wk){
    	$rueckgabe['zids'][$wk['id']] = array();
    	foreach($jahrg as $jgid => $jg){
        	if($this->_jahrgangInJahrgangsbereich($jg,$wk['jahrgang'])){
            	$zeit = '';
            	foreach($pz as $pnr => $pzeit){
                	if($pzeit['jahrgangid'] == $jgid and $pzeit['wkid'] == $wk['id']){
    					$rueckgabe['zids'][$wk['id']][$jgid] = $pzeit['id'];
                        unset($pz['pnr']);
                        continue 2;
                    }
                }
    			$rueckgabe['zids'][$wk['id']][$jgid] = '?';
            }
            else{
    			$rueckgabe['zids'][$wk['id']][$jgid] = '-';
            }
        }

    }
    return $rueckgabe;
}

function _jahrgangInJahrgangsbereich($jahrgang,$bereich){
	$jahrgang = trim($jahrgang);
    $bereich  = trim($bereich);
	if($bereich == '*' or $bereich == ''){
    	return true;
    }
	if(empty($this->wettkampfjahr)){
    	$this->wettkampfjahr = date('Y');
    }
    if(strpos($bereich,',') !== false){ # Bereich enthaelt mehrere Jahrgaenge
    	$bereich = explode(',',$bereich);
    }
    else{ # Bereich enthaelt nur einen Wert
    	$bereich = array($bereich);
    }

    # Array mit Bereichsjahrgaengen bauen
    $_bereich = array();
	foreach($bereich as $b){
    	if($b == 'ak95+'){
        	$b = 'ak95';
        }
    	if(strpos($b,'+') !== false){ # Bereich enthaelt "und aelter"
        	$tmp = $this->_altersklasse2jahrgaenge(substr($b,0,-1));
            $min = is_array($tmp)?min($tmp):$tmp;
            $_bereich = is_array($tmp)?$tmp:array($tmp);
            for($i=$min-1;$i>=$this->wettkampfjahr-140;$i--){
            	$_bereich[] = $i;
            }
        }
        elseif(strlen($b)==9 and substr($b,4,1)=='-'){
        	list($anfang,$ende) = explode('-',$b);
            if($anfang > $ende){
            	$tmp = $anfang;
                $anfang = $ende;
                $ende = $tmp;
            }
            for($i=$anfang;$i<=$ende;$i++){
            	$_bereich[] = $i;
            }

        }
    	elseif(strpos($b,'-') !== false){ # Bereich enthaelt "und juenger"
        	$tmp = $this->_altersklasse2jahrgaenge(substr($b,0,-1));
            $max = is_array($tmp)?max($tmp):$tmp;
            $_bereich = is_array($tmp)?$tmp:array($tmp);
            for($i=$max+1;$i<=$this->wettkampfjahr;$i++){
                $_bereich[] = $i;
            }
        }
        else{ # Bereich ist einfacher Jahrgang (bzw. jugendX/junioren/akXX)
        	#$_bereich = $this->_altersklasse2jahrgaenge($b);
        	$tmp = $this->_altersklasse2jahrgaenge($b);
            if(is_array($tmp)){
            	foreach($tmp as $t){
            	    $_bereich[] = $t;
                }
            }
            else{
            	$_bereich[] = $tmp;
            }
        }
    }
    # Array mit Jahrgangjahrgaengen bauen
    if(strpos($jahrgang,',') !== false){ # Bereich enthaelt mehrere Jahrgaenge
    	$jahrgang = explode(',',$jahrgang);
    }
    else{ # Bereich enthaelt nur einen Wert
    	$jahrgang = array($jahrgang);
    }
    # Array mit Bereichsjahrgaengen bauen
    $_jahrgang = array();
	foreach($jahrgang as $j){
    	if($j == 'ak95+'){
        	$j = 'ak95';
        }
    	if(strpos($j,'+') !== false){ # Bereich enthaelt "und aelter"
        	$tmp = $this->_altersklasse2jahrgaenge(substr($b,0,-1));
            $min = is_array($tmp)?min($tmp):$tmp;
            $_jahrgang = is_array($tmp)?$tmp:array($tmp);
            for($i=$min-1;$i>=$this->wettkampfjahr-140;$i--){
            	$_jahrgang[] = $i;
            }
        }
    	elseif(strpos($j,'-') !== false){ # Bereich enthaelt "und juenger"
        	$tmp = $this->_altersklasse2jahrgaenge(substr($b,0,-1));
            $max = is_array($tmp)?max($tmp):$tmp;
            $_jahrgang = is_array($tmp)?$tmp:array($tmp);
            for($i=$max+1;$i<=$this->wettkampfjahr;$i++){
                $_jahrgang[] = $i;
            }
        }
        else{ # Bereich ist einfacher Jahrgang (bzw. jugendX/junioren/akXX)
        	$tmp = $this->_altersklasse2jahrgaenge($j);
            if(is_array($tmp)){
            	foreach($tmp as $t){
            	    $_jahrgang[] = $t;
                }
            }
            else{
            	$_jahrgang[] = $tmp;
            }
        }
    }
    if(!is_array($_jahrgang)){
    	$_jahrgang = array($_jahrgang);
    }
    foreach($_jahrgang as $jahrg){
    	if(in_array($jahrg,$_bereich)){
        	return true;
        }
    }
    return false;
}

function _altersklasse2jahrgaenge($altersklasse){
	if(empty($this->wettkampfjahr)){
    	$this->wettkampfjahr = date('Y');
    }
    if(!in_array($altersklasse,array_keys($this->conf['altersklassen']))){
    	if(strlen($altersklasse) <= 2){ # es ist ein Alter angegeben
        	return $this->wettkampfjahr-$altersklasse;
        }
    	return $altersklasse;
    }
    $jahrgaenge = array();
    if($altersklasse == 'ak95'){
    	for($i=95;$i<=140;$i++){
        	$jahrgaenge[] = $this->wettkampfjahr-$i;
        }
        return $jahrgaenge;
    }
    $jahre = explode(',',$this->conf['altersklassen'][$altersklasse]);
    foreach($jahre as $jahr){
    	$jahrgaenge[] = $this->wettkampfjahr-$jahr;
    }
    return $jahrgaenge;
}

function verschiebeJahrgang($jahrgid,$richtung){
	if(!ctype_digit($jahrgid) or !in_array($richtung,array('oben','unten'))){
    	return false;
    }
    # Abschnitid des Jahrgangs holen
    $query = "SELECT abschnittid, pos FROM ".DB_PREFIX."pflichtzeiten_jahrgaenge WHERE id = ".$jahrgid."";
    $this->db->holeDaten($query);
    if($this->db->ergebnis['anzahl'] != 1){
    	return false;
    }
    $abschnid = $this->db->holeWert('abschnittid');
    $pos = $this->db->holeWert('pos');

    # pruefen ob Jahrgang verschoben werden kann
    if($pos == 1 and $richtung == 'oben'){
    	return false;
    }
    $query = "SELECT MAX(pos) as mpos FROM ".DB_PREFIX."pflichtzeiten_jahrgaenge WHERE abschnittid = ".$abschnid."";
    $this->db->holeDaten($query);
    $mpos = $this->db->holeWert();
    if($pos == $mpos and $richtung == 'unten'){
    	return false;
    }

    # alles ok, Jahrgang verscheiben
    if($richtung == 'unten'){ # nach unten schieben
    	$query1 = "UPDATE ".DB_PREFIX."pflichtzeiten_jahrgaenge SET pos = pos-1 WHERE pos > ".$pos." AND abschnittid = ".$abschnid." ORDER BY pos ASC LIMIT 1";
        $query2 = "UPDATE ".DB_PREFIX."pflichtzeiten_jahrgaenge SET pos = pos+1 WHERE id = ".$jahrgid."";
    }
    else{ # nach oben schieben
		$query1 = "UPDATE ".DB_PREFIX."pflichtzeiten_jahrgaenge SET pos = pos+1 WHERE pos < ".$pos." AND abschnittid = ".$abschnid." ORDER BY pos DESC LIMIT 1";
        $query2 = "UPDATE ".DB_PREFIX."pflichtzeiten_jahrgaenge SET pos = pos-1 WHERE id = ".$jahrgid."";
    }
    $this->db->fuehreQueryAus($query1);
    $this->db->fuehreQueryAus($query2);
    return true;
}

function holePflichtzeitjahrgaenge($abschnittid){
	$query = "SELECT id, richtpflicht, offiziell, jahrgang
                FROM ".DB_PREFIX."pflichtzeiten_jahrgaenge WHERE abschnittid = ".$abschnittid." ORDER BY pos";
	$this->db->holeDaten($query);
	if($this->db->holeAnzahl() < 1){
    	return array();
    }
    $rueckgabe = array();
    foreach($this->db->ergebnis['daten'] as $row){
    	$rueckgabe[$row['id']] = array(
        	'richtpflicht' => $row['richtpflicht'],
        	'offiziell' => $row['offiziell'],
            'jahrgang' => $row['jahrgang']
        );
    }
    return $rueckgabe;
}

function holeAbschnitte($wkid,$wks=false){
/*
Holt die Abschnitte zu der angegebenen Wettkampfid
 - $wkdid: die ID des gesuchten Wettkampfes
 - $wks:   bei true werden auch die Wettkaempfe dazu geholt
*/
	$query = "SELECT id, nr, DATE_FORMAT(datum,'%d.%m.%Y') as datum, DATE_FORMAT(datum,'%Y') as jahr,
                  TIME_FORMAT(beginn,'%H:%i') as beginn, DATE_FORMAT(datum,'%w') as wochentag, kindgerecht
                FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$wkid." ORDER BY nr";
	$this->db->holeDaten($query);
	if($this->db->ergebnis['anzahl'] < 1){
    	return array();
    }
    $rueckgabe = array();
    $ergebnis = $this->db->ergebnis['daten'];
    foreach($ergebnis as $row){
        $rueckgabe[$row['id']] = array(
            'nr'        => $row['nr'],
            'datum'     => $row['datum'],
            'beginn'    => $row['beginn'],
            'wochentag' => $row['wochentag']==0?7:$row['wochentag'],
            'kindgerecht' => !is_null($row['kindgerecht'])
        );
    	if($wks){
        	$rueckgabe[$row['id']]['_wks'] = array();
        	$query = "SELECT id, wknr, mw, laenge, disziplin, jahrgang, wkart FROM ".DB_PREFIX."wks
                        WHERE abschnittid = ".$row['id']." ORDER BY wknr";
            $this->db->holeDaten($query);
            if($this->db->ergebnis['anzahl'] < 1){
				continue;
            }
            $tmp = $this->db->ergebnis['daten'];

            foreach($tmp as $row2){
            	$tmp2 = array(
                	'wknr' => $row2['wknr'],
                    'wkid' => $row2['id'],
                    'lage' => $row2['laenge'].'m '.$this->conf['lagen'][$row2['disziplin']].' '.$row2['mw'].($row2['wkart']!='e'?' - '.$this->conf['wkarten'][$row2['wkart']]:''),
                    'details' => array(
                    	'laenge'   => $row2['laenge'],
                        'lage'     => $row2['disziplin'],
                        'mw'       => $row2['mw'],
                        'jahrgang' => $row2['jahrgang'],
                        'wkart'    => $row2['wkart']
                     ),
                    'jahrgang' => $this->_formatiereJahrgang($row2['jahrgang'], $row['jahr'])
                );
        		$rueckgabe[$row['id']]['_wks'][] = $tmp2;
            }
        }
    }
    return $rueckgabe;
}

function _formatiereJahrgang($jahrgang, $jahr = ''){
	if(empty($jahr)){
    	$jahr = date('Y',time());
    }
	if(strpos($jahrgang,',') === false){
		$jahrgang = array($jahrgang);
    }
    else{
    	$jahrgang = explode(',',$jahrgang);
    }
    $tmp = array();
    $anhaengen = array();
    foreach($jahrgang as $jhrg){
        if($jhrg == '*'){
            $tmp[] = 'offen';
        }
        elseif((substr($jhrg,0,1) == 'j' or substr($jhrg,0,2) == 'ak')){
            if(in_array($jhrg,array_keys($this->conf['altersklassen']))){
                $teile = explode(',',$this->conf['altersklassen'][$jhrg]);
                foreach($teile as $t){
                    $tmp[] = $jahr-$t;
                }
                if($jhrg == 'junioren'){
                    $anhaengen[] = 'Junioren';
                }
                elseif(substr($jhrg,0,1) == 'j'){
                    $anhaengen[] = 'Jugend '.strtoupper(substr($jhrg,1));
                }
                else{
                    $anhaengen[] = strtoupper($jhrg);
                }
            }
			if(in_array(substr($jhrg,0,strlen($jhrg)-1),array_keys($this->conf['altersklassen']))){
                $j = substr($jhrg,0,strlen($jhrg)-1);
                if($j == 'junioren'){
                    $klasse = 'Junioren';
                }
                elseif(substr($j,0,1) == 'j'){
                    $klasse = 'Jugend '.strtoupper(substr($j,1));
                }
                else{
                    $klasse = strtoupper($j);
                }
                switch(substr($jhrg,-1)){
                case '+':
					$tmp[] = $jahr-substr($this->conf['altersklassen'][$j],0,2).' u. lter';
                    $anhaengen[] = $klasse.' u. lter';
                    break;
                case '-':
					$tmp[] = $jahr-substr($this->conf['altersklassen'][$j],strpos($this->conf['altersklassen'][$j],',')+1).' u. jnger';
                    $anhaengen[] = $klasse.' u. jnger';
                    break;
                default:
                	$append = substr($jhrg,-1);
                    break;
                }
            }
        }
        elseif(substr($jhrg,-1) == '+'){
            return str_replace('+',' u. lter',$jhrg);
        }
        elseif(substr($jhrg,-1) == '-'){
            $tmp[] = str_replace('-',' u. jnger',$jhrg);
        }
        else{
			$tmp[] = $jhrg;
        }
    }
    sort($tmp);
    $rueckgabe = implode(', ',$tmp);
    if(count($anhaengen) >= 1){
		$rueckgabe .= ' ('.implode(', ',$anhaengen).')';
    }
    return $rueckgabe;
}

function holeSelectOptionen($art,$id){
/*
Liefert ein Array mit den Abschnitten (Wettkmpfen) eines Wettkmpfes (Abschnittes)
 - $art: was soll geholt werden? (abschnitte|wettkaempfe)
 - $id:  id des Wettkampfes bzw. Abschnittes ([0-9]+)
*/
	if(!in_array($art,array('abschnitte','wettkaempfe')) or !ctype_digit($id)){
    	return false;
    }
    if($art == 'abschnitte'){
    	$query = "SELECT id, CONCAT(nr,'. Abschnitt; Beginn: ',TIME_FORMAT(beginn,'%H:%i'),' (am ',DATE_FORMAT(datum,'%d.%m.%Y'),')') as titel
                    FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$id." ORDER BY nr";
        $this->db->holeDaten($query);
        $erg = $this->db->ergebnis;
        if($erg['anzahl'] < 1){
        	return array();
        }
        return $this->db->baueArray('titel','id');
    }
    elseif($art == 'wettkaempfe'){

    }
}

function parseMeldegeld($daten,$eingangsart,$ausgangsart){
    /*
    $feldinhalt ist der Inhalt des Feldes aus der Datenbank
    $rueckgabeart gibt an, wie das Ergebnis zurckgegeben werden soll,
      bei "array" (Standard) wird das Array zurckgegeben, bei "string"
      der ggf. formatierte String (zum Speichern beim ndern)
    */

    # Daten zur internen Verwendung vereinheitlichen
    $internedaten = array();
    switch($eingangsart){
    case 'db':
    	if(empty($daten)){
        	$daten = '||';
        }
    	elseif(substr_count($daten,'|') != 2){
        	return false;
        }
    	list($einzel,$staffel,$wks) = explode('|',$daten,3);
        $einzel = $this->_formatiereGeldbetrag($einzel);
        $staffel = $this->_formatiereGeldbetrag($staffel);
    	$internedaten = array(
        	'einzel'  => $einzel,
        	'staffel' => $staffel,
        	'wks'     => array()
        );

        if(!empty($wks)){
        	if(strpos($wks,';') !== false){
            	$wks = explode(';',$wks);
            }
            else{
            	$wks = array($wks);
            }
            $anz = count($wks);
            for($i=0;$i<$anz;$i++){
            	list($wk,$preis) = explode(':',$wks[$i]);
            	$internedaten['wks'][$wk] = $preis;
            }
        }
    	break;
    case 'formular':
		if(!is_array($daten) or count($daten)!=3){
    		return false;
    	}
        $datenok = array(
        	'einzel'  => true,
        	'staffel' => true,
        	'wks'     => true
        );
        $einzel = $this->_formatiereGeldbetrag($daten['einzel']);
        $staffel = $this->_formatiereGeldbetrag($daten['staffel']);
        if($einzel === false or strlen($einzel) > 6){
        	$datenok['einzel'] = false;
        }
        if($staffel === false or strlen($staffel) > 6){
        	$datenok['staffel'] = false;
        }
    	$internedaten = array(
        	'einzel'  => $einzel,
        	'staffel' => $staffel,
        	'wks'     => array()
        );
        if(!empty($daten['wks'])){
            $wks = str_replace(array('WK',' '),'',strtoupper($daten['wks']));
            $wks = preg_replace('~[^0-9,:;]~',',',$wks);
            $wks = preg_replace('~,{2,}~',',',$wks);
            if(strlen($wks)>136){
            	$datenok['wks'] = false;
            }
            else{
                if(substr($wks,-1) == ';'){
                    $wks = substr($wks,0,-1);
                }
                if(strpos($wks,';') !== false){
                    $wks = explode(';',$wks);
                }
                else{
                    $wks = array($wks);
                }
                $anz = count($wks);
                $regex = '~^([0-9]{1,4})(?:(,[0-9]{1,4})*)?:([0-9]+)(,[0-9]{1,2})?$~';
                $vorhandenewk = array();
                $tmpwks = array();
                for($i=0;$i<$anz;$i++){
                    if(!preg_match($regex,$wks[$i])){
                        $datenok['wks'] = false;
                        break;
                    }
                    list($wk,$preis) = explode(':',$wks[$i]);
                    $preis = $this->_formatiereGeldbetrag($preis);
                    if(strpos($wk,',') !== false){
                        $wk = explode(',',$wk);
                    }
                    else{
                        $wk = array($wk);
                    }
                    $anz2 = count($wk);
                    for($j=0;$j<$anz2;$j++){
                        if(in_array($wk[$j],$vorhandenewk)){
                        	$datenok['wks'] = false;
                            break 2;
                        }
                        if(!isset($tmpwks[$preis])){
                            $tmpwks[$preis] = array();
                        }
                        $vorhandenewk[] = $wk[$j];
                        $tmpwks[$preis][] = $wk[$j];
                        sort($tmpwks[$preis]);
                    }
                    ksort($tmpwks);
                    $internedaten['wks'][$wk] = $preis; # evtl. muss hier statt $wk $wk[$j] hin
                }
            }
        }

        # Falls ein Fehler aufgetreten ist -> abbrechen
        if(!$datenok['einzel'] or !$datenok['staffel'] or !$datenok['wks']){
        	return $datenok;
        }
        # Daten in das interne Array schreiben
        if(!empty($daten['wks'])){
            foreach($tmpwks as $preis => $wks){
                $internedaten['wks'][implode(',',$wks)] = $preis;
            }
        }
        break;
    case 'array':
    case 'array_formatieren':
		if(!is_array($daten) or count($daten)!=3){
    		return false;
    	}
        if($eingangsart == 'array_formatieren'){
        	$daten['einzel']  = $this->_formatiereGeldbetrag($daten['einzel']);
        	$daten['staffel'] = $this->_formatiereGeldbetrag($daten['staffel']);
            foreach($daten['wks'] as $wks => $preis){
        		$daten['wks'][$wks] = $this->_formatiereGeldbetrag($preis);
            }
        }
    	$internedaten = $daten;
    	break;
    default:
    	return false;
    }
    # Daten zur internen Verwendung vereinheitlicht -> Ausgabe zusammenbauen
    switch($ausgangsart){
    case 'db':
    	$daten = ($internedaten['einzel']=='0,00'?'':$internedaten['einzel']).'|';
    	$daten .= ($internedaten['staffel']=='0,00'?'':$internedaten['staffel']).'|';
        if(count($internedaten['wks']) > 0){
        	$db = array();
            $preise = array();
        	foreach($internedaten['wks'] as $wks => $preis){
            	if(!isset($preise[$preis])){
                	$preise[$preis] = array();
                }
                $preise[$preis][] = $wks;
            }
            foreach($preise as $preis => $wks){
                $db[] = implode(',', $wks).':'.$preis;
            }
            $daten .= implode(';',$db);
        }
        if($daten == '||'){
        	$daten = '';
        }
    	break;
    case 'formular':
    	$daten = array(
        	'einzel'  => $internedaten['einzel']=='0,00'?'':$internedaten['einzel'],
        	'staffel' => $internedaten['staffel']=='0,00'?'':$internedaten['staffel'],
        	'wks'     => ''
        );
        if(count($internedaten['wks']) > 0){
        	$db = array();
        	foreach($internedaten['wks'] as $wks => $preis){
            	$db[] = 'WK'.$wks.':'.$preis;
            }
            $daten['wks'] = implode('; ',$db);
        }
        break;
    case 'wkpreis_rechnen':
    case 'wkpreis':
    	$daten = array(
        	'einzel'  => $internedaten['einzel'],
        	'staffel' => $internedaten['staffel'],
        	'wks'     => array()
        );
        if(count($internedaten['wks']) > 0){
        	foreach($internedaten['wks'] as $wks => $preis){
                if(strpos($wks,',') !== false){
                    $wks = explode(',',$wks);
                }
                else{
                    $wks = array($wks);
                }
                $anz = count($wks);
                for($i=0;$i<$anz;$i++){
                	$daten['wks'][$wks[$i]] = $preis;
                }
            }
            ksort($daten['wks']);
        }
        if($ausgangsart == 'wkpreis_rechnen'){
    		$daten['einzel'] = str_replace(',','.',$daten['einzel']);
    		$daten['staffel'] = str_replace(',','.',$daten['staffel']);
    		foreach($daten['wks'] as $key => $w){
    			$daten['wks'][$key] = str_replace(',','.',$w);
    		}
        }
        break;
    case 'array':
    	$daten = $internedaten;
    	break;
    default:
    	return false;
    }
    # und raus damit
    return $daten;
}

function _formatiereGeldbetrag($wert){
	$anz = preg_match('~^(\d+)?\D?(\d{1,2})?(.*?)$~',$wert,$match);
    if($anz == 0 or (empty($match[1])) and $match[1]!=0){
    	return false;
    }
    return sprintf('%d,%-02s',$match[1],$match[2]);
}

} # Ende der Klasse, EOF
?>