<?php

class zeiten {

var $rekordzeiten = NULL;
var $db;
var $cache;

function schreibeAktuelleZeiten(){
	global $_einst, $_gleinst;
    require_once('class/wettkaempfe.inc.php');
    $wk = new wettkaempfe;
    $wk->db = &$this->db;
    $wk->conf = array('_einst'=>&$_einst,'_gleinst'=>&$_gleinst);
    printr();

    # Tabelle leeren
    $query = "TRUNCATE TABLE ".DB_PREFIX."aktuellezeiten";
    $this->db->fuehreQueryAus($query);

    # Mitglieder-IDs holen
    $query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE ausgetreten IS NULL";
    $this->db->holeDaten($query);
    $mitglieder = $this->db->baueArray('id','id');
    $qs = array();
    foreach($mitglieder as $id => $row){
    	$zeiten = $wk->holeAktuelleZeitenFuerMitglied($id,'NOW()');
        $anz = count($zeiten);
        if($anz < 1){
            continue;
        }
        foreach($zeiten as $strecke => $zeit){
        	list($l,$d) = explode('_',$strecke);
            list($zeitid, $zeit) = explode('_', $zeit);
            $qs[] =  '('.$id.', '.$l.', '.$d.', '.$zeit.', '.$zeitid.')';
        }

    }
    $anz = count($qs);
    if($anz>0){
    	# Zeiten schreiben
        $q = array();
        for($i=1;;$i++){ # die Schleife sorgt dafr, dass maximal 500 Zeiten auf einmal angelegt werden (damit der Query nicht zu lang wird)
        	$tmp = array_shift($qs);
            if(is_null($tmp)){
            	break;
            }
            $q[] = $tmp;
            if($i<500){
            	continue;
            }
        	$query = "INSERT INTO ".DB_PREFIX."aktuellezeiten (mid,laenge,disziplin,zeit,zeitid) VALUES ".implode(', ',$q)."";
        	$this->db->fuehreQueryAus($query);
            $q = array();
            $i = 0;
        }
        if(count($q)>0){ # falls noch ein Rest vorhanden den noch wegschreiben
        	$query = "INSERT INTO ".DB_PREFIX."aktuellezeiten (mid,laenge,disziplin,zeit,zeitid) VALUES ".implode(', ',$q)."";
        	$this->db->fuehreQueryAus($query);
        }
    	return true;
    }
    else{
    	return false;
    }
}

function holeVereinsrekorde($strecke = '', $alter = '', $mw = 'x', $stand = ''){
/*
$strecke kann ein Array aus Disziplin und Lnge sein (z.B. array(2,50) fr 50B), Reihenfolge ist egal
$alter kann je 8-19, bis11, ak20-ak95 oder * sein (* = offene Wertung, Leerstring (=Standard) alle Alterklassen)
$mw kann m, w oder x sein (bei x wird m und w geholt)
$stand kann ein Datum sein, in dem Fall werden nur Zeiten bercksichtigt, deren Datum <=$stand ist
*/
	global $_lagen, $_altersklassen;

    # Strecke(n) festlegen
    $strecken = array(
        array('lage'=>1,'laenge'=>50),
        array('lage'=>1,'laenge'=>100),
        array('lage'=>1,'laenge'=>200),
        array('lage'=>1,'laenge'=>400),
        array('lage'=>1,'laenge'=>800),
        array('lage'=>1,'laenge'=>1500),
        array('lage'=>2,'laenge'=>50),
        array('lage'=>2,'laenge'=>100),
        array('lage'=>2,'laenge'=>200),
        array('lage'=>3,'laenge'=>50),
        array('lage'=>3,'laenge'=>100),
        array('lage'=>3,'laenge'=>200),
        array('lage'=>4,'laenge'=>50),
        array('lage'=>4,'laenge'=>100),
        array('lage'=>4,'laenge'=>200),
        array('lage'=>5,'laenge'=>100),
        array('lage'=>5,'laenge'=>200),
        array('lage'=>5,'laenge'=>400)
    );
    $laengen = array(50,100,200,400,800,1500);
    if(is_array($strecke) and in_array($strecke[0],array_keys($_lagen)) and in_array($strecke[1],$laengen)){
    	$_strecken = array(
            array('lage' => $strecke[0], 'laenge' => $strecke[1])
        );
    }
    elseif(is_array($strecke) and in_array($strecke[1],array_keys($_lagen)) and in_array($strecke[0],$laengen)){
    	$_strecken = array(
            array('lage' => $strecke[1], 'laenge' => $strecke[0])
        );
    }
    else{
    	$_strecken = $strecken;
    }

    # Alter festlegen
    $altersklassen = array();
    $altersklassen['*'] = '*'; # offen
    for($i=8;$i<=19;$i++){ # je 8-19 Jahre
        $altersklassen[$i] = $i;
    }

    # ltesten Schwimmer holen
    if(!isset($this->cache['aeltesterschwimmer'])){
    	$query = "SELECT YEAR(z.datum)-YEAR(gebdatum) as maxalter
    	            FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id
    	            WHERE YEAR(gebdatum)>1900 ORDER BY maxalter DESC LIMIT 1";
    	$this->db->holeDaten($query);
    	$this->cache['aeltesterschwimmer'] = $this->db->holeWert();
    }
    $maxalter = $this->cache['aeltesterschwimmer'];
    foreach($_altersklassen as $key => $talter){ # Masters (AK20-AK95)
        if(substr($key,0,2) != 'ak'){
            continue;
        }
        if(substr($key,-2) > $maxalter){ # ltere Schwimmer gab es bisher nicht -> berspringen
        	continue;
        }
        if($key == 'ak95'){
            $altersklassen[$key] = implode(',',range(95,130));
            continue;
        }
        $altersklassen[$key] = $talter;
    }

    if(!empty($alter) and in_array($alter,array_keys($altersklassen))){
    	$_alter = array($alter => $altersklassen[$alter]);

    }
    else{
    	$_alter = $altersklassen;
    }
    # Geschlecht(er) festlegen
    if(in_array($mw,array('m','w'))){
    	$_geschlechter = array($mw);
    }
    else{
    	$_geschlechter = array('m','w');
    }

    # Stand festlegen
    require_once('func/datumerkennen.inc.php');
    $ok = datumerkennen($stand);
    if($ok){
		$_stand = text_format($stand,'dbdatum');
    }
    else{
    	$_stand = '';
    }

    # Rekord(e) holen
    $rekorde = array();
    $sperren = array();
    foreach($_strecken as $strecke){
    	foreach($_alter as $altersklasse => $alter){
    		foreach($_geschlechter as $geschlecht){
    			$keyanfang = $strecke['laenge'].'_'.$strecke['lage'].'_'.$geschlecht;
                if(in_array($keyanfang, $sperren)){
                	continue;
                }
                $tmp = $this->_holeVereinsrekord($strecke, array($altersklasse,$alter), $geschlecht, $_stand);
                if(empty($tmp)){
                	if($altersklasse == '*'){
                    	$sperren[] = $keyanfang;
                    }
                	continue;
                }
            	$rekorde[$keyanfang.'_'.$altersklasse] = $tmp;
            }
        }
    }
    return $rekorde;
}

function _holeVereinsrekord($strecke, $alter, $geschlecht, $stand){
    if($alter[1] == '*'){
        $akwhere = '';
    }
    elseif(strpos($alter[1],',')===false){
        $akwhere = ' AND YEAR(z.datum)-YEAR(m.gebdatum) = '.$alter[1];
    }
    else{
        $akwhere = ' AND YEAR(z.datum)-YEAR(m.gebdatum) IN ('.$alter[1].')';
    }
    if(empty($stand)){
    	$standwhere = '';
    }
    else{
    	$standwhere = " AND z.datum < '".$stand."'";
    }
    $query = "SELECT z.id as zid FROM ".DB_PREFIX."zeiten as z, ".DB_PREFIX."mitglieder as m
                WHERE z.mitgliedid = m.id AND disziplin = ".$strecke['lage']." AND streckenlaenge = ".$strecke['laenge']." AND
                  zeit IS NOT NULL AND bestenliste = 1".$akwhere.$standwhere." AND mw = '".$geschlecht."'
                ORDER BY zeit LIMIT 1";
    $this->db->holeDaten($query);
    if($this->db->holeAnzahl()==0){
        return '';
    }
    return $this->db->holeWert();
}


function holeBestenlisten($strecke = '', $geschlecht = 'x', $stand = ''){

	global $_lagen, $_altersklassen;

    # Strecke(n) festlegen
    $strecken = array(
        array('lage'=>1,'laenge'=>50),
        array('lage'=>1,'laenge'=>100),
        array('lage'=>1,'laenge'=>200),
        array('lage'=>2,'laenge'=>50),
        array('lage'=>2,'laenge'=>100),
        array('lage'=>2,'laenge'=>200),
        array('lage'=>3,'laenge'=>50),
        array('lage'=>3,'laenge'=>100),
        array('lage'=>3,'laenge'=>200),
        array('lage'=>4,'laenge'=>50),
        array('lage'=>4,'laenge'=>100),
        array('lage'=>4,'laenge'=>200),
        array('lage'=>5,'laenge'=>200)
    );
    $laengen = array(50,100,200);
    if(is_array($strecke) and in_array($strecke[0],array_keys($_lagen)) and in_array($strecke[1],$laengen)){
    	$_strecken = array(
            array('lage' => $strecke[0], 'laenge' => $strecke[1])
        );
    }
    elseif(is_array($strecke) and in_array($strecke[1],array_keys($_lagen)) and in_array($strecke[0],$laengen)){
    	$_strecken = array(
            array('lage' => $strecke[1], 'laenge' => $strecke[0])
        );
    }
    else{
    	$_strecken = $strecken;
    }

    # Geschlecht(er) festlegen
    if(in_array($geschlecht,array('m','w'))){
    	$_geschlechter = array($geschlecht);
    }
    else{
    	$_geschlechter = array('m','w');
    }

    # Stand festlegen
    require_once('func/datumerkennen.inc.php');
    $ok = datumerkennen($stand);
    if($ok){
		$_stand = text_format($stand,'dbdatum');
    }
    else{
    	$_stand = '';
    }

    require_once('func/holebestenlistendaten.inc.php');
    $halloffame = array();
    if(!empty($_stand)){
    	$conf = array('vordatum' => $_stand);
    }
    else{
    	$conf = array();
    }

    foreach($_strecken as $strecke){
    	foreach($_geschlechter as $geschlecht){
        	$key = $strecke['laenge'].'_'.$strecke['lage'].'_'.$geschlecht.'_o';
            $daten = holeBestenlistenDaten($strecke['lage'], $strecke['laenge'], $geschlecht, 10, $conf);
            $ids = array();
            foreach($daten['daten'] as $zeit){
            	$ids[] = $zeit['zid'];
            }
    		$halloffame[$key] = $ids;
            if($strecke['laenge'] == '50'){ # bei den 50m-Strecken auch die Listen fr die bis 11 jhrigen holen
        		$key = $strecke['laenge'].'_'.$strecke['lage'].'_'.$geschlecht.'_b';
                $tmp = $conf;
                $tmp['maxalter'] = 11;
           		$daten = holeBestenlistenDaten($strecke['lage'], $strecke['laenge'], $geschlecht, 10, $tmp);
            	$ids = array();
            	foreach($daten['daten'] as $zeit){
            		$ids[] = $zeit['zid'];
            	}
    			$halloffame[$key] = $ids;
            }
        }
    }
    return $halloffame;
}

function leseVereinsrekordeEin(){
    $vereinsrekorde = array();
	$vereinsrekorde['rekorde'] = $this->holeVereinsrekorde('', '', 'x', '');
    $vereinsrekorde['halloffame'] = $this->holeBestenlisten('', 'x', '');

    # Lschen der bestehenden Rekordvermerke
    $query = "DELETE FROM ".DB_PREFIX."zeiten_rekorde WHERE LEFT(art,1)='a'";
    $this->db->fuehreQueryAus($query);
    # aktuelle Vereinsrekorde in die Datenbank schreiben
      # VR/VJR schreiben
    $datensaetze = array();
    foreach($vereinsrekorde['rekorde'] as $strecke => $zid){
    	list(,,,$alter) = explode('_', $strecke);
        if($alter == '*'){
        	$datensaetze[] = "(".$zid.", 'aVR', NULL)";
        }
        else{
        	$datensaetze[] = "(".$zid.", 'aVJR', NULL)";
        }
    }
    if(count($datensaetze)>0){
    	$query = "INSERT INTO ".DB_PREFIX."zeiten_rekorde (zeitid, art, laenge) VALUES ".implode(', ', $datensaetze)."";
        $this->db->fuehreQueryAus($query);
    }
      # Hall-of-Fame-Eintrge schreiben
    $datensaetze = array();
    foreach($vereinsrekorde['halloffame'] as $strecke => $zeitids){
        if(count($zeitids)<1){
        	continue;
        }
        $art = substr($strecke,-1)=='o'?'aHoF':'aHoF11';
        $i = 1;
        foreach($zeitids as $id){
            $datensaetze[] = "(".$id.", '".$art."_".$i."', NULL)";
            $i++;
        }
    }
    if(count($datensaetze)>0){
    	$query = "INSERT INTO ".DB_PREFIX."zeiten_rekorde (zeitid, art, laenge) VALUES ".implode(', ', $datensaetze)."";
        $this->db->fuehreQueryAus($query);
    }

    # dem Cronjob ggf. sagen, dass er die Rekorde nicht mehr einlesen muss
    $cronjobini = parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true);
    if($cronjobini['flags']['vereinsrekordeeinlesen'] == 1){
    	require_once('func/schreibe_ini_datei.inc.php');
    	$cronjobini['flags']['vereinsrekordeeinlesen'] = 0;
    	schreibe_ini_datei(PFAD_INCLUDE.'conf/cronjob.ini',$cronjobini,true);
    }
    return true;
}


function zeitIstRekord($zeit, $laenge, $disziplin, $mw, $alter, $mid, $wkid){
    if(is_null($this->rekordzeiten)){
    	$this->rekordzeiten = array(
    	    'vr'  => array(),
    	    'vjr' => array(),
    	    'hof' => array(),
            '_mid2alter' => array(),
            '_wkdaten' => array()
    	);
    }

    if(is_array($wkid)){
    	/*
        $wkid muss dieses Array enthalten:
        array(
        	id   => # ID des Wettkampfes
            jahr => # Jahr der Zeit
            datum => # Datum der Zeit in der Form YYYY-MM-DD
            bahnlaenge => # Bahnlaenge auf der die Zeit geschwommen wurde (idR 25 oder 50)
        )
        */
    	$this->rekordzeiten['_wkdaten'] = $wkid;
    }
    elseif(!isset($this->rekordzeiten['_wkdaten']['id']) or $this->rekordzeiten['_wkdaten']['id'] != $wkid){
    	# WK-Daten holen
    	$query = "SELECT id, YEAR(datum) as jahr, DATE_FORMAT(datum,'%Y-%m-%d') as datum, bahnlaenge
                    FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$wkid."";
        $this->db->holeDaten($query);
    	$this->rekordzeiten['_wkdaten'] = $this->db->holeZeile();
    }

    $ergebnis = array();

    $vjrtest = ((in_array($disziplin,array(2,3,4)) and in_array($laenge,array(50,100,200))) or
      ($disziplin==1 and in_array($laenge,array(50,100,200,400,800,1500))) or
      ($disziplin==5 and in_array($laenge,array(100,200,400))));
    $key = $disziplin.'_'.$laenge.'_'.$mw;
    if($vjrtest){ # bei 25m Strecken nicht auf V(J)R prfen (sondern nur bei den normalen Strecken, fr die es auch deutsche Rekorde gibt)
        # auf VR testen
        if(!isset($this->rekordzeiten['vr'][$key])){
            $vrid = $this->holeVereinsrekorde(array($laenge,$disziplin), '*', $mw, $this->rekordzeiten['_wkdaten']['datum']);
            $vrid = array_shift($vrid);
            if(is_null($vrid)){
                $this->rekordzeiten['vr'][$key] = 1;
            }
            else{
                $query = "SELECT zeit FROM ".DB_PREFIX."zeiten WHERE id = ".$vrid."";
                $this->db->holeDaten($query);
                $this->rekordzeiten['vr'][$key] = $this->db->holeWert();
            }
        }

        if($this->rekordzeiten['vr'][$key] == 1){ # erster der die Strecke geschwommen ist
            $ergebnis[] = 'VR(1)';
            $ergebnis[] = 'VJR(1)';
            $ergebnis[] = 'HoF';
            return $ergebnis;
        }
        if($zeit <= $this->rekordzeiten['vr'][$key]){
            $ergebnis[] = 'VR';
            # da ein VR gleichzeitig auch ein VJR, eine PB und in der HoF steht, knnen weitere Prfungen weg gelassen werden
            $ergebnis[] = 'VJR';
            $ergebnis[] = 'PB';
            $ergebnis[] = 'HoF';
            return $ergebnis;
        }

        # auf VJR testen
        $vjrkey = $key.'_'.$alter;
        if(!isset($this->rekordzeiten['vjr'][$vjrkey])){
            $vjrid = $this->holeVereinsrekorde(array($laenge,$disziplin), $alter, $mw, $this->rekordzeiten['_wkdaten']['datum']);
            $vjrid = array_shift($vjrid);
            if(is_null($vjrid)){
                $this->rekordzeiten['vjr'][$vjrkey] = 1;
            }
            else{
                $query = "SELECT zeit FROM ".DB_PREFIX."zeiten WHERE id = ".$vjrid."";
                $this->db->holeDaten($query);
                $this->rekordzeiten['vjr'][$vjrkey] = $this->db->holeWert();
            }
        }
        if($zeit <= $this->rekordzeiten['vjr'][$vjrkey]){
            $ergebnis[] = 'VJR';
        }
        if($this->rekordzeiten['vjr'][$vjrkey] == 1){ # erster der die Strecke geschwommen ist
            $ergebnis[] = 'VJR(1)';
        }
    }

    # auf PB testen
    $query = "SELECT MIN(zeit) as min, bahnlaenge FROM ".DB_PREFIX."zeiten as z, ".DB_PREFIX."wettkaempfe as w
                WHERE mitgliedid = ".$mid." AND disziplin = ".$disziplin." ANd streckenlaenge = ".$laenge." AND
                  zeit IS NOT NULL AND bestenliste = 1 AND z.wettkampfid = w.id AND z.datum < '".$this->rekordzeiten['_wkdaten']['datum']."'
                GROUP BY bahnlaenge";
    $this->db->holeDaten($query);
    $zeiten = $this->db->baueArray('min','bahnlaenge');
    if(!isset($zeiten[25])){
    	$zeiten[25] = 1;
    }
    if(!isset($zeiten[50])){
    	$zeiten[50] = 1;
    }
	$wkb = $this->rekordzeiten['_wkdaten']['bahnlaenge']; # = Bahnlnge des Wettkampfes
    $wkb2 = $wkb==25?50:25;
    $pb = false;

	if($zeiten[$wkb] > $zeit){ # -> prinzipiell PB, aber noch prfen ob Zusatz ntig oder nicht
    	if($zeiten[$wkb2] == 1 or $zeiten[$wkb2] > $zeit){
        	$ergebnis[] = 'PB';
        	$pb = true;
        }
        else{
        	$ergebnis[] = 'PB'.$wkb;
        }
    }
    elseif($zeiten[$wkb] == 1){
    	if($zeiten[$wkb2] > $zeit){
        	$ergebnis[] = 'PB';
            $pb = true;
        }
        elseif($zeiten[$wkb2] == 1){
        	$pb = true;
        }
    }

    # auf HoF testen (nur wenn PB und es eine Bestenliste gibt)
    $hoftest = (in_array($disziplin,array(1,2,3,4)) and in_array($laenge,array(50,100,200))) or ($disziplin==5 and $laenge==200);
    if($pb and $hoftest){
    	if(!isset($this->rekordzeiten['hof'][$key.'_o'])){
    		$blkey = $laenge.'_'.$disziplin.'_'.$mw;
        	$hof = $this->holeBestenlisten(array($disziplin,$laenge), $mw, $this->rekordzeiten['_wkdaten']['datum']);
            $b = isset($hof[$blkey.'_b']);
            # letzte IDs holen
            $oids = $hof[$blkey.'_o'];
            $id_o = $id_b = false;
            if(count($oids) < 10){
            	$zeit_o = 359999;
            }
            else{
            	$id_o = array_pop($oids);
            }
            if($b){
            	$bids = $hof[$blkey.'_b'];
            	if(count($bids) < 10){
            		$zeit_b = 359999;
            	}
                else{
                	$id_b = array_pop($bids);
                }
            }
            if($id_o !== false or $id_b !== false){
            	$ids = array();
                if($id_o !== false){
                	$ids[] = $id_o;
                }
                if($id_b !== false){
                	$ids[] = $id_b;
                }
    			$query = "SELECT id, zeit FROM ".DB_PREFIX."zeiten WHERE id IN (".implode(',',$ids).")";
    			$this->db->holeDaten($query);
    			$id2zeit = $this->db->baueArray('zeit','id');
                if($id_o !== false){
                	$zeit_o = $id2zeit[$id_o];
                }
                if($id_b !== false){
                	$zeit_b = $id2zeit[$id_b];
                }
            }
            # testen ob $zeit kleine ist als lezte Zeit in der HoF (in dem Fall muss die neue Zeit drin stehen)
            $this->rekordzeiten['hof'][$key.'_o'] = $zeit_o;
            if($b){
                $this->rekordzeiten['hof'][$key.'_b'] = $zeit_b;
            }
        }

        if($alter[0] != 'a' and $alter <= 11 and isset($this->rekordzeiten['hof'][$key.'_b'])){ # HoF11?
        	if($this->rekordzeiten['hof'][$key.'_b'] > $zeit){
            	$ergebnis[] = 'HoF11';
            }
        }
        if(isset($this->rekordzeiten['hof'][$key.'_o'])){ # HoF? (Prfung, auf vorhandensein, da es nicht fr jede Disziplin eine HoF gibt)
        	if($this->rekordzeiten['hof'][$key.'_o'] > $zeit){
        		$ergebnis[] = 'HoF';
        	}
        }
    }

	return $ergebnis;
}


function holeRekorde($art){

/*
Rekordarten:
VR    = Vereinsrekord
VR11  = Vereinsrekord fr max. 11 jhrige
VJR   = Vereinsjahrgangsrekord (fr 12 bis 19 jhrige)

statt V knnen auch folgende Buchstaben eingesetzt werden:
D = Deutscher Rekord
E = Europarekord
W = Weltrekord


*/

}



}

# EOF
?>