<?php
/*
 Wettkampfabwicklung, Aktion: ergebnisseimportieren
 verwendete Templates:
  - wettkaempfe/42.abwickeln-import-dateiform.inc.html
  - wettkaempfe/42.abwickeln-import-vereinwaehlen.inc.html
  - tools/9902.loeschfrage.inc.html
  - wettkaempfe/42.abwickeln-import-mitgliederpruefen.inc.html
  - wettkaempfe/42.abwickeln-import-datenbearbeiten.inc.html
  - wettkaempfe/42.abwickeln-import-anzahlstarter.inc.html
*/

if(isset($_GET['zuruecksetzen'])){
	unset($_SESSION['wk_abwickeln']['import']);
}

if(!isset($_SESSION['wk_abwickeln']['import'])){ # erster Schritt (= Auswahl der DSV-Datei)
	# Ergebnis-Datei auswhlen und einlesen
    $dateien = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
    $anzeigen = array();
    foreach($dateien as $datei => $daten){
    	# momentan werden von tkswim nur DSV-Dateien untersttzt, wenn weitere Dateiformate untersttzt werden, muss
        #  der Code hier so angepasst werden, dass auch diese Formate angezeigt werden
        if(substr(strtolower($daten),-4) != '.dsv'){
            continue;
        }
        list(,$userid,$dateiname) = explode('|',$daten);
        if($userid != $_SESSION['user']['id'] and !prueferechte('s_dateien_rootzugriff')){
            continue;
        }
        $anzeigen[$datei] = $dateiname;
        arsort($anzeigen);
    }

    if(!isset($_POST['datei']) or !in_array($_POST['datei'],array_keys($anzeigen))){
        $_tmpl->assign('dateien',$anzeigen);
        $_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-import-dateiform.inc.html');
    }
    else{
    	$datname = $_POST['datei'];
        require_once('class/dsv.inc.php');
        $dsv = new dsv;
        $erg = $dsv->leseDateiEin(PFAD_TMP.$datname);

    	# diverse Prfungen ob die Datei in Ordung ist
        $f = '';
        if($erg === false){
        	$f .= 'Die angegebene Datei ist keine gltige DSV-Ergebnis-Datei<br />';
        }
        else{
        	if(!in_array($dsv->daten['art'], array('vereinsergebnisliste', 'wettkampfergebnisliste'))){
            	$f .= 'Die angegebene Datei ist keine Vereins- oder Wettkampfergebnisdatei<br />';
            }
            if($dsv->daten['art'] == 'vereinsergebnisliste' and $dsv->daten['vereinsbezeichnung'][1]['vnkennzahl'] != TKSWIM_VEREINSID){
            	$f .= 'Die angegebene Datei ist eine Vereinsergebnisdatei fr einen anderen Verein<br />';
            }
        }
        # Fehler ausgeben bzw. Daten in Session speichern
        if(!empty($f)){
            $_tmpl->assign('fehler',$f);
        	$_tmpl->assign('dateien',$anzeigen);
        	$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-import-dateiform.inc.html');
        }
        else{
        	# nicht bentigte Daten lschen und in Rest in der Session speichern
            $daten = $dsv->daten;
            foreach($daten['abschnitte'] as $key => $abschn){
            	$daten['abschnitte'][$key] = text_format($abschn['datum'], 'dbdatum');
            }
            foreach($daten['wettkaempfe'] as $key => $wettk){
            	unset($daten['wettkaempfe'][$key]['blzuordn']);
            }
            unset($daten['veranstaltung'], $daten['veranstalter'], $daten['ausrichter'], $daten['absender']);
	        $_SESSION['wk_abwickeln']['import'] = array(
	            'schritt' => 2,
                'verein'  => '',
                'flags'   => array(),
                'daten'   => $daten
	        );
            if($daten['art'] == 'vereinsergebnisliste'){
            	# bei Vereinsergebnisdateien entfllt der zweite Schritt (Auswahl des Vereins)
                $_SESSION['wk_abwickeln']['import']['flags']['nureinverein'] = true;
                $_SESSION['wk_abwickeln']['import']['verein'] = array(1);
            }
            weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren');
        }
    }
}
elseif($_SESSION['wk_abwickeln']['import']['schritt'] == 2){ # zweiter Schritt (= Auswahl des Vereins)
	# nur ein Verein vorhanden -> $_POST setzten als ob das Formular bereits abgeschickt worden wre
	if(isset($_SESSION['wk_abwickeln']['import']['flags']['nureinverein'])){
    	$_POST['vereine'] = $_SESSION['wk_abwickeln']['import']['verein'];
        unset($_SESSION['wk_abwickeln']['import']['flags']['nureinverein']);
    }

	# Verein auswhlen
    if(isset($_POST['vereine']) and is_array($_POST['vereine'])){
    	foreach($_POST['vereine'] as $key => $verein){
        	if(!in_array($verein, array_keys($_SESSION['wk_abwickeln']['import']['daten']['vereinsbezeichnung']))){
            	unset($_POST['vereine'][$key]);
            }
        }
       if(count($_POST['vereine'])<1){
        	$_tmpl->assign('fehler', 'es wurde kein Verein ausgewhlt.');
        }
        else{
        	$_SESSION['wk_abwickeln']['import']['verein'] = $_POST['vereine'];
            # Session-Daten entrmpeln
              # Vereine rauswerfen
            unset($_SESSION['wk_abwickeln']['import']['daten']['vereinsbezeichnung']);
              # Ergebnisse durchlaufen und die Ergebnisse der anderen Vereine rauswerfen
              #  gleichzeitig ein Array mit Mitgliedern erstellen
            $mitglieder = array();
            $staffeln = array();
            $vorhanden = array();
            $i = 1;
            $is = 1;
            foreach($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'] as $wknr => $daten){
                foreach($daten as $wkart => $ergebnisse){
                	foreach($ergebnisse as $key => $row){
                    	if(!in_array($row['verein'], $_SESSION['wk_abwickeln']['import']['verein'])){
                        	unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart][$key]);
                        	continue;
                        }
                        # Mitglied in Array schreiben
                        if(isset($row['mannschaft'])){ # Staffel
                        	if(count($row['schwimmer'])<1 and $row['platz']=='NA'){
                            	unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart][$key]);
                            	continue; # NA-Staffeln ohne Teilnehmer verwerfen
                            }
                            # Schwimmer suchen/anlegen
                        	foreach($row['schwimmer'] as $sid => $schw){
                                $suchkey = $schw['name'].$schw['mw'].$schw['jahrg'].$schw['dsvid'];
                                if(in_array($suchkey, $vorhanden)){
                                    $arrayid = array_search($suchkey, $vorhanden);
                                    $mitglieder[$arrayid]['_staffel'][] = $is;
                                }
                                else{
                                    $arrayid = $i;
                                    $i++;
                                    $vorhanden[$arrayid] = $suchkey;
                                    list($nname, $vname) = explode(',', $schw['name']);
                                    $mitglieder[$arrayid] = array(
                                        'vorname'  => trim($vname),
                                        'nachname' => trim($nname),
                                        'jg'       => $schw['jahrg'],
                                        'mw'       => $schw['mw'],
                                        'dsvid'    => $schw['dsvid'],
                                        'mid'      => '',
                                        '_sort'    => trim($nname).trim($vname).$schw['jahrg'],
                                    	'_einzel'  => false,
                                        '_staffel' => array($is)
                                    );
                                }
                                $row['schwimmer'][$sid]['_arrayid'] = $arrayid;
                            }
                            $_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart][$key]['schwimmer'] = $row['schwimmer'];

                            # Staffel speichern
                            $wkdat = $_SESSION['wk_abwickeln']['import']['daten']['wettkaempfe'][$wknr];
                            $staffeln[$is] = array(
                                'mannschaft' => $row['mannschaft'],
                                'strecke'    => $wkdat['laenge'].$_lagen[$wkdat['lage']][0].$wkdat['mw'],
                                '_schwimmer' => array()
                            );
                            foreach($row['schwimmer'] as $schw){
                                $staffeln[$is]['_schwimmer'][] = $schw['_arrayid'];
                            }
                            $_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart][$key]['_arrayid'] = $is;
                            $is++;
                        }
                        else{ # Einzelstrecke
                        	$suchkey = $row['name'].$row['mw'].$row['jahrg'].$row['dsvid'];
                            if(in_array($suchkey, $vorhanden)){
                            	$arrayid = array_search($suchkey, $vorhanden);
                                $mitglieder[$arrayid]['_einzel'] = true;
                            }
                            else{
                            	$arrayid = $i;
                                $i++;
                                $vorhanden[$arrayid] = $suchkey;
                                list($nname, $vname) = explode(',', $row['name']);
                            	$mitglieder[$arrayid] = array(
                                	'vorname'  => trim($vname),
                                    'nachname' => trim($nname),
                                    'jg'       => $row['jahrg'],
                                    'mw'       => $row['mw'],
                                    'dsvid'    => $row['dsvid'],
                                    'mid'      => '',
                                    '_sort'    => trim($nname).trim($vname).$row['jahrg'],
                                    '_einzel'  => true,
                                    '_staffel' => array()
                                );
                            }
                            $_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart][$key]['_arrayid'] = $arrayid;
                        }
                    }
                    if(count($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart])<1){
                    	unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart]);
                    }
                }
                if(count($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr])<1){
                	unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr]);
                }
            }

            # IDs der Mitglieder suchen
            $dsvid2key = array();
            foreach($mitglieder as $key => $row){
            	if(empty($row['dsvid'])){
                	continue;
                }
            	$dsvid2key[$row['dsvid']] = $key;
            }
              # ID anhand der DSV-ID suchen
            if(count($dsvid2key)>0){
            	$query = "SELECT id, dsvid FROM ".DB_PREFIX."mitglieder WHERE dsvid IN (".implode(',', array_keys($dsvid2key)).")";
                $_db->holeDaten($query);
                $daten = $_db->baueArray('id', 'dsvid');
                foreach($daten as $dsvid => $mid){
                	$mitglieder[$dsvid2key[$dsvid]]['mid'] = $mid;
                }
            }
             # ggf. noch die IDs von Mitgliedern ohne DSV-ID suchen
            foreach($mitglieder as $key => $row){
            	if(!empty($row['dsvid'])){
                	continue;
                }
                $query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE
                            vorname  = '".text_format($row['vorname'], 'db')."' AND
                            nachname = '".text_format($row['nachname'], 'db')."' AND
                            mw       = '".text_format($row['mw'], 'db')."' AND
                            YEAR(gebdatum) = '".text_format($row['jg'], 'db')."'";
                $_db->holeDaten($query);
                if($_db->holeAnzahl() == 1){
                	$mitglieder[$key]['mid'] = $_db->holeWert();
                }
            }
              # Mitgliederarry sortieren und sort-Key wieder entfernen
            function sortiereMitglieder($a, $b){
            	return strcmp($a['_sort'], $b['_sort']);
            }
            uasort($mitglieder, 'sortiereMitglieder');
            foreach($mitglieder as $key => $row){
            	unset($mitglieder[$key]['_sort']);
            }


              # Mitglieder in Session speichern
            $_SESSION['wk_abwickeln']['import']['mitglieder'] = $mitglieder;

            # Staffeln in Session speichern
            $_SESSION['wk_abwickeln']['import']['staffeln'] = $staffeln;

            # und weiter zum nchsten Schritt
            $_SESSION['wk_abwickeln']['import']['schritt'] = 3;
            weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren');
        }
    }
    $vereine = array();
    $ausgewaehlt = array();
    foreach($_SESSION['wk_abwickeln']['import']['daten']['vereinsbezeichnung'] as $vid => $vdat){
    	$vereine[$vid] = '&nbsp;'.$vdat['name'].' (ID: '.$vdat['vnkennzahl'].')';
        if($vdat['vnkennzahl'] == TKSWIM_VEREINSID){
        	$ausgewaehlt[] = $vid;
        }
    }
    asort($vereine);
    $_tmpl->assign('vereine',$vereine);
    $_tmpl->assign('gewaehlt',$ausgewaehlt);
    $_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-import-vereinwaehlen.inc.html');
}
elseif($_SESSION['wk_abwickeln']['import']['schritt'] == 3){ # dritter Schritt (Auswahl/Zuordnung der Personen)
	$daten_m = $_SESSION['wk_abwickeln']['import']['mitglieder'];
	$daten_s = $_SESSION['wk_abwickeln']['import']['staffeln'];
    $flags   = $_SESSION['wk_abwickeln']['import']['flags'];
    $listezeigen = true;

    if(isset($_POST['weiter'])){
    	$_SESSION['wk_abwickeln']['import']['schritt'] = 4;
        weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren');
    }

    # Mitglieder suchen
    if(isset($_GET['mitgliedaendern']) and $_GET['mitgliedaendern'] != 'abbrechen' and in_array($_GET['mitgliedaendern'],array_keys($daten_m))){
    	if(!isset($_GET['id']) or !ctype_digit($_GET['id'])){
        	if(!isset($_SESSION['wk_abwickeln']['import']['flags']['suchnamegesetzt'])){
            	$_SESSION['suche']['einst']['vorname']  = $daten_m[$_GET['mitgliedaendern']]['vorname'];
            	$_SESSION['suche']['einst']['nachname'] = $daten_m[$_GET['mitgliedaendern']]['nachname'];
            	$_SESSION['suche']['einst']['jahrg']    = $daten_m[$_GET['mitgliedaendern']]['jg'];
                $_SESSION['wk_abwickeln']['import']['flags']['suchnamegesetzt'] = true;
            }
			require_once('func/mitgliedwaehlen.inc.php');
			$_inh .= mitgliedwaehlen('/wettkaempfe/abwickeln.html', 'aktion=ergebnisseimportieren&amp;mitgliedaendern='.$_GET['mitgliedaendern']);
            $_inh .= '<hr /><p><a href="'.ROOT.'/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren&amp;mitgliedaendern=abbrechen">abbrechen</a></p>';
            $listezeigen = false;
        }
        else{
            unset($_SESSION['wk_abwickeln']['import']['flags']['suchnamegesetzt']);
        	$_SESSION['wk_abwickeln']['import']['mitglieder'][$_GET['mitgliedaendern']]['mid'] = $_GET['id'];
            weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren');
        }
    }
    elseif(isset($_GET['mitglaendern']) and $_GET['mitglaendern']=='abbrechen'){
    	unset($_SESSION['wk_abwickeln']['import']['flags']['suchnamegesetzt']);
        weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren');
    }

    # Einzelstarts verwerfen
    if(isset($_GET['startsverwerfen']) and in_array($_GET['startsverwerfen'], array_keys($daten_m)) and $daten_m[$_GET['startsverwerfen']]['_einzel'] === true){
        if(!isset($_GET['sicher'])){
        	$_tmpl->assign('frage','Sollen die Starts des Mitgliedes wirklich verworfen werden?');
        	$_tmpl->assign('neinquery','aktion=ergebnisseimportieren');
        	$_tmpl->assign('url', '/wettkaempfe/abwickeln.html');
        	$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
        	$listezeigen = false;
        }
        else{
            foreach($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'] as $wknr => $daten){
                foreach($daten as $wkart => $ergebnisse){
                    foreach($ergebnisse as $key => $row){
                        if(isset($row['mannschaft'])){ # Staffel
                        	continue 3;
                        }
                        if($row['_arrayid'] == $_GET['startsverwerfen']){
                        	unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart][$key]);
                        }
                    }
                    if(count($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart])<1){
                        unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart]);
                    }
                }
                if(count($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr])<1){
                    unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr]);
                }
            }

            if(count($daten_m[$_GET['startsverwerfen']]['_staffel']) > 0){
                # Staffelstarts -> speichern das keine Einzelstarts vorhanden sind
                $_SESSION['wk_abwickeln']['import']['mitglieder'][$_GET['startsverwerfen']]['_einzel'] = false;
            }
            else{
                # keine Staffelstarts -> weg mit dem Mitglied
                unset($_SESSION['wk_abwickeln']['import']['mitglieder'][$_GET['startsverwerfen']]);
            }
            weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren', 'Die Starts wurden aus dem Import entfernt');
        }
    }

    # Staffelstarts verwerfen
    if(isset($_GET['staffelverwerfen']) and in_array($_GET['staffelverwerfen'], array_keys($daten_s))){
        # Staffel in den Ergebnissen lschen
        foreach($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'] as $wknr => $daten){
            foreach($daten as $wkart => $ergebnisse){
                foreach($ergebnisse as $key => $row){
                    if(!isset($row['mannschaft'])){ # Einzel
                    	continue 3;
                    }
                    if($row['_arrayid'] == $_GET['staffelverwerfen']){
                    	unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart][$key]);
                        break 3;
                    }
                }
                if(count($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart])<1){
                    unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr][$wkart]);
                }
            }
            if(count($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr])<1){
                unset($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'][$wknr]);
            }
        }
        # Verweise bei den Mitgliedern auf die Staffel lschen
        foreach($daten_s[$_GET['staffelverwerfen']]['_schwimmer'] as $sid){
            # Staffelstart lschen
            $loeschen = array_search($_GET['staffelverwerfen'], $daten_m[$sid]['_staffel']);
            #trigger_error($loeschen, E_USER_NOTICE);
            unset($_SESSION['wk_abwickeln']['import']['mitglieder'][$sid]['_staffel'][$loeschen], $daten_m[$sid]['_staffel'][$loeschen]);
            if((count($daten_m[$sid]['_staffel']) < 1) and $daten_m[$sid]['_einzel'] === false){ # keine Starts mehr
            	unset($_SESSION['wk_abwickeln']['import']['mitglieder'][$sid]);
            }
        }
        # Staffel selbst lschen
        unset($_SESSION['wk_abwickeln']['import']['staffeln'][$_GET['staffelverwerfen']]);
        # und zurck zur bersicht
        weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren', 'Die Staffel wurden aus dem Import entfernt');
    }

	$fehlende = 0;
	foreach($daten_m as $key => $row){
    	if(empty($row['mid'])){
        	$fehlende++;
        }
    	if(rand(1,5)==1){
        }
    }

	if($listezeigen){
		$_tmpl->assign('fehlende', $fehlende);
		$_tmpl->assign('mitglieder', $daten_m);
		$_tmpl->assign('staffeln', $daten_s);
    	$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-import-mitgliederpruefen.inc.html');
    }
}
elseif($_SESSION['wk_abwickeln']['import']['schritt'] == 4){ # vierter Schritt (Starts berprfen)
	if(isset($_SESSION['wk_abwickeln']['import']['verein'])){ # Daten umformen
        $daten = array(
            'mitglieder'    => array(),
            'wettkaempfe'   => array(),
            'abschnitte'    => array(),
            'meldezeiten'   => array(),
            'einzelstarts'  => array(),
            'staffelstarts' => array()
        );

        # Mitglieder
        $m_key2id = array();
        foreach($_SESSION['wk_abwickeln']['import']['mitglieder'] as $key => $row){
            $daten['mitglieder'][$row['mid']] = array(
                'mid'      => $row['mid'],
                'vorname'  => $row['vorname'],
                'nachname' => $row['nachname'],
                'jg'       => $row['jg'],
                'mw'       => $row['mw'],
                'dsvid'    => $row['dsvid']
            );
            $m_key2id[$key] = $row['mid'];
        }

        # Wettkmpfe
        foreach($_SESSION['wk_abwickeln']['import']['daten']['wettkaempfe'] as $nr => $wettk){
            $daten['wettkaempfe'][$nr] = array(
                'nr' => $nr,
                'art' => $_wkarten[strtolower($wettk['art'])],
                'abschn' => $wettk['abschn'],
                'laenge' => $wettk['laenge'],
                'lage_kurz' => $wettk['lage'],
                'lage' => $_lagen[$wettk['lage']],
                'mw' => $wettk['mw'],
                'mw_lang' => $_geschlechter[$wettk['mw']]
            );
        }

        # Abschnitte
        foreach($_SESSION['wk_abwickeln']['import']['daten']['abschnitte'] as $nr => $abschn){
            $tmp = explode('-', $abschn);
            $daten['abschnitte'][$nr] = array(
                'nr' => $nr,
                'datumsort' => $abschn,
                'datum' => $tmp[2].'.'.$tmp[1].'.'.$tmp[0]
            );
        }

        # Meldezeiten holen
        $query = "SELECT mt.mid, w.wknr, mt.id, ms.wkid, ms.meldezeit
                    FROM ".DB_PREFIX."meldungen_teilnehmer as mt, (".DB_PREFIX."meldungen_starts as ms LEFT JOIN ".DB_PREFIX."wks as w ON ms.wkid=w.id)
                    WHERE mt.id = ms.teilnehmerid AND wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND ms.teilnahme != '-'
                    ORDER BY mid, wknr";
        $_db->holeDaten($query);
        if($_db->holeAnzahl() < 1){
            $daten['meldezeiten'] = false;
        }
        else{
            $verfuegbare = array();
            $tmp = $_db->baueArray('*', '#');
            foreach($tmp as $row){
                $key = $row['mid'].'_'.$row['wknr'];
                $daten['meldezeiten'][$key] = array(
                    'mid'  => $row['mid'],
                    'wknr' => $row['wknr'],
                    'tid'  => $row['id'],
                    'wkid' => $row['wkid'],
                    'meldezeit' => $row['meldezeit'],
                    '_key' => $key
                );
                $verfuegbare[$key] = $key;
            }
        }

        require_once('func/pruefen.inc.php');
        # Einzelstarts
        $daten['einzelstarts'] = array(0=>'foo');
        foreach($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'] as $wknr => $foo){
            if(strpos($_SESSION['wk_abwickeln']['import']['daten']['wettkaempfe'][$wknr]['laenge'], 'x') !== false){
                continue; # keine Einzeldisziplin
            }
            foreach($foo as $foo2){
            foreach($foo2 as $row){
                pruefen($row['endzeit'],'schwimmzeit','-');
                $zwzeiten = array();
                $i = 0;
                foreach($row['zwischenzeiten'] as $zwid => $zwzeit){
                    pruefen($zwzeit,'schwimmzeit','-');
                    if($zwzeit > 0){
                        $zwzeiten[$i==0?50:$i*100] = $zwzeit;
                    }
                    $i++;
                }
                $mitgl = $_SESSION['wk_abwickeln']['import']['mitglieder'][$row['_arrayid']];
                $wettk = $_SESSION['wk_abwickeln']['import']['daten']['wettkaempfe'][$wknr];
                $sort = $mitgl['nachname'].'_'.$mitgl['vorname'].'_'.$wettk['lage'].'_'.str_pad($wettk['laenge'], 5, '0', STR_PAD_LEFT).'_'.str_pad($wknr, 3, '0', STR_PAD_LEFT);
                $tmp = array(
                    'mid'       => $m_key2id[$row['_arrayid']],
                    'wknr'      => $wknr,
                    'meldezeit' => (isset($daten['meldezeiten'][$m_key2id[$row['_arrayid']].'_'.$wknr])?$m_key2id[$row['_arrayid']].'_'.$wknr:false),
                    'endzeit'   => $row['endzeit'],
                    'platz'     => $row['platz']=='0'?'AK':$row['platz'],
                    'platzvon'  => (isset($row['anzahl']) and !empty($row['anzahl']))?$row['anzahl']:false,
                    'zwischenzeiten' => count($zwzeiten)>0?$zwzeiten:false,
                    'rekord'    => empty($row['rekord'])?false:$row['rekord'],
                    'bemerkung' => $row['dsbem'],
                    '_sort'     => $sort
                );
                $daten['einzelstarts'][] = $tmp;
            }
            }
        }
        unset($daten['einzelstarts'][0]);

        # Staffelstarts
        $daten['staffelstarts'] = array(0=>'foo');
        foreach($_SESSION['wk_abwickeln']['import']['daten']['ergebnisse'] as $wknr => $foo){
            if(strpos($_SESSION['wk_abwickeln']['import']['daten']['wettkaempfe'][$wknr]['laenge'], 'x') === false){
                continue; # ist eine Einzeldisziplin
            }
            foreach($foo as $foo2){
            foreach($foo2 as $row){
                pruefen($row['endzeit'],'schwimmzeit','-');
                $zwzeiten = array();
                $i = 0;
                $wettk = $_SESSION['wk_abwickeln']['import']['daten']['wettkaempfe'][$wknr];
                list($anz,$laenge) = explode('x', $wettk['laenge']);
                foreach($row['zwischenzeiten'] as $zwid => $zwzeit){
                    pruefen($zwzeit,'schwimmzeit','-');
                    if($zwzeit > 0){
                        if($laenge==50){
                        	$zwzeiten[($i+1)*50] = $zwzeit;
                        }
                        elseif($laenge==25){
                        	$zwzeiten[($i+1)*25] = $zwzeit;
                        }
                        else{
                            $zwzeiten[$i==0?50:$i*100] = $zwzeit;
                        }
                    }
                    $i++;
                }
                $schwimmer = array();
                $i = 1;
                foreach($row['schwimmer'] as $schw){
                    $schwimmer[$i] = array(
                    	'mid'    => $m_key2id[$schw['_arrayid']],
                        'zwzeit' => $i*$laenge
                    );
                    $i++;
                }
                $sort = $wettk['lage'].'_'.str_pad($anz, 2, '0', STR_PAD_LEFT).'_'.str_pad($laenge, 5, '0', STR_PAD_LEFT).'_'.str_pad($wknr, 3, '0', STR_PAD_LEFT).'_'.str_pad($row['endzeit'], 7, '0', STR_PAD_LEFT);
                $tmp = array(
                    'schwimmer' => $schwimmer,
                    'wknr'      => $wknr,
                    'endzeit'   => $row['endzeit'],
                    'platz'     => $row['platz'],
                    'platzvon'  => (isset($row['anzahl']) and !empty($row['anzahl']))?$row['anzahl']:false,
                    'zwischenzeiten' => count($zwzeiten)>0?$zwzeiten:false,
                    'rekord'    => empty($row['rekord'])?false:$row['rekord'],
                    'bemerkung' => $row['dsbem'],
                    '_sort'     => $sort
                );
                $daten['staffelstarts'][] = $tmp;
            }
            }
        }
        unset($daten['staffelstarts'][0]);

        # Einzel- und Staffelergebnisse sortieren
        function ergebnissesortieren($a, $b){
            if ($a['_sort'] == $b['_sort']) {
                return 0;
            }
            return ($a['_sort'] < $b['_sort']) ? -1 : 1;
        }
        uasort($daten['einzelstarts'], 'ergebnissesortieren');
        uasort($daten['staffelstarts'], 'ergebnissesortieren');

        $_SESSION['wk_abwickeln']['import'] = array(
        	'schritt' => 4,
            'flags'   => $_SESSION['wk_abwickeln']['import']['flags']
        );
        foreach($daten as $key => $value){
        	$_SESSION['wk_abwickeln']['import'][$key] = $value;
        }
        weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren');
    }
    else{ # Daten anzeigen und ggf. korrigieren
        if(isset($_GET['loeschen'])){
        	$art = $_GET['loeschen'][0];
        	$id = substr($_GET['loeschen'], 1);
            if($art == 'e'){
				if(isset($_SESSION['wk_abwickeln']['import']['einzelstarts'][$id])){
                	unset($_SESSION['wk_abwickeln']['import']['einzelstarts'][$id]);
            		weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren', 'Der Start wurde gelscht.');
                }
            }
        }
        elseif(isset($_GET['bearbeiten'])){
        	$art = $_GET['bearbeiten'][0];
        	$id = substr($_GET['bearbeiten'], 1);
            $platzfussnote = 'Entweder eine Zahl fr eine Platzierung einer der Werte ';
            $ptmp = array();
            foreach($_platzarten as $part => $pbeschr){
            	$ptmp[] = ''.$part.' (='.$pbeschr.')';
            }
            $anz = count($ptmp);
            for($i=0;$i<$anz;$i++){
            	$platzfussnote .= $ptmp[$i].($i==$anz-2?' oder ':', ');
            }
            $_tmpl->assign('platzfussnote', $platzfussnote);

            if($art == 'e' and isset($_SESSION['wk_abwickeln']['import']['einzelstarts'][$id])){
                $_tmpl->assign('art', 'e');
                $daten = $_SESSION['wk_abwickeln']['import']['einzelstarts'][$id];
                $meldezeiten = array();
                if(is_array($_SESSION['wk_abwickeln']['import']['meldezeiten'])){
                    foreach($_SESSION['wk_abwickeln']['import']['meldezeiten'] as $row){
                        if($row['mid'] != $daten['mid']){
                            continue;
                        }
                        $wkdat = $_SESSION['wk_abwickeln']['import']['wettkaempfe'][$row['wknr']];
                        $meldezeiten[$row['_key']] = text_format($row['meldezeit'], 'schwimmzeit').' - WK '.$row['wknr'].', '.$wkdat['laenge'].'m '.$wkdat['lage'];
                    }
                    foreach($_SESSION['wk_abwickeln']['import']['einzelstarts'] as $key => $row){
                        if($key == $id){
                            continue;
                        }
                        if(in_array($row['meldezeit'],array_keys($meldezeiten))){
                            unset($meldezeiten[$row['meldezeit']]);
                        }
                    }
                    $_tmpl->assign('meldezeiten', $meldezeiten);
                }
                else{
                    $_tmpl->assign('meldezeiten', false);
                }

                $zwischenzeiten = array();
                for($i=50;$i<$_SESSION['wk_abwickeln']['import']['wettkaempfe'][$daten['wknr']]['laenge'];$i+=50){
                    if(($i==50) or ($i%100==0)){
                        $zwischenzeiten[$i] = '';
                        if(isset($daten['zwischenzeiten'][$i])){
                            $zwischenzeiten[$i] = $daten['zwischenzeiten'][$i];
                        }
                    }
                }
                $daten['zwischenzeiten'] = $zwischenzeiten;

                if(isset($_POST['speichern'])){
                    # Daten prfen
                    require_once('func/pruefen.inc.php');
                    $f = '';
                      # Endzeit
                    if($_POST['daten']['endzeit'] != '-'){
                    	$f .= pruefen($_POST['daten']['endzeit'], 'schwimmzeit', 'Die Endzeit ist ungltig');
                    }
                    $daten['endzeit'] = $_POST['daten']['endzeit'];
                      # Meldezeit
                    if(isset($_POST['daten']['meldezeit'])){
                    	$f .= pruefen($_POST['daten']['meldezeit'], 'wertemenge', 'Die Meldezeit ist ungltig', array_keys($meldezeiten));
                    	$daten['meldezeit'] = $_POST['daten']['meldezeit'];
                    }
                      # Platz, Platzvon
                    $_POST['daten']['platz'] = strtoupper($_POST['daten']['platz']);
                    $tmp1 = pruefen($_POST['daten']['platz'], 'wertemenge', '1', array_keys($_platzarten));
                    $tmp2 = pruefen($_POST['daten']['platz'], 'zahl', '2');
                    $tmp3 = pruefen($_POST['daten']['platz'], 'maxlaenge', '3', 3);
                    $tmp4 = pruefen($_POST['daten']['platz'], 'leer', '4');
                    if(empty($tmp1) and $_POST['daten']['platz'] != 'AK' and $_POST['daten']['endzeit'] != '-'){
                    	$f .= 'Der Schwimmer kann aufgrund der Platzierung keine gltige Zeit haben<br />';
                    }
                    if((empty($tmp2) or $_POST['daten']['platz'] == 'AK') and $_POST['daten']['endzeit'] == '-'){
                    	$f .= 'Der Schwimmer muss aufgrund der Platzierung eine gltige Zeit haben<br />';
                    }
                    if((!empty($tmp1) and !empty($tmp2)) or !empty($tmp3) or !empty($tmp4)){
                    	$f .= 'Der Platz ist ungltig<br />';
                    }
                    $f .= pruefen($_POST['daten']['platzvon'], 'zahl', 'Der Wert fr Platzvon ist ungltig');
                    $f .= pruefen($_POST['daten']['platzvon'], 'maxlaenge', 'Der Wert fr Platzvon ist ungltig', 3);
                    $daten['platz'] = $_POST['daten']['platz'];
                    $daten['platzvon'] = $_POST['daten']['platzvon'];
                      # Zwischenzeiten
                    if(isset($_POST['daten']['zwischenzeiten'])){
                        $zwischenzeiten = array();
                    	foreach($daten['zwischenzeiten'] as $laenge => $zwzeit){
                        	if(isset($_POST['daten']['zwischenzeiten'][$laenge])){
                                $f .= pruefen($_POST['daten']['zwischenzeiten'][$laenge], 'schwimmzeit', 'Die '.text_format($laenge,'html').'m-Zwischenzeit ist ungltig');
                                $zwischenzeiten[$laenge] = $_POST['daten']['zwischenzeiten'][$laenge];
                                if($_POST['daten']['zwischenzeiten'][$laenge] > 0){
                                	if($_POST['daten']['zwischenzeiten'][$laenge] < $tmp){
                                		$f .= 'Die '.text_format($laenge,'html').'m-Zwischenzeit darf nicht kleiner sein als die vorherige Zwischenzeit<br />';
                                	}
                                	$tmp = $_POST['daten']['zwischenzeiten'][$laenge];
                                }
                                $zwischenzeiten[$laenge] = $_POST['daten']['zwischenzeiten'][$laenge];
                            }
                        }
                    	$daten['zwischenzeiten'] = $zwischenzeiten;
                    }
                    else{
                    	$daten['zwischenzeiten'] = array();
                    }
                      # Rekord
                    $f .= pruefen($_POST['daten']['rekord'], 'wertemenge', 'Der Rekordwert ist ungltig', array('-', 'dr', 'djr', 'dmr'));
                    $daten['rekord'] = $_POST['daten']['rekord']=='-'?false:$_POST['daten']['rekord'];
                      # Bemerkung
                    $f .= pruefen($_POST['daten']['bemerkung'], 'maxlaenge', 'Die Bemerkung ist zu lang', 255);
                    $daten['bemerkung'] = $_POST['daten']['bemerkung'];

                    if(empty($f)){
                        if($_SESSION['wk_abwickeln']['import']['einzelstarts'][$id]['platzvon'] != $daten['platzvon']){
                            $_SESSION['wk_abwickeln']['import']['flags']['anzahleingeben'] = false;
                        }
                        foreach($daten['zwischenzeiten'] as $key => $value){
                        	if(empty($value)){
                            	unset($daten['zwischenzeiten'][$key]);
                            }
                        }
                        $_SESSION['wk_abwickeln']['import']['einzelstarts'][$id] = $daten;
                        weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren', 'Die nderungen wurden gespeichert.');
                    }
                    else{
                        $_tmpl->assign('fehler', $f);
                    }
                }
            }
            elseif($art == 's' and isset($_SESSION['wk_abwickeln']['import']['staffelstarts'][$id])){
				$mitglieder = array();
                foreach($_SESSION['wk_abwickeln']['import']['mitglieder'] as $row){
                	$mitglieder[$row['mid']] = $row['nachname'].', '.$row['vorname'].', '.$row['mw'].', JG: '.$row['jg'].', DSV-ID: '.$row['dsvid'];
                }
                $_tmpl->assign('mitglieder', $mitglieder);

                $_tmpl->assign('art', 's');
                $daten = $_SESSION['wk_abwickeln']['import']['staffelstarts'][$id];
                $zwischenzeiten = array();
                list($anz,$laenge) = explode('x',$_SESSION['wk_abwickeln']['import']['wettkaempfe'][$daten['wknr']]['laenge'],2);
                for($i=25;$i<$anz*$laenge;$i+=25){
                	if(($laenge==25) or ($laenge==50 and ($i%50==0)) or ($laenge>50 and (($i==50) or ($i%100==0)))){
                        $zwischenzeiten[$i] = '';
                        if(isset($daten['zwischenzeiten'][$i])){
                            $zwischenzeiten[$i] = $daten['zwischenzeiten'][$i];
                        }
                    }
                }
                $br = $br2 = array();
                foreach($daten['schwimmer'] as $nr => $row){
                	$br[$nr] = $row['zwzeit'];
                	$br2[$row['zwzeit']] = $nr;
                }
                $_tmpl->assign('br', $br);
                $_tmpl->assign('br2', $br2);
                $daten['zwischenzeiten'] = $zwischenzeiten;
                if(isset($_POST['speichern'])){
                    # Daten prfen
                    require_once('func/pruefen.inc.php');
                    $f = '';
                      # Schwimmer
                    $tmp = array();
                    foreach($_POST['daten']['schwimmer'] as $nr => $row){
                    	$tmp[$row] = $row;
                        $daten['schwimmer'][$nr]['mid'] = $row;
                    }
                    if(count($tmp) != $anz){
                    	$f .= 'Jeder Schwimmer kann nur einmal in der Staffel auftauchen<br />';
                    }
                      # Endzeit
                    if($_POST['daten']['endzeit'] != '-'){
                    	$f .= pruefen($_POST['daten']['endzeit'], 'schwimmzeit', 'Die Endzeit ist ungltig');
                    }
                    $daten['endzeit'] = $_POST['daten']['endzeit'];
                      # Platz, Platzvon
                    $_POST['daten']['platz'] = strtoupper($_POST['daten']['platz']);
                    $tmp1 = pruefen($_POST['daten']['platz'], 'wertemenge', '1', array_keys($_platzarten));
                    $tmp2 = pruefen($_POST['daten']['platz'], 'zahl', '2');
                    $tmp3 = pruefen($_POST['daten']['platz'], 'maxlaenge', '3', 3);
                    $tmp4 = pruefen($_POST['daten']['platz'], 'leer', '4');
                    if((!empty($tmp1) and !empty($tmp2)) or !empty($tmp3) or !empty($tmp4)){
                    	$f .= 'Der Platz ist ungltig<br />';
                    }
                    $f .= pruefen($_POST['daten']['platzvon'], 'zahl', 'Der Wert fr Platzvon ist ungltig');
                    $f .= pruefen($_POST['daten']['platzvon'], 'maxlaenge', 'Der Wert fr Platzvon ist ungltig', 3);
                    $daten['platz'] = $_POST['daten']['platz'];
                    $daten['platzvon'] = $_POST['daten']['platzvon'];
                      # Zwischenzeiten
                    if(isset($_POST['daten']['zwischenzeiten'])){
                        $zwischenzeiten = array();
                        $tmp = 0;
                    	foreach($daten['zwischenzeiten'] as $laenge => $zwzeit){
                        	if(isset($_POST['daten']['zwischenzeiten'][$laenge])){
                                $f .= pruefen($_POST['daten']['zwischenzeiten'][$laenge], 'schwimmzeit', 'Die '.text_format($laenge,'html').'m-Zwischenzeit ist ungltig');
                                if($_POST['daten']['zwischenzeiten'][$laenge] > 0){
                                	if($_POST['daten']['zwischenzeiten'][$laenge] < $tmp){
                                		$f .= 'Die '.text_format($laenge,'html').'m-Zwischenzeit darf nicht kleiner sein als die vorherige Zwischenzeit<br />';
                                	}
                                	$tmp = $_POST['daten']['zwischenzeiten'][$laenge];
                                }
                                $zwischenzeiten[$laenge] = $_POST['daten']['zwischenzeiten'][$laenge];
                            }
                        }
                    	$daten['zwischenzeiten'] = $zwischenzeiten;
                    }
                    else{
                    	$daten['zwischenzeiten'] = array();
                    }
                      # Rekord
                    $f .= pruefen($_POST['daten']['rekord'], 'wertemenge', 'Der Rekordwert ist ungltig', array('-', 'dr', 'djr', 'dmr'));
                    $daten['rekord'] = $_POST['daten']['rekord']=='-'?false:$_POST['daten']['rekord'];
                      # Bemerkung
                    $f .= pruefen($_POST['daten']['bemerkung'], 'maxlaenge', 'Die Bemerkung ist zu lang', 255);
                    $daten['bemerkung'] = $_POST['daten']['bemerkung'];

                    if(empty($f)){
                        if($_SESSION['wk_abwickeln']['import']['staffelstarts'][$id]['platzvon'] != $daten['platzvon']){
                            $_SESSION['wk_abwickeln']['import']['flags']['anzahleingeben'] = false;
                        }
                        foreach($daten['zwischenzeiten'] as $key => $value){
                        	if(empty($value)){
                            	unset($daten['zwischenzeiten'][$key]);
                            }
                        }
                        if(count($daten['zwischenzeiten'])<1){
                        	$daten['zwischenzeiten'] = false;
                        }
                        $alt = $daten['_sort'];
                        $teile = explode('_', $daten['_sort']);
                        $teile[4] = str_pad($daten['endzeit'], 7, '0', STR_PAD_LEFT);
                        $daten['_sort'] = implode('_',$teile);
                        $_SESSION['wk_abwickeln']['import']['staffelstarts'][$id] = $daten;
                        if($alt != $daten['_sort']){
                            function ergebnissesortieren($a, $b){
                                if ($a['_sort'] == $b['_sort']) {
                                    return 0;
                                }
                                return ($a['_sort'] < $b['_sort']) ? -1 : 1;
                            }
                            uasort($_SESSION['wk_abwickeln']['import']['staffelstarts'], 'ergebnissesortieren');
                        }
                        weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren', 'Die nderungen wurden gespeichert.');
                    }
                    else{
                        $_tmpl->assign('fehler', $f);
                    }
                }
            }
            $_tmpl->assign('daten', $daten);
            $_tmpl->assign('sonstdaten', $_SESSION['wk_abwickeln']['import']);
            $_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-import-datenbearbeiten.inc.html');
        }
        elseif(isset($_GET['anzahlstartereingeben']) and (!isset($_SESSION['wk_abwickeln']['import']['flags']['anzahleingeben']) or $_SESSION['wk_abwickeln']['import']['flags']['anzahleingeben'] == true)){
            $einzelstarts = array();
            foreach($_SESSION['wk_abwickeln']['import']['einzelstarts'] as $row){
                if(!isset($einzelstarts[$row['wknr']])){
                    $einzelstarts[$row['wknr']] = array();
                }
                $jg = $_SESSION['wk_abwickeln']['import']['mitglieder'][$row['mid']]['jg'];
                if(!isset($einzelstarts[$row['wknr']][$jg])){
                    $einzelstarts[$row['wknr']][$jg] = $row['platzvon'];
                }
            }
            ksort($einzelstarts);
            foreach($einzelstarts as $key => $w){
                krsort($einzelstarts[$key]);
            }

            $staffelstarts = array();
            $schwimmer = $_SESSION['wk_abwickeln']['import']['mitglieder'];
            foreach($_SESSION['wk_abwickeln']['import']['staffelstarts'] as $key => $row){
                $tmp = array(
                    'wknr' => $row['wknr'],
                    'endzeit' => $row['endzeit'],
                    'schwimmer' => array(),
                    'anzahl' => $row['platzvon']
                );
                foreach($row['schwimmer'] as $schw){
                    $tmp['schwimmer'][] = $schwimmer[$schw['mid']]['vorname'][0].'. '.$schwimmer[$schw['mid']]['nachname'];
                }
                $tmp['schwimmer'] = implode(', ', $tmp['schwimmer']);
                $staffelstarts[$key] = $tmp;
            }
            if(isset($_POST['speichern'])){
            	$f = '';
                require_once('func/pruefen.inc.php');

                foreach($einzelstarts as $wknr => $werte){
                	foreach($werte as $jg => $anzahl){
                    	if(!isset($_POST['einzelstarts'][$wknr][$jg])){
                        	continue;
                        }
                        $f .= pruefen($_POST['einzelstarts'][$wknr][$jg], 'maxlaenge', 'Der Wert bei WK '.$wknr.', JG '.$jg.' ist zu lang (max drei Ziffern).',3);
                        $f .= pruefen($_POST['einzelstarts'][$wknr][$jg], 'zahl', 'Der Wert bei WK '.$wknr.', JG '.$jg.' ist keine Zahl.');
                        $einzelstarts[$wknr][$jg] = $_POST['einzelstarts'][$wknr][$jg];
                    }
                }
                foreach($staffelstarts as $key => $wert){
                    	if(!isset($_POST['staffelstarts'][$key])){
                        	continue;
                        }
                        $f .= pruefen($_POST['staffelstarts'][$key], 'maxlaenge', 'Der Wert bei WK '.$staffelstarts[$key]['wknr'].' ist zu lang (max drei Ziffern).',3);
                        $f .= pruefen($_POST['staffelstarts'][$key], 'zahl', 'Der Wert bei WK '.$staffelstarts[$key]['wknr'].' ist keine Zahl.');
                        $staffelstarts[$key]['anzahl'] = $_POST['staffelstarts'][$key];
                }

                if(!empty($f)){
                	$_tmpl->assign('fehler', $f);
                }
                else{
            		foreach($_SESSION['wk_abwickeln']['import']['einzelstarts'] as $key => $row){
                		$jg = $_SESSION['wk_abwickeln']['import']['mitglieder'][$row['mid']]['jg'];
                    	$_SESSION['wk_abwickeln']['import']['einzelstarts'][$key]['platzvon'] = $einzelstarts[$row['wknr']][$jg];
                    }
            		foreach($_SESSION['wk_abwickeln']['import']['staffelstarts'] as $key => $wert){
                		$jg = $_SESSION['wk_abwickeln']['import']['mitglieder'][$row['mid']]['jg'];
                    	$_SESSION['wk_abwickeln']['import']['staffelstart'][$key]['platzvon'] = $staffelstarts[$key];
                    }
                    weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren', 'Die nderungen wurden gespeichert.');
                }
            }
            $_tmpl->assign('staffelstarts', $staffelstarts);
            $_tmpl->assign('einzelstarts', $einzelstarts);
            $_tmpl->assign('wettkaempfe', $_SESSION['wk_abwickeln']['import']['wettkaempfe']);
            $_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-import-anzahlstarter.inc.html');
        }
        elseif(isset($_GET['naergebnisseentfernen'])){
        	$anzahl = 0;
			foreach($_SESSION['wk_abwickeln']['import']['einzelstarts'] as $key => $row){
            	if($row['platz'] == 'NA'){
                	unset($_SESSION['wk_abwickeln']['import']['einzelstarts'][$key]);
                    $anzahl++;
                }
            }
			foreach($_SESSION['wk_abwickeln']['import']['staffelstarts'] as $key => $row){
            	if($row['platz'] == 'NA'){
                	unset($_SESSION['wk_abwickeln']['import']['staffelstarts'][$key]);
                    $anzahl++;
                }
            }
            if($anzahl == 0){
            	$text = 'Es sind keine NA-Ergebnisse vorhanden.';
            }
            elseif($anzahl == 1){
            	$text = 'Es wurde ein NA-Ergebniss entfernt.';
            }
            else{
            	$text = 'Es wurden '.$anzahl.' NA-Ergebnisse entfernt.';
            }
            weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren', $text);
        }
        elseif(isset($_POST['datenindbspeichern'])){
        	if(isset($_SESSION['wk_abwickeln']['import']['flags']['anzahleingeben'])){
        		unset($_SESSION['wk_abwickeln']['import']['flags']['anzahleingeben']);
            }
        	$_SESSION['wk_abwickeln']['import']['schritt'] = 5;
        	weiterleiten('/wettkaempfe/abwickeln.html?aktion=ergebnisseimportieren');
        }
        else{
    		$_tmpl->assign('daten', $_SESSION['wk_abwickeln']['import']);
        	$platzarten = array();
        	foreach($_platzarten as $key => $value){
    			$platzarten[$key] = str_replace(' ', '&nbsp;', $value);
        	}
    		$_tmpl->assign('flags', $_SESSION['wk_abwickeln']['import']['flags']);
    		$_tmpl->assign('_platzarten', $platzarten);
    		$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-import-datenpruefen.inc.html');
        }
    }
}
elseif($_SESSION['wk_abwickeln']['import']['schritt'] == 5){ # fnfter Schritt (Ergebnisse in die Datenbank schreiben)
    # Einzelstarts
    $abschnitte = $_SESSION['wk_abwickeln']['import']['abschnitte'];
    $wettkaempfe = $_SESSION['wk_abwickeln']['import']['wettkaempfe'];
    $meldezeiten = $_SESSION['wk_abwickeln']['import']['meldezeiten'];
    $anzahl = array(
        'einzel' => 0,
        'rekorde' => 0,
        'zwischenzeiten' => 0,
        'staffel' => 0,
        'staffelschwimmer' => 0
    );
    foreach($_SESSION['wk_abwickeln']['import']['einzelstarts'] as $row){
    	$datum = $abschnitte[$wettkaempfe[$row['wknr']]['abschn']]['datumsort'];
        $query = "INSERT INTO ".DB_PREFIX."zeiten SET
                      mitgliedid = ".$row['mid'].",
                      datum = '".$datum."',
                      zeit = ".($row['endzeit']<1?'NULL':$row['endzeit']).",
                      disziplin = ".$wettkaempfe[$row['wknr']]['lage_kurz'].",
                      streckenlaenge = ".$wettkaempfe[$row['wknr']]['laenge'].",
                      wettkampfid = ".$_SESSION['wk_abwickeln']['id'].",
                      bestenliste = 1,
                      platz = '".$row['platz']."',
                  	  platzvon = ".(empty($row['platzvon'])?'NULL':$row['platzvon']).",
                  	  bemerkung = ".(empty($row['bemerkung'])?'NULL':"'".text_format($row['bemerkung'], 'db')."'")."";
        $_db->fuehreQueryAus($query);
        $insertid = $_db->ergebnis['insertid'];
        $anzahl['einzel']++;

        if($row['rekord'] !== false){
        	$query = "INSERT INTO ".DB_PREFIX."zeiten_rekorde SET zeitid = ".$insertid.", art = '".strtoupper($row['rekord'])."'";
        	$_db->fuehreQueryAus($query);
        	$anzahl['rekorde']++;
        }

        if($row['meldezeit'] != false){
        	$query = "UPDATE ".DB_PREFIX."meldungen_starts SET zeitid = ".$insertid."
            		    WHERE teilnehmerid = ".$meldezeiten[$row['meldezeit']]['tid']." AND wkid = ".$meldezeiten[$row['meldezeit']]['wkid']."";
        	$_db->fuehreQueryAus($query);
        }

        if($row['zwischenzeiten'] !== false){
        	foreach($row['zwischenzeiten'] as $laenge => $zeit){
            	$query = "INSERT INTO ".DB_PREFIX."zwischenzeiten SET
                			  zeitid = ".$insertid.",
                              streckenlaenge = ".$laenge.",
                              zeit = ".$zeit.",
                              bestenliste = 1";
        		$_db->fuehreQueryAus($query);
                $anzahl['zwischenzeiten']++;
            }
        }
    }

    # Staffelstarts
    $lagen2einzel = array(1=>3,2=>2,3=>4,4=>1);
	foreach($_SESSION['wk_abwickeln']['import']['staffelstarts'] as $row){
    	$datum = $abschnitte[$wettkaempfe[$row['wknr']]['abschn']]['datumsort'];
    	list($anz,$laenge) = explode('x',$wettkaempfe[$row['wknr']]['laenge']);
        $query = "INSERT INTO ".DB_PREFIX."staffeln SET
                    wettkampfid = ".$_SESSION['wk_abwickeln']['id'].",
                    disziplin = ".$wettkaempfe[$row['wknr']]['lage_kurz'].",
                    anzahl = ".$anz.",
                    laenge = ".$laenge.",
                    mw = '".$wettkaempfe[$row['wknr']]['mw']."',
                    gesamtzeit = ".($row['endzeit']<1?'NULL':$row['endzeit']).",
                  	platz = '".$row['platz']."',
                  	platzvon = ".(empty($row['platzvon'])?'NULL':$row['platzvon']).",
                  	bemerkung = ".(empty($row['bemerkung'])?'NULL':"'".text_format($row['bemerkung'], 'db')."'")."";
    	$_db->fuehreQueryAus($query);
    	$insertid = $_db->ergebnis['insertid'];
        $anzahl['staffel']++;

        if($row['zwischenzeiten'] === false){
        	foreach($row['schwimmer'] as $nr => $dat){
            	if($wettkaempfe[$row['wknr']]['lage_kurz'] == 5){
                	$d = $lagen2einzel[$nr];
                }
                else{
                	$d = $wettkaempfe[$row['wknr']]['lage_kurz'];
                }

                $query = "INSERT INTO ".DB_PREFIX."zeiten SET
                            mitgliedid = ".$dat['mid'].",
                            datum = '".$datum."',
                            zeit = NULL,
                            disziplin = ".$d.",
                            streckenlaenge = ".$laenge.",
                            wettkampfid = ".$_SESSION['wk_abwickeln']['id'].",
                            bestenliste = 0";
                $anzahl['staffelschwimmer']++;
                $_db->fuehreQueryAus($query);
            	$zeitid = $_db->ergebnis['insertid'];
                $query = "INSERT INTO ".DB_PREFIX."staffeln_zeiten SET staffelid = ".$insertid.", zeitid = ".$zeitid.", schwimmernr = ".$nr."";
                $_db->fuehreQueryAus($query);
            }
        }
        else{
        	$row['zwischenzeiten'][$anz*$laenge] = $row['endzeit'];
            $schwimmer2zeitid = array();
            $erl = array();
        	foreach($row['schwimmer'] as $nr => $dat){
            	if($wettkaempfe[$row['wknr']]['lage_kurz'] == 5){
                	$d = $lagen2einzel[$nr];
                }
                else{
                	$d = $wettkaempfe[$row['wknr']]['lage_kurz'];
                }
                if(!isset($row['zwischenzeiten'][$dat['zwzeit']])){
                	$zeit = NULL;
                }
                else{
                	$zeit = $row['zwischenzeiten'][$dat['zwzeit']];
                    if($nr > 1){
                    	if(!isset($row['zwischenzeiten'][$row['schwimmer'][$nr-1]['zwzeit']])){
                        	$zeit = NULL;
                        }
                        else{
                        	$zeit = $zeit-$row['zwischenzeiten'][$row['schwimmer'][$nr-1]['zwzeit']];
                        }
                    }
                    $erl[] = $dat['zwzeit'];
                }
                $query = "INSERT INTO ".DB_PREFIX."zeiten SET
                            mitgliedid = ".$dat['mid'].",
                            datum = '".$datum."',
                            zeit = ".(is_null($zeit)?'NULL':$zeit).",
                            disziplin = ".$d.",
                            streckenlaenge = ".$laenge.",
                            wettkampfid = ".$_SESSION['wk_abwickeln']['id'].",
                            bestenliste = ".($nr==1?1:0)."";
                $anzahl['staffelschwimmer']++;
                $_db->fuehreQueryAus($query);
            	$zeitid = $_db->ergebnis['insertid'];
                $schwimmer2zeitid[$nr] = $zeitid;
                $query = "INSERT INTO ".DB_PREFIX."staffeln_zeiten SET staffelid = ".$insertid.", zeitid = ".$zeitid.", schwimmernr = ".$nr."";
                $_db->fuehreQueryAus($query);
            }

        	foreach($row['zwischenzeiten'] as $laenge => $zeit){
            	if(in_array($laenge, $erl)){
                	continue;
                }
                $abziehen = 0;
                foreach($row['schwimmer'] as $nr => $dat){
                	if($laenge < $dat['zwzeit']){
                    	$laenge = $laenge-$abziehen;
                        break;
                    }
                    $abziehen = $dat['zwzeit'];
                }
            	$query = "INSERT INTO ".DB_PREFIX."zwischenzeiten SET
                			  zeitid = ".$schwimmer2zeitid[$nr].",
                              streckenlaenge = ".$laenge.",
                              zeit = ".$zeit.",
                              bestenliste = ".($nr==1?1:0)."";
        		$_db->fuehreQueryAus($query);
                $anzahl['zwischenzeiten']++;
            }
        }
    }

    # Flag in der ini-Datei ndern
    $_wkeinst['flags']['ergebnisseimportiert'] = '+';
    schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);

    $einzelteile = array();
    if($anzahl['einzel']>0){
    	$einzelteile[] = $anzahl['einzel'].' '.($anzahl['einzel']==1?'Einzelstart':'Einzelstarts');
    }
    if($anzahl['staffel']>0){
    	$einzelteile[] = $anzahl['staffel'].' '.($anzahl['staffel']==1?'Staffel':' Staffeln').' ('.$anzahl['staffelschwimmer'].' Staffelteilnehmer)';
    }
    if($anzahl['zwischenzeiten']>0){
    	$einzelteile[] = $anzahl['zwischenzeiten'].' '.($anzahl['zwischenzeiten']==1?'Zwischenzeit':'Zwischenzeiten');
    }
    if($anzahl['rekorde']>0){
    	$einzelteile[] = $anzahl['rekorde'].' '.($anzahl['rekorde']==1?'Rekord':'Rekorde');
    }
    $text = 'Die Ergebnisse wurden importiert ('.implode(', ',$einzelteile).')';
    unset($_SESSION['wk_abwickeln']['import']);
    weiterleiten('/wettkaempfe/abwickeln.html', $text);
}

# EOF
?>