<?php
/*
 Wettkampfabwicklung, Aktion: pdf_pflichtzeitliste
 verwendete Templates:
  - [keines]
*/
require_once('class/pdf.inc.php');
# Richt- oder Pflichtzeit?
$query = "SELECT richtpflicht FROM ".DB_PREFIX."pflichtzeiten WHERE id = ".$_SESSION['wk_abwickeln']['pflichtzeiten']."";
$_db->holeDaten($query);
$richtpflicht = $_db->holeWert();
# Wettkaempfe holen
$query = "SELECT ps.id, wknr, a.nr as abschnnr, w.mw, w.laenge, w.disziplin, w.jahrgang
            FROM ".DB_PREFIX."pflichtzeiten_strecken as ps, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
            WHERE pflichtzeitenid = ".$_SESSION['wk_abwickeln']['pflichtzeiten']." AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND
              ps.laenge=w.laenge AND ps.disziplin = w.disziplin AND ps.mw=w.mw AND w.abschnittid = a.id AND (wkart = 'e' OR wkart = 'v')
            ORDER BY ps.laenge, ps.disziplin, w.wknr";
$_db->holeDaten($query);
if($_db->ergebnis['anzahl']<1){
	$_SESSION['hinweis'] = 'Es wurden keine Wettkmpfe gefunden';
}
else{
$wks = $_db->baueArray('*','id');
# Schwimmer fuer Wettkaempfe holen
foreach($wks as $wkid => $w){
    $conf = $w;
    $conf['richtpflicht'] = $wks[$wkid]['richtpflicht'] = $richtpflicht;
    $conf['maxzeitalter'] = $_gleinst['wettkaempfe_abwickeln']['maxzeitalter'];
    $conf['toleranz'] = $_gleinst['wettkaempfe_abwickeln'][($richtpflicht=='p'?'pflichtzeitabstand':'richtzeittoleranz')];
    unset($conf['wkart']);
	$wks[$wkid]['_schwimmer'] = $wk->schwimmerFuerPflichtzeit($conf);
}
# PDF-Klasse starten, Kopf- und Fusszeile setzen
require_once('class/pdf.inc.php');
$pdf = new tkpdf(12);
$schriftgroesse = 12;
$pdf->ezSetMargins(45,40,50,20);
$pdf->tkseitennummern();
$pdf->tkseitentitel('Mitglieder die die Richt-/Pflichtzeiten fr '.$_SESSION['wk_abwickeln']['titel'].' erfllen');
# Optionen fuer Tabellen
$optionen = array(
    'fontSize' => $schriftgroesse,
    'xPos' => 60,
    'xOrientation' => 'right',
    'shaded' => 0,
    'showLines' => 2,
    'colGap' => 7
);
# Liste nach Mitgliedern sortiert
$pdf->ezText('Liste nach Mitgliedern sortiert',$schriftgroesse+4);
$mitglieder = array();
foreach($wks as $w){
    $richtpflicht = ($w['richtpflicht']=='r'?'Richt':'Pflicht').'zeit';
	foreach($w['_schwimmer'] as $m){
    	if(!isset($mitglieder[$m['mid']])){
        	$tmp = array();
            $tmp['mid'] = $m['mid'];
            $tmp['name'] = $m['name'];
            $tmp['jahrg'] = $m['jahrg'];
            $tmp['dsvid'] = $m['dsvid'];
            $tmp['mw'] = $m['mw'];
            $tmp['richtpflicht'] = $richtpflicht;
            $tmp['_wks'] = array();
            $mitglieder[$m['mid']] = $tmp;
        }
        $tmp = array();
        $tmp['lage'] = $w['laenge'].' '.$_lagen[$w['disziplin']];
        $tmp['wknr'] = $w['wknr'].' ('.$w['abschnnr'].')';
        $tmp['meldezeit'] = text_format($m['zeit'],'schwimmzeit');
        $tmp['pflichtzeit'] = text_format($m['pflichtzeit'],'schwimmzeit');
    	$tmp['datumwettkampf'] = $m['datum'].', '.$m['kurztitel'];
        $mitglieder[$m['mid']]['_wks'][] = $tmp;
    }
}
# Mitglieder holen, die nicht an Wettkaempfen teilnehmen
$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND eigenschaft = 'keinewettkampfteilnahme'";
$_db->holeDaten($query);
$mids = $_db->baueArray('artid','#');
# Mitglieder sortieren
$tmp = array();
foreach($mitglieder as $row){
    if(in_array($row['mid'],$mids)){
        continue;
    }
    $tmp[$row['mid']] = $row['name'];
}
asort($tmp);
foreach($tmp as $mid => $name){
    $tmp[$mid] = $mitglieder[$mid];
}
$mitglieder = $tmp;
# PDF-Eintraege generieren
$spalten = array(
    'lage' => 'Strecke',
    'wknr' => 'WK',
    'meldezeit' => 'Meldezeit',
    'pflichtzeit' => '',
    'datumwettkampf' => 'Datum, Wettkampf'
);
$anz = count($mitglieder);
$i = 1;
foreach($mitglieder as $m){
	$titel = $m['name'].' ('.$m['mw'].', '.$m['jahrg'].', '.(!empty($m['dsvid'])?$m['dsvid']:'-').')';
	$y = $pdf->ezText($titel,$schriftgroesse+2);
    $spalten['pflichtzeit'] = $m['richtpflicht'];
    $daten = array();
    foreach($m['_wks'] as $w){
        $daten[] = $w;
    }
    $pdf->ezSetDy(-7);
    $y = $pdf->ezTable($daten,$spalten,'',$optionen);
    $i++;
    if($y < 120 and $i <= $anz){
    	$pdf->eznewPage();
    }
    if($i <= $anz){
    	$y = $pdf->ezSetDy(-15);
    }
}
$pdf->eznewPage();

# Tabelle nach Wettkaempfen sortiert
$pdf->ezText('Liste nach Wettkmpfen sortiert',$schriftgroesse+4);
$spalten = array(
	'name' => 'Name',
    'meldezeit' => 'Meldezeit',
    'pflichtzeit' => '',
    'datumwettkampf' => 'Datum, Wettkampf'
);
foreach($wks as $w){
	$titel = 'WK'.$w['wknr'].' - '.$w['laenge'].'m '.$_lagen[$w['disziplin']].' ';
    $titel .= $w['mw'].' (Jahrgnge: '.$w['jahrgang'].', Abschnitt: '.$w['abschnnr'].')';
	$y = $pdf->ezText($titel,$schriftgroesse+2);
    $spalten['pflichtzeit'] = ($w['richtpflicht']=='r'?'Richt':'Pflicht').'zeit';
    $daten = array();
    foreach($w['_schwimmer'] as $s){
        $tmp = array();
        $tmp['name'] = $s['name'].' ('.$s['jahrg'].')';
    	$tmp['meldezeit'] = text_format($s['zeit'],'schwimmzeit');
        $tmp['pflichtzeit'] = text_format($s['pflichtzeit'],'schwimmzeit');
    	$tmp['datumwettkampf'] = $s['datum'].', '.$s['kurztitel'];
        $daten[] = $tmp;
    }
    $pdf->ezSetDy(-7);
    if(count($daten) < 1){
		$y = $pdf->ezText('Fr diesen Wettkampf wurden keine Schwimmer gefunden',$schriftgroesse+2);
    }
    else{
    	$y = $pdf->ezTable($daten,$spalten,'',$optionen);
    }
    if($y < 120){
    	$pdf->eznewPage();
    }
    else{
    	$y = $pdf->ezSetDy(-15);
    }
}
# PDF-Autor und -Titel setzen, ausgeben
$pdf->tk_autor = $_SESSION['user']['realname'];
$pdf->tk_titel = 'Mitglieder die Richt-/Pflichtzeiten fr '.$_SESSION['wk_abwickeln']['titel'].' erfllen';
if(isset($_GET['ziel']) and $_GET['ziel']=='dateisystem' and isset($_SESSION['wk_abwickeln']['verzeichnisid'])){
	require_once('class/dateien.inc.php');
    $dat = new dateien($_db,$_tmpl);
	$daten = $pdf->tkstream('liste_pflichtzeiten.pdf','rueckgabe');
    if($dat->legeDateiInWettkampfvereichnisAn($_SESSION['wk_abwickeln']['verzeichnisid'], 'liste_pflichtzeiten.pdf', 'pdf', $daten, 'Schwimmer die die Pflichtzeiten erfllen',true)){
    	weiterleiten('/wettkaempfe/abwickeln.html','die Datei wurde im Dateisystem abgelegt');
    }
}
$pdf->tkstream('liste_pflichtzeiten.pdf');
} # Ende else fr Prfung auf Vorhandensein von Wettkmpfen
# EOF
?>