<?php
/*
 Wettkampfabwicklung, Aktion: pdf_teilnehmer
 verwendete Templates:
  - [keines]
*/
$query = "SELECT mt.id as tid, mid, CONCAT(m.nachname,', ',m.vorname) as name, m.mw, YEAR(gebdatum) as jg,
              w.wknr, w.id as wkid, a.nr as abschnnr, w.laenge as laenge, w.disziplin, ms.meldezeit as zeit, mt.teilnahme
            FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."wks as w,
              ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."mitglieder as m
            WHERE ms.teilnehmerid=mt.id AND w.id = ms.wkid AND w.abschnittid = a.id AND
              mt.mid = m.id AND mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND
              ms.teilnahme IN ('0','+') AND mt.teilnahme IN ('0','+')
            ORDER BY m.nachname, m.vorname, w.wknr";
$_db->holeDaten($query);
$mitgldaten = array();
if($_db->ergebnis['anzahl'] > 0){
	$mid = 0;
    foreach($_db->ergebnis['daten'] as $row){
    	if($mid != $row['mid']){
        	$mitgldaten[$row['mid']] = array(
            	'mid'  => $row['mid'],
                'tid'  => $row['tid'],
                'name' => $row['name'],
                'mw'   => $row['mw'],
                'jg'   => $row['jg'],
                'teilnahme' => $row['teilnahme'],
                '_wks' => array()
            );
            $mid = $row['mid'];
        }
        $mitgldaten[$row['mid']]['_wks'][] = array(
        	'wknr'      => $row['wknr'],
            'wkid'      => $row['wkid'],
        	'anr'       => $row['abschnnr'],
        	'laenge'    => $row['laenge'],
        	'disziplin' => $row['disziplin'],
        	'zeit'      => is_null($row['zeit'])?'[ohne]':$row['zeit']
        );
    }
}
require_once('class/pdf.inc.php');
$schriftgroesse = (isset($_GET['sg']) and ctype_digit($_GET['sg']))?$_GET['sg']:12;
$pdf = new tkpdf($schriftgroesse);
$daten = array();
$teilnahmenichtsicher = false;
foreach($mitgldaten as $m){
	$name = $m['name'].' ('.$m['mw'].', '.$m['jg'].')'.($m['teilnahme']=='0'?'*':'');
    if($m['teilnahme']=='0'){
    	$teilnahmenichtsicher = true;
    }
    $i = 1;
	foreach($m['_wks'] as $wk){
    	$tmp = array();
        $tmp['name'] = ($i==1?$name:'');
        $tmp['lage'] = $wk['laenge'].' '.$_lagen[$wk['disziplin']];
        $tmp['wknr'] = $wk['wknr'].' ('.$wk['anr'].')';
        $tmp['meldezeit'] = text_format($wk['zeit'],'schwimmzeit');
        $tmp['erreichte'] = '';
        $daten[] = $tmp;
        $i++;
    }
}
$spalten = array(
	'name' => '<b>Name</b>',
    'lage' => '<b>Strecke</b>',
    'wknr' => '<b>WK</b>',
    'meldezeit' => '<b>Meldez.</b>',
    'erreichte' => '<b>er. Zeit</b>'
);
$optionen = array(
	'fontSize' => $schriftgroesse,
    'xPos' => 60,
    'xOrientation' => 'right',
    'shaded' => 0,
    'showLines' => 2,
    'colGap' => 7
);
$pdf->ezSetMargins(45,40,50,20);
$pdf->tkseitennummern();
$pdf->tkseitentitel('Teilnehmerliste fr '.$_SESSION['wk_abwickeln']['titel'].' (nach Mitgliedern sortiert)');
$pdf->ezTable($daten,$spalten,'',$optionen);
if($teilnahmenichtsicher){
	$pdf->ezText("\n* Teilnahme noch nicht sicher",$schriftgroesse);
}
$pdf->tk_autor = $_SESSION['user']['realname'];
$pdf->tk_titel = 'Teilnehmerliste, '.$_SESSION['wk_abwickeln']['titel'];
if(isset($_GET['ziel']) and $_GET['ziel']=='dateisystem' and isset($_SESSION['wk_abwickeln']['verzeichnisid'])){
	require_once('class/dateien.inc.php');
    $dat = new dateien($_db,$_tmpl);
	$daten = $pdf->tkstream('wettkampfmeldung_teilnehmer.pdf','rueckgabe');
    if($dat->legeDateiInWettkampfvereichnisAn($_SESSION['wk_abwickeln']['verzeichnisid'], 'wettkampfmeldung_teilnehmer.pdf', 'pdf', $daten, 'Teilnehmerliste',true)){
    	weiterleiten('/wettkaempfe/abwickeln.html','die Datei wurde im Dateisystem abgelegt');
    }
}
$pdf->tkstream('wettkampfmeldung_teilnehmer.pdf');
# EOF
?>