<?php

$_einstellungen_module = array(
	'features' => array(
    	'titel'        => 'Features',
        'beschreibung' => 'ein- bzw. ausschalten von einzelnen Features'
    ),
    'seitenweit' => array(
    	'titel'        => 'seitenweite Einstellungen',
    	'beschreibung' => 'Einstellungen die gesamte Seite betreffen bzw. sich nicht einer Kategorie zuordnen lassen'
    ),
	'training_anwesenheitsliste' => array(
    	'titel'        => 'Training - Anwesenheitsliste',
    	'beschreibung' => 'Einstellungen fr der Erzeugen von Anwesenheitslisten'
    ),
	'wettkaempfe_abwickeln' => array(
    	'titel'        => 'Wettkmpfe - abwickeln',
    	'beschreibung' => 'Einstellungen zum Abwickeln von Wettkmpfen'
    ),
	'wettkaempfe_abwickeln_meldezettel' => array(
    	'titel'        => 'Wettkmpfe - abwickeln (Meldezettel)',
    	'beschreibung' => 'Verfgbare Abkrzungen fr die Texte auf Meldezetteln bzw. Texte auf dem Rcklaufzettel'
    ),
);

$_einstellungen = array(
	'features' => array(
    	'mitgliederkarten' => array(
        	'titel'    => 'Mitgliederkarten',
            'beschreibung' => 'Soll in tkswim das Vorhandensein von Mitgliederkarten verwaltet werden?',
            'art'      => 'bool',
            'standard' => '1'
        )
    ),
	'seitenweit' => array(
    	'standardvorwahl' => array(
        	'titel'    => 'Standardvorwahl',
            'beschreibung' => 'Die Standard-Telefonvorwahl um die Telefonnummern ohne Vorwahl automatisch ergnzt werden',
            'art'      => 'text',
            'standard' => '0911',
            'form'     => '0[0-9]{2,4}',
            'fehler'   => 'Die Telefonvorwahl muss zwischen 3 und 5 Ziffern lang sein und mit einer 0 beginnen'
        )
    ),
	'training_anwesenheitsliste' => array(
    	'traininginferien' => array(
        	'titel'    => 'Training in den Ferien',
            'beschreibung' => 'Findet in den Ferien Training statt?',
            'art'      => 'bool',
            'standard' => '0',
        )
    ),
	'wettkaempfe_abwickeln' => array(
        'ruecklaufzettel' => array(
            'titel'    => 'Rcklaufzettel',
            'beschreibung' => 'Sollen in tkswim die Rcklaufzettel zu Wettkmpfen verwaltet werden?',
            'art'      => 'bool',
            'standard' => '1',
        ),
		'richtzeittoleranz' => array(
        	'titel'    => 'Richtzeittoleranz',
            'beschreibung' => 'Gibt an wieviele Sekunden die Meldezeit langsamer als die Richtzeit sein darf.',
            'art'      => 'text',
            'standard' => '5',
            'form'     => '-?[0-9.]{1,4}%?',
            'fehler'   => 'Die Richtzeittoleranz muss eine Zahl (1-3 Stellen) sein'
        ),
		'pflichtzeitabstand' => array(
        	'titel'    => 'Pflichtzeitabstand',
            'beschreibung' => 'Gibt an wieviele Sekunden die Meldezeit unter der Pflichtzeit liegen muss.',
            'art'      => 'text',
            'standard' => '2',
            'form'     => '-?[0-9.]{1,4}%?',
            'fehler'   => 'Der Pflichtzeitabstand muss eine Zahl (1-3 Stellen) sein'
        ),
		'maxzeitalter' => array(
        	'titel'    => 'max. Zeitalter',
            'beschreibung' => 'Gibt an wie alt (in Monaten) die Meldezeiten maximal sein drfen.',
            'art'      => 'text',
            'standard' => '18',
            'form'     => '[0-9]{1,2}',
            'fehler'   => 'Das maximale Zeitalter muss eine Zahl (1 oder 2 Stellen) sein'
        ),
		'interplationsfaktorhoch' => array(
        	'titel'    => 'Interpolationsfaktor (hoch)',
            'beschreibung' => 'Mit welchem Faktor sollen interpolierte Zeiten hochgerechnet werden?',
            'art'      => 'text',
            'standard' => '1.11',
            'form'     => '[0-9]{1,2}\.[0-9]{1,2}',
            'fehler'   => 'Der Interpolationsfaktor muss eine Zahl (mit je 1 oder 2 Vor- und Nachkommastellen, mit Punkt getrennt) sein'
        ),
		'interplationsfaktorrunter' => array(
        	'titel'    => 'Interpolationsfaktor (runter)',
            'beschreibung' => 'Mit welchem Faktor sollen interpolierte Zeiten runtergerechnet werden?',
            'art'      => 'text',
            'standard' => '0.91',
            'form'     => '[0-9]{1,2}\.[0-9]{1,2}',
            'fehler'   => 'Der Interpolationsfaktur muss eine Zahl (mit je 1 oder 2 Vor- und Nachkommastellen, mit Punkt getrennt) sein'
        )
    ),
	'wettkaempfe_abwickeln_meldezettel' => array(
    	'keinewertsachen' => array(
        	'titel'    => 'Text keinewertsachen',
            'beschreibung' => 'Der Text zum Schlsselwort keinewertsachen',
            'art'      => 'text',
            'standard' => 'Bitte keine Wertsachen mitnehmen!',
            'form'     => '.{0,1000}',
            'fehler'   => 'Der Text keinewertsachen darf maximal 1000 Zeichen lang sein'
        ),
    	'rueckmeldezettelbis' => array(
        	'titel'    => 'Text rueckmeldezettelbis',
            'beschreibung' => 'Der Text zum Schlsselwort rueckmeldezettelbis',
            'art'      => 'text',
            'standard' => 'Bitte bis sptestens %s die Rckmeldezettel bei euren Trainern abgeben.',
            'form'     => '.{0,1000}',
            'fehler'   => 'Der Text rueckmeldezettelbis darf maximal 1000 Zeichen lang sein'
        ),
    	'beinichtteilnahme' => array(
        	'titel'    => 'Text beinichtteilnahme',
            'beschreibung' => 'Der Text zum Schlsselwort beinichtteilnahme',
            'art'      => 'text',
            'standard' => 'Bei Nichtteilnahme sofort bei %s abmelden!',
            'form'     => '.{0,1000}',
            'fehler'   => 'Der Text beinichtteilnahme darf maximal 1000 Zeichen lang sein'
        ),
    	'staffelwarnung' => array(
        	'titel'    => 'Text staffelwarnung',
            'beschreibung' => 'Der Text zum Schlsselwort staffelwarnung',
            'art'      => 'text',
            'standard' => '<b>Achtung:</b> Du kannst auch noch in der Staffel eingesetzt werden.',
            'form'     => '.{0,1000}',
            'fehler'   => 'Der Text staffelwarnung darf maximal 1000 Zeichen lang sein'
        ),
    	'freibadhinweis' => array(
        	'titel'    => 'Text freibadhinweis',
            'beschreibung' => 'Der Text zum Schlsselwort freibadhinweis',
            'art'      => 'text',
            'standard' => '<i>Hinweis:</i> der Wettkampf findet in einem Freibad statt, nimm deswegen bei schlechtem Wetter einen Trainingsanzug o.. und Wechselsachen mit.',
            'form'     => '.{0,1000}',
            'fehler'   => 'Der Text freibadhinweis darf maximal 1000 Zeichen lang sein'
        ),
    	'gemeinsamefahrt' => array(
        	'titel'    => 'Text gemeinsamefahrt',
            'beschreibung' => 'Der Text zum Schlsselwort gemeinsamefahrt',
            'art'      => 'text',
            'standard' => 'Wir treffen uns alle am Palm Beach und fahren gemeinsam %s, nach dem Wettkampf fahren wir wieder gemeinsam zurck zum Palm Beach.',
            'form'     => '.{0,1000}',
            'fehler'   => 'Der Text gemeinsamefahrt darf maximal 1000 Zeichen lang sein'
        ),
    	'dmsjhinweis' => array(
        	'titel'    => 'Text dmsjhinweis',
            'beschreibung' => 'Der Text zum Schlsselwort dmsjhinweis',
            'art'      => 'text',
            'standard' => 'Bedenke bitte, dass die DMS-J ein Mannschaftswettkampf ist (d.h. es gibt nur Staffeln) - wenn du also gemeldet bist, komme bitte auch, da sonst u.U. die ganze Mannschaft nicht starten kann!',
            'form'     => '.{0,1000}',
            'fehler'   => 'Der Text dmsjhinweis darf maximal 1000 Zeichen lang sein'
        ),
    	'meldegeldhinweis' => array(
        	'titel'    => 'Text meldegeldhinweis',
            'beschreibung' => 'Der Text zum Schlsselwort meldegeldhinweis',
            'art'      => 'text',
            'standard' => 'Das Meldegeld von %sEUR pro Start zahlt der Verein. Bei unentschuldigtem Fehlen msst ihr die Kosten selbst tragen!',
            'form'     => '.{0,1000}',
            'fehler'   => 'Der Text meldegeldhinweis darf maximal 1000 Zeichen lang sein'
        ),
    	'unterschriftstext' => array(
        	'titel'    => 'Unterschriftstext',
            'beschreibung' => 'Der Text ber dem Feld fr die Unterschrift der Eltern',
            'art'      => 'text',
            'standard' => 'Ich besttige hiermit, dass mein Kind die Sportgesundheit durch ein rztliches Zeugnis nachweisen kann.',
            'form'     => '.{0,200}',
            'fehler'   => 'Der Text Unterschriftstext darf maximal 200 Zeichen lang sein'
        ),
    	'freieplaetze' => array(
        	'titel'    => 'Fahrttext freieplaetze',
            'beschreibung' => 'Der Text hinter dem Kstchen fr Kinder deren Eltern selbst zum Wettkampf fahren',
            'art'      => 'text',
            'standard' => 'ich fahre selbst vom Palm Beach zum Schwimmbad und habe noch ___ Pltze frei',
            'form'     => '.{0,90}',
            'fehler'   => 'Der Fahrttext freieplaetze darf maximal 90 Zeichen lang sein'
        ),
    	'mitfahrgelegenheit' => array(
        	'titel'    => 'Fahrttext mitfahrgelegenheit',
            'beschreibung' => 'Der Text hinter dem Kstchen fr Kinder die eine Mitfahrgelegenheit brauchen',
            'art'      => 'text',
            'standard' => 'ich bentige noch eine Mitfahrgelegenheit',
            'form'     => '.{0,90}',
            'fehler'   => 'Der Fahrttext mitfahrgelegenheit darf maximal 90 Zeichen lang sein'
        )
    )
);
# EOF
?>