<?php
/*
versucht in $datum ein Datum ein Datum  zu finden und formatiert
es bei Erfolg (Rckgabe = true) im Format DD.MM.JJJJ - wenn
kein Datum erkannt wird, bleib $datum unverndert und es wird
false zurckgegeben.

Erkannte Formate (JJ wird durch $jahrprefixJJ ersetzt):
  DD(.)MM(.)(JJ)JJ
  (JJ)JJ(.)MM(.)DD
(wobei der . fr \D+ steht)

*/
function datumerkennen(&$datum,$jahrprefix=20){
    $_d = trim($datum);
    $_d = preg_replace('~[\D]+~','.',$_d);
    $teile = explode('.',$_d);
    if(count($teile) != 3){
		return false;
    }
	list($t1,$t2,$t3) = $teile;
    if(strlen($t1)==4){
        if(_gueltigesdatum($t3,$t2,$t1)){ # JJJJ.MM.DD
        	$datum = sprintf('%02d.%02d.%04d', $t3, $t2, $t1);
            return true;
        }
        return false;
    }
    if(strlen($t3)==4){
        if(_gueltigesdatum($t1,$t2,$t3)){ # DD.MM.JJJJ
        	$datum = sprintf('%02d.%02d.%04d', $t1, $t2, $t3);
            return true;
        }
        return false;
    }
    $jahr = date('Y');
    if($jahrprefix == 'auto'){
    	$tmpjahr = abs($jahr-($t3+1900)-50)<abs($jahr-($t3+2000))?$t3+1900:$t3+2000;
    }
    else{
    	$tmpjahr = $jahrprefix.$t3;
    }
    if(_gueltigesdatum($t1,$t2,$tmpjahr)){ # DD.MM.JJ
    	$datum = sprintf('%02d.%02d.%04d', $t1, $t2, $tmpjahr);
        return true;
    }
    if($jahrprefix == 'auto'){
    	$tmpjahr = abs($jahr-($t1+1900)-50)<abs($jahr-($t1+2000))?$t1+1900:$t1+2000;
    }
    else{
    	$tmpjahr = $jahrprefix.$t1;
    }
    if(_gueltigesdatum($t3,$t2,$tmpjahr)){ # JJ.MM.DD
    	$datum = sprintf('%02d.%02d.%04d', $t3, $t2, $tmpjahr);
        return true;
    }
    return false;
}

function _gueltigesdatum($tag,$monat,$jahr){
    if($tag == '' or $monat == '' or $jahr == ''){
        return false;
    }
    if(strlen($jahr) != 4){
        return false;
    }
    if(!ctype_digit($tag) or !ctype_digit($monat) or !ctype_digit($jahr)){
        return false;
    }
    if(checkdate($monat,$tag,$jahr)){
        return true;
    }
    else{
        return false;
    }
}
# EOF
?>