<?php
function erstelleAnwesenheitsliste($gruppen, $art, $conf){
	global $_db, $_tmpl, $_einst, $_gleinst, $_wochentage, $_lagen;
    require_once('class/pdf.inc.php');
    require_once('func/holetrainingsgruppen.inc.php');
    # diverse Variablen ermitteln
      # Schriftgroesse, Liniendicke, Zeilenabstand, Kstchen
    $_schriftgroesse = $_einst['anwesenheitsliste']['schriftgroesse'];
    $_liniendicke = 1;
    $_zeilenabstand = round($_schriftgroesse+$_schriftgroesse/2);
    $_nummerierung = $_einst['anwesenheitsliste']['nummerierung']==1;
    $namensanzeige = array(
        'vorname_nachname' => "CONCAT(vorname,' ',nachname)",
        'nachname_vorname' => "CONCAT(nachname,', ',vorname)"
    );
    $sortierung = array(
        'nachname'          => 'm.nachname, m.vorname',
        'vorname'           => 'm.vorname, m.nachname',
        'jahrgang_vorname'  => "YEAR(m.gebdatum), m.vorname",
        'jahrgang_nachname' => "YEAR(m.gebdatum), m.nachname"
    );
    $namensquerys = array(
        'normal-mittelefon' => "SELECT ".$namensanzeige[$_einst['anwesenheitsliste']['namensanzeige']]." as name, YEAR(gebdatum) as jg,
                  m.id, CONCAT(vorwahl,'/',nummer) as nr, MIN(telefonart) as telefonart
                FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."telefon as t ON t.mitgliedid = m.id,
                  ".DB_PREFIX."mitglieder_trainingsgruppen as tg
                WHERE tg.trainingsgruppenid = %s AND m.id = tg.mitgliedid GROUP BY m.id
                ORDER BY ".$sortierung[$_einst['anwesenheitsliste']['sortierung']],
    	'normal-ohnetelefon' => "SELECT ".$namensanzeige[$_einst['anwesenheitsliste']['namensanzeige']]." as name, YEAR(gebdatum) as jg, m.id
                FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."mitglieder_trainingsgruppen as tg
                WHERE tg.trainingsgruppenid = %s AND m.id = tg.mitgliedid
                ORDER BY ".$sortierung[$_einst['anwesenheitsliste']['sortierung']]
    );

    if($art == 'wettkampfmeldung'){
    	require_once('class/wettkaempfe.inc.php');
        $_wk = new wettkaempfe;
        $_wk->tmpl = &$_tmpl;
        $_wk->db = &$_db;
        global $_lagen, $_wkarten, $_altersklassen;
        $_wk->conf = array('lagen'=>$_lagen,'wkarten'=>$_wkarten,'altersklassen'=>$_altersklassen,'_einst'=>$_einst,'_gleinst'=>$_gleinst);

		$_teilnehmendejahrgaenge = $_wk->holeWettkampfjahrgaenge($conf['wettkampf']);

        $query = "SELECT w.id, laenge, disziplin, w.wknr
                    FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
                    WHERE w.abschnittid = a.id AND a.wettkampfid = ".$conf['wettkampf']."";
        $_db->holeDaten($query);
        $wks = array();
        foreach($_db->baueArray('*','#') as $row){
        	$wks[$row['id']] = $row['laenge'].$_lagen[$row['disziplin']][0].'('.$row['wknr'].')';
        }

        $query = "SELECT titel, YEAR(datum) as jahr FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$conf['wettkampf']."";
        $_db->holeDaten($query);
        $conf['zusatztitel'] = 'Wettkampfmeldung ('.$_db->holeWert('titel').')';
        $conf['wkjahr'] = $_db->holeWert('jahr');
    	$namensquerys['wkmeldung'] = "SELECT ".$namensanzeige[$_einst['anwesenheitsliste']['namensanzeige']]." as name, YEAR(gebdatum) as jg, m.id,
                  IF(dsvid IS NULL,0,1) as dsvid, IF(jahr IS NULL,IF(".$conf['wkjahr']."-YEAR(gebdatum)<10,'-',0),1) as lizenziert
                FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."lizenzierungen as l ON l.mitgliedid = m.id AND l.jahr = ".$conf['wkjahr'].",
                  ".DB_PREFIX."mitglieder_trainingsgruppen as tg
                WHERE tg.trainingsgruppenid = %s AND m.id = tg.mitgliedid
                ORDER BY ".$sortierung[$_einst['anwesenheitsliste']['sortierung']];
       $query = "SELECT a.nr, wknr FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
                    WHERE w.abschnittid = a.id AND a.wettkampfid = ".$conf['wettkampf']." AND w.wkart IN ('e','v')
                    ORDER BY nr, wknr";
        $_db->holeDaten($query);
        $abschnitte = array();
        foreach($_db->ergebnis['daten'] as $row){
        	if(!isset($abschnitte[$row['nr']])){
            	$abschnitte[$row['nr']] = array();
            }
            $abschnitte[$row['nr']][] = $row['wknr'];
        }
        $a = array();
        foreach($abschnitte as $nr => $abschnitt){
            $min = min($abschnitt);
            $max = max($abschnitt);
            $a[] = $nr.' (WK: '.$min.'-'.$max.')';
        }
        $fusstext = 'Abschnitte: '.implode(', ',$a);
    }

    if($art == 'normale'){
    	global $_monate, $_kurzmonate;
        require_once('class/kalender.inc.php');
        $kal = new kalender();
        $kal->db =& $_db;
    }
    # PDF-Klasse starten
    $pdf = new tkpdf($_schriftgroesse, 'quer');
    $raender = $pdf->holeRandabstaende('pt',true);

    # Titel und Wochentag der Gruppen holen
    $query = "SELECT id, wochentag, CONCAT(TIME_FORMAT(anfangszeit,'%H:%i'),'-',TIME_FORMAT(endzeit,'%H:%i')) as zeit, kommentar
                FROM ".DB_PREFIX."trainingsgruppen WHERE id IN (".implode(',',$gruppen).")";
    $_db->holeDaten($query);
    $titel = array();
    foreach($_db->baueArray('*','#') as $row){
    	$gruppendaten[$row['id']] = array(
        	'titel'     => $_wochentage[$row['wochentag']].' '.$row['zeit'].(!empty($row['kommentar'])?' - '.$row['kommentar']:''),
            'wochentag' => $row['wochentag']
        );
    }

    # aktuelle Zeiten holen
    if(isset($conf['aktuellezeiten'])){
    	$query = "SELECT mid, CONCAT(disziplin,'_',laenge) as schluessel, zeit
                    FROM ".DB_PREFIX."aktuellezeiten as a, ".DB_PREFIX."mitglieder_trainingsgruppen as mt
                    WHERE a.mid=mt.mitgliedid AND mt.trainingsgruppenid IN (".implode(',',$gruppen).")
                    HAVING schluessel IN ('".implode("','",$conf['aktuellezeiten'])."')";
        $_db->holeDaten($query);
        $_aktuellezeiten = array();
        foreach($_db->baueArray('*','#') as $row){
        	if(!isset($_aktuellezeiten[$row['mid']])){
            	$_aktuellezeiten[$row['mid']] = array();
            }
            if($conf['genauigkeit'] != 'hundertstel'){
            	$row['zeit'] = round($row['zeit'], $conf['genauigkeit']=='sekunden'?-2:-1);
            }
            $row['zeit'] = text_format((int)$row['zeit'],'schwimmzeit');
            if($conf['genauigkeit'] != 'hundertstel'){
            	$row['zeit'] = substr($row['zeit'],0,$conf['genauigkeit']=='sekunden'?-3:-1);
            }
            if($row['zeit'][0] == '0'){
            	$row['zeit'] = substr($row['zeit'],1);
            }
            $_aktuellezeiten[$row['mid']][$row['schluessel']] = $row['zeit'];
        }
    }

    $_ferientage = array();
    $erste = true;
    $mitglieder = array();
    $doppeltebreite = (isset($conf['doppeltebreite']) and $conf['doppeltebreite'])?2.2:1;
    foreach($gruppen as $gruppe){
    	if($erste){$erste = false;}else{$pdf->eznewPage();}
        # Titel setzen
        $gdat = &$gruppendaten[$gruppe];
    	$pdf->addText($raender['links']+3, 595-$raender['oben']-($_schriftgroesse+3), $_schriftgroesse+3, $gdat['titel']);
        if($art == 'wettkampfmeldung'){
        	$ztbreite = $pdf->tkgetTextWidth($_schriftgroesse+1,$conf['zusatztitel']);
    		$pdf->addText(842-$raender['rechts']-$ztbreite, 595-$raender['oben']-4, $_schriftgroesse+1, $conf['zusatztitel']);
            $query = sprintf($namensquerys['wkmeldung'], $gruppe);
        }
        else{
            $query = sprintf($namensquerys['normal-'.($conf['telefon']?'mit':'ohne').'telefon'], $gruppe);
        }

        # Mitglieder holen
        $_db->holeDaten($query);
        $mig   = $_db->baueArray('id','#');
        $daten = $_db->baueArray('*','#');
        $maxbreite_name = $maxbreite_tel = $maxbreite_az = 0;
        if(isset($conf['aktuellezeiten'])){
        	foreach($conf['aktuellezeiten'] as $az){
        		$maxbreite_zeiten[$az] = 0;
            }
        }
        foreach($daten as $row){
        	if(!isset($mitglieder[$row['id']])){
            	unset($row['telefonart']);
                $mitglieder[$row['id']] = $row;
                $mitglieder[$row['id']]['namensbreite'] = $pdf->tkgetTextWidth($_schriftgroesse, $row['name']);
                # Telefon
                if(isset($conf['telefon']) and $conf['telefon']===true){
                    if(!is_null($mitglieder[$row['id']]['nr'])){
                        $tel = $mitglieder[$row['id']]['nr'];
                        $tel = (substr($tel,0,4)==$_gleinst['seitenweit']['standardvorwahl']?substr($tel,strlen($_gleinst['seitenweit']['standardvorwahl'])+1):$tel);
                        $mitglieder[$row['id']]['telbreite'] = $pdf->tkgetTextWidth($_schriftgroesse, $tel);
                        if($mitglieder[$row['id']]['telbreite'] > $maxbreite_tel){
                            $maxbreite_tel = $mitglieder[$row['id']]['telbreite'];
                        }
                        $mitglieder[$row['id']]['nr']  = $tel;
                    }
                    else{
                        $mitglieder[$row['id']]['nr']  = '';
                        $mitglieder[$row['id']]['telbreite'] = 0;
                    }
                }
                # aktuelle Zeiten
                if(isset($conf['aktuellezeiten'])){
                    $mitglieder[$row['id']]['aktuellezeiten'] = array();
                    $mitglieder[$row['id']]['zeitbreite'] = array();
                    if(isset($_aktuellezeiten[$row['id']])){
                        foreach($conf['aktuellezeiten'] as $az){
                            if(isset($_aktuellezeiten[$row['id']][$az])){
                                $mitglieder[$row['id']]['aktuellezeiten'][$az] = $_aktuellezeiten[$row['id']][$az];
                                $mitglieder[$row['id']]['zeitbreite'][$az] = $pdf->tkgetTextWidth($_schriftgroesse, $_aktuellezeiten[$row['id']][$az])*$doppeltebreite;
                            }
                            else{
                                $mitglieder[$row['id']]['aktuellezeiten'][$az] = '';
                                $mitglieder[$row['id']]['zeitbreite'][$az] = 0;
                            }

                        }
                    }
                    else{
                        foreach($conf['aktuellezeiten'] as $az){
                            $mitglieder[$row['id']]['aktuellezeiten'][$az] = '';
                            $mitglieder[$row['id']]['zeitbreite'][$az] = 0;
                        }
                    }
                }
                # Wettkmpfe
                if($art == 'wettkampfmeldung'){
                    if(!in_array($row['jg'], $_teilnehmendejahrgaenge)){
                        $mitglieder[$row['id']]['darfnichtteilnehmen'] = 1;
                        $mitglieder[$row['id']]['dsvid'] = '-';
                        $mitglieder[$row['id']]['lizenziert'] = '-';
                    }
                    else{
                        $wkids = $_wk->wettkaempfeFuerSchwimmer($conf['wettkampf'], $row['id'], true);
                        $mitglieder[$row['id']]['wks'] = array();
                        foreach($wkids['wks'] as $id){
                            $mitglieder[$row['id']]['wks'][] = $wks[$id];
                        }
                    }
                }
            }

            if($mitglieder[$row['id']]['namensbreite'] > $maxbreite_name){
                $maxbreite_name = $mitglieder[$row['id']]['namensbreite'];
            }
            if(isset($mitglieder[$row['id']]['telbreite']) and ($mitglieder[$row['id']]['telbreite'] > $maxbreite_tel)){
                $maxbreite_tel = $mitglieder[$row['id']]['telbreite'];
            }
        	if(isset($conf['aktuellezeiten'])){
        		foreach($conf['aktuellezeiten'] as $az){
                	if($mitglieder[$row['id']]['zeitbreite'][$az] > $maxbreite_zeiten[$az]){
                    	$maxbreite_zeiten[$az] = $mitglieder[$row['id']]['zeitbreite'][$az];
                    }
            	}
        	}
        }

        if($maxbreite_name == 0){
        	$maxbreite_name = 120;
        }
        if($maxbreite_tel == 0){
        	$maxbreite_tel = 50;
        }
        if(isset($conf['aktuellezeiten'])){
        	foreach($maxbreite_zeiten as $az => $breite){
            	if($breite == 0){
                	unset($maxbreite_zeiten[$az]);
                    continue;
                }
                $maxbreite_az += $breite+$_schriftgroesse;
            }
            $speicher = 0;
        	foreach($maxbreite_zeiten as $az => $breite){
            	$maxbreite_zeiten[$az] = $speicher;
                $speicher += $breite+$_schriftgroesse;
            }
        }

        $y = 595-$raender['oben']-$_schriftgroesse-5-40;
        $x = array();
        $x['namen'] = $raender['links'];
        if($_nummerierung){
            $x['namen'] += 14;
        }
        $x['jg'] = $x['namen']+$maxbreite_name+5;
        if($art == 'wettkampfmeldung'){
        	$x['wkmeldung'] = $x['namen']+$maxbreite_name+$_zeilenabstand+7;
        }
        if(isset($conf['telefon']) and $conf['telefon']){
        	$x['telefon'] = 842-$raender['rechts']-$maxbreite_tel;
        }
        else{
        	$x['telefon'] = 842-$raender['rechts']+($_schriftgroesse/2);
        }
        if(isset($conf['aktuellezeiten'])){
        	$x['az'] = $x['telefon']-$maxbreite_az-($_schriftgroesse/2);
        }

        # Beschriftungen
        $pdf->addText($x['namen'], $y, $_schriftgroesse, 'Name');
        $pdf->addText($x['jg'], $y, $_schriftgroesse, 'JG');
        if(isset($conf['telefon']) and $conf['telefon']){
        	$pdf->addText($x['telefon'], $y, $_schriftgroesse, 'Telefon');
        }
        if(isset($conf['aktuellezeiten']) and count($maxbreite_zeiten)>0){
        	$anz = count($maxbreite_zeiten);
        	$text = $anz<2?'AZ':($anz<3?'akt.Zeiten':'aktuelle Zeiten');
        	$pdf->addText($x['az']+($_schriftgroesse/2), $y+$_zeilenabstand, $_schriftgroesse, $text);
            foreach($maxbreite_zeiten as $az => $breite){
            	list($d,$l) = explode('_',$az);
        		$pdf->addText($x['az']+$breite+($_schriftgroesse/4), $y, $_schriftgroesse, $l.$_lagen[$d][0]);
            }
        }
        if($art == 'wettkampfmeldung'){
        	$pdf->addText(842-$raender['rechts']-13, $y, $_schriftgroesse-2, 'DSV-ID', 270);
            $pdf->addText(842-$raender['rechts'], $y, $_schriftgroesse-2, 'lizenziert', 270);
        }

        # Mitglieder
        $y -= $_zeilenabstand;
        if($_nummerierung){
            $j = 1;
        }

        foreach($mig as $id){
        	if($art == 'wettkampfmeldung' and isset($mitglieder[$id]['darfnichtteilnehmen'])){
            	$pdf->tkaddText($x['namen'], $y, $_schriftgroesse, $mitglieder[$id]['name']);
            }
            else{
            	$pdf->addText($x['namen'], $y, $_schriftgroesse, $mitglieder[$id]['name']);
            }
            if($art == 'wettkampfmeldung'){
                if(isset($mitglieder[$id]['darfnichtteilnehmen'])){
                    $pdf->addText($x['wkmeldung'], $y, $_schriftgroesse, '-');
                }
                else{
                    $pdf->addText($x['wkmeldung'], $y, $_schriftgroesse, implode(', ',$mitglieder[$id]['wks']));
                }
                $pdf->addText(842-$raender['rechts']-20, $y, $_schriftgroesse, $mitglieder[$id]['dsvid']);
                $pdf->addText(842-$raender['rechts']-7, $y, $_schriftgroesse, $mitglieder[$id]['lizenziert']);
            }
            $pdf->addText($x['jg'], $y, $_schriftgroesse, substr($mitglieder[$id]['jg'],-2));
            if(isset($conf['telefon']) and $conf['telefon']===true){
            	$pdf->addText($x['telefon'], $y, $_schriftgroesse, $mitglieder[$id]['nr']);
            }
            if($_nummerierung){
                $pdf->addText($raender['links'], $y, $_schriftgroesse, $j);
                $j++;
            }
	        if(isset($conf['aktuellezeiten']) and count($maxbreite_zeiten)>0){
	            foreach($maxbreite_zeiten as $az => $breite){
	        		$pdf->addText($x['az']+$breite+($_schriftgroesse/2), $y, $_schriftgroesse, $mitglieder[$id]['aktuellezeiten'][$az]);
	            }
	        }
            $y -= $_zeilenabstand;
        }

        # waagrechte Linien
        $y = 595-$raender['oben']-$_schriftgroesse-7-40;
        $pdf->line($raender['links'],$y,842-$raender['rechts'],$y); # oberste
        while($y-$_zeilenabstand>$raender['unten']){
            $y -= $_zeilenabstand;
            $pdf->line($raender['links'], $y, 842-$raender['rechts'], $y);
        }
        $_untereslinienende = $y;
        $x2 = $x['namen']+$maxbreite_name+$_zeilenabstand+5;

        if($art == 'wettkampfmeldung'){
        	$fussbreite = $pdf->tkgetTextWidth($_schriftgroesse, $fusstext);
            $pdf->addText(842-$raender['rechts']-$fussbreite, $_untereslinienende+2, $_schriftgroesse, $fusstext);
            $pdf->line($x2, $_untereslinienende, $x2, 595-$raender['oben']-2-40);
            $pdf->line(842-$raender['rechts']-23, $_untereslinienende+$_zeilenabstand, 842-$raender['rechts']-23, 595-$raender['oben']-2-40);
        }
        if($art == 'blanko'){
        	$y = 595-$raender['oben']-2-40;
            for($i=0;$i<=$conf['kaestchen'];$i++){
                $pdf->line($x2,$_untereslinienende,$x2,$y);
                $x2 += $_zeilenabstand;
            }
        }
	    if(isset($conf['aktuellezeiten']) and count($maxbreite_zeiten)>0){
        	$y = 595-$raender['oben']-2-40;
	        $pdf->line($x['az'], $y, $x['az']+$maxbreite_az, $y);
	        $pdf->line($x['az'], $y+$_zeilenabstand, $x['az']+$maxbreite_az, $y+$_zeilenabstand);
	        $pdf->line($x['az'], $y+$_zeilenabstand, $x['az'], $y);
	        $pdf->line($x['az']+$maxbreite_az, $y+$_zeilenabstand, $x['az']+$maxbreite_az, $y);
	    	foreach($maxbreite_zeiten as $az => $breite){
	        	$pdf->line($x['az']+$breite, $y, $x['az']+$breite, $_untereslinienende);
	    	}
	        $pdf->line($x['az']+$maxbreite_az, $y, $x['az']+$maxbreite_az, $_untereslinienende);
        }

        if($art == 'normale'){
              # ersten Tag ermitteln
            list($tag,$monat,$jahr) = explode('.',$conf['von']);
            $aktuell = mktime(12,0,0,$monat,$tag,$jahr);
            $aktuellerwochentag = date('w',$aktuell);
            if($aktuellerwochentag == 0){
                $aktuellerwochentag = 7;
            }
            $tageaddieren = (7-$aktuellerwochentag+$gdat['wochentag'])%7;
            $_erstertag = $aktuell+($tageaddieren*86400);
              # letzter Tag
            list($tag,$monat,$jahr) = explode('.',$conf['bis']);
            $_letztertag = mktime(12,0,0,$monat,$tag,$jahr);
            # Trainingstage ermitteln (mit Hilfe der Klasse 'kalender')
            $i = $_erstertag;
            $m = 0;
            $j = date('Y',$i);
            $trainingstage = array();
            while($i<=$_letztertag){
                $tmp = date('Y',$i);
                if($tmp != $j){
                    $j = $tmp;
                }
                $tmp = date('n',$i);
                if($tmp != $m){
                    $m = $tmp;
                    if(!isset($_ferientage[$m.$j])){
                    	$_ferientage[$m.$j] = $kal->holeFerientage($m,$j);
                    }
                    $ferientage = $_ferientage[$m.$j];
                    $trainingstage[$m] = array();
                }
                if(!in_array(date('j',$i),$ferientage['ferientage']) or $_gleinst['training_anwesenheitsliste']['traininginferien'] == 1){
                    $trainingstage[$m][] = $i;
                }
                $i += 86400*7;
            }
            # Trainingstage
            $_trainingstagestart_x = $x2;
        	$y = 595-$raender['oben']-$_zeilenabstand-1-40;
            $pdf->line($x2,$_untereslinienende,$x2,$y+$_zeilenabstand);
            foreach($trainingstage as $key => $monat){
                $anz = count($monat);
                if($anz <= 0){
                    continue;
                }
                if($anz == 1){ # bei nur einem Tag: Monatsnummer verwenden
                    $text = $key;
                }
                elseif($anz <= 3){ # bei 2 oder 3 Tagen: Monatskurzbezeichnungen verwenden
                    $text = $_kurzmonate[$key];
                }
                else{ # bei mehr als 3 Tagen: Langbezeichnungen verwenden
                    $text = $_monate[$key];
                }
                $pdf->addText($x2+3,$y+$_zeilenabstand+2,$_schriftgroesse,$text); # Monatstext
                $pdf->line($x2,$y+$_zeilenabstand,$x2,$y+$_zeilenabstand*2); # senkrechte Linie vor Monatstext
                foreach($monat as $tag){
                    $pdf->addText($x2+1.5,$y+2,$_schriftgroesse,date('j',$tag)); # Tag des Monats
                    $x2 += $_zeilenabstand; # erhoehe x
                    $pdf->line($x2,$_untereslinienende,$x2,$y+$_zeilenabstand);
                }
                if(isset($anz) and $anz > 0){ # Linien um die Monatsnamen herum (ausser links)
                    $rechteslinienende = $x2;
                    $pdf->line($_trainingstagestart_x,$y+$_zeilenabstand*2,$rechteslinienende,$y+$_zeilenabstand*2); #obere
                    $pdf->line($_trainingstagestart_x,$y+$_zeilenabstand,$rechteslinienende,$y+$_zeilenabstand); #untere
                    $pdf->line($rechteslinienende,$_untereslinienende,$rechteslinienende,$y+$_zeilenabstand*2);
                }
            }
        }
    }

    $pdf->tk_autor = $_SESSION['user']['realname'];
	$pdf->tk_titel = 'Anwesenheitsliste - '.date('d.m.Y');
    $pdf->tkstream('anwesenheitsliste_'.date('Y-m-d').'.pdf');
}
# EOF
?>