<?php
function text_format($text, $aktion, $mq=true){
	if(is_array($text)){
    	foreach($text as $key => $t){
        	$text[$key] = text_format($t, $aktion, $mq);
        }
        return $text;
    }
	if($mq and get_magic_quotes_gpc()==1){
		$text = stripslashes($text);
	}
	if(is_array($aktion)){
		foreach($aktion as $akt){
        	$text = ausfuehren($text,$akt);
        }
	}
	else{
		$text = ausfuehren($text,$aktion);
	}
	return $text;
}
function ausfuehren($text, $aktion){
	switch($aktion){
    case 'dbdatum': #erwartet ein Datum DD.MM.YYYY und mach daraus YYYY-MM-DD
    	if(empty($text)){
    		return '';
    	}
      	$text = preg_replace('~[^0-9.]~','',$text);
      	list($tag,$monat,$jahr) = explode('.',$text,3);
      	return $jahr.'-'.$monat.'-'.$tag;
    case 'schwimmzeit':
    	$text = trim($text);
    	if(!ctype_digit($text)){
			return $text;
        }
        $_sec = floor($text/100);
        $min = floor($_sec/60);
        $sec = $_sec%60;
        $hdtl = $text - $_sec*100;
        if($min >= 60){
        	$std = floor($min/60);
        	$min = $min%60;
            return sprintf('%02d:%02d:%02d,%02d',$std,$min,$sec,$hdtl);
        }
        return sprintf('%02d:%02d,%02d',$min,$sec,$hdtl);
    	break;
    case 'linksersetzen':
    	$test = preg_match_all("/\[([Ll][Ii][Nn][Kk]):\s*([^\]\s]+)\s*\]/",$text,$erg);
      	$von = array();
      	$nach = array();
      	for($i=0;isset($erg[0][$i]);$i++){
        	if(substr($erg[2][$i],0,7)!='http://' and $erg[2][$i]{0}!='/') continue;
        	$von[] = $erg[0][$i];
        	$nach[] = '<a href="'.$erg[2][$i].'">'.$erg[2][$i].'</a>';
      	}
      	$textmitlinks = str_replace($von,$nach,$text);
      	return $textmitlinks;
    case 'db':
      	return mysql_escape_string($text);
    case 'htmlmaskieren':
    case 'html':
    case 'xml':
      	return htmlspecialchars($text);
    case 'php':
    	return str_replace("'","\\'",$text);
    case 'nl2br':
      	return preg_replace("/(\015\012)|(\015)|(\012)/",'<br />',$text);
    case 'value':
    	if($text == ''){
        	return '';
        }
      	$text = ausfuehren($text,'htmlmaskieren');
      	return ' value="'.$text.'"';
    case 'textausgabe':
      	$text = ausfuehren($text,'htmlmaskieren');
      	return ausfuehren($text,'nl2br');
    default:
      	return $text;
  }
}
//EOF
?>