<?php
# relevante Teile der _start.inc.php
require_once('conf/conf.inc.php');
if(version_compare(PHP_VERSION, '5.1.0', '>=')){
	date_default_timezone_set('Europe/Berlin');
}
# Einstellungen, Klassen und Funktionen laden
require_once('class/db.inc.php');
require_once('func/text_format.inc.php');
require_once('func/prueferechte.inc.php');
# Konstante ROOT setzen
if((strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST']) and isset($_SERVER['HTTPS'])) or isset($_SERVER['HTTP_X_FORWARDED_HOST'])){
    define('ROOT', ROOT_HTTPS);
    if(strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST'])){
        #$_SERVER['PHP_SELF'] = '/'.substr(ROOT_HTTP,7).$_SERVER['PHP_SELF'];
        ini_set('session.cookie_path', '/'.substr(ROOT_HTTP,7).'/');
    }
}
else{
    define('ROOT',ROOT_HTTP);
    if(ROOT != 'http://'.$_SERVER['HTTP_HOST']){
        ini_set('session.cookie_path', substr(ROOT_HTTP,strlen('http://'.$_SERVER['HTTP_HOST'])).'/');
    }
}
session_start();
# Ende _start.inc.php


if(!isset($_POST['aktion'])){
	exit;
}
ob_start();
switch($_POST['aktion']){

/*
case 'foobar':
    if(TKSWIM_DEBUG){
        # Debugdaten schreiben - Anfang
        $fh = fopen(PFAD_LOGDATEIEN.'tmp.xml','w');
        fwrite($fh,$ausgabe,strlen($ausgabe));
        fclose($fh);
        # Debugdaten schreiben - Ende
    }

    break;
*/
case 'online':
    header('Content-Type: text/plain');
    echo 1;
    break;

case 'dbverbindungtesten':
    function ergebnismeldung($fehler, $meldung){
        $ausgabe = '<?xml version="1.0" encoding="ISO-8859-1" ?>'."\n";
        $ausgabe .= '<ergebnis>'."\n";
        $ausgabe .= ' <erfolg>'.($fehler?0:1).'</erfolg>'."\n";
        $ausgabe .= ' <meldung>'.text_format($meldung,'htmlmaskieren').'</meldung>'."\n";
        $ausgabe .= '</ergebnis>'."\n";
        header('Content-Type: text/xml');
        echo $ausgabe;
    }

	if(!isset($_SESSION['adminlogin'])){
    	ergebnismeldung(true, 'keine Rechte');
        break;
    }
    $eralt = error_reporting(0);
    $fehler = false;

    if(!function_exists('mysql_connect')){
		$fehler = true;
        $meldung = 'Die MySQL-Erweiterung ist nicht installiert.';
    }
    else{
		$conn = @mysql_connect($_POST['server'], $_POST['benutzername'], $_POST['passwort'], true);
        if($conn === false){
        	$fehler = true;
            $meldung = 'MySQL hat folgenden Fehler gemeldet: '.mysql_error();
        }
        else{
        	$sel = mysql_select_db($_POST['name'], $conn);
            if($sel === false){
            	$fehler = true;
                $meldung = 'Es konnte nicht mit der Datenbank verbunden werden (Fehlermeldung: '.mysql_error().')';
            }
            else{
            	$meldung = 'Es wurde erfolgreich mit der Datenbank verbunden.';
            }
        }
    }
    error_reporting($eralt);
    ergebnismeldung($fehler, $meldung);
	break;

case 'alteadressespeichern':
    header('Content-Type: text/plain');
    if(!pruefeRechte('m_aendern')){
        echo 0;
        break;
    }
    # Datenbankklasse starten und Verbindung oeffnen
    $_inh = '';
    $_db = new db;
    $_db->tmpl = &$_tmpl;
    $_db->schreibschutz = TKSWIM_SCHREIBSCHUTZ;
    if(TKSWIM_SCHREIBSCHUTZ){
        echo 0;
        break;
    }
    $_db->setzeDbParameter();
    $_db->verbindeMitDb();

    $query = "SELECT id, strasse, hausnr, plz, ort FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_POST['mid'],'db')."'";
    $_db->holeDaten($query);
    if($_db->ergebnis['anzahl'] != 1){
        echo 0;
        break;
    }
    $row = $_db->holeZeile();
    $alteadresse = $row['strasse'].' '.$row['hausnr'].'|'.$row['plz'].' '.$row['ort'];
    # Datensatz bereits vorhanden?
    $query = "SELECT wert FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND artid = ".$row['id']." AND eigenschaft = 'alteadresse'";
    $_db->holeDaten($query);
    if($_db->ergebnis['anzahl'] == 0){ # kein Datensatz vorhanden -> anlegen
    	$query = "INSERT INTO ".DB_PREFIX."eigenschaften (art, artid, eigenschaft, wert)
                    VALUES ('m', ".$row['id'].", 'alteadresse', '".text_format($alteadresse,'db')."')";
    }
    else{ # Datensatz vorhanden -> aendern
    	$query = "UPDATE ".DB_PREFIX."eigenschaften SET wert = '".text_format($alteadresse,'db')."'
                    WHERE art = 'm' AND artid = ".$row['id']." AND eigenschaft = 'alteadresse'";
    }
    $_db->fuehreQueryAus($query);
	$_db->speichereGeaenderteTabellen();
    echo 1;
    break;

case 'plzortergaenzen':
    $ausgabe = '<?xml version="1.0" encoding="ISO-8859-1" ?>'."\n";
    $str = isset($_POST['str'])?utf8_decode(trim($_POST['str'])):'';
    $ort = isset($_POST['ort'])?utf8_decode(trim($_POST['ort'])):'';
    $plz = isset($_POST['plz'])?utf8_decode(trim($_POST['plz'])):'';
    function strassensort($a, $b){
        if($a['strasse'] == $b['strasse']){
            return ($a['ort'] < $b['ort']) ? -1 : 1;
        }
        return ($a['strasse'] < $b['strasse']) ? -1 : 1;
    }
    function anzsort($a, $b){
        if($a['anz'] == $b['anz']){
            return ($a['ort'] < $b['ort']) ? -1 : 1;
        }
        return ($a['anz'] < $b['anz']) ? 1 : -1;
    }

    $ausgabe .= '<ergebnis>'."\n";
    if(empty($ort) and empty($str) and empty($plz)){
    	$ausgabe .= ' <fehler reaktionsart="alert">Es muss mindestens eines der Felder Strae, Ort und PLZ (teil)ausgefllt sein.</fehler>'."\n";
    }
    else{
        # Datenbankklasse starten und Verbindung oeffnen
        $_inh = '';
        $_db = new db;
        $_db->tmpl = &$_tmpl;
        $_db->schreibschutz = TKSWIM_SCHREIBSCHUTZ;
        if(TKSWIM_SCHREIBSCHUTZ){
            echo 0;
            break;
        }
        $_db->setzeDbParameter();
        $_db->verbindeMitDb();
        # Daten ohne Strasse
        if(!empty($ort) or !empty($plz)){
            $where = array();
            if(!empty($ort)){
                $where[] = "ort LIKE '".text_format($ort,'db')."%'";
            }
            if(!empty($plz)){
                $where[] = "plz LIKE '".text_format($plz,'db')."%'";
            }

            $query = "SELECT strasse, ort, plz FROM ".DB_PREFIX."mitglieder
                        WHERE ".implode(' AND ',$where)." AND ausgetreten IS NULL";
            $_db->holeDaten($query);
            if($_db->ergebnis['anzahl'] == 0){
                $ausgabe .= '<daten id="ohnestrasse" anzahl="0" />'."\n";
            }
            else{
                $daten = array();
                foreach($_db->ergebnis['daten'] as $row){
                    foreach($daten as $key2 => $row2){
                        if($row['ort'] != $row2['ort'] or $row['plz'] != $row2['plz']){
                            continue;
                        }
                        $daten[$key2]['anz']++;
                        continue 2;
                    }
                    $row['anz'] = 1;
                    $daten[] = $row;
                }
                usort($daten,'anzsort');
                $ausgabe .= '<daten id="ohnestrasse" anzahl="'.count($daten).'">'."\n";
                foreach($daten as $row){
                    $ausgabe .= '  <datensatz anz="'.$row['anz'].'"';
                    $ausgabe .= ' ort="'.text_format($row['ort'],'htmlmaskieren').'" plz="'.text_format($row['plz'],'htmlmaskieren').'" />'."\n";
                }
                $ausgabe .= '</daten>'."\n";
            }
        }
        else{
        	$ausgabe .= '<daten id="ohnestrasse" anzahl="0" />'."\n";
        }

    	# Daten mit Strasse
    	$where = array();
        if(!empty($str)){
        	$where[] = "strasse LIKE '".text_format($str,'db')."%'";
        }
        if(!empty($ort)){
        	$where[] = "ort LIKE '".text_format($ort,'db')."%'";
        }
        if(!empty($plz)){
        	$where[] = "plz LIKE '".text_format($plz,'db')."%'";
        }

    	$query = "SELECT strasse, ort, plz FROM ".DB_PREFIX."mitglieder
                    WHERE ".implode(' AND ',$where)." AND ausgetreten IS NULL";
        $_db->holeDaten($query);
        if($_db->ergebnis['anzahl'] == 0){
        	$ausgabe .= '<daten id="mitstrasse" anzahl="0" />'."\n";
        }
        else{
            $daten = array();
            foreach($_db->ergebnis['daten'] as $row){
            	foreach($daten as $key2 => $row2){
                	if($row['strasse'] != $row2['strasse'] or $row['ort'] != $row2['ort'] or $row['plz'] != $row2['plz']){
                    	continue;
                    }
                    $daten[$key2]['anz']++;
                    continue 2;
                }
                $row['anz'] = 1;
                $daten[] = $row;
            }
            usort($daten,'strassensort');
            $ausgabe .= '<daten id="mitstrasse" anzahl="'.count($daten).'">'."\n";
            foreach($daten as $row){
            	$ausgabe .= '  <datensatz anz="'.$row['anz'].'" str="'.text_format($row['strasse'],'htmlmaskieren').'"';
            	$ausgabe .= ' ort="'.text_format($row['ort'],'htmlmaskieren').'" plz="'.text_format($row['plz'],'htmlmaskieren').'" />'."\n";
            }
        	$ausgabe .= '</daten>'."\n";
        }
    }
    $ausgabe .= '</ergebnis>';
    header('Content-Type: text/xml');
    echo $ausgabe;
	break;

case 'familieanlegen':
    $ausgabe = '<?xml version="1.0" encoding="ISO-8859-1" ?>'."\n";
	if(!pruefeRechte('m_familien_bearbeiten')){
    	$ausgabe .= '<ergebnis><fehler reaktionsart="alert">Dir fehlen fr diese Aktion die Rechte</fehler></ergebnis>';
    }
    elseif(!isset($_POST['familientitel']) or empty($_POST['familientitel'])){
    	$ausgabe .= '<ergebnis><fehler reaktionsart="keine">Es wurde kein Wert angegeben</fehler></ergebnis>';
    }
    else{
        # Datenbankklasse starten und Verbindung oeffnen
        $_inh = '';
        $_db = new db;
        $_db->tmpl = &$_tmpl;
        $_db->schreibschutz = TKSWIM_SCHREIBSCHUTZ;
        if(TKSWIM_SCHREIBSCHUTZ){
    		$ausgabe .= '<ergebnis><fehler reaktionsart="alert">Der Schreibschutz fr alle Daten ist gesetzt</fehler></ergebnis>';
        }
        else{
            $_db->setzeDbParameter();
            $_db->verbindeMitDb();

            $query = "INSERT INTO ".DB_PREFIX."familien SET titel = '".text_format(utf8_decode($_POST['familientitel']),'db')."'";
            $_db->fuehreQueryAus($query);
            $neueid = $_db->ergebnis['insertid'];
            $query = "SELECT id, titel FROM ".DB_PREFIX."familien ORDER BY titel";
            $_db->holeDaten($query);
            $ausgabe .= '<ergebnis><daten>'."\n";
            foreach($_db->ergebnis['daten'] as $row){
                $ausgabe .= '<eintrag key="'.$row['id'].'" value="'.$row['titel'].'"';
                if($row['id'] == $neueid){
                    $ausgabe .= ' selected="1"';
                }
                $ausgabe .= ' />'."\n";
            }
        }
        $ausgabe .= '</daten></ergebnis>'."\n";
    	$_db->speichereGeaenderteTabellen();
    }
    header('Content-Type: text/xml');
    echo $ausgabe;
	break;

default:
	exit;
}

/*
if(TKSWIM_DEBUG){
    # Debugdaten schreiben - Anfang
    $fh = fopen(PFAD_LOGDATEIEN.'tmp.txt','w');
    foreach($GLOBALS as $key => $value){
        if(substr($key,0,4) == 'HTTP' or in_array($key,array('_db','_tmpl','_einst','_gleinst','_eigenschaften','_SERVER','_altersklassen','_monate','_kurzmonate','_rauswerfen'))){
            unset($GLOBALS[$key]);
        }
    }
    $inh = print_r($GLOBALS,true);
    fwrite($fh,$inh,strlen($inh));
    fclose($fh);
    # Debugdaten schreiben - Ende
}
*/
exit;
# EOF
?>