<?php
function microtime_float(){
	if(version_compare(PHP_VERSION, '5.0.0', '>=')){
    	return microtime(true);
    }
    list($usec, $sec) = explode(' ', microtime());
    return ((float)$usec + (float)$sec);
}
$anfangszeit = microtime_float();
# Einstellungen holen
require_once('conf/conf.inc.php');
$_conf = array(
	'log'  => parse_ini_file(PFAD_LOGDATEIEN.'cronjob.ini',true),
    'conf' => parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true)
);
# Pruefen ob Zugriff erlaubt
if(!empty($_conf['conf']['einstellungen']['aufrufvonip'])){
	$ips = explode(',',$_conf['conf']['einstellungen']['aufrufvonip']);
	if(!in_array($_SERVER['REMOTE_ADDR'],$ips)){
		echo 'nene';
	    exit;
	}
}
# restliche Einstellungen
$_email = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
$_dateiensichern = array(
    'log'  => false,
    'conf' => false
);
$_gleinst = parse_ini_file(PFAD_INCLUDE.'conf/einstellungen.ini', true);

# Datenbankverbindung herstellen, Smarty starten, Mailscript starten
require_once('class/tktemplate.inc.php');
require_once('class/mail.inc.php');
require_once('class/db.inc.php');
require_once('class/zip.inc.php');
require_once('class/einstellungen.inc.php');
require_once('func/schreibe_ini_datei.inc.php');
require_once('func/text_format.inc.php');
$_db = new db;
$_db->setzeDbParameter();
$_db->verbindeMitDb();

$_tmpl = new tktemplate;
$_db->tmpl = &$_tmpl;
$_tmpl->register_function('pruefeRechte','pruefeRechte');

function aktionausfuehren($_aktion){
/*
 prft ob die angegebene Aktion ausgefhrt werden muss und liefert entweder true oder false zurck
*/
	global $_conf;
    if(!isset($_conf['conf']['zeitpunkte'][$_aktion])){
    	return false;
    }
    $conf = $_conf['conf']['zeitpunkte'][$_aktion];
    if($conf == 'nie'){
    	return false;
    }
    if($conf == 'taeglich'){
    	return true;
    }
    list($aktion, $wert) = explode(':',$conf);
    $wtag_heute = date('w');
    if($wtag_heute == 0){
    	$wtag_heute = 7;
    }
    if($aktion == 'woechentlich' and $wert == $wtag_heute){
    	return true;
    }
    $tag_heute  = date('j');
    # Wochentag des Monatsersten bestimmen
    $ts_1   = mktime(12,0,0,date('n'),1,date('Y'));
    $wtag_1 = date('w',$ts_1);
    if($wtag_1 == 0){
    	$wtag_1 = 7;
    }
    $tag2tag = array('mo'=>1,'di'=>2,'mi'=>3,'do'=>4,'fr'=>5,'sa'=>6,'so'=>7);
    # Aktionen einzeln behandeln
    switch($aktion){
    case 'monatlich':
    	if($wert == 'ersten' and $tag_heute == 1){
        	return true;
        }
    	if($wert == 'letzten' and (date('m') != date('m',strtotime('+1 day')))){
        	return true;
        }
    	$ges_wtag = $tag2tag[substr($wert,-2)];
        if($ges_wtag != $wtag_heute){ # die Bedingung kann heute nicht mehr zugreffen
        	return false;
        }
        # bestimmen der wievielte Wochentag das heute ist
        $faktor = $wtag_1>$wtag_heute?(7-$wtag_1+$wtag_heute):($wtag_heute-$wtag_1);
        $ges_wtag_1 = strtotime('+'.$faktor.' day',$ts_1);
        $tage = array(
        	1 => date('d',$ges_wtag_1),
        	2 => date('d',strtotime('+1 week',$ges_wtag_1)),
        	3 => date('d',strtotime('+2 week',$ges_wtag_1)),
        	4 => date('d',strtotime('+3 week',$ges_wtag_1))
        );
        if($tage[substr($wert,0,1)] == $tag_heute){
        	return true;
        }
    	break;
    case 'zweimalimmonat':
    	if($wert == '115' and ($tag_heute == 1 or $tag_heute == 15)){
        	return true;
        }
    	$ges_wtag = $tag2tag[substr($wert,-2)];
        if($ges_wtag != $wtag_heute){ # die Bedingung kann heute nicht mehr zugreffen
        	return false;
        }
        # bestimmen der wievielte Wochentag das heute ist
        $faktor = $wtag_1>$wtag_heute?(7-$wtag_1+$wtag_heute):($wtag_heute-$wtag_1);
        $ges_wtag_1 = strtotime('+'.$faktor.' day',$ts_1);
        $tage = array(
        	1 => date('d',$ges_wtag_1),
        	2 => date('d',strtotime('+1 week',$ges_wtag_1)),
        	3 => date('d',strtotime('+2 week',$ges_wtag_1)),
        	4 => date('d',strtotime('+3 week',$ges_wtag_1))
        );
        if($tage[substr($wert,0,1)] == $tag_heute or $tage[substr($wert,1,1)] == $tag_heute){
        	return true;
        }
    	break;
    default:
    	return false;
    }
    return false;
}

$anzahlmails = 0;
$query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
$_db->holeDaten($query, E_USER_ERROR, 'row');
$tabellen = $_db->baueArray('0','#');
$meldungen = array();
$relevanteeinstellungen = array(
    1 => 'emailbenachrichtigung-fehlendemitgliedskarten',
    2 => 'emailbenachrichtigung-terminbenachrichtigungszeitraum',
    3 => 'emailbenachrichtigung-terminbenachrichtigungen',
    4 => 'emailbenachrichtigung-analletermineerinnern',
    5 => 'emailbenachrichtigung-ablaufendetrainerlizenz'
);

$mail = new email;
$mail->setzeHeader('From',$_email['absender']['name'].' <'.$_email['absender']['email'].'>');
$mail->setzeHeader('User-Agent','tkswim '.TKSWIM_VERSION);
if(!empty($_email['sonstiges']['fparameter'])){
	$mail->setzeParameter('-f '.$_email['sonstiges']['fparameter'],false);
}

# zum Austritt vorgemerkte Mitglieder auf ausgetreten setzen
if(aktionausfuehren('austritte')){
	$gespeicherte = parse_ini_file(PFAD_INIDATEIEN.'tools_ausgetretene.ini',true);
    $anzahl = 0;
    require_once('func/setzemitgliedaufausgetreten.inc.php');
    foreach($gespeicherte as $jahr => $mitglieder){
    	if($jahr >= date('Y')){
        	continue;
        }
        $anzahl += setzeMitgliedAufAusgetreten(array_keys($mitglieder),$jahr,$_db);
        unset($gespeicherte[$jahr]);
    }
    if($anzahl > 0){
		$meldungen[] = 'Es '.($anzahl==1?'wurde 1 Mitglied':'wurden '.$anzahl.' Mitglieder').' als ausgetreten markiert.';
    	schreibe_ini_datei(PFAD_INIDATEIEN.'tools_ausgetretene.ini',$gespeicherte,true);
        $_db->speichereGeaenderteTabellen();
    }
}

# Feiertage und Ferien in Ferientabelle eintragen
if(aktionausfuehren('feiertageanlegen')){
	require_once('class/kalender.inc.php');
    $kal = new kalender;
    $kal->db = &$_db;
    $daten = $kal->holeFerientermine();
    if(!is_array($daten)){
        $meldungen[] = 'Fehler: '.$daten;
    }
    else{
        $erg = $kal->legeFeiertageAn($daten);
        if($erg['angelegt'] > 1 and $erg['korrigiert'] == 0){
        	$meldungen[] = 'Es wurde'.($erg['angelegt']>1?'n '.$erg['angelegt'].' Feiertage':' ein Feiertag').' angelegt.';
        }
        elseif($erg['angelegt'] == 0 and $erg['korrigiert'] > 1){
        	$meldungen[] = 'Es wurde'.($erg['korrigiert']>1?'n '.$erg['korrigiert'].' Feiertage':' ein Feiertag').' korrigiert.';
        }
        elseif($erg['angelegt'] > 1 and $erg['korrigiert'] == 0){
        	$meldungen[] = 'Es wurde'.($erg['angelegt']>1?'n '.$erg['angelegt'].' Feiertage':' ein Feiertag').' angelegt und '.($erg['korrigiert']>1?$erg['korrigiert'].' Feiertage':' ein Feiertag').' korrigiert.';
        }
    }
}

# aktuelle Zeiten anlegen
if(aktionausfuehren('aktuellezeiten')){
	require_once('class/zeiten.inc.php');
    if(!isset($_einst)){
    	$_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_default.ini',true);
    }
	$z = new zeiten;
    $z->db = &$_db;
    $z->schreibeAktuelleZeiten();
	$meldungen[] = 'Die aktuellen Zeiten wurden geschrieben';
    $_db->speichereGeaenderteTabellen();
}

# Tabellen optimieren
if(aktionausfuehren('tabellenoptimieren')){
	$query = "OPTIMIZE TABLE ".implode(', ',$tabellen)."";
	$_db->fuehreQueryAus($query);
	$meldungen[] = 'Die Tabellen wurden optimiert';
}

if($_conf['conf']['flags']['zeitenentwicklungsbilderloeschen'] == 1){
	$dateien = glob(PFAD_INCLUDE.'bilder_speicher/zeitenentwicklung_*.png');
	foreach($dateien as $datei){
    	unlink($datei);
    }
    $meldungen[] = 'Es wurden alle Zeitenentwicklungsbilder gelscht ('.(count($dateien)==1?'1 Datei':count($dateien).' Dateien').')';
}

if(aktionausfuehren('gc')){
	# Zeitenentwicklungsbilder lschen
    if($_conf['conf']['flags']['zeitenentwicklungsbilderloeschen'] != 1){
          # vorhandene Dateien suchen
        $vorhandenedateien = array();
        foreach(glob(PFAD_INCLUDE.'bilder_speicher/zeitenentwicklung_*.png') as $datei){
            $tmp = array(
                'dateiname' => $datei,
                'mid'       => substr($datei,strlen(PFAD_INCLUDE)+34,-4),
                'groesse'   => filesize($datei),
                'erstellt'  => filemtime($datei)
            );
            $vorhandenedateien[] = $tmp;
        }
          # Aktionen auftrennen
        $tmp = explode(';',$_conf['conf']['gc']['zeitenentwicklungbilder']);
        $aktionen = array();
        foreach($tmp as $key => $aktion){
            if(strpos($aktion,':')!==false){
                list($a,$w) = explode(':',$aktion);
                $aktionen[$a] = $w;
            }
            else{
                $aktionen[$aktion] = '';
            }
        }
        $geloeschte = 0;
          # Dateien die lter sind als x Tage lschen
        if(isset($aktionen['aelterals'])){
            $ts_vorloeschen = strtotime('-'.$aktionen['aelterals'].' day');
            foreach($vorhandenedateien as $key => $datei){
                if($datei['erstellt'] >= $ts_vorloeschen){
                    continue;
                }
                unlink($datei['dateiname']);
                unset($vorhandenedateien[$key]);
                $geloeschte++;
            }
        }
          # Datein von ausgetretenen Mitgliedern lschen
        if(isset($aktionen['ausgetretene'])){
            $query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE ausgetreten IS NOT NULL";
            $_db->holeDaten($query);
            $ids = $_db->baueArray('id','#');
            foreach($vorhandenedateien as $key => $datei){
                if(!in_array($datei['mid'],$ids)){
                    continue;
                }
                unlink($datei['dateiname']);
                unset($vorhandenedateien[$key]);
                $geloeschte++;
            }
        }
          # Dateien lschen wenn die Dateien zusammen zu gro sind
        if(isset($aktionen['groesserals'])){
            # pruefen wie gro das Verzeichnis ist
            $groesse = 0;
            foreach($vorhandenedateien as $datei){
                $groesse += $datei['groesse'];
            }
            $groesse /= 1024*1024;
            if($groesse > $aktionen['groesserals']){
                # Dateien umsortieren
                function groessensort($a, $b){
                    if($a['erstellt'] == $b['erstellt']){
                        return 0;
                    }
                    return ($a['erstellt'] < $b['erstellt'])?-1:1;
                }
                usort($vorhandenedateien,'groessensort');
                $i = 0;
                # so lange lschen, bis die Gesamtgre unter dem Sollwert liegt
                while($groesse > $aktionen['groesserals']){
                    $groesse -= ($vorhandenedateien[$i]['groesse']/(1024*1024));
                    unlink($vorhandenedateien[$i]['dateiname']);
                    unset($vorhandenedateien[$i]);
                    $geloeschte++;
                    $i++;
                }
            }
        }
        if($geloeschte > 0){
            $meldungen[] = 'Es '.($geloeschte==1?'wurde 1 Zeitenentwicklungsbild':'wurden '.$geloeschte.' Zeitenentwicklungsbilder').' gelscht.';
        }
    }

    # Tmp-Dateien loeschen
    $datinh = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini',false);
    $geloescht = 0;
    foreach($datinh as $systemname => $eintrag){
        list($zeit,,) = explode('|',$eintrag,3);
        if(($zeit+$_conf['conf']['gc']['tmpdateien']*86400) < time()){
            if(file_exists(PFAD_TMP.$systemname)){
                unlink(PFAD_TMP.$systemname);
            }
            unset($datinh[$systemname]);
            $geloescht++;
        }
    }
    if($geloescht > 0){
        $datinh = schreibe_ini_datei(PFAD_INIDATEIEN.'dateien_tmp.ini',$datinh,false);
        $meldungen[] = 'Es '.($geloescht==1?'wurde 1 tmp-Datei':'wurden '.$geloescht.' tmp-Dateien').' gelscht.';
    }

    # Wettkampfabwicklungsdateien lschen
    $dateien = glob(PFAD_INIDATEIEN.'wkabwickeln_*.ini');
    $loeschen = array();
    foreach($dateien as $pfad){
    	$datei = basename($pfad);
        if($datei == 'wkabwickeln_default.ini'){
        	continue;
        }
        $inhalt = parse_ini_file($pfad, true);
        list($d, $m, $j) = explode('.', $inhalt['wettkampfdaten']['datum']);
        $datum = mktime(0, 0, 0, $m, $d, $j);
        $loeschpunkt = strtotime('+'.$_conf['conf']['gc']['wettkampfabwicklungsdateien'].' year' ,$datum);
        if($loeschpunkt > time()){
        	continue;
        }
        $loeschen[] = array('datei'=>$datei,'pfad'=>$pfad);
        #unlink($pfad);
        #$geloescht++;
    }
    if(count($loeschen) > 2){ # nur lschen wenn mindestens drei Dateien gelscht werden knnen
		$wkzip = new zipfile();
    	foreach($loeschen as $row){
            $zeit = filemtime($row['pfad']);
        	$wkzip->addFile_pfad($row['pfad'], $row['datei'], $zeit);
            unlink($row['pfad']);
        }
        $wkzip->speichereDatei(PFAD_INCLUDE.'sicherung/'.date('Y-m-d_H-i').'_wkabwicklungsdateien.zip');
        unset($wkzip);
        $meldungen[] = 'Es '.(count($loeschen)==1?'wurde 1 WK-Abwicklungsdatei':'wurden '.count($loeschen).' WK-Abwicklungsdateien').' gelscht.';
    }

    # Zeitenexportdatenstze lschen
    $datensaetze = parse_ini_file(PFAD_INIDATEIEN.'zeiten_export.ini',true);
    $geloescht = 0;
    foreach($datensaetze as $key => $datensatz){
    	list(,,$zeitpunkt,) = explode(';', $datensatz['_daten'], 4);
        $loeschpunkt = strtotime((count($datensatz)>1?'+6 month':'+2 week'), $zeitpunkt);
        if($loeschpunkt > time()){
        	continue;
        }
        unset($datensaetze[$key]);
        $geloescht++;
    }
    if($geloescht > 0){
        $datinh = schreibe_ini_datei(PFAD_INIDATEIEN.'zeiten_export.ini', $datensaetze, true);
        $meldungen[] = 'Es wurde'.($geloescht==1?' 1 Zeitenexport-Datensatz':'n '.$geloescht.' Zeitenexport-Datenstze').' gelscht.';
    }
}

# Usereinstellungen einlesen
if(isset($_conf['conf']['flags']['userconfeinlesen']) and $_conf['conf']['flags']['userconfeinlesen'] == 1){
    $verzeichnis = PFAD_INIDATEIEN;
	$dh = opendir($verzeichnis);
	while(false !== ($datei = readdir($dh))){
    	if(substr($datei,0,9) != 'userconf_' or $datei == 'userconf_default.ini'){
        	continue;
        }
        $datinh = parse_ini_file($verzeichnis.$datei,true);
        $mid = str_replace(array('userconf_','.ini'),'',$datei);
        $tmp = array();
        foreach($relevanteeinstellungen as $id => $einst){
        	list($key,$value) = explode('-',$einst);
        	$tmp[] = $id.'-'.$datinh[$key][$value];
        }
        $_conf['log']['userconf'][$mid] = implode(';',$tmp);
        unset($tmp);
	}
	closedir($dh);
	$meldungen[] = 'Die Usereinstellungen wurden neu eingelesen';
    $_dateiensichern['conf'] = true;
    $_dateiensichern['log'] = true;
	$_conf['conf']['flags']['userconfeinlesen'] = 0;
}

# Vereinsrekorde einlesen (teuer, >1000 Querys!)
if(isset($_conf['conf']['flags']['vereinsrekordeeinlesen']) and $_conf['conf']['flags']['vereinsrekordeeinlesen'] == 1){
	require_once(PFAD_INCLUDE.'conf/select.inc.php');
    require_once('class/zeiten.inc.php');
    $zeit = new zeiten;
    $zeit->db = $_db;
    $zeit->leseVereinsrekordeEin();
    $meldungen[] = 'Die Vereinsrekorde wurden neu eingelesen';
    $_conf['conf']['flags']['vereinsrekordeeinlesen'] = 0;
    $_dateiensichern['conf'] = true;
}

# Usereinstellungen durchgehen und Aktionen durchfuehren (jeden Tag)
$userspeicher = array(); # speichert schon ausgelesene Daten
$datenspeicher = array();
$durchzufuehrendeaktionen = array();
foreach($relevanteeinstellungen as $id => $einst){
	$durchzufuehrendeaktionen[$einst] = array();
}
foreach($_conf['log']['userconf'] as $mid => $einst){ # Einstellungen auseinanderpfrimeln
	$tmp = explode(';',$einst);
    foreach($tmp as $value){
    	list($aktion,$wert) = explode('-',$value,2);
        $durchzufuehrendeaktionen[$relevanteeinstellungen[$aktion]][$mid] = $wert;
    }
}
foreach($durchzufuehrendeaktionen as $aktion => $mitglieder){
	foreach($mitglieder as $mid => $wert){
    	$einst = new einstellungen(PFAD_INCLUDE.'conf/user-ini.xml',PFAD_INIDATEIEN.'userconf_',$mid.'.ini');
    	$einst->db = &$_db;
        $einst->einlesen();
    	if(!isset($userspeicher[$mid])){
        	$userspeicher[$mid] = array();
        }
    	switch($aktion){
		case 'emailbenachrichtigung-terminbenachrichtigungszeitraum':
        	require_once('conf/select.inc.php');
            $_wochentage[0] = $_wochentage[7];
            $zeitraum = $wert;
            $benachrichtigungen = $durchzufuehrendeaktionen['emailbenachrichtigung-terminbenachrichtigungen'][$mid];
            if($zeitraum == 'nicht' or $benachrichtigungen == 'termine:|gruppen:|personen:'){
            	break;
            }
            if($zeitraum == 'woche' and date('w') != 1){ # aktueller Tag kein Montag
            	break;
            }
            if($zeitraum == 'monat' and date('j') != 1){ # aktueller Tag kein Monatserster
            	break;
            }
        	if(!isset($userspeicher[$mid]['email'])){
            	$query = "SELECT email, vorname, nachname, mw FROM ".DB_PREFIX."mitglieder WHERE id = ".$mid."";
                $_db->holeDaten($query);
                $row = $_db->holeZeile();
                $userspeicher[$mid]['email'] = $row['email'];
                $userspeicher[$mid]['mw'] = $row['mw'];
                $userspeicher[$mid]['vorname'] = $row['vorname'];
                $userspeicher[$mid]['nachname'] = $row['nachname'];
            }
            if(!isset($datenspeicher['uebungsleiter'])){
                $query = "SELECT mitgliedid FROM ".DB_PREFIX."uebungsleiter";
                $_db->holeDaten($query);
                $datenspeicher['uebungsleiter'] = $_db->baueArray('mitgliedid','#');
            }
            if(!isset($datenspeicher['kampfrichter'])){
                $query = "SELECT mitgliedid FROM ".DB_PREFIX."kampfrichter";
                $_db->holeDaten($query);
                $datenspeicher['kampfrichter'] = $_db->baueArray('mitgliedid','#');
            }
            if(!isset($datenspeicher['vorstand'])){
                $query = "SELECT mitgliedid FROM ".DB_PREFIX."vorstand";
                $_db->holeDaten($query);
                $datenspeicher['vorstand'] = $_db->baueArray('mitgliedid','#');
            }
            if(!empty($userspeicher[$mid]['email'])){
                list($termine, $gruppen, $personen) = explode('|',$benachrichtigungen);
                $termine = explode(',',substr($termine,8));
                $gruppen = explode(',',substr($gruppen,8));
                $personen = explode(',',substr($personen,9));
                $filtern = false;
                if(in_array('uebungsleiter',$gruppen)){
                	foreach($datenspeicher['uebungsleiter'] as $id){
                    	$personen[] = $id;
                    }
                    $filtern = true;
                }
                if(in_array('kampfrichter',$gruppen)){
                	foreach($datenspeicher['kampfrichter'] as $id){
                    	$personen[] = $id;
                    }
                    $filtern = true;
                }
                if(in_array('vorstand',$gruppen)){
                	foreach($datenspeicher['vorstand'] as $id){
                    	$personen[] = $id;
                    }
                    $filtern = true;
                }

                if($filtern){ # Sondergruppen aus Gruppenarray rauswerfen
                    $tmp = $gruppen;
                    $gruppen = array();
                    foreach($tmp as $gr){
                    	if(in_array($gr,array('uebungsleiter','kampfrichter','vorstand'))){
                        	continue;
                        }
                        $gruppen[] = $gr;
                    }
                }
                $anz = count($personen);
                for($i=0;$i<$anz;$i++){
                	if(empty($personen[$i])){
                    	unset($personen[$i]);
                    }
                }

                $anz = count($gruppen);
                for($i=0;$i<$anz;$i++){
                	if(empty($gruppen[$i])){
                    	unset($gruppen[$i]);
                    }
                }
                $maileinst = array(
                    'vorname' => $userspeicher[$mid]['vorname'],
                    'zeitraum' => $zeitraum
                );
                $geburtstagsbedingung = '';
                if(count($gruppen)>0){
                	$geburtstagsbedingung .= "(m.id=mt.mitgliedid AND mt.trainingsgruppenid IN (".implode(',',$gruppen)."))";
                }
                if(count($personen)>0){
                	if(!empty($geburtstagsbedingung)){
                    	$geburtstagsbedingung .= ' OR ';
                    }
                    $geburtstagsbedingung .= "m.id IN (".implode(',',$personen).")";
                }
                $alletermine = ($durchzufuehrendeaktionen['emailbenachrichtigung-analletermineerinnern'][$mid]==1)?true:false;
            	switch($zeitraum){
                case 'tag':
                	# Geburtstage
                    if(!empty($geburtstagsbedingung)){
                        $query = "SELECT CONCAT(vorname,' ',nachname,' (',YEAR(NOW())-YEAR(gebdatum),', JG:',YEAR(gebdatum),')') as name
                                    FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."mitglieder_trainingsgruppen as mt
                                    WHERE MONTH(gebdatum) = MONTH(NOW()) AND DAYOFMONTH(gebdatum) = DAYOFMONTH(NOW()) AND (".$geburtstagsbedingung.")
                                    GROUP BY name ORDER BY vorname, nachname";
                        $_db->holeDaten($query);
                        if($_db->ergebnis['anzahl'] > 0){
                            $maileinst['geburtstage'] = $_db->baueArray('name','#');
                        }
                    }
                    # Termine
                    if($alletermine or (count($termine) > 0 and !empty($termine[0]))){
                        $query = "SELECT id, IF(DATE_FORMAT(datum,'%H%i')!='0000',CONCAT(DATE_FORMAT(datum,'%H:%i: '),titel),titel) as titel
                                    FROM ".DB_PREFIX."termine
                                    WHERE DATE_FORMAT(datum,'%d%m%Y') = DATE_FORMAT(CURDATE(),'%d%m%Y')
                                      ".($alletermine?'':"AND id IN (".implode(',',$termine).")")."";
                        $_db->holeDaten($query);
                        if($_db->ergebnis['anzahl'] > 0){
                            $maileinst['termine'] = $_db->baueArray('titel','id');
                            $gel = $einst->benachrichtigungLoeschen(array_keys($maileinst['termine']),'termin');
                            if($gel == true){
                            	$einst->cronjobEinstellungenEinlesen();
                            }
                        }
                    }
                    if(!isset($maileinst['termine']) and !isset($maileinst['geburtstage'])){
                    	break 2;
                    }
                    # Betreff
                    $betreff = 'den '.date('d.m.Y');
                	break;
                case 'woche':
                	# Geburtstage
                    if(!empty($geburtstagsbedingung)){
                        $query = "SELECT CONCAT(CONVERT(DATE_FORMAT(gebdatum,'%d.%m.: ') USING latin1),vorname,' ',nachname,' (',YEAR(NOW())-YEAR(gebdatum),
                                      ', JG:',YEAR(gebdatum),')') as name, DATE_FORMAT(CONCAT(YEAR(NOW()),'-',DATE_FORMAT(gebdatum,'%m-%d')),'%w') as wtag
                                    FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."mitglieder_trainingsgruppen as mt
                                    WHERE (".$geburtstagsbedingung.")  AND
                                      IF(DATE_ADD(gebdatum, INTERVAL (YEAR(NOW()) - YEAR(gebdatum)) YEAR) < CURDATE(),
                                         DATE_ADD(gebdatum, INTERVAL (YEAR(NOW()) - YEAR(gebdatum) + 1) YEAR),
                                         DATE_ADD(gebdatum, INTERVAL (YEAR(NOW()) - YEAR(gebdatum)) YEAR)
                                         ) >= CURDATE()
                                      AND
                                      IF(DATE_ADD(gebdatum, INTERVAL (YEAR(NOW()) - YEAR(gebdatum)) YEAR) < CURDATE(),
                                         DATE_ADD(gebdatum, INTERVAL (YEAR(NOW()) - YEAR(gebdatum) + 1) YEAR),
                                         DATE_ADD(gebdatum, INTERVAL (YEAR(NOW()) - YEAR(gebdatum)) YEAR)
                                         ) <= DATE_ADD(CURDATE(), INTERVAL (6) DAY)
                                    GROUP BY name ORDER BY MONTH(gebdatum), DAYOFMONTH(gebdatum), name";
                        $_db->holeDaten($query);
                        if($_db->ergebnis['anzahl'] > 0){
                        	foreach($_db->ergebnis['daten'] as $key => $row){
                            	$_db->ergebnis['daten'][$key]['name'] = substr($_wochentage[$row['wtag']],0,2).', '.$row['name'];
                            }
                            $maileinst['geburtstage'] = $_db->baueArray('name','#');
                        }
                    }
                    # Termine
                    if($alletermine or (count($termine) > 0 and !empty($termine[0]))){
                        $query = "SELECT id, IF(DATE_FORMAT(datum,'%H%i')!='0000',CONCAT(DATE_FORMAT(datum,'%d.%m.%Y, %H:%i: '),titel),
                                     CONCAT(DATE_FORMAT(datum,'%d.%m.%Y: '),titel)) as titel
                                    FROM ".DB_PREFIX."termine
                                    WHERE datum <= DATE_ADD(NOW(),INTERVAL 7 DAY) AND datum >= CURDATE()
                                      ".($alletermine?'':"AND id IN (".implode(',',$termine).")")."
                                    ORDER BY datum, titel";
                        $_db->holeDaten($query);
                        if($_db->ergebnis['anzahl'] > 0){
                            $maileinst['termine'] = $_db->baueArray('titel','id');
                            $einst->benachrichtigungLoeschen(array_keys($maileinst['termine']),'termin');
                            $einst->cronjobEinstellungenEinlesen();
                        }
                    }
                    /*if(!isset($maileinst['termine']) and !isset($maileinst['geburtstage'])){
                    	break 2; # um woechentliche Mails bei keinen Terminen nicht zu verschicken die Kommentarzeichen entfernen
                    }*/
                    # Betreff
                    $betreff = 'die Woche von '.date('d.m.').'-'.date('d.m.Y',strtotime('+6 day'));
                	break;
                case 'monat':
                	# Geburtstage
                    if(!empty($geburtstagsbedingung)){
                        $query = "SELECT CONCAT(CONVERT(DATE_FORMAT(gebdatum,'%d.%m.: ') USING latin1),vorname,' ',nachname,' (',YEAR(NOW())-YEAR(gebdatum),
                                      ', JG:',YEAR(gebdatum),')') as name, DATE_FORMAT(CONCAT(YEAR(NOW()),'-',DATE_FORMAT(gebdatum,'%m-%d')),'%w') as wtag
                                    FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."mitglieder_trainingsgruppen as mt
                                    WHERE MONTH(gebdatum) = MONTH(NOW()) AND (".$geburtstagsbedingung.")
                                    GROUP BY name ORDER BY DAYOFMONTH(gebdatum), name";
                        $_db->holeDaten($query);
                        if($_db->ergebnis['anzahl'] > 0){
                        	foreach($_db->ergebnis['daten'] as $key => $row){
                            	$_db->ergebnis['daten'][$key]['name'] = substr($_wochentage[$row['wtag']],0,2).', '.$row['name'];
                            }
                            $maileinst['geburtstage'] = $_db->baueArray('name','#');
                        }
                    }
                    # Termine
                    if($alletermine or (count($termine) > 0 and !empty($termine[0]))){
                        $query = "SELECT id, IF(DATE_FORMAT(datum,'%H%i')!='0000',CONCAT(DATE_FORMAT(datum,'%d.%m.%Y, %H:%i: '),titel),
                                     CONCAT(DATE_FORMAT(datum,'%d.%m.%Y: '),titel)) as titel
                                    FROM ".DB_PREFIX."termine
                                    WHERE MONTH(datum) = MONTH(NOW()) AND YEAR(datum) = YEAR(NOW())
                                      ".($alletermine?'':"AND id IN (".implode(',',$termine).")")."
                                    ORDER BY datum, titel";
                        $_db->holeDaten($query);
                        if($_db->ergebnis['anzahl'] > 0){
                            $maileinst['termine'] = $_db->baueArray('titel','id');
                            $einst->benachrichtigungLoeschen(array_keys($maileinst['termine']),'termin');
                            $einst->cronjobEinstellungenEinlesen();
                        }
                    }
                    # Betreff
                    $betreff = str_replace('','ae',$_monate[date('n')]).' '.date('Y');
                	break;
                }


                $mail->setzeBetreff($_email['betreff']['kennung_cronjob'].'Termine fuer '.$betreff,false);
                $variablen = array(
                    'daten' => $maileinst
                );
                $mail->setzeTextTemplate('sonstiges/66.cronjobmail-terminbenachrichtigungen.inc.txt', $_tmpl, $userspeicher[$mid], $variablen);
                $_inh = $mail->verschickeMail();
                $anzahlmails++;
            }
        	break;

        case 'emailbenachrichtigung-fehlendemitgliedskarten':
            if(!isset($datenspeicher['fehlendemitgliedskarten'])){
                $query = "SELECT COUNT(*) as anz
                            FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."eigenschaften as e
                              ON e.artid=m.id AND e.art='m' AND e.eigenschaft='keinekartemachen'
                            WHERE mitgliedskarte = 1 AND ausgetreten IS NULL AND e.wert IS NULL";
                $_db->holeDaten($query);
                $datenspeicher['fehlendemitgliedskarten'] = $_db->holeWert();
            }
        	if($wert == 0 or $datenspeicher['fehlendemitgliedskarten'] < $wert){
            	break;
            }
        	if(!isset($userspeicher[$mid]['email'])){
            	$query = "SELECT email, vorname, nachname, mw FROM ".DB_PREFIX."mitglieder WHERE id = ".$mid."";
                $_db->holeDaten($query);
                $row = $_db->holeZeile();
                $userspeicher[$mid]['email'] = $row['email'];
                $userspeicher[$mid]['mw'] = $row['mw'];
                $userspeicher[$mid]['vorname'] = $row['vorname'];
                $userspeicher[$mid]['nachname'] = $row['nachname'];
            }
            if(!empty($userspeicher[$mid]['email'])){
                $mail->setzeBetreff($_email['betreff']['kennung_cronjob'].'Es fehlen '.$datenspeicher['fehlendemitgliedskarten'].' Mitgliederkarten',false);
                $variablen = array(
                    'anzahl' => $datenspeicher['fehlendemitgliedskarten']
                );
                $mail->setzeTextTemplate('sonstiges/66.cronjobmail-fehlendemitgliedskarten.inc.txt', $_tmpl, $userspeicher[$mid], $variablen);
                $_inh = $mail->verschickeMail();
                $anzahlmails++;
            }
        	break;
        }
    }
}

# Benachrichtigungen bei ablaufenden Trainerlizenzen (an jedem Monatsersten)
if(date('d') == 1){
    $query = "SELECT m.id, u.trainerbis, m.vorname, m.nachname, m.mw, m.email
                FROM (".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."uebungsleiter as u ON m.id=u.mitgliedid)
                  LEFT JOIN ".DB_PREFIX."trainingsgruppen_uebungsleiter as tu ON u.id=tu.uebungsleiterid
                WHERE trainerbis IS NOT NULL AND tu.trainingsgruppenid IS NOT NULL
                GROUP BY m.id ORDER BY m.nachname, m.vorname";
    $_db->holeDaten($query);
    $trainer = $_db->baueArray('*','id');
    $jahr = date('Y');
    foreach($trainer as $tr){
        $mid = $tr['id'];
        if(isset($durchzufuehrendeaktionen['emailbenachrichtigung-ablaufendetrainerlizenz'][$mid]) and
            $durchzufuehrendeaktionen['emailbenachrichtigung-ablaufendetrainerlizenz'][$mid] != 1){
            # der Trainer mchte nicht erinnert werden
            continue;
        }
        # prfen ob Lizenz in den nchsten 2 Jahren abluft
        if($tr['trainerbis'] < $jahr){
            # die Lizenz ist bereits abgelaufen
            continue;
        }
        if($tr['trainerbis']-$jahr >= 2){
            # die Lizenz luft erst in mehr als 2 Jahren ab
            continue;
        }
        if(empty($tr['email'])){
			continue;
        }
        $monat = date('m');
        if($tr['trainerbis']-$jahr == 1 and $monat == 1){
            # erste Erinnerung
            $verbleibendezeit = 24;
        }
        elseif($tr['trainerbis']-$jahr == 1 and $monat == 7){
            # zweite Erinnerung
            $verbleibendezeit = 18;
        }
        elseif($tr['trainerbis'] == $jahr and $monat != 2 and $monat != 4){
            # dritte bis elfte Erinnerung
            $verbleibendezeit = 12-$monat;
        }
        else{
            # keine Erinnerung
            continue;
        }
        $text = 'Trainierlizenz laeuft in '.($verbleibendezeit==1?'1 Monat':$verbleibendezeit.' Monaten').' ab';
        $mail->setzeBetreff($_email['betreff']['kennung_cronjob'].$text, false);
        $variablen = array(
            'trainerbis' => $tr['trainerbis'],
            'verbleibendezeit' => $verbleibendezeit
        );
        $mail->setzeTextTemplate('sonstiges/66.cronjobmail-ablaufendetrainerlizenz.inc.txt', $_tmpl, $tr, $variablen);
        $_inh = $mail->verschickeMail();
        $anzahlmails++;
    }
}

if($anzahlmails > 0){
	$meldungen[] = 'Es wurde'.($anzahlmails==1?' 1 Mail':'n '.$anzahlmails.' Mails').' verschickt';
}

# Zip-Datei "starten"
$zip = new zipfile();

# DB-Sicherung (jeden Tag die gnderten, je nach Einstellung Komplettsicherung)
$dbsichern = true;
if($_conf['conf']['flags']['komplettsicherung']==1 or aktionausfuehren('dbsichern')){
    $zusicherndetabellen = $tabellen;
    $meldungsanhang = '(Komplettsicherung, '.count($tabellen).' Tabellen)';
    # ini-Datei leeren
    $fh = fopen(PFAD_LOGDATEIEN.'dbaenderungen.ini', 'w');
    fclose($fh);
}
else{ # sonst nur geaenderte Tabellen
    $dbaenderungen = parse_ini_file(PFAD_LOGDATEIEN.'dbaenderungen.ini',false);
    if(count($dbaenderungen) == 0){ # es wurden seit der letzten Komplettsicheurng keine Tabellen gendert)
		$dbsichern = false;
    }
    else{
        $zusicherndetabellen = array();
        foreach($dbaenderungen as $tabelle => $geaendert){
            if($geaendert != 1){
                continue;
            }
            $zusicherndetabellen[] = $tabelle;
            $dbaenderungen[$tabelle] = 0;
        }
        if(count($zusicherndetabellen) > 0){
            schreibe_ini_datei(PFAD_LOGDATEIEN.'dbaenderungen.ini',$dbaenderungen,false);
            $anz = count($zusicherndetabellen);
            $meldungsanhang = '(Teilsicherung, '.($anz==1?'1 Tabelle':$anz.' Tabellen').')';
        }
        else{
            $dbsichern = false;
        }
    }
}
# Datenbank-Daten exportieren
if($dbsichern){
	$zip->addFile_daten($_db->exportiereDatenbank('', $zusicherndetabellen), date('Y-m-d_H-i').'_tsv.sql', time());
	$meldungen[] = 'Datenbanksicherung durchgefhrt '.$meldungsanhang;
}

# Daten in zip-Datei sichern
if(count($_conf['conf']['zusicherndeverzeichnisse']) > 0){
	$alle = ($_conf['conf']['flags']['komplettsicherung']==1 or aktionausfuehren('dateiensichern'));
    if($alle){
		$_dateiensichern['conf'] = true;
    }
	$verzeichnisse = $_conf['conf']['zusicherndeverzeichnisse'];
    $vorhandenedateien = array();
    $anzahlgesicherterdateien = 0;
    if(isset($_conf['log']['dateien']) and count($_conf['log']['dateien']) != 0 and !$alle){
    	foreach($_conf['log']['dateien'] as $t){
        	list($zeit,$dat) = explode(':',$t,2);
        	$vorhandenedateien[$dat] = $zeit;
    	}
    }
    foreach($verzeichnisse as $verz){
    	list($pfad, $zippfad) = explode(':',$verz);
        # Konstanten ersetzen
        $anz = preg_match('~[A-Z_]{2,}~', $pfad, $match);
        if($anz > 0){
        	foreach($match as $m){
            	if(!defined($m)){
                	continue;
                }
                $pfad = str_replace($m, constant($m), $pfad);
            }
        }
        # Verzeichnis oeffenen
		$dh = opendir($pfad);
		while(false !== ($file=readdir($dh))){
        	if($file{0} == '.'){
            	continue;
            }
            $zeit = filemtime($pfad.$file);
            $zipdatei = $zippfad.$file;
            if($alle){ # alle Dateien speichern
            	$vorhandenedateien[$zipdatei] = $zeit;
				$zip->addFile_pfad($pfad.$file, $zipdatei, $zeit);
                $anzahlgesicherterdateien++;
                continue;
            }
            if(!in_array($zipdatei, array_keys($vorhandenedateien))){ # reinschreiben, Datei sichern
            	$vorhandenedateien[$zipdatei] = $zeit;
                if(filesize($pfad.$file) == 0){ # leere Dateien nicht sichern
                	continue;
                }
				$zip->addFile_pfad($pfad.$file, $zipdatei, $zeit);
                $anzahlgesicherterdateien++;
            }
            else{
            	$gespeichertezeit = $vorhandenedateien[$zipdatei];
                if($gespeichertezeit < $zeit){ # Wert aktualisieren, speichern
            		$vorhandenedateien[$zipdatei] = $zeit;
                    if(filesize($pfad.$file) == 0){ # leere Dateien nicht sichern
                    	continue;
                    }
					$zip->addFile_pfad($pfad.$file, $zipdatei, $zeit);
                    $anzahlgesicherterdateien++;
                }
                else{ # weiter gehen
                    continue;
                }
            }
		}
		closedir($dh);
    }
    if($alle){
		$meldungen[] = 'Alle Dateien ('.$anzahlgesicherterdateien.') gesichert';
    }
    else{
    	if($anzahlgesicherterdateien == 1){
			$meldungen[] = 'Es wurde 1 Datei gesichert';
        }
        elseif($anzahlgesicherterdateien > 1){
			$meldungen[] = 'Es wurden '.$anzahlgesicherterdateien.' Dateien gesichert';
        }
    }
    if($anzahlgesicherterdateien > 0){
	    $_conf['log']['dateien'] = array();
	    foreach($vorhandenedateien as $dat => $zeit){
	    	$_conf['log']['dateien'][] = $zeit.':'.$dat;
	    }
	    rsort($_conf['log']['dateien']);
        $_dateiensichern['log'] = true;
    }
}

# Zip- bzw. txt-Datei schreiben
if($zip->tk_dateien > 0){ # Zip-Datei speichern
	$inhalt = $zip->speichereDatei(PFAD_INCLUDE.'sicherung/'.date('Y-m-d_H-i').'.zip');
}
else{
	$zip->verwerfeDatei();
	$inhalt = 'Es gibt keine zu speichernden Dateien.';
	$fh = fopen(PFAD_INCLUDE.'sicherung/'.date('Y-m-d_H-i').'.txt', 'w');
    fwrite($fh, $inhalt, strlen($inhalt));
    fclose($fh);
}

# Cronjob-Einstellungen speichern
if($_dateiensichern['log']){
	schreibe_ini_datei(PFAD_LOGDATEIEN.'cronjob.ini',$_conf['log'],true);
}
if($_conf['conf']['flags']['zeitenentwicklungsbilderloeschen'] == 1){
	$_conf['conf']['flags']['zeitenentwicklungsbilderloeschen'] = 0;
    $_dateiensichern['conf'] = true;
}
if($_conf['conf']['flags']['komplettsicherung'] == 1){
	$_conf['conf']['flags']['komplettsicherung'] = 0;
    $_dateiensichern['conf'] = true;
}
if($_dateiensichern['conf']){
	schreibe_ini_datei(PFAD_INCLUDE.'conf/cronjob.ini',$_conf['conf'],true);
}

if(!empty($_email['cronjob']['empfaenger_statusmeldung'])){
    $query = "SELECT id, nachname, vorname, email, mw FROM ".DB_PREFIX."mitglieder WHERE id = ".$_email['cronjob']['empfaenger_statusmeldung']."";
    $_db->holeDaten($query);
    $user = $_db->holeZeile();
    $mail->setzeBetreff('[Cronjob] tkswim-Aktionen ausgefuehrt',false);
    $maileinst = array(
        'datum'     => date('d.m.Y'),
        'zeit'      => date('H:i'),
        'laufzeit'  => round(microtime_float() - $anfangszeit,4),
        'dbquerys'  => $_db->anzahldbabfragen,
        'meldungen' => $meldungen
    );
    $mail->setzeTextTemplate('sonstiges/66.cronjobmail-erfolgsmeldung.inc.txt', $_tmpl, $user, $maileinst);
    $_inh = $mail->verschickeMail();
}

echo 'fertig';
exit;
# EOF
?>