<?php

### Einstellungen ##############################################################
$include_pfad = './__inc/';

### Einstellungen Ende #########################################################

$_seite = 'admin';
require_once($include_pfad.'conf/conf.inc.php');
if(TKSWIM_DEBUG){
	$startzeit = microtime(true);
	error_reporting(E_ALL);
    require_once($include_pfad.'func/printr.inc.php');
}
else{
	error_reporting(E_ALL ^ E_NOTICE);
}

session_start();
# Einstellungen, Klassen und Funktionen laden
require_once($include_pfad.'class/db.inc.php');
require_once($include_pfad.'class/tktemplate.inc.php');
require_once($include_pfad.'func/weiterleiten.inc.php');
require_once($include_pfad.'func/text_format.inc.php');
require_once($include_pfad.'conf/select.inc.php');


function pruefeRechte(){
    $rechte = func_get_args();
    global $_seite;
    if($_seite == 'admin' and $rechte[0] != '_dummy'){
        return true;
    }
    return false;
}

# ROOT-Konstante setzen
if(ROOT_HTTP != ''){
    if((strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST']) and isset($_SERVER['HTTPS'])) or isset($_SERVER['HTTP_X_FORWARDED_HOST'])){
        define('ROOT', ROOT_HTTPS);
        if(strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST'])){
            ini_set('session.cookie_path', '/'.substr(ROOT_HTTP,7).'/');
        }
    }
    else{
        define('ROOT',ROOT_HTTP);
        if(ROOT != 'http://'.$_SERVER['HTTP_HOST']){
            ini_set('session.cookie_path', substr(ROOT_HTTP,strlen('http://'.$_SERVER['HTTP_HOST'])).'/');
        }
    }
}
else{
    define('ROOT', htmlspecialchars('http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])));
}

# Smarty starten und Variablen zuweisen
$_tmpl = new tktemplate;
$_tmpl->register_function('pruefeRechte','pruefeRechte');
$_tmpl->register_function('strlen','strlen');
$_tmpl->tk_fussnoten = array();
if(!is_dir(PFAD_INCLUDE)){
	$_tmpl->template_dir  = $include_pfad.'templates/';
    $_tmpl->compile_dir   = $include_pfad.'templates_c/';
	$_tmpl->plugins_dir[] = $include_pfad.'templates/_plugins/';
}
$_tmpl->assign('jsdateien','');

if(!is_dir(PFAD_INCLUDE) and !isset($_SESSION['adminlogin'])){
	if(isset($_POST['anmelden'])){
    	if($_POST['loginanmeldename'] == 'admin' and $_POST['loginpasswort'] == TKSWIM_ADMINPASSWORT){
    		$_SESSION['eingelogt'] = 1;
        	$_SESSION['adminlogin'] = 1;
	    	$_SESSION['user']['name'] = 'admin';
	    	$_SESSION['user']['realname'] = 'admin';
    		$_SESSION['user']['letzterzugriff'] = time();
	    	$_SESSION['user']['id'] = 0;
        	if(isset($_SESSION['versuche'])){
        	    unset($_SESSION['versuche']);
            }
        	unset($_SESSION['vonseite']);
        	if(isset($_SESSION['fehler'])){
        		unset($_SESSION['fehler']);
        	}
        	# und ab zur Adminseite
        	weiterleiten('/admin.php');
        }
        else{
			if(!isset($_SESSION['versuche'])){
				$_SESSION['versuche'] = 1;
            }
            else{
				$_SESSION['versuche']++;
            }
            # warten und dann Fehlermeldung zuweisen
			if($_SESSION['versuche'] <= 2){
				sleep(0.2);
            }
            elseif($_SESSION['versuche'] <= 10){
                sleep(1);
            }
            else{
            	sleep(10);
            }
            $_SESSION['fehler'] = 'falsche Daten';
        }
    }
	$_tmpl->assign('cssstyle','screen_original.css');
	$_inh = $_tmpl->fetch('admin/29.index.inc.html');
    $_tmpl->assign('inhalt',$_inh);
    $_tmpl->assign('s',$_seite);
    $inhalt = $_tmpl->fetch('tmpl.inc.html');
    if(!headers_sent()){
    	header('x-Powered-By: tkswim');
    }
	echo $inhalt;
    exit;
}

# Datenbankklasse starten und Verbindung oeffnen
$_inh = '';
if(DB_BENUTZERNAME != ''){
	$_db = new db;
	$_db->tmpl = &$_tmpl;
	$_db->schreibschutz = TKSWIM_SCHREIBSCHUTZ;
	if(TKSWIM_SCHREIBSCHUTZ){
		$_tmpl->assign('dauerhinweis','Achtung! Die Datenbank ist gegen Schreibzugriffen geschtzt, es knnen momentan keine Daten verndert werden!');
	}
	$_db->setzeDbParameter();
	$_db->verbindeMitDb();
	$mysqlversion_41 = false;
	if(version_compare($_db->version(),'4.1.0','gt')){
		$mysqlversion_41 = true;
	}
}
else{
	$_db = false;
}

if(!isset($_SESSION['adminlogin']) and is_dir(PFAD_INCLUDE)){
    weiterleiten('/');
}

if(isset($_SESSION['eingelogt'])){
	# Einstellungen laden
	$_einst = parse_ini_file($include_pfad.'ini_speicher/userconf_default.ini',true);

    # Zeitpunkt der letzten Aktivitaet speichern
    if((time() - $_SESSION['user']['letzterzugriff']) > TKSWIM_TIMEOUT){
        $_SESSION = array();
        $_SESSION['fehler'] = 'Die Sitzung ist abgelaufen, bitte neu anmelden.';
    }
    else{
    	$_SESSION['user']['letzterzugriff'] = time();
    }
	if($_einst['globaleeinstellungen']['sicherheitsabfragenabschalten']){
	    $_GET['sicher'] = 1;
	}
}
else{
	#$_tmpl->tk_append_string('onload',"document.forms[0].elements['loginanmeldename'].focus();");
}
$_tmpl->assign('cssstyle','screen_original.css');

$_tmpl->assign('ueberschrift','Administration von tkswim');
if(!isset($_SESSION['adminlogin'])){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'module':

	$vorhandenemodule = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
	$_bereiche = array(
    	'wkabwickeln' => 'Wettkampfabwicklung',
        'sonstiges'   => 'Sonstiges'
    );

    if(isset($_GET['details']) and in_array($_GET['details'], array_keys($vorhandenemodule['_versionen']))){
		$daten = parse_ini_file(PFAD_INCLUDE.'module/'.$_GET['details'].'/conf.ini', true);
        $daten['conf']['bereich'] = $_bereiche[$daten['conf']['bereich']];
        foreach($daten['dateien'] as $key => $datei){
        	$datei = str_replace('{http}', '<em>Root-Verzeichnis:</em> /', $datei);
        	$datei = str_replace('{inc}', '<em>Include-Verzeichnis:</em> /', $datei);
            $daten['dateien'][$key] = $datei;
        }
        foreach($daten['rechte'] as $key => $recht){
        	$recht = substr($recht, strpos($recht,';')+1);
            $daten['rechte'][$key] = $recht;
        }
        $daten['conf']['tkswimversion'] = $daten['conf']['tkswimversion_bis']=='*'?'ab Version '.$daten['conf']['tkswimversion_ab']:'Versionen '.$daten['conf']['tkswimversion_ab'].' bis '.$daten['conf']['tkswimversion_bis'];

        $_tmpl->assign('daten', $daten);
        $_inh .= $_tmpl->fetch('admin/29.admin-module-details.inc.html');
    }
    elseif(isset($_GET['installieren'])){
    	if(!isset($_SESSION['installieren'])){
        	# noch nicht installierte Module suchen
            $installierte = array_keys($vorhandenemodule['_versionen']);
            $pfad = PFAD_INCLUDE.'module/';
            $dh = opendir($pfad);
            if($dh === false){
            	trigger_error('Das Modulverzeichnis kann nicht geffnet werden.', E_USER_ERROR);
            }
            $zuinstallierende = array();
            while(($file = readdir($dh)) !== false){
            	if(!is_dir($pfad.$file) or $file == '.' or $file == '..'){
                	continue;
                }
                if(in_array($file, $installierte)){
                	# das Modul in diesem Verzeichnis ist bereits installiert
                	continue;
                }
                if(!file_exists($pfad.$file.'/conf.ini')){
                	# im Modulverzeichnis existiert keine conf.ini
                    continue;
                }
                $conf = parse_ini_file($pfad.$file.'/conf.ini', true);
                if(version_compare($conf['conf']['tkswimversion_ab'], TKSWIM_VERSION, '>')){
                	# die eingesetzte tkswim-Version ist zu alt fr das Modul
                	continue;
                }
                if($conf['conf']['tkswimversion_bis'] != '*' and version_compare($conf['conf']['tkswimversion_bis'], TKSWIM_VERSION, '<')){
                	# die eingesetzte tkswim-Version ist zu jung fr das Modul
                    #  (das Modul kann also nur mit einer frheren Version von tkswim eingesetzt werden)
                	continue;
                }
                $zuinstallierende[$file] = $conf['conf']['name'].' ('.$_bereiche[$conf['conf']['bereich']].', Version '.$conf['conf']['version'].')';
            }
            closedir($dh);
            if(isset($_POST['modul']) and in_array($_POST['modul'], array_keys($zuinstallierende))){
            	$_SESSION['installieren'] = $_POST['modul'];
                weiterleiten('/admin.php?aktion=module&installieren');
            }
        	$_tmpl->assign('zuinstallierende', $zuinstallierende);
            $_inh .= $_tmpl->fetch('admin/29.admin-module-installieren-waehlen.inc.html');
        }
        else{
        	# Moduldaten holen
            $moduldat = parse_ini_file(PFAD_INCLUDE.'module/'.$_SESSION['installieren'].'/conf.ini', true);
            # richtige Pfade zusammenbauen
            $p_von = array('{inc}', '{http}');
            $p_nach = array(PFAD_INCLUDE, PFAD_HTTP);
            $moduldat['dateien'] = str_replace($p_von, $p_nach, $moduldat['dateien']);
            # noch fehlende Dateien sammeln
            $fehlendedateien = array();
            foreach($moduldat['dateien'] as $datei){
            	if(file_exists($datei)){
                	continue;
                }
                $fehlendedateien[] = $datei;
            }

            if(count($fehlendedateien) > 0){
            	$_tmpl->assign('fehlendedateien', $fehlendedateien);
                $_inh .= $_tmpl->fetch('admin/29.admin-module-installieren-dateien.inc.html');
            }
            else{
            	# Modul fertig anlegen
                  # Rechte Anlegen
            	if(count($moduldat['rechte'])>0){
                	$rgr = $r = array();
                    foreach($moduldat['rechte'] as $rid => $recht){
                    	list($sort, $bez) = explode(';', $recht, 2);
                    	$r[] = "('".text_format($rid,'db')."', '".text_format($sort,'db')."', '".text_format($bez,'db')."')";
                        $rgr[] = "(1, '".text_format($rid,'db')."')";
                    }
                    $query = "INSERT INTO ".DB_PREFIX."rechte (id, sort, bezeichnung) VALUES ".implode(', ', $r)."";
                    $_db->fuehreQueryAus($query);
                    $query = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES ".implode(', ', $rgr)."";
                    $_db->fuehreQueryAus($query);
            	}
                  # Eintrag in die modul.ini schreiben
            	$vorhandenemodule = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
                if(!isset($vorhandenemodule[$moduldat['conf']['bereich']])){
                	$vorhandenemodule[$moduldat['conf']['bereich']] = array();
                }
                $vorhandenemodule[$moduldat['conf']['bereich']][substr($_SESSION['installieren'],strpos($_SESSION['installieren'], '_')+1)] = $moduldat['conf']['name'];
                $vorhandenemodule['_versionen'][$_SESSION['installieren']] = $moduldat['conf']['version'];
            	require_once('func/schreibe_ini_datei.inc.php');
        		schreibe_ini_datei(PFAD_INCLUDE.'conf/module.ini', $vorhandenemodule, true);
                  # Sessiondaten lschen, weiterleiten
            	unset($_SESSION['installieren']);
            	weiterleiten('/admin.php?aktion=module','Das Modul wurde installiert.');
            }
        }
    }
    elseif(isset($_GET['deinstallieren']) and in_array($_GET['deinstallieren'], array_keys($vorhandenemodule['_versionen']))){
    	if(isset($_SESSION['deinstallieren']) and $_SESSION['deinstallieren']['key'] != $_GET['deinstallieren']){
        	unset($_SESSION['deinstallieren']);
        }

    	if(!isset($_SESSION['deinstallieren']) and substr($_GET['deinstallieren'],0,11)=='wkabwickeln'){
        	# prfen ob Wettkmpfe mit dem zu lschenden Typ existieren
            $query = "SELECT artid FROM ".DB_PREFIX."eigenschaften
                        WHERE art = 'w' AND eigenschaft = 'wettkampfart' AND wert = '".substr($_GET['deinstallieren'],12)."'";
            $_db->holeDaten($query);
            if($_db->holeAnzahl() > 0){
            	$_tmpl->assign('fehler', 'Das Modul kann nicht gelscht werden, da Wettkmpfe mit diesem Wettkampftyp existieren.');
                $_inh .= '<p><a href="'.ROOT.'/admin.php?aktion=module">zurck zur Modulbersicht</a></p>';
                break;
            }
        }

    	if(!isset($_SESSION['deinstallieren']) or $_SESSION['deinstallieren']['key'] != $_GET['deinstallieren']){
        	# zum Lschen ntige Informationen in der Session speichern
            $speichern = array();
            $speichern['key'] = $_GET['deinstallieren'];
			$daten = parse_ini_file(PFAD_INCLUDE.'module/'.$_GET['deinstallieren'].'/conf.ini', true);

            $speichern['name'] = $daten['conf']['name'].' ('.$_bereiche[$daten['conf']['bereich']].')';
            $speichern['bereich'] = $daten['conf']['bereich'];
            # Dateilisten der anderen Module holen
            $zubehaltendedateien = array();
            $p_von = array('{inc}', '{http}');
            $p_nach = array(PFAD_INCLUDE, PFAD_HTTP);
            foreach($vorhandenemodule['_versionen'] as $key => $version){
            	if($key == $_GET['deinstallieren']){
                	continue;
                }
				$dat = parse_ini_file(PFAD_INCLUDE.'module/'.$key.'/conf.ini', true);
                foreach($dat['dateien'] as $datei){
                	$zubehaltendedateien[] = str_replace($p_von, $p_nach, $datei);
                }
            }
            $zubehaltendedateien = array_unique($zubehaltendedateien);
            # zu lschende Dateien ermitteln
            $speichern['dateien'] = array();
            $speichern['zuloeschendedateien'] = 0;
            $speichern['modulverzeichnis'] = '';
            foreach($daten['dateien'] as $datei){
            	$datei = str_replace($p_von, $p_nach, $datei);
            	if(in_array($datei, $zubehaltendedateien)){
                	continue;
                }
                $speichern['dateien'][] = array(
                	'datei' => $datei,
                    'geloescht' => 0
                );
                if(substr($datei, -8) == 'conf.ini'){

                	$speichern['modulverzeichnis'] = substr($datei, 0, -8);
                }
                $speichern['zuloeschendedateien']++;
            }
            $speichern['rechte'] = array();
            foreach($daten['rechte'] as $rid => $bezeichnung){
            	$speichern['rechte'][] = $rid;
            }
            $_SESSION['deinstallieren'] = $speichern;
        }

        if(($_SESSION['deinstallieren']['zuloeschendedateien'] > 0 or !empty($_SESSION['deinstallieren']['modulverzeichnis'])) and isset($_POST['weiter'])){
        	if(!empty($_SESSION['deinstallieren']['modulverzeichnis']) and !file_exists($_SESSION['deinstallieren']['modulverzeichnis'])){
            	$_SESSION['deinstallieren']['modulverzeichnis'] = '';
            }
        	foreach($_SESSION['deinstallieren']['dateien'] as $key => $datei){
            	if($datei['geloescht'] == 1){
                	continue;
                }
                if(!file_exists($datei['datei'])){
                	$_SESSION['deinstallieren']['dateien'][$key]['geloescht'] = 1;
                    $_SESSION['deinstallieren']['zuloeschendedateien']--;
                }
            }
        }

        $_tmpl->assign('modulname', $_SESSION['deinstallieren']['name']);
        if($_SESSION['deinstallieren']['zuloeschendedateien'] > 0 or !empty($_SESSION['deinstallieren']['modulverzeichnis'])){
        	# es mssen noch Dateien gelscht werden
        	$_tmpl->assign('dateien', $_SESSION['deinstallieren']['dateien']);
        	$_tmpl->assign('modulverzeichnis', $_SESSION['deinstallieren']['modulverzeichnis']);
            $_inh .= $_tmpl->fetch('admin/29.admin-module-loeschen-dateien.inc.html');
        }
        else{
        	# restliches Zeug lschen
              # Rechte lschen
            if(count($_SESSION['deinstallieren']['rechte'])>0){
            	$ids = "'".implode("','", $_SESSION['deinstallieren']['rechte'])."'";
                $query = "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid IN (".$ids.")";
                $_db->fuehreQueryAus($query);
                $query = "DELETE FROM ".DB_PREFIX."rechte WHERE id IN (".$ids.")";
                $_db->fuehreQueryAus($query);
            }
              # Eintrge aus der modul.ini lschen
			$vorhandenemodule = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
            unset($vorhandenemodule['_versionen'][$_SESSION['deinstallieren']['key']]);
            $id = substr($_SESSION['deinstallieren']['key'], strpos($_SESSION['deinstallieren']['key'], '_')+1);
            unset($vorhandenemodule[$_SESSION['deinstallieren']['bereich']][$id]);
            if(count($vorhandenemodule[$_SESSION['deinstallieren']['bereich']]) < 1){
            	unset($vorhandenemodule[$_SESSION['deinstallieren']['bereich']]);
            }
              # Reste in der Session entfernen
            unset($_SESSION['deinstallieren']);
            # ini-Datei schreiben und zurck zur bersicht
            require_once('func/schreibe_ini_datei.inc.php');
        	schreibe_ini_datei(PFAD_INCLUDE.'conf/module.ini', $vorhandenemodule, true);
            weiterleiten('/admin.php?aktion=module','Das Modul wurde gelscht.');
        }
    }
    else{
        $module = array();
        foreach($vorhandenemodule['_versionen'] as $key => $version){
            list($b, $e) = explode('_', $key);
            $module[$key] = array(
                'bereich' => $_bereiche[$b],
                'bezeichnung' => $vorhandenemodule[$b][$e],
                'version' => $version
            );
        }
        $_tmpl->assign('module', $module);
        $_inh .= $_tmpl->fetch('admin/29.admin-module-index.inc.html');
    }
	break;

case 'backuperstellen':
	$query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
	$_db->holeDaten($query, E_USER_ERROR, 'row');
	$tabellen = $_db->baueArray('0','#');
    ini_set('memory_limit', '32M');
	$inhalt = $_db->exportiereDatenbank('',$tabellen);
    $dateiname = date('Y-m-d_H-i').'_tkswim.sql';
    require_once('class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($inhalt, $dateiname, time());
    $zip->gebeDateiaus($dateiname.'.zip');
    exit;

case 'pfade':
	if(!is_writable($include_pfad.'conf/conf.inc.php')){
    	$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/conf.inc.php) ist nicht beschreibbar, nderungen mssen von Hand gemacht werden.');
        if(isset($_POST['speichern'])){
        	unset($_POST['speichern']);
        }
    }
	if(isset($_POST['speichern'])){
    	require_once($include_pfad.'func/pruefen.inc.php');
        $f = '';
        $d = &$_POST['daten'];

        if(!is_dir($_POST['daten']['pfad_include'])){ # Include-Verzeichnis prfen
        	$f .= 'Das Include-Verzeichnis existiert nicht<br />';
        }
        elseif(substr($_POST['daten']['pfad_include'],-1) != '/'){
        	$f .= 'Das Include-Verzeichnis muss mit einem Slash (/) enden<br />';
        }
        else{ # Subverzeichnise des include-Verzeichnises prfen
         	# Templates
        	if(!is_dir($_POST['daten']['pfad_include'].$_POST['daten']['pfad_templates'])){
        		$f .= 'Das Templates-Verzeichnis existiert nicht (es muss innerhalb des include-Verzeichnisses liegen!)<br />';
        	}
        	elseif(substr($_POST['daten']['pfad_templates'],-1) != '/'){
        		$f .= 'Das Templates-Verzeichnis muss mit einem Slash (/) enden<br />';
        	}
            # Template-Plugins
        	if(!is_dir($_POST['daten']['pfad_include'].$_POST['daten']['pfad_tmplplugins'])){
        		$f .= 'Das Verzeichnis fr die Template-Plugins existiert nicht (es muss innerhalb des include-Verzeichnisses liegen!)<br />';
        	}
        	elseif(substr($_POST['daten']['pfad_tmplplugins'],-1) != '/'){
        		$f .= 'Das Verzeichnis fr die Template-Plugins muss mit einem Slash (/) enden<br />';
        	}
            # ini-Dateien
        	if(!is_dir($_POST['daten']['pfad_include'].$_POST['daten']['pfad_inidateien'])){
        		$f .= 'Das Verzeichnis fr die ini-Dateien existiert nicht (es muss innerhalb des include-Verzeichnisses liegen!)<br />';
        	}
        	elseif(substr($_POST['daten']['pfad_inidateien'],-1) != '/'){ # Include-Verzeichnis prfen
        		$f .= 'Das Verzeichnis fr die ini-Dateien muss mit einem Slash (/) enden<br />';
        	}
            # Dateien
        	if(!is_dir($_POST['daten']['pfad_include'].$_POST['daten']['pfad_dateien'])){
        		$f .= 'Das Dateien-Verzeichnis existiert nicht (es muss innerhalb des include-Verzeichnisses liegen!)<br />';
        	}
        	elseif(substr($_POST['daten']['pfad_dateien'],-1) != '/'){ # Include-Verzeichnis prfen
        		$f .= 'Das Dateien-Verzeichnis muss mit einem Slash (/) enden<br />';
        	}
            # Log-Dateien
        	if(!is_dir($_POST['daten']['pfad_include'].$_POST['daten']['pfad_logdateien'])){
        		$f .= 'Das Verzeichnis fr die Logdateien existiert nicht (es muss innerhalb des include-Verzeichnisses liegen!)<br />';
        	}
        	elseif(substr($_POST['daten']['pfad_logdateien'],-1) != '/'){ # Include-Verzeichnis prfen
        		$f .= 'Das Verzeichnis fr die Logdateien muss mit einem Slash (/) enden<br />';
        	}
            # tmp
        	if(!is_dir($_POST['daten']['pfad_include'].$_POST['daten']['pfad_tmp'])){
        		$f .= 'Das tmp-Verzeichnis existiert nicht (es muss innerhalb des include-Verzeichnisses liegen!)<br />';
        	}
        	elseif(substr($_POST['daten']['pfad_tmp'],-1) != '/'){ # Include-Verzeichnis prfen
        		$f .= 'Das tmp-Verzeichnis muss mit einem Slash (/) enden<br />';
        	}
        }
        # Smarty-Pfad
        if(!is_dir($_POST['daten']['pfad_smarty'])){
        	$f .= 'Das Smarty-Verzeichnis existiert nicht<br />';
        }
        elseif(substr($_POST['daten']['pfad_smarty'],-1) != '/'){
        	$f .= 'Das Smarty-Verzeichnis muss mit einem Slash (/) enden<br />';
        }
        # Templatesc
        if(!@is_dir($_POST['daten']['pfad_templatesc'])){
        	$f .= 'Das Verzeichnis fr die kompilierten Templates existiert nicht<br />';
        }
        elseif(substr($_POST['daten']['pfad_templatesc'],-1) != '/'){
        	$f .= 'Das Verzeichnis fr die kompilierten Templates muss mit einem Slash (/) enden<br />';
        }
        # HTTP-Verzeichnis
        if(!is_dir($_POST['daten']['pfad_http'])){
        	$f .= 'Das HTTP-Verzeichnis existiert nicht<br />';
        }
        elseif(substr($_POST['daten']['pfad_http'],-1) != '/'){
        	$f .= 'Das HTTP-Verzeichnis muss mit einem Slash (/) enden<br />';
        }

        # HTTP-ROOT
        if(substr($_POST['daten']['root_http'],0,7) != 'http://'){
            $f .= 'Das HTTP-Domain muss mit http:// beginnen<br />';
        }
        if(substr($_POST['daten']['root_http'],-1) == '/'){
        	$f .= 'Das HTTP-Domain darf nicht mit einem Slash (/) enden<br />';
        }
        # HTTPS-ROOT
        if($_POST['daten']['root_https'] != '-'){
	        if(substr($_POST['daten']['root_https'],0,8) != 'https://'){
	            $f .= 'Das HTTPS-Domain muss mit https:// beginnen<br />';
	        }
	        if(substr($_POST['daten']['root_https'],-1) == '/'){
	        	$f .= 'Das HTTPS-Domain darf nicht mit einem Slash (/) enden<br />';
	        }
        }

        if(empty($f)){
        	# eigentlich wre die oberen zwei Zeilen ideal, allerdings funktioniert das nicht, da bei der Prfung
            #   der erhhte Wert u.U. schon gesetzt ist, und der Eintrag damit weggelassen wird, obwohl er ntig wre.
        	#$grenze_umf = substr(ini_get('upload_max_filesize'),0,-1)*1048576;
        	#$grenze_pms = substr(ini_get('post_max_size'),0,-1)*1048576;
        	$grenze_umf = 2*1048576;
        	$grenze_pms = 8*1048576;
            $speichern = array(
                'pfad_include'     => $d['pfad_include'],
                'pfad_smarty'      => $d['pfad_smarty'],
                'pfad_templates'   => $d['pfad_templates'],
                'pfad_templatesc'  => $d['pfad_templatesc'],
                'pfad_tmplplugins' => $d['pfad_tmplplugins'],
                'pfad_inidateien'  => $d['pfad_inidateien'],
                'pfad_dateien'     => $d['pfad_dateien'],
                'pfad_logdateien'  => $d['pfad_logdateien'],
                'pfad_tmp'         => $d['pfad_tmp'],
                'pfad_http'        => $d['pfad_http'],
                'root_http'        => $d['root_http'],
                'root_https'       => $d['root_https'],
                'htaccess_include' => ($d['pfad_include'][0]!='/'?substr($d['pfad_include'],strpos($d['pfad_include'],'/')):$d['pfad_include']),
                'upload_max_filesize' => (TKSWIM_MAXDATEIGROESSE>$grenze_umf?ceil(TKSWIM_MAXDATEIGROESSE/1048576).'M':false),
                'post_max_size'       => (TKSWIM_MAXDATEIGROESSE>$grenze_pms?ceil(TKSWIM_MAXDATEIGROESSE/1048576).'M':false)
            );
            $_tmpl->assign('daten',$speichern);
            $confinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
            $htaccessinhalt = $_tmpl->fetch('admin/29.admin-htaccess.inc.html');
            $fh = fopen($d['pfad_http'].'.htaccess','w');
            fwrite($fh, $htaccessinhalt, strlen($htaccessinhalt));
            fclose($fh);
            $fh = fopen($include_pfad.'conf/conf.inc.php','w');
            fwrite($fh, $confinhalt, strlen($confinhalt));
            fclose($fh);
            weiterleiten('/admin.php','Die nderungen wurden gespeichert.');
        }
        else{
        	$_tmpl->assign('fehler',$f);
            $daten = $_POST['daten'];
        }
    }
    else{
    	$daten = array(
        	'pfad_include'     => PFAD_INCLUDE,
        	'pfad_smarty'      => (PFAD_SMARTY==''?(isset($_SESSION['_smarty'])?$_SESSION['_smarty']:''):PFAD_SMARTY),
        	'pfad_templates'   => substr(PFAD_TEMPLATES,strlen(PFAD_INCLUDE)),
        	'pfad_templatesc'  => PFAD_TEMPLATESC,
        	'pfad_tmplplugins' => substr(PFAD_TMPLPLUGINS,strlen(PFAD_INCLUDE)),
        	'pfad_inidateien'  => substr(PFAD_INIDATEIEN,strlen(PFAD_INCLUDE)),
        	'pfad_dateien'     => substr(PFAD_DATEIEN,strlen(PFAD_INCLUDE)),
        	'pfad_logdateien'  => substr(PFAD_LOGDATEIEN,strlen(PFAD_INCLUDE)),
        	'pfad_tmp'         => substr(PFAD_TMP,strlen(PFAD_INCLUDE)),
        	'pfad_http'        => PFAD_HTTP,
        	'root_http'        => ROOT_HTTP,
        	'root_https'       => ROOT_HTTPS
        );
    }
    $_tmpl->assign('daten',$daten);
    $_inh .= $_tmpl->fetch('admin/29.admin-pfade.inc.html');
	break;

case 'kollationen':
	if(!$mysqlversion_41){
    	$_tmpl->assign('fehler','Dieses Feature gibt es nur bei MySQL-Versionen >= 4.1.0');
        break;
    }
    # Stand der aufgelisteten Spalten: Version 0.8.5
    $spalten = array(
        DB_PREFIX.'dateien - dateiname', DB_PREFIX.'dateien - beschreibung', DB_PREFIX.'eigenschaften - wert',
        DB_PREFIX.'familien - titel', DB_PREFIX.'ferien - bezeichnung', DB_PREFIX.'meldungen_teilnehmer - kommentar',
        DB_PREFIX.'mitglieder - vorname', DB_PREFIX.'mitglieder - nachname', DB_PREFIX.'mitglieder - strasse',
        DB_PREFIX.'mitglieder - hausnr', DB_PREFIX.'mitglieder - email', DB_PREFIX.'mitglieder - ort',
        DB_PREFIX.'mitglieder - sonstiges', DB_PREFIX.'pflichtzeiten - bezeichnung', DB_PREFIX.'rechte - bezeichnung',
        DB_PREFIX.'rechtegruppen - bezeichnung', DB_PREFIX.'staffeln - bemerkung', DB_PREFIX.'termine - titel',
        DB_PREFIX.'termine - was', DB_PREFIX.'trainingsgruppen - kommentar', DB_PREFIX.'verzeichnisse - name',
        DB_PREFIX.'vorstand - bezeichnung', DB_PREFIX.'wettkaempfe - titel', DB_PREFIX.'wettkaempfe - kurztitel',
        DB_PREFIX.'wettkaempfe - ort', DB_PREFIX.'wettkaempfe - meldeadresse', DB_PREFIX.'wettkaempfe - sonstiges',
        DB_PREFIX.'zeiten - bemerkung'
    );

    $allespalten = array(
    	DB_PREFIX.'abschnitte - kindgerecht', DB_PREFIX.'dateien - rechte', DB_PREFIX.'dateien - dateiname',
        DB_PREFIX.'dateien - typ', DB_PREFIX.'dateien - systemname', DB_PREFIX.'dateien - groesse',
        DB_PREFIX.'dateien - beschreibung', DB_PREFIX.'eigenschaften - art', DB_PREFIX.'eigenschaften - eigenschaft',
        DB_PREFIX.'eigenschaften - wert', DB_PREFIX.'familien - titel', DB_PREFIX.'ferien - bezeichnung',
        DB_PREFIX.'lenreferenzzeiten - mw', DB_PREFIX.'logins - anmeldename', DB_PREFIX.'logins - salz',
        DB_PREFIX.'logins - passwort', DB_PREFIX.'meldungen_starts - teilnahme', DB_PREFIX.'meldungen_teilnehmer - teilnahme',
        DB_PREFIX.'meldungen_teilnehmer - telefon', DB_PREFIX.'meldungen_teilnehmer - kommentar', DB_PREFIX.'mitglieder - dsvid',
        DB_PREFIX.'mitglieder - vorname', DB_PREFIX.'mitglieder - nachname', DB_PREFIX.'mitglieder - mw',
        DB_PREFIX.'mitglieder - strasse', DB_PREFIX.'mitglieder - hausnr', DB_PREFIX.'mitglieder - plz',
        DB_PREFIX.'mitglieder - ort', DB_PREFIX.'mitglieder - email', DB_PREFIX.'mitglieder - sonstiges',
        DB_PREFIX.'pflichtzeiten - bezeichnung', DB_PREFIX.'pflichtzeiten - richtpflicht', DB_PREFIX.'pflichtzeiten_jahrgaenge - jahrgang',
        DB_PREFIX.'pflichtzeiten_strecken - mw', DB_PREFIX.'rechte - id', DB_PREFIX.'rechte - bezeichnung',
        DB_PREFIX.'rechtegruppen - bezeichnung', DB_PREFIX.'rechtegruppen_rechte - rechteid',
        DB_PREFIX.'staffeln - mw', DB_PREFIX.'staffeln - platz', DB_PREFIX.'staffeln - bemerkung',
        DB_PREFIX.'telefon - vorwahl', DB_PREFIX.'telefon - nummer', DB_PREFIX.'termine - titel',
        DB_PREFIX.'termine - was', DB_PREFIX.'trainingsgruppen - kommentar', DB_PREFIX.'verzeichnisse - rechte',
        DB_PREFIX.'verzeichnisse - name', DB_PREFIX.'vorstand - bezeichnung', DB_PREFIX.'wettkaempfe - titel',
        DB_PREFIX.'wettkaempfe - kurztitel', DB_PREFIX.'wettkaempfe - ort', DB_PREFIX.'wettkaempfe - bahnlaenge',
        DB_PREFIX.'wettkaempfe - meldegeld', DB_PREFIX.'wettkaempfe - meldeadresse', DB_PREFIX.'wettkaempfe - sonstiges',
        DB_PREFIX.'wks - mw', DB_PREFIX.'wks - laenge', DB_PREFIX.'wks - jahrgang',
        DB_PREFIX.'wks - wkart', DB_PREFIX.'zeiten - bestenliste', DB_PREFIX.'zeiten - platz',
        DB_PREFIX.'zeiten - bemerkung', DB_PREFIX.'zeiten_rekorde - art', DB_PREFIX.'zeiten_rekorde - laenge',
        DB_PREFIX.'zwischenzeiten - bestenliste'
    );

    $tabellen = array(
        DB_PREFIX.'dateien', DB_PREFIX.'eigenschaften', DB_PREFIX.'familien', DB_PREFIX.'ferien',
        DB_PREFIX.'meldungen_teilnehmer', DB_PREFIX.'mitglieder', DB_PREFIX.'pflichtzeiten', DB_PREFIX.'rechte',
        DB_PREFIX.'rechtegruppen', DB_PREFIX.'staffeln', DB_PREFIX.'termine', DB_PREFIX.'trainingsgruppen',
        DB_PREFIX.'verzeichnisse', DB_PREFIX.'vorstand', DB_PREFIX.'wettkaempfe', DB_PREFIX.'zeiten'
    );

    # Collationen holen
    $query = "SHOW COLLATION";
    $_db->holeDaten($query);
    $collations = array();
    $collation2charset = array();
    $dbdat = $_db->baueArray('*','#');
    foreach($dbdat as $row){
    	if(!isset($collations[$row['Charset']])){
        	$collations[$row['Charset']] = array();
        }
        $collation2charset[$row['Collation']] = $row['Charset'];
        $collations[$row['Charset']][] = $row['Collation'];
    }
      # sortieren
    if(isset($collations['utf8'])){
    	$tmp_utf8 = $collations['utf8'];
        sort($tmp_utf8);
    	unset($collations['utf8']);
    }
    if(isset($collations['latin1'])){
    	$tmp_latin1 = $collations['latin1'];
        sort($tmp_latin1);
    	unset($collations['latin1']);
    }
    $rest = $collations;
    ksort($rest);
    $collations = array();
    if(isset($tmp_latin1)){
        foreach($tmp_latin1 as $c){
        	$collations['latin1'][$c] = $c;
        }
    }
    if(isset($tmp_utf8)){
        foreach($tmp_utf8 as $c){
        	$collations['utf8'][$c] = $c;
        }
    }
    foreach($rest as $char => $col){
    	sort($col);
        foreach($col as $c){
        	$collations[$char][$c] = $c;
        }
    }

    # Aktionen ausfhren
    if(isset($_GET['art'])){
    	$query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
    	$_db->holeDaten($query, E_USER_ERROR, 'row');
    	$alletabellen = $_db->baueArray('0','#');
    	switch($_GET['art']){
        case 'spalten':
			$_tmpl->assign('s_spalten',$_POST['spalten']);
			$_tmpl->assign('s_kollation',$_POST['kollation']);
            if(!isset($_POST['spalten']) or !is_array($_POST['spalten']) or count($_POST['spalten'])<1){
            	$f .= 'Es wurde keine Spalten angegeben<br />';
            }
            else{
            	foreach($_POST['spalten'] as $spalte){
                	if(!in_array($spalte,$allespalten)){
                    	$f .= 'Die Spalte ist ungltig<br />';
                    }
                }
            }
            if(!isset($_POST['kollation']) or !in_array($_POST['kollation'],array_keys($collation2charset))){
            	$f .= 'Die Kollation fehlt oder ist ungltig<br />';
            }
            if(!empty($f)){
            	$_tmpl->assign('fehler',$f);
                break;
            }
            $spaltenspeicher = array();
            $col = ' CHARACTER SET '.$collation2charset[$_POST['kollation']].' COLLATE '.$_POST['kollation'].' ';
            foreach($_POST['spalten'] as $tabellenspalte){
            	list($tabelle, $spalte) = explode(' - ',$tabellenspalte,2);
                if(!isset($spaltenspeicher[$tabelle])){
                	$query = "SHOW COLUMNS FROM ".$tabelle."";
                    $_db->holeDaten($query);
                    $spaltenspeicher[$tabelle] = $_db->baueArray('*','Field');
                }

                $query = "ALTER TABLE ".$tabelle." MODIFY ".$spalte." ".$spaltenspeicher[$tabelle][$spalte]['Type']." ";
                $query .= $col.($spaltenspeicher[$tabelle][$spalte]['Null']=='NO'?'NOT':'').' NULL';

                $d = $spaltenspeicher[$tabelle][$spalte]['Default'];
                if($d != '' or is_null($d)){
                	$d = $spaltenspeicher[$tabelle][$spalte]['Default'];
                	$query .= ' DEFAULT '.(is_null($d)?'NULL':"'".$d."'");
                }
                $_db->fuehreQueryAus($query);
            }
        	weiterleiten('/admin.php?aktion=kollationen','Die Kollation(en) wurden gendert');

        case 'tabellen':
            $f = '';
			$_tmpl->assign('t_tabellen',$_POST['tabellen']);
			$_tmpl->assign('t_kollation',$_POST['kollation']);
            if(!isset($_POST['tabellen']) or !is_array($_POST['tabellen']) or count($_POST['tabellen'])<1){
            	$f .= 'Es wurde keine Tabelle angegeben<br />';
            }
            else{
            	foreach($_POST['tabellen'] as $tabelle){
                	if(!in_array($tabelle,$alletabellen)){
                    	$f .= 'Die Tabelle ist ungltig<br />';
                    }
                }
            }
            if(!isset($_POST['kollation']) or !in_array($_POST['kollation'],array_keys($collation2charset))){
            	$f .= 'Die Kollation fehlt oder ist ungltig<br />';
            }
            if(!empty($f)){
            	$_tmpl->assign('fehler',$f);
                break;
            }
            $col = ' CHARACTER SET '.$collation2charset[$_POST['kollation']].' COLLATE '.$_POST['kollation'];
            foreach($_POST['tabellen'] as $tabelle){
            	$query = "ALTER TABLE ".$tabelle.$col."";
                $_db->fuehreQueryAus($query);
            }
        	weiterleiten('/admin.php?aktion=kollationen','Die Kollation(en) wurden gendert');

        case 'global':
			$_tmpl->assign('g_kollation',$_POST['kollation']);
            $f = '';
            if(!isset($_POST['kollation']) or !in_array($_POST['kollation'],array_keys($collation2charset))){
            	$f .= 'Die Kollation fehlt oder ist ungltig<br />';
            }
            if(!empty($f)){
            	$_tmpl->assign('fehler',$f);
                break;
            }
            $col = ' CHARACTER SET '.$collation2charset[$_POST['kollation']].' COLLATE '.$_POST['kollation'];
            if(isset($_POST['dbsetzen'])){
            	$query = "ALTER DATABASE `".DB_NAME."`".$col."";
                $_db->fuehreQueryAus($query);
            }
            foreach($alletabellen as $tabelle){
            	$query = "ALTER TABLE ".$tabelle.$col."";
                $_db->fuehreQueryAus($query);
            }
            $spaltenspeicher = array();
            $col = ' CHARACTER SET '.$collation2charset[$_POST['kollation']].' COLLATE '.$_POST['kollation'].' ';
            foreach($allespalten as $tabellenspalte){
            	list($tabelle, $spalte) = explode(' - ',$tabellenspalte,2);
                if(!isset($spaltenspeicher[$tabelle])){
                	$query = "SHOW COLUMNS FROM ".$tabelle."";
                    $_db->holeDaten($query);
                    $spaltenspeicher[$tabelle] = $_db->baueArray('*','Field');
                }

                $query = "ALTER TABLE ".$tabelle." MODIFY ".$spalte." ".$spaltenspeicher[$tabelle][$spalte]['Type']." ";
                $query .= $col.($spaltenspeicher[$tabelle][$spalte]['Null']=='NO'?'NOT':'').' NULL';

                $d = $spaltenspeicher[$tabelle][$spalte]['Default'];
                if($d != '' or is_null($d)){
                	$d = $spaltenspeicher[$tabelle][$spalte]['Default'];
                	$query .= ' DEFAULT '.(is_null($d)?'NULL':"'".$d."'");
                }
                $_db->fuehreQueryAus($query);
            }
        	weiterleiten('/admin.php?aktion=kollationen','Die Kollationen wurden gendert');

        default:
        	weiterleiten('/admin.php?aktion=kollationen');
            break;
        }
    }
    $_tmpl->assign('collations',$collations);
    $_tmpl->assign('tabellen',$tabellen);
    $_tmpl->assign('spalten',$spalten);
    $_inh .= $_tmpl->fetch('admin/29.admin-kollationen.inc.html');
	break;

case 'rechteueberpruefen':
	$verzeichnisse = array(
    	PFAD_INCLUDE.'bilder_speicher/',
        PFAD_DATEIEN,
        PFAD_INIDATEIEN,
        PFAD_INCLUDE.'sicherung/',
        PFAD_INCLUDE.'export/pdf_fonts/',
        PFAD_TMP,
        PFAD_TEMPLATESC
    );
    $dateien = array(
        PFAD_HTTP.'.htaccess',
    	PFAD_LOGDATEIEN.'cronjob.ini',
        PFAD_LOGDATEIEN.'dbaenderungen.ini',
        PFAD_LOGDATEIEN.'logdatei.log',
        PFAD_INCLUDE.'conf/cronjob.ini',
        PFAD_INCLUDE.'conf/conf.inc.php',
        PFAD_INCLUDE.'conf/einstellungen.ini',
        PFAD_INCLUDE.'conf/emails.ini',
        PFAD_INCLUDE.'conf/module.ini',
        PFAD_INIDATEIEN.'dateien_tmp.ini',
        PFAD_INIDATEIEN.'userconf_default.ini',
        PFAD_INIDATEIEN.'zeiten_export.ini',
        PFAD_DATEIEN.'anwenderhandbuch.pdf'
    );
    $daten = array('v'=>array(),'d'=>array());
    foreach($verzeichnisse as $verz){
    	$daten['v'][$verz] = is_writable($verz);
    }
    foreach($dateien as $dat){
    	$daten['d'][$dat] = is_writable($dat);
    }
    $_tmpl->assign('daten',$daten);
    $_inh .= $_tmpl->fetch('admin/29.admin-rechteueberpruefen.inc.html');
	break;

case 'sonstige':
	if(!is_writable($include_pfad.'conf/conf.inc.php')){
    	$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/conf.inc.php) ist nicht beschreibbar, nderungen mssen von Hand gemacht werden.');
        if(isset($_POST['speichern'])){
        	unset($_POST['speichern']);
        }
    }
    $_lsvkennziffern = array(
        '01' => 'Badischer Schwimm-Verband (01)',
        '02' => 'Bayerischer Schwimm-Verband (02)',
        '03' => 'Berliner Schwimm-Verband (03)',
        '04' => 'Landesschwimmverband Brandenburg (04)',
        '05' => 'Landesschwimmverband Bremen (05)',
        '06' => 'Hamburger Schwimm-Verband (06)',
        '07' => 'Hessischer Schwimm-Verband (07)',
        '08' => 'Schwimmverband Mecklenburg/Vorpommern (08)',
        '09' => 'Landesschwimmverband Niedersachsen (09)',
        '10' => 'Schwimmverband Rheinland (10)',
        '11' => 'Saarlndischer Schwimm-Bund (11)',
        '12' => 'Schsischer Schwimm-Verband (12)',
        '13' => 'Landesschwimmverband Sachsen-Anhalt (13)',
        '14' => 'Schleswig-Holsteinischer Schwimm-Verband (14)',
        '15' => 'Sdwestdeutscher Schwimm-Verband (15)',
        '16' => 'Thringer Schwimm-Verband (16)',
        '17' => 'Schwimmverband Nordrhein-Westfalen (17)',
        '18' => 'Schwimmverband Wrttemberg (18)'
	);
    $_vereinsarten = array(
    	'abteilung' => 'Abteilung',
        'verein'    => 'Schwimmverein',
        'sg'        => 'Startgemeinschaft (SG)'
    );
	if(isset($_POST['speichern'])){
    	require_once($include_pfad.'func/pruefen.inc.php');
        $f = '';
        $d = &$_POST['daten'];
        $d['maxdateigroesse'] = str_replace(',','.',$d['maxdateigroesse']);
        $f .= pruefen($d['maxdateigroesse'],'regexpr','die maximale Dateigre ist ungltig','^[0-9]{1,2}(\.[0-9]{1,2})?$');
        if(empty($f) and (int)$d['maxdateigroesse'] > 50){
        	$f .= 'Die maximale Dateigre ist zu gro (max. 50 MB)<br />';
        }
        $f .= pruefen($d['version'],'leer','Die Version fehlt');
        $f .= pruefen($d['version'],'maxlaenge','Die Version ist zu lang (max. 20 Zeichen)',20);
        $f .= pruefen($d['adminpasswort'],'leer','Das Adminpasswort fehlt');
        $f .= pruefen($d['adminpasswort'],'passwort','Das Passwort muss aus mindestens je eines der
                    Zeichen [a-z], [A-Z] und [0-9] enthalten und mindestens 8 Zeichen lang sein.');
        $f .= pruefen($d['adminpasswort'],'maxlaenge','Das Adminpasswort ist zu lang (max. 200 Zeichen)',200);
        $tmp = pruefen($d['timeout'],'leer','Der Timeout-Wert fehlt');
        $tmp .= pruefen($d['timeout'],'zahl','Der Timeout ist keine Zahl');
        if(empty($tmp)){
        	if($d['timeout']<2){
            	$f .= 'Der Timeout-Wert ist zu klein (min. 2 Minuten)';
            }
        	if($d['timeout']>999){
            	$f .= 'Der Timeout-Wert ist zu gro (max. 999 Minuten)';
            }
        }
        else{
        	$f .= $tmp;
        }
        $f .= pruefen($d['verein'],'leer','Der Verein fehlt');
        $f .= pruefen($d['verein'],'maxlaenge','Der Verein ist zu lang (max. 200 Zeichen)',200);
        $f .= pruefen($d['vereinsid'],'leer','Die Vereinsid fehlt');
        $f .= pruefen($d['vereinsid'],'regexpr','Die Vereinsid ist ungltig (sie muss aus genau 4 Ziffern bestehen)','^[0-9]{4}$');
        $f .= pruefen($d['lsvkennziffer'],'leer','Die LSV-Kennziffer fehlt');
        $f .= pruefen($d['lsvkennziffer'],'wertemenge','Die LSV-Kennziffer ist ungltig',array_keys($_lsvkennziffern));
        $f .= pruefen($d['vereinsart'],'wertemenge','Die Vereinsart ist ungltig',array_keys($_vereinsarten));
        if(empty($f)){
        	# eigentlich wre die oberen zwei Zeilen ideal, allerdings funktioniert das nicht, da bei der Prfung
            #   der erhhte Wert u.U. schon gesetzt ist, und der Eintrag damit weggelassen wird, obwohl er ntig wre.
        	#$grenze_umf = substr(ini_get('upload_max_filesize'),0,-1);
        	#$grenze_pms = substr(ini_get('post_max_size'),0,-1);
        	$grenze_umf = 2;
        	$grenze_pms = 8;
            $speichern = array(
                'tkswim_maxdateigroesse' => round($d['maxdateigroesse']*(1024*1024)),
                'tkswim_schreibschutz'   => isset($d['schreibschutz'])?'true':'false',
                'tkswim_version'         => $d['version'],
                'tkswim_adminpasswort'   => $d['adminpasswort'],
                'tkswim_debug'           => isset($d['debug'])?'true':'false',
                'tkswim_timeout'         => $d['timeout']*60,
                'tkswim_verein'          => $d['verein'],
                'tkswim_vereinsart'      => $d['vereinsart'],
                'tkswim_vereinsid'       => $d['vereinsid'],
                'tkswim_lsvkennziffer'   => $d['lsvkennziffer'],
                'htaccess_include' => (substr(PFAD_INCLUDE,0,1)!='/'?substr(PFAD_INCLUDE,strpos(PFAD_INCLUDE,'/')):PFAD_INCLUDE),
                'upload_max_filesize' => ($d['maxdateigroesse']>$grenze_umf?$d['maxdateigroesse'].'M':false),
                'post_max_size'       => ($d['maxdateigroesse']>$grenze_pms?$d['maxdateigroesse'].'M':false)
            );
            $_tmpl->assign('daten',$speichern);
            $htaccessinhalt = $_tmpl->fetch('admin/29.admin-htaccess.inc.html');
            $fh = fopen(PFAD_HTTP.'.htaccess','w');
            fwrite($fh, $htaccessinhalt, strlen($htaccessinhalt));
            fclose($fh);
            $_tmpl->assign('daten',$speichern);
            $confinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
            $fh = fopen($include_pfad.'conf/conf.inc.php','w');
            fwrite($fh, $confinhalt, strlen($confinhalt));
            fclose($fh);
            weiterleiten('/admin.php','Die nderungen wurden gespeichert.');
        }
        else{
        	$_tmpl->assign('fehler',$f);
            $daten = $_POST['daten'];
        }
    }
    else{
    	$daten = array(
        	'maxdateigroesse' => round(TKSWIM_MAXDATEIGROESSE/(1024*1024),1),
        	'schreibschutz'   => TKSWIM_SCHREIBSCHUTZ?1:0,
        	'version'         => TKSWIM_VERSION,
        	'adminpasswort'   => TKSWIM_ADMINPASSWORT,
        	'debug'           => TKSWIM_DEBUG?1:0,
        	'timeout'         => TKSWIM_TIMEOUT/60,
        	'verein'          => TKSWIM_VEREIN,
            'vereinsart'      => TKSWIM_VEREINSART,
        	'vereinsid'       => TKSWIM_VEREINSID,
        	'lsvkennziffer'   => TKSWIM_LSVKENNZIFFER
        );
    }
    $_tmpl->assign('_lsvkennziffern',$_lsvkennziffern);
    $_tmpl->assign('_vereinsarten',$_vereinsarten);
    $_tmpl->assign('daten',$daten);
    $_inh .= $_tmpl->fetch('admin/29.admin-sonstige.inc.html');
	break;

case 'zusicherndetabellen':
	if(!is_writable($include_pfad.'log/dbaenderungen.ini')){
    	$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/log/dbaenderungen.ini) ist nicht beschreibbar, nderungen mssen von Hand gemacht werden.');
        if(isset($_POST['speichern'])){
        	unset($_POST['speichern']);
        }
    }
    $query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
    $_db->holeDaten($query, E_USER_ERROR, 'row');
    $tabellen = $_db->baueArray('0','#');
	if(isset($_POST['speichern'])){
        $speichern = array();
        if(!isset($_POST['gespeicherte'])){
        	$_POST['gespeicherte'] = array();
        }
        foreach($tabellen as $tabelle){
        	$speichern[$tabelle] = in_array($tabelle,$_POST['gespeicherte'])?1:0;
        }
        require_once($include_pfad.'func/schreibe_ini_datei.inc.php');
        schreibe_ini_datei($include_pfad.'log/dbaenderungen.ini',$speichern,false);
        weiterleiten('/admin.php','Die Tabellen wurden gespeichert');
    }
    else{
    	$daten = array();
        $gespeichert = parse_ini_file($include_pfad.'log/dbaenderungen.ini',false);
        foreach($gespeichert as $tabelle => $sichern){
        	if($sichern != 1){
            	continue;
            }
            $daten[] = $tabelle;
        }
    }
    $_tmpl->assign('tabellen',$tabellen);
    $_tmpl->assign('daten',$daten);
    $_inh .= $_tmpl->fetch('admin/29.admin-zusicherndetabellen.inc.html');
	break;

case 'email':
	if(!is_writable($include_pfad.'conf/emails.ini')){
    	$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/emails.ini) ist nicht beschreibbar, nderungen mssen von Hand gemacht werden.');
        if(isset($_POST['speichern'])){
        	unset($_POST['speichern']);
        }
    }
    $_dusie = array(
    	'du'  => 'geduzt',
        'sie' => 'gesiezt'
    );
    $query = "SELECT m.id, CONCAT(nachname,', ',vorname) as name FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."logins as l ON m.id=l.id
                WHERE email != '' AND l.anmeldename IS NOT NULL AND l.freigeschaltet = 1 ORDER BY name";
    $_db->holeDaten($query);
    $_mitglieder = $_db->baueArray('name','id');

    if(!isset($_POST['speichern'])){
    	$daten = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
        $daten['textteile']['begruessung'] = str_replace('[br]',"\n",$daten['textteile']['begruessung']);
        $daten['textteile']['verabschiedung'] = str_replace('[br]',"\n",$daten['textteile']['verabschiedung']);
    }
    else{
    	require_once($include_pfad.'func/pruefen.inc.php');
        $f = '';
        # Absender
        $_POST['absender']['name'] = trim($_POST['absender']['name']);
        $_POST['absender']['email'] = trim($_POST['absender']['email']);
        $f .= pruefen($_POST['absender']['name'],'leer','Der Absendername fehlt');
        $f .= pruefen($_POST['absender']['name'],'maxlaenge','Der Absendername ist zu lang (max. 100 Zeichen)',100);
        $f .= pruefen($_POST['absender']['email'],'leer','Die Absenderadresse fehlt');
        $f .= pruefen($_POST['absender']['email'],'email','Die Absenderadresse ist ungltig');
        $f .= pruefen($_POST['absender']['email'],'maxlaenge','Die Absenderadresse ist zu lang (max. 100 Zeichen)',100);
        # Cronjob
        if(count($_mitglieder)>0){
        	$f .= pruefen($_POST['cronjob']['empfaenger_statusmeldung'],'wertemenge',
        	   'Der Empfnger fr die Statusmeldungen ist ungltig',array_keys($_mitglieder));
        }
        else{
        	$_POST['cronjob']['empfaenger_statusmeldung'] = '';
        }
        # Sonstiges
        $_POST['sonstiges']['fparameter'] = trim($_POST['sonstiges']['fparameter']);
        $f .= pruefen($_POST['sonstiges']['fparameter'],'email','Der -f-Parameter ist ungltig');
        $f .= pruefen($_POST['sonstiges']['fparameter'],'maxlaenge','Der -f-Parameter ist zu lang (max. 100 Zeichen)',100);
        $f .= pruefen($_POST['sonstiges']['dusie'],'wertemenge','Der Sie/Du-Wert ist ungltig',array_keys($_dusie));
        # Betreff
        $_POST['betreff']['kennung_cronjob'] = trim($_POST['betreff']['kennung_cronjob']);
        $_POST['betreff']['zugangsdaten'] = trim($_POST['betreff']['zugangsdaten']);
        $f .= pruefen($_POST['betreff']['kennung_cronjob'],'maxlaenge','Die Kennung fr die Cronjobmails ist zu lang (max. 30 Zeichen)',30);
        $f .= pruefen($_POST['betreff']['zugangsdaten'],'leer','Der Betreff fr die Zugangsdatenmails fehlt');
        $f .= pruefen($_POST['betreff']['zugangsdaten'],'maxlaenge','Der Betreff fr die Zugangsdatenmails ist zu lang (max. 200 Zeichen)',200);
        # Textteile
        $f .= pruefen($_POST['textteile']['begruessung'],'leer','Die Begrung fehlt');
        $f .= pruefen($_POST['textteile']['begruessung'],'maxlaenge','Die Begrung ist zu lang (max. 500 Zeichen)',500);
        $f .= pruefen($_POST['textteile']['verabschiedung'],'leer','Die Verabschiedung fehlt');
        $f .= pruefen($_POST['textteile']['verabschiedung'],'maxlaenge','Die Verabschiedung ist zu lang (max. 500 Zeichen)',500);
        if(!empty($f)){
        	$_tmpl->assign('fehler',$f);
            $daten = $_POST;
        }
        else{
        	$einstellungen = array(
            	'absender'  => array('name','email'),
                'cronjob'   => array('empfaenger_statusmeldung'),
                'sonstiges' => array('fparameter','dusie'),
                'betreff'   => array('kennung_cronjob','zugangsdaten'),
                'textteile' => array('begruessung','verabschiedung')
            );
        	foreach($einstellungen as $kat => $unterkat){
            	$conf[$kat] = array();
                foreach($unterkat as $wert){
            		$conf[$kat][$wert] = $_POST[$kat][$wert];
                }
            }
            if(!empty($conf['betreff']['kennung_cronjob'])){
            	$conf['betreff']['kennung_cronjob'] .= ' ';
            }
            $conf['textteile']['begruessung'] = preg_replace("/(\015\012)|(\015)|(\012)/",'[br]',$conf['textteile']['begruessung']);
            $conf['textteile']['verabschiedung'] = preg_replace("/(\015\012)|(\015)|(\012)/",'[br]',$conf['textteile']['verabschiedung']);
            require_once($include_pfad.'func/schreibe_ini_datei.inc.php');
            schreibe_ini_datei($include_pfad.'conf/emails.ini',$conf,true);
            weiterleiten('/admin.php','Die Einstellungen wurden gespeichert.');
        }
    }
    if(count($_mitglieder)){
    	$_tmpl->assign('_mitglieder',$_mitglieder);
    }
	$_tmpl->assign('_dusie',$_dusie);
	$_tmpl->assign('daten',$daten);
    $_inh .= $_tmpl->fetch('admin/29.admin-email.inc.html');
	break;

case 'cronjob':
	if(!is_writable($include_pfad.'conf/cronjob.ini')){
    	$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/cronjob.ini) ist nicht beschreibbar, nderungen mssen von Hand gemacht werden.');
        if(isset($_POST['speichern'])){
        	unset($_POST['speichern']);
        }
    }
	$zweimalimmonat = array(
    	'115'  => '1. und 15. jeden Monats',     '13mo' => '1. und 3. Montag im Monat',     '13di' => '1. und 3. Dienstag im Monat',
        '13mi' => '1. und 3. Mittwoch im Monat', '13do' => '1. und 3. Donnerstag im Monat', '13fr' => '1. und 3. Freitag im Monat',
        '13sa' => '1. und 3. Samstag im Monat',  '13so' => '1. und 3. Sonntag im Monat',    '24mo' => '2. und 4. Montag im Monat',
        '24di' => '2. und 4. Dienstag im Monat', '24mi' => '2. und 4. Mittwoch im Monat',   '24do' => '2. und 4. Donnerstag im Monat',
        '24fr' => '2. und 4. Freitag im Monat',  '24sa' => '2. und 4. Samstag im Monat',    '24so' => '2. und 4. Sonntag im Monat'
    );
    $monatlich = array(
    	'ersten' => 'Monatsersten',        '1mo' => '1. Montag im Monat',     '1di' => '1. Dienstag im Monat',
        '1mi' => '1. Mittwoch im Monat',   '1do' => '1. Donnerstag im Monat', '1fr' => '1. Freitag im Monat',
        '1sa' => '1. Samstag im Monat',    '1so' => '1. Sonntag im Monat',    '2mo' => '2. Montag im Monat',
        '2di' => '2. Dienstag im Monat',   '2mi' => '2. Mittwoch im Monat',   '2do' => '2. Donnerstag im Monat',
        '2fr' => '2. Freitag im Monat',    '2sa' => '2. Samstag im Monat',    '2so' => '2. Sonntag im Monat',
        '3mo' => '3. Montag im Monat',     '3di' => '3. Dienstag im Monat',   '3mi' => '3. Mittwoch im Monat',
        '3do' => '3. Donnerstag im Monat', '3fr' => '3. Freitag im Monat',    '3sa' => '3. Samstag im Monat',
        '3so' => '3. Sonntag im Monat',    '4mo' => '4. Montag im Monat',     '4di' => '4. Dienstag im Monat',
        '4mi' => '4. Mittwoch im Monat',   '4do' => '4. Donnerstag im Monat', '4fr' => '4. Freitag im Monat',
        '4sa' => '4. Samstag im Monat',    '4so' => '4. Sonntag im Monat',    'letzen' => 'Monatsletzten'
    );
    $sicherbarepfade = array(
        'PFAD_INCLUDEbilder_speicher/:bilder_speicher/' => ' Bildercache (bilder_speicher)',
        'PFAD_INCLUDEconf/:conf/'                       => ' Einstellungsdateien (conf)',
        'PFAD_INCLUDEdateien/:dateien/'                 => ' Dateien aus der Dateiverwaltung (dateien)',
    	'PFAD_INCLUDEini_speicher/:ini_speicher/'       => ' user- oder wettkampfspezifische Einstellungsdateien (ini_speicher)'
    );
    $erlaubteintervalle = array(
    	'austritte'          => array('taeglich','woechentlich','zweimalimmonat','monatlich','nie'),
    	'feiertageanlegen'   => array('woechentlich','zweimalimmonat','monatlich','nie'),
    	'tabellenoptimieren' => array('woechentlich','zweimalimmonat','monatlich','nie'),
    	'dbsichern'          => array('taeglich','woechentlich','zweimalimmonat','monatlich'),
    	'dateiensichern'     => array('taeglich','woechentlich','zweimalimmonat','monatlich'),
    	'gc'                 => array('woechentlich','zweimalimmonat','monatlich'),
        'aktuellezeiten'     => array('woechentlich','zweimalimmonat','monatlich')
    );
    $standardintervalle = array(
    	'intervall'                => 'monatlich',
        'zeitpunkt_woechentlich'   => '1',
        'zeitpunkt_zweimalimmonat' => '115',
        'zeitpunkt_monatlich'      => 'ersten',
    );

    if(!isset($_POST['speichern'])){
    	$daten = array();
    	$conf = parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true);
        # Zeitpunkte
        $daten['zeitpunkte'] = array();
        foreach($conf['zeitpunkte'] as $aktion => $wert){
            $daten['zeitpunkte'][$aktion] = $standardintervalle;
            if(strpos($wert,':')===false){
            	$daten['zeitpunkte'][$aktion]['intervall'] = $wert;
            	continue;
            }
        	list($interval, $zeitpunkt) = explode(':',$wert);
            $daten['zeitpunkte'][$aktion]['intervall'] = $interval;
            $daten['zeitpunkte'][$aktion]['zeitpunkt_'.$interval] = $zeitpunkt;
        }
        # zu sichernde Verzichenisse
        $daten['zusicherndeverzeichnisse'] = $conf['zusicherndeverzeichnisse'];
        # gc
        $daten['gc'] = array();
        foreach($conf['gc'] as $gc => $wert){
        	if(in_array($gc,array('tmpdateien','wettkampfabwicklungsdateien'))){
            	$daten['gc'][$gc] = $wert;
                continue;
            }
        	$daten['gc'][$gc.'_optionen'] = array();
            $aktionen = explode(';',$wert);
            foreach($aktionen as $aktion){
            	if(strpos($aktion,':')!==false){
                	list($a,$w) = explode(':',$aktion);
                    $daten['gc'][$gc][] = $a;
                    $daten['gc'][$gc.'_optionen'][$a] = $w;
                }
                else{
                    $daten['gc'][$gc][] = $aktion;
                }
            }
        }
        # sonstiges
        $daten['einstellungen'] = $conf['einstellungen'];
        $daten['einstellungen']['aufrufvonip'] = str_replace(',',', ',$daten['einstellungen']['aufrufvonip']);
        $daten['flags'] = $conf['flags'];
    }
    else{
    	require_once($include_pfad.'func/pruefen.inc.php');
        $f = '';
        # Zeitpunkte
        foreach($erlaubteintervalle as $aktion => $erlaubt){
        	if(!isset($_POST['zeitpunkte'][$aktion])){
            	$f .= $aktion.' fehlt<br />';
                continue;
            }
            $a = &$_POST['zeitpunkte'][$aktion];
        	if(!isset($a['intervall'])){
            	$f .= 'Das gewhlte Intervall ist fr die Aktion '.$aktion.' fehlt<br />';
                continue;
            }
        	if(!in_array($a['intervall'],$erlaubt)){
            	$f .= 'Das gewhlte Intervall ist fr die Aktion '.$aktion.' nicht erlaubt oder ungltig<br />';
                continue;
            }
            switch($a['intervall']){
            case 'woechentlich':
            	if(!isset($a['zeitpunkt_woechentlich']) or !in_array($a['zeitpunkt_woechentlich'],array_keys($_wochentage))){
                	$f .= 'Der Zeitpunkt fr die Aktion '.$aktion.' fehlt oder ist ungltig.<br />';
                }
                $a['zeitpunkt_zweimalimmonat'] = $standardintervalle['zeitpunkt_zweimalimmonat'];
                $a['zeitpunkt_monatlich'] = $standardintervalle['zeitpunkt_monatlich'];
            	break;
            case 'zweimalimmonat':
            	if(!isset($a['zeitpunkt_zweimalimmonat']) or !in_array($a['zeitpunkt_zweimalimmonat'],array_keys($zweimalimmonat))){
                	$f .= 'Der Zeitpunkt fr die Aktion '.$aktion.' fehlt oder ist ungltig.<br />';
                }
                $a['zeitpunkt_woechentlich'] = $standardintervalle['zeitpunkt_woechentlich'];
                $a['zeitpunkt_monatlich'] = $standardintervalle['zeitpunkt_monatlich'];
            	break;
            case 'monatlich':
            	if(!isset($a['zeitpunkt_monatlich']) or !in_array($a['zeitpunkt_monatlich'],array_keys($monatlich))){
                	$f .= 'Der Zeitpunkt fr die Aktion '.$aktion.' fehlt oder ist ungltig.<br />';
                }
                $a['zeitpunkt_woechentlich'] = $standardintervalle['zeitpunkt_woechentlich'];
                $a['zeitpunkt_zweimalimmonat'] = $standardintervalle['zeitpunkt_zweimalimmonat'];
            	break;
            }
        }
        # zusicherndeverzeichnisse
        foreach($_POST['zusicherndeverzeichnisse'] as $key => $verz){
        	if(!in_array($verz,array_keys($sicherbarepfade))){
            	$f .= 'Der angegebene, zu sichernde Pfad ist ungltig<br />';
            }
        }
        # gc
        if(!isset($_POST['gc']['zeitenentwicklungbilder'])){
        	$f .= 'Es muss mindestens ein garbage collector zum Lschen von Zeitenentwicklungsbildern definiert sein<br />';
        }
        else{
        	foreach($_POST['gc']['zeitenentwicklungbilder'] as $gc){
            	if(!in_array($gc,array('aelterals','ausgetretene','groesserals'))){
                	$f .= 'Die gewhlte Aktion zum Lschen von Zeitenentwicklungsbildern ist ungltig<br />';
                    continue;
                }
                switch($gc){
                case 'aelterals':
                	$f .= pruefen($_POST['gc']['zeitenentwicklungbilder_optionen']['aelterals'],'zahl',
                        'Die Anzahl der Tage beim Zeitenentwicklungsbilder-gc ist keine ganze Zahl');
                	break;
                case 'groesserals':
        			$f .= pruefen($_POST['gc']['zeitenentwicklungbilder_optionen']['groesserals'],'leer',
                        'Die maximale Gre der Bilder beim Zeitenentwicklungsbilder-gc fehlt');
                	$f .= pruefen($_POST['gc']['zeitenentwicklungbilder_optionen']['groesserals'],'regexpr',
                        'Die maximale Gre der Bilder beim Zeitenentwicklungsbilder-gc ist keine Zahl','^[0-9](?:[.,][0-9]{1,2})?$');
                    break;
                default:
                	break;
                }
            }
        }
        $f .= pruefen($_POST['gc']['tmpdateien'],'leer','Die Anzahl der Tage fr den gc der temporren Dateien fehlt');
        $f .= pruefen($_POST['gc']['tmpdateien'],'zahl','Die Anzahl der Tage fr den gc der temporren Dateien ist keine gltige ganz Zahl');
        $f .= pruefen($_POST['gc']['wettkampfabwicklungsdateien'],'leer','Die Anzahl der Jahre fr den gc der WK-Abwicklungsdateien fehlt');
        $f .= pruefen($_POST['gc']['wettkampfabwicklungsdateien'],'zahl','Die Anzahl der Jahre fr den gc der WK-Abwicklungsdateien ist keine gltige ganz Zahl');
        # sonstiges
        $_POST['einstellungen']['aufrufvonip'] = str_replace(' ','',$_POST['einstellungen']['aufrufvonip']);
        $f .= pruefen($_POST['einstellungen']['aufrufvonip'],'regexpr','mindestens eine der eingegebenen IPs ist ungltig',
          '^([0-9]{1,3}(\.[0-9]{1,3}){3})(,[0-9]{1,3}(\.[0-9]{1,3}){3})*$');

        if(!empty($f)){
        	$_tmpl->assign('fehler',$f);
        	$_POST['einstellungen']['aufrufvonip'] = str_replace(',',', ',$_POST['einstellungen']['aufrufvonip']);
            $daten = $_POST;
        }
        else{
        	$conf = array();
            # zeitpunkte
            $conf['zeitpunkte'] = array();
            foreach($_POST['zeitpunkte'] as $zeitpunkt => $aktion){
            	$conf['zeitpunkte'][$zeitpunkt] = $aktion['intervall'];
                if(in_array($aktion['intervall'],array('woechentlich','zweimalimmonat','monatlich'))){
                	$conf['zeitpunkte'][$zeitpunkt] .= ':'.$aktion['zeitpunkt_'.$aktion['intervall']];
                }
            }
            # zusicherndeverzeichnisse
            $conf['zusicherndeverzeichnisse'] = array();
            foreach($_POST['zusicherndeverzeichnisse'] as $verz){
            	$conf['zusicherndeverzeichnisse'][] = $verz;
            }
            # gc
            $conf['gc'] = array();
            $conf['gc']['zeitenentwicklungbilder'] = '';
            $_POST['gc']['zeitenentwicklungbilder_optionen']['groesserals'] = str_replace(',','.',$_POST['gc']['zeitenentwicklungbilder_optionen']['groesserals']);
            foreach($_POST['gc']['zeitenentwicklungbilder'] as $aktion){
            	$conf['gc']['zeitenentwicklungbilder'] .= (empty($conf['gc']['zeitenentwicklungbilder'])?'':';').$aktion;
                if(isset($_POST['gc']['zeitenentwicklungbilder_optionen'][$aktion])){
                	$conf['gc']['zeitenentwicklungbilder'] .= ':'.$_POST['gc']['zeitenentwicklungbilder_optionen'][$aktion];
                }
            }
            $conf['gc']['tmpdateien'] = $_POST['gc']['tmpdateien'];
            $conf['gc']['wettkampfabwicklungsdateien'] = $_POST['gc']['wettkampfabwicklungsdateien'];
            # sonstiges
            $conf['einstellungen'] = array();
            $conf['flags'] = array();
            $conf['einstellungen']['aufrufvonip'] = $_POST['einstellungen']['aufrufvonip'];
            $conf['flags']['userconfeinlesen'] = isset($_POST['flags']['userconfeinlesen'])?1:0;
            $conf['flags']['komplettsicherung'] = isset($_POST['flags']['komplettsicherung'])?1:0;
            $conf['flags']['zeitenentwicklungsbilderloeschen'] = isset($_POST['flags']['zeitenentwicklungsbilderloeschen'])?1:0;
            $conf['flags']['vereinsrekordeeinlesen'] = isset($_POST['flags']['vereinsrekordeeinlesen'])?1:0;
            # cronjob.ini schreiben und weiterleiten
            require_once($include_pfad.'func/schreibe_ini_datei.inc.php');
            schreibe_ini_datei($include_pfad.'conf/cronjob.ini',$conf,true);
            weiterleiten('/admin.php','Die nderungen wurden gespeichert.');
        }
    }
	$_tmpl->assign('_sicherbarepfade',$sicherbarepfade);
	$_tmpl->assign('_zweimalimmonat',$zweimalimmonat);
	$_tmpl->assign('_monatlich',$monatlich);
	$_tmpl->assign('_wochentage',$_wochentage);
	$_tmpl->assign('_monate',$_monate);
    if(!isset($daten['gc']['zeitenentwicklungbilder'])){
    	$daten['gc']['zeitenentwicklungbilder'] = array();
    }
	$_tmpl->assign('daten',$daten);
    $_inh .= $_tmpl->fetch('admin/29.admin-cronjob.inc.html');
	break;

case 'dbdaten':
	if(!is_writable($include_pfad.'conf/conf.inc.php')){
    	$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/conf.inc.php) ist nicht beschreibbar, nderungen mssen von Hand gemacht werden.');
        if(isset($_POST['speichern'])){
        	unset($_POST['speichern']);
        }
    }
	if(isset($_POST['speichern'])){
    	require_once($include_pfad.'func/pruefen.inc.php');
        $f = '';
        $f .= pruefen($_POST['daten']['db_server'],'maxlaenge','Der Servername ist zu lang (max. 200 Zeichen)',200);
        $f .= pruefen($_POST['daten']['db_benutzername'],'maxlaenge','Der Benutzername ist zu lang (max. 200 Zeichen)',200);
        $f .= pruefen($_POST['daten']['db_passwort'],'maxlaenge','Das Passwort ist zu lang (max. 200 Zeichen)',200);
        $f .= pruefen($_POST['daten']['db_name'],'maxlaenge','Der Datenbankname ist zu lang (max. 200 Zeichen)',200);
        $f .= pruefen($_POST['daten']['db_prefix'],'maxlaenge','Das Tabellenprefix ist zu lang (max. 50 Zeichen)',50);
        $f .= pruefen($_POST['daten']['db_prefix'],'regexpr','Das Tabellenprefix darf nur aus den Zeichen a-z0-9_ bestehen.','^[a-zA-Z0-9_]+$');

        if(empty($f)){
            # bei geaendertem DB_PREFIX Tabellen umbenennen
            if($_POST['daten']['db_prefix'] != DB_PREFIX and $_POST['daten']['db_name'] == DB_NAME){
            	$dat = &$_POST['daten'];
            	$_db = new db;
                $_db->tmpl = &$_tmpl;
                $_db->schreibschutz = false;
                $_db->setzeDbParameter($dat['db_server'], $dat['db_benutzername'], $dat['db_passwort'], $dat['db_name']);
                $_db->verbindeMitDb();
                $query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
                $_db->holeDaten($query, E_USER_ERROR, 'row');
                $tabellen = $_db->baueArray('0','0');
                foreach($tabellen as $tabelle){
                    $alt = $tabelle;
                    $neu = $dat['db_prefix'].substr($tabelle,strlen(DB_PREFIX));
                    $query = "ALTER TABLE ".$alt." RENAME TO ".$neu."";
                    $_db->fuehreQueryAus($query);
                }
             	# log/dbaenderungen.ini zuruecksetzen
            	$fh = fopen($include_pfad.'log/dbaenderungen.ini','w');
                fclose($fh);
            }
            # conf-Datei schreiben
            $daten = array(
                'db_server'        => $_POST['daten']['db_server'],
                'db_benutzername'  => $_POST['daten']['db_benutzername'],
                'db_passwort'      => $_POST['daten']['db_passwort'],
                'db_name'          => $_POST['daten']['db_name'],
                'db_prefix'        => $_POST['daten']['db_prefix']
            );
            $_tmpl->assign('daten',$daten);
            $confinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
            $fh = fopen($include_pfad.'conf/conf.inc.php','w');
            fwrite($fh, $confinhalt, strlen($confinhalt));
            fclose($fh);
            weiterleiten('/admin.php','Die nderungen wurden gespeichert.');
        }
        else{
        	$_tmpl->assign('fehler',$f);
            $daten = $_POST['daten'];
        }
    }
    else{
    	$daten = array(
        	'db_server'        => DB_SERVER,
            'db_benutzername'  => DB_BENUTZERNAME,
            'db_passwort'      => DB_PASSWORT,
            'db_name'          => DB_NAME,
            'db_prefix'        => DB_PREFIX
        );
    }
    $_tmpl->assign('daten',$daten);
    $_inh .= $_tmpl->fetch('admin/29.admin-dbdaten.inc.html');
	break;

case 'userconfdefault':
    $_schriftgroessen = array(
        8  => '8pt',
        9  => '9pt',
        10 => '10pt',
        11 => '11pt',
        12 => '12pt',
        13 => '13pt',
        14 => '14pt',
    );
    $_globaleeinstellungen_pdfquerformatoben = array(
        'links'  => 'linker Rand',
        'rechts' => 'rechter Rand'
    );
    $_stundennachweis_anfang = array(
        'heute'  => 'Heute',
        'woche'  => 'nchste Woche',
        'monat'  => 'nchsten Monat',
        'ferien' => 'nach den nchsten Ferien',
        'vorgegeben' => 'vorgegebene Zeitrume (siehe Doku)'
    );
    $_stundennachweis_zeitraum = array(
        'monat1' => '1 Monat',
        'monat2' => '2 Monate',
        'monat3' => '3 Monate',
        'monat4' => '4 Monate',
        'monat5' => '5 Monate',
        'monat6' => '6 Monate'
    );
    $_stundennachweis_sortierung = array(
        'nachname'          => 'Nachname, Vorname',
        'vorname'           => 'Vorname, Nachname',
        'jahrgang_vorname'  => 'Jahrgang, Vorname',
        'jahrgang_nachname' => 'Jahrgang, Nachname'
    );
    $_stundennachweis_namensanzeige = array(
        'nachname_vorname' => 'Nachname, Vorname',
        'vorname_nachname' => 'Vorname Nachname',
    );
    $_terminbenachrichtigung_zeitraum = array(
        'nicht' => 'garnicht',
        'tag'   => 'tglich',
        'woche' => 'wchentlich',
        'monat' => 'monatlich'
    );
    $_dateisystem_klickaufdatei = array(
        'runterladen' => 'Datei herunterladen',
        'details'     => 'Details der Datei zeigen'
    );
    $_dateisystem_csvtrenner = array(
        ';'    => 'Semikolon (;)',
        ','    => 'Komma (,)',
        ':'    => 'Doppelpunkt (:)',
        'tab'  => 'Tabulator (\t)',
        'leer' => 'Leerzeichen ( )'
    );
	require_once($include_pfad.'class/einstellungen.inc.php');
	$einst = new einstellungen(PFAD_INCLUDE.'conf/user-ini.xml',PFAD_INIDATEIEN,'userconf_default.ini');
	$einst->db = &$_db;
	$einst->einlesen();
	$_tmpl->assign('bodyid','einstellungen');

    if(isset($_POST['speichern'])){
        $f = '';
    	foreach($_POST as $mid => $modul){
        	if(!isset($einst->daten[$mid]) or !is_array($modul)){
				continue;
            }
        	foreach($modul as $oid => $option){
            	if(!isset($einst->daten[$mid]) or !isset($einst->daten[$mid]['optionen'][$oid])){
                	continue;
                }
            	switch($einst->daten[$mid]['optionen'][$oid]['art']){
                case 'datei':
                	if(!file_exists( $einst->daten[$mid]['optionen'][$oid]['verzeichnis'].$option)){
                    	$f .= $einst->daten[$mid]['optionen'][$oid]['fehler'].'<br />';
                    }
                    break;
                case 'bool':
                    $_POST[$mid][$oid] = $option==1?1:0;
                    break;
                case 'text':
                    if(preg_match('~^'.$einst->daten[$mid]['optionen'][$oid]['form'].'$~',$option,$match) == 0){
                    	$f .= $einst->daten[$mid]['optionen'][$oid]['fehler'].'<br />';
                    }
                    break;
                case 'select':
                    if(!in_array($option,array_keys(${$einst->daten[$mid]['optionen'][$oid]['variable']}))){
                    	$f .= $einst->daten[$mid]['optionen'][$oid]['fehler'].'<br />';
                    }
                    break;
                }
            }
        }
        if(!empty($f)){
        	$_tmpl->assign('fehler',$f);
            $_POST['emailbenachrichtigung']['terminbenachrichtigungen'] = $_einst['emailbenachrichtigung']['terminbenachrichtigungen'];
        	$daten = $einst->erzeugeBearbeitenDaten($_POST);
        	$_tmpl->assign('daten',$daten);
        	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-formular.inc.html');
        }
        else{
        	$schreiben = $einst->erzeugeIniBaum();
            $schreiben['emailbenachrichtigung']['terminbenachrichtigungen'] = $_einst['emailbenachrichtigung']['terminbenachrichtigungen'];
    		foreach($schreiben as $mid => $modul){
            	if(!isset($_POST[$mid])){
					continue;
                }
           		foreach($modul as $oid => $option){
                	if(isset($_POST[$mid][$oid])){
                    	$schreiben[$mid][$oid] = $_POST[$mid][$oid];
                    }
                }
            }
			require_once($include_pfad.'func/schreibe_ini_datei.inc.php');
        	schreibe_ini_datei($einst->userconfpfad.$einst->userdatei,$schreiben,true);
            weiterleiten('/admin.php?aktion=userconfdefault');
        }
    }
    else{
    	$usereinst = parse_ini_file($einst->userconfpfad.$einst->userdatei,true);
    	$daten = $einst->erzeugeBearbeitenDaten($usereinst);
    	$_tmpl->assign('daten',$daten);
    	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-formular.inc.html');
    }
	break;

default:
	$_tmpl->assign('mysqlversion_41',isset($mysqlversion_41)?$mysqlversion_41:NULL);
	$_inh .= $_tmpl->fetch('admin/29.index.inc.html');
    break;
}
} # Ende Rechte-else

if(isset($_db) and $_db !==false){
	$_db->speichereGeaenderteTabellen();
}
$_tmpl->assign('inhalt',$_inh);
$_tmpl->assign('s',$_seite);
if(count($_tmpl->tk_fussnoten) > 0){
	$_tmpl->assign('fussnoten',$_tmpl->tk_fussnoten);
}
$_tmpl->assign('_datumwahl',isset($_tmpl->tk_datumwahl));
# JS-Dateien
$jsdateien = $_tmpl->get_template_vars('jsdateien');
if(is_array($jsdateien)){
	unset($jsdateien[0]);
    $jsdateien = array_unique($jsdateien);
	$_tmpl->assign('jsdateien',$jsdateien);
    if(in_array('/src/js/loeschfrage.js',$jsdateien) and $_einst['globaleeinstellungen']['sicherheitsabfragenabschalten']){
        $_tmpl->tk_append_string('js_inline',"var keineloeschfrage = 1;",1);
    }
}

# Konstanten in $js_inline ersetzen
$js = $_tmpl->get_template_vars('js_inline');
if(!empty($js)){
	$anz = preg_match('~[A-Z_]{2,}~', $js, $match);
	if($anz > 0){
    	foreach($match as $m){
        	if(!defined($m)){
            	continue;
            }
            else{
            	$js = str_replace($m, constant($m), $js);
            }
        }
    }
    $_tmpl->assign('js_inline',trim($js));
}

$inhalt = $_tmpl->fetch('tmpl.inc.html');
if(!headers_sent()){
    header('x-Powered-By: Tobias Kloth');
}
if(isset($_einst) and $_einst['globaleeinstellungen']['inhaltkomprimiertausliefern']){
	ob_start('ob_gzhandler');
	echo $inhalt;
	ob_end_flush();
}
else{
	echo $inhalt;
}

if(isset($_SESSION['hinweis'])){
	unset($_SESSION['hinweis']);
}
# EOF
?>