/* Tabellen anlegen */
CREATE TABLE tkswim_abschnitte (
  id smallint(5) unsigned NOT NULL auto_increment,
  wettkampfid smallint(5) unsigned NOT NULL default '0',
  nr tinyint(3) unsigned NOT NULL default '0',
  datum date NOT NULL default '0000-00-00',
  beginn time NOT NULL default '00:00:00',
  kindgerecht char(1) collate latin1_german2_ci default NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_aktuellezeiten (
  mid smallint(5) unsigned NOT NULL,
  laenge smallint(5) unsigned NOT NULL,
  disziplin tinyint(3) unsigned NOT NULL,
  zeit mediumint(8) unsigned NOT NULL,
  zeitid mediumint(8) unsigned NOT NULL,
  UNIQUE KEY strecke (mid,laenge,disziplin)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_dateien (
  id mediumint(8) unsigned NOT NULL auto_increment,
  angelegt datetime NOT NULL default '0000-00-00 00:00:00',
  letzteaenderung datetime NOT NULL default '0000-00-00 00:00:00',
  userid smallint(5) unsigned NOT NULL default '0',
  gruppenid tinyint(3) unsigned NOT NULL default '0',
  rechte varchar(9) collate latin1_german2_ci NOT NULL,
  dateiname varchar(100) collate latin1_german2_ci NOT NULL,
  typ varchar(4) collate latin1_german2_ci NOT NULL,
  systemname varchar(100) collate latin1_german2_ci NOT NULL,
  groesse varchar(10) collate latin1_german2_ci NOT NULL,
  verzeichnisid smallint(5) unsigned NOT NULL default '0',
  beschreibung text collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_eigenschaften (
  art enum('m','w') collate latin1_german2_ci NOT NULL default 'm',
  artid smallint(5) unsigned NOT NULL default '0',
  eigenschaft varchar(50) collate latin1_german2_ci NOT NULL,
  wert varchar(255) collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (art,artid,eigenschaft)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_familien (
  id smallint(5) unsigned NOT NULL auto_increment,
  titel varchar(100) collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY titel (titel)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_ferien (
  art tinyint(3) unsigned NOT NULL,
  jahr year(4) NOT NULL,
  nr tinyint(3) unsigned NOT NULL default '1',
  von date default NULL,
  bis date default NULL,
  bezeichnung varchar(50) collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (art,jahr,nr)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_kampfrichter (
  id tinyint(3) unsigned NOT NULL auto_increment,
  mitgliedid smallint(5) unsigned NOT NULL default '0',
  gueltigbis year(4) NOT NULL default '0000',
  gruppe tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_lenreferenzzeiten (
  id tinyint(3) unsigned NOT NULL auto_increment,
  strecke smallint(4) unsigned NOT NULL default '0',
  disziplin tinyint(3) unsigned NOT NULL default '0',
  mw char(1) collate latin1_german2_ci NOT NULL,
  zeit mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_lizenzierungen (
  mitgliedid smallint(5) unsigned NOT NULL default '0',
  jahr year(4) NOT NULL default '0000',
  UNIQUE KEY mitgliedid (mitgliedid,jahr)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_logins (
  id smallint(5) unsigned NOT NULL default '0',
  anmeldename varchar(50) collate latin1_german2_ci NOT NULL,
  salz varchar(10) collate latin1_german2_ci default NULL,
  passwort varchar(32) collate latin1_german2_ci NOT NULL,
  freigeschaltet tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_meldungen_starts (
  teilnehmerid smallint(5) unsigned NOT NULL default '0',
  teilnahme char(1) collate latin1_german2_ci NOT NULL default '0',
  meldezeit mediumint(8) unsigned default NULL,
  wkid mediumint(8) unsigned NOT NULL default '0',
  zeitid mediumint(8) unsigned default NULL,
  KEY zeitid (zeitid)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_meldungen_teilnehmer (
  id smallint(5) unsigned NOT NULL auto_increment,
  wettkampfid smallint(5) unsigned NOT NULL default '0',
  mid smallint(5) unsigned NOT NULL default '0',
  fahrt tinyint(3) NOT NULL default '-2',
  teilnahme char(1) collate latin1_german2_ci NOT NULL default '0',
  telefon varchar(22) collate latin1_german2_ci NOT NULL default '',
  kommentar varchar(200) collate latin1_german2_ci NOT NULL default '',
  PRIMARY KEY  (id),
  KEY wettkampfid (wettkampfid)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_mitglieder (
  id smallint(5) unsigned NOT NULL auto_increment,
  dsvid varchar(6) collate latin1_german2_ci default NULL,
  vorname varchar(30) collate latin1_german2_ci NOT NULL,
  nachname varchar(50) collate latin1_german2_ci NOT NULL,
  familienid smallint(5) unsigned NOT NULL default '0',
  mw char(1) collate latin1_german2_ci NOT NULL default 'x',
  gebdatum date NOT NULL default '0000-00-00',
  eingetreten date NOT NULL default '0000-00-00',
  ausgetreten year(4) default NULL,
  strasse varchar(40) collate latin1_german2_ci default NULL,
  hausnr varchar(5) collate latin1_german2_ci default NULL,
  plz varchar(5) collate latin1_german2_ci default NULL,
  ort varchar(40) collate latin1_german2_ci default NULL,
  email varchar(50) collate latin1_german2_ci default NULL,
  homeverzeichnisid smallint(5) unsigned default NULL,
  mitgliedskarte tinyint(1) NOT NULL default '1',
  attestbis date default NULL,
  sonstiges text collate latin1_german2_ci,
  PRIMARY KEY  (id),
  UNIQUE KEY dsvid (dsvid)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_mitglieder_trainingsgruppen (
  mitgliedid smallint(5) unsigned NOT NULL default '0',
  trainingsgruppenid tinyint(3) unsigned NOT NULL default '0',
  KEY mitgliedid (mitgliedid)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_pflichtzeiten (
  id tinyint(3) unsigned NOT NULL auto_increment,
  bezeichnung varchar(100) collate latin1_german2_ci NOT NULL,
  richtpflicht char(1) collate latin1_german2_ci NOT NULL,
  offiziell tinyint(3) unsigned NOT NULL default '0',
  sort tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_pflichtzeiten_jahrgaenge (
  id smallint(5) unsigned NOT NULL auto_increment,
  pflichtzeitenid tinyint(3) unsigned NOT NULL default '0',
  jahrgang varchar(50) collate latin1_german2_ci NOT NULL,
  pos tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_pflichtzeiten_strecken (
  id smallint(5) unsigned NOT NULL auto_increment,
  pflichtzeitenid tinyint(3) unsigned NOT NULL default '0',
  disziplin tinyint(3) unsigned NOT NULL default '0',
  laenge smallint(5) unsigned NOT NULL default '0',
  mw char(1) collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_pflichtzeiten_zeiten (
  streckenid smallint(5) unsigned NOT NULL default '0',
  jahrgangid smallint(5) unsigned NOT NULL default '0',
  zeit mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (streckenid,jahrgangid)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_rechte (
  id varchar(35) collate latin1_german2_ci NOT NULL,
  sort smallint(5) unsigned NOT NULL default '0',
  bezeichnung varchar(100) collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_rechtegruppen (
  id tinyint(3) unsigned NOT NULL auto_increment,
  sort tinyint(3) unsigned NOT NULL default '0',
  bezeichnung varchar(100) collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_rechtegruppen_mitglieder (
  mitgliedid smallint(5) unsigned NOT NULL default '0',
  rechtegrid tinyint(3) unsigned NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_rechtegruppen_rechte (
  rechtegrid smallint(5) unsigned NOT NULL default '0',
  rechteid varchar(35) collate latin1_german2_ci NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_staffeln (
  id smallint(5) unsigned NOT NULL auto_increment,
  wettkampfid smallint(5) unsigned NOT NULL default '0',
  disziplin tinyint(3) unsigned NOT NULL default '0',
  anzahl tinyint(3) unsigned NOT NULL,
  laenge smallint(5) unsigned NOT NULL default '0',
  mw char(1) collate latin1_german2_ci NOT NULL default 'x',
  gesamtzeit mediumint(8) unsigned default NULL,
  platz varchar(3) collate latin1_german2_ci default NULL,
  platzvon tinyint(3) unsigned default NULL,
  bemerkung varchar(255) collate latin1_german2_ci default NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_staffeln_zeiten (
  staffelid smallint(5) unsigned NOT NULL default '0',
  zeitid mediumint(8) unsigned default '0',
  schwimmernr tinyint(3) unsigned NOT NULL default '0',
  KEY zeitid (zeitid)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_telefon (
  id mediumint(10) unsigned NOT NULL auto_increment,
  mitgliedid smallint(10) unsigned NOT NULL default '0',
  telefonart tinyint(3) unsigned NOT NULL default '1',
  vorwahl varchar(6) collate latin1_german2_ci NOT NULL,
  nummer varchar(12) collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_termine (
  id smallint(5) unsigned NOT NULL auto_increment,
  datum datetime NOT NULL default '0000-00-00 00:00:00',
  titel varchar(100) collate latin1_german2_ci NOT NULL,
  was text collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_trainingsgruppen (
  id tinyint(3) unsigned NOT NULL auto_increment,
  anfangszeit time NOT NULL default '00:00:00',
  endzeit time NOT NULL default '00:00:00',
  wochentag tinyint(3) unsigned NOT NULL default '0',
  kommentar varchar(50) collate latin1_german2_ci NOT NULL,
  rangfolge tinyint(3) unsigned default NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_trainingsgruppen_uebungsleiter (
  trainingsgruppenid tinyint(3) unsigned NOT NULL default '0',
  uebungsleiterid tinyint(3) unsigned NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_uebungsleiter (
  id tinyint(3) unsigned NOT NULL auto_increment,
  mitgliedid smallint(5) unsigned NOT NULL default '0',
  trainerbis year(4) default NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_verzeichnisse (
  id smallint(5) unsigned NOT NULL auto_increment,
  userid smallint(5) unsigned NOT NULL default '0',
  gruppenid tinyint(3) unsigned NOT NULL default '7',
  rechte varchar(9) collate latin1_german2_ci NOT NULL,
  `name` varchar(50) collate latin1_german2_ci NOT NULL,
  parentid smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_vorstand (
  id tinyint(3) unsigned NOT NULL auto_increment,
  sort tinyint(3) unsigned NOT NULL default '0',
  bezeichnung varchar(50) collate latin1_german2_ci NOT NULL,
  mitgliedid smallint(5) unsigned default NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci PACK_KEYS=0;

CREATE TABLE tkswim_wettkaempfe (
  id smallint(5) unsigned NOT NULL auto_increment,
  titel varchar(100) collate latin1_german2_ci NOT NULL,
  kurztitel varchar(40) collate latin1_german2_ci NOT NULL,
  ort varchar(30) collate latin1_german2_ci NOT NULL,
  datum date NOT NULL default '0000-00-00',
  bahnlaenge enum('25','50') collate latin1_german2_ci default '25',
  meldeschluss datetime default NULL,
  meldegeld varchar(150) collate latin1_german2_ci NOT NULL,
  meldeadresse text collate latin1_german2_ci NOT NULL,
  sonstiges text collate latin1_german2_ci NOT NULL,
  verzeichnisid smallint(5) unsigned default NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_wks (
  id mediumint(8) unsigned NOT NULL auto_increment,
  abschnittid mediumint(8) unsigned NOT NULL default '0',
  wknr smallint(2) unsigned NOT NULL default '0',
  mw char(1) collate latin1_german2_ci NOT NULL,
  laenge varchar(5) collate latin1_german2_ci NOT NULL,
  disziplin tinyint(1) unsigned NOT NULL default '0',
  jahrgang varchar(255) collate latin1_german2_ci NOT NULL,
  wkart char(1) collate latin1_german2_ci NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_zeiten (
  id mediumint(8) unsigned NOT NULL auto_increment,
  mitgliedid smallint(5) unsigned NOT NULL default '0',
  datum date NOT NULL default '0000-00-00',
  zeit mediumint(8) unsigned default '0',
  disziplin tinyint(3) unsigned NOT NULL default '0',
  streckenlaenge smallint(5) unsigned NOT NULL default '0',
  wettkampfid smallint(5) unsigned NOT NULL default '0',
  bestenliste char(1) collate latin1_german2_ci NOT NULL default '1',
  platz varchar(3) collate latin1_german2_ci default NULL,
  platzvon tinyint(3) unsigned default NULL,
  bemerkung varchar(255) collate latin1_german2_ci default NULL,
  PRIMARY KEY  (id),
  KEY wettkampfid (wettkampfid),
  KEY mitgliedid (mitgliedid),
  KEY strecke (disziplin,streckenlaenge)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_zeiten_rekorde (
  zeitid mediumint(8) unsigned NOT NULL,
  art varchar(10) collate latin1_german2_ci NOT NULL,
  laenge varchar(6) collate latin1_german2_ci default NULL,
  KEY zeitid (zeitid)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

CREATE TABLE tkswim_zwischenzeiten (
  zeitid mediumint(8) unsigned NOT NULL,
  streckenlaenge smallint(5) unsigned NOT NULL,
  zeit mediumint(8) unsigned NOT NULL,
  bestenliste char(1) collate latin1_german2_ci NOT NULL default '0',
  PRIMARY KEY  (zeitid,streckenlaenge)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci;

/* Grunddaten einfuegen */
INSERT INTO tkswim_dateien (id, angelegt, letzteaenderung, userid, gruppenid, rechte, dateiname, typ, systemname, groesse, verzeichnisid, beschreibung) VALUES
(1, NOW(), NOW(), 1, 1, 'rwxr--r--', 'anwenderhandbuch.pdf', 'pdf', 'anwenderhandbuch.pdf', 451121, 0, 'Dokumentation zu tkswim');

INSERT INTO tkswim_lenreferenzzeiten (id,strecke,disziplin,mw,zeit) VALUES 
(1,100,2,'m',5930), (2,100,2,'w',6637), (3,100,1,'m',4784), (4,100,1,'w',5352), (5,100,3,'m',5345), (6,100,3,'w',5958),
(7,100,4,'m',5076), (8,100,4,'w',5661), (9,1500,1,'m',87456), (10,1500,1,'w',95210), (11,200,2,'m',12904), (12,200,2,'w',14244),
(13,200,1,'m',10406), (14,200,1,'w',11664), (15,200,5,'m',11594), (16,200,5,'w',12972), (17,200,3,'m',11474), (18,200,3,'w',12662),
(19,200,4,'m',11393), (20,200,4,'w',12578), (21,400,1,'m',22008), (22,400,1,'w',24385), (23,400,5,'m',24826), (24,400,5,'w',27359),
(25,50,2,'m',2718), (26,50,2,'w',3057), (27,50,1,'m',2164), (28,50,1,'w',2413), (29,50,3,'m',2480), (30,50,3,'w',2825),
(31,50,4,'m',2330), (32,50,4,'w',2557), (33,800,1,'m',45916), (34,800,1,'w',49622), (35,100,5,'m',5258), (36,100,5,'w',5880); 

INSERT INTO tkswim_logins (id,anmeldename,passwort,freigeschaltet) VALUES (1,'tkswim','d41d8cd98f00b204e9800998ecf8427e',1);

INSERT INTO tkswim_mitglieder (id,vorname,nachname,mw,gebdatum) VALUES (1,'Admin','Admin','m','1983-01-01');

INSERT INTO tkswim_rechte (id,sort,bezeichnung) VALUES 
('m_aendern',110,'Mitglieder - ndern'), ('m_logins',120,'Mitglieder - Anmeldenamen ndern'),
('m_aendern_rechtegruppen',112,'Mitglieder - ndern (Rechtegruppen zuordnen)'),
('m_kampfrichter_anzeigen',130,'Kampfrichter anzeigen'), ('m_kampfrichter_bearbeiten',131,'Kampfrichter ndern'),
('m_anzeigen_name',140,'Mitglieder - anzeigen (Name, Jahrgang, mw, DSV-ID)'),
('m_anzeigen_adresse',141,'Mitglieder - anzeigen (Geburtsdatum, Adresse, Telefon, E-Mailadresse)'),
('m_anzeigen_zeiten',145,'Mitglieder - anzeigen (Zeiten)'),
('m_anzeigen_trainingsgruppen',143,'Mitglieder - anzeigen (Trainingsgruppen)'),
('m_anzeigen_sonstiges',142,'Mitglieder - anzeigen (sonstige Daten)'),
('m_anzeigen_wettkampfteilnahmen',144,'Mitglieder - anzeigen (Wettkampfteilnahmen)'), ('m_anlegen',150,'Mitglieder - anlegen'),
('m_familien_anzeigen',160,'Familien anzeigen'), ('m_familien_bearbeiten',161,'Familien anlegen/ndern'),
('a_dbbackup',202,'Admin - DB-Backup durchfhren'), ('a_zugangsdatenverschicken',203,'Admin - Zugangsdaten verschicken'),
('a_rechte_anzeigen',210,'Rechte anzeigen'), ('a_rechte_bearbeiten',211,'Rechte anlegen'),
('a_rechtegruppen_anzeigen',220,'Rechtegruppen anzeigen'), ('a_rechtegruppen_bearbeiten',221,'Rechtegruppen anlegen'),
('z_zeitenbearbeiten',502,'Zeiten - bearbeiten'), ('tr_gruppen_anzeigen',310,'Trainingsgruppen anzeigen'),
('tr_gruppen_bearbeiten',312,'Trainingsgruppen ndern'),
('tr_gruppen_mitglieder_anzeigen',313,'Zuordnung Mitglieder-Trainingsgruppen anzeigen'),
('tr_gruppen_mitglieder_bearbeiten',314,'Zuordnung Mitglieder-Trainingsgruppen bearbeiten'),
('tr_uebungsleiter_anzeigen',320,'bungsleiter anzeigen'), ('tr_uebungsleiter_bearbeiten',321,'bungsleiter anlegen'),
('tr_anwesenheitsliste',330,'Anwesenheitsliste generieren'), ('tr_stundennachweis',340,'Stundennachweis'),
('w_anzeigen',410,'Wettkmpfe anzeigen'), ('w_bearbeiten',411,'Wettkmpfe bearbeiten'),
('w_abwickeln',420,'Wettkmpfe abwickeln - Grundrechte'), ('w_anlegen',430,'Wettkmpfe anlegen'),
('z_lenreferenzzeiten_anzeigen',510,'LEN-Referenzzeiten anzeigen'),
('z_lenreferenzzeiten_bearbeiten',511,'LEN-Referenzzeiten ndern'), ('e_zeiten',720,'Export - Zeiten'),
('z_importieren',540,'Zeiten - importieren'), ('z_bestenlisten',560,'Bestenlisten anzeigen'),
('z_staffeln_anzeigen',570,'Staffeln anzeigen'), ('z_staffeln_bearbeiten',571,'Staffeln anlegen'),
('s_kalender_anzeigen',610,'Kalender - anzeigen'), ('s_kalender_ferienbearbeiten',611,'Kalender - Ferien bearbeiten'),
('s_kalender_terminebearbeiten',612,'Kalender - Termine anlegen/ndern'), ('s_einstellungen',620,'Einstellungen'),
('s_dateien',640,'Dateien - allgemeiner Zugriff'), ('s_dateien_rootzugriff',641,'Dateien - root-Zugriff'),
('t_zeiteninterpolieren',901,'Tools - Zeiten interpolieren'), ('t_austrittevormerken',902,'Tools - Austritte vormerken'),
('t_rechteneueinlesen',903,'Tools - Rechte neu einlesen'), ('t_lenpunkteberechnen',905,'Tools - LEN-Punkte berechnen'),
('e_adressen',730,'Export - Adressen'), ('e_fehlendemitgliedskarten',702,'Export - fehlende Mitgliedskarten'),
('e_trainingsgruppenzuordung',740,'Export - Trainingsgruppenzuordnung'), ('e_adressaenderungen',701,'Export - Adressaenderungen'),
('e_trainierendemitglieder',741,'Export - trainierende Mitglieder'), ('t_logdatei_anzeigen',920,'Tools - Logdatei anzeigen'),
('t_logdatei_leeren',921,'Tools - Logdatei leeren'), ('t_berichte',930,'Tools - Berichte anzeigen'),
('t_statistik',950,'Tools - Statistik anzeigen'), ('e_zeiten_alledatensaetze',721,'Export - Zeiten - Zugriff auf alle Datenstze'),
('_dummy',1,'_dummy'), ('w_lizenzen_anzeigen',440,'Lizenzen anzeigen'), ('w_lizenzen_bearbeiten',441,'Lizenzen bearbeiten'),
('m_vorstand_anzeigen',170,'Vorstand anzeigen'), ('m_vorstand_bearbeiten',171,'Vorstand bearbeiten'),
('m_tools_dsvformulare',180,'Mitgliedertools - DSV-Formulare'), ('w_pflichtzeiten',450,'Pflichtzeiten'),
('z_eingeben_einzelne',520,'Zeiten - eingeben (einzelne)'), ('z_eingeben_protokoll',522,'Zeiten - eingeben (Protokollweise)'),
('z_eingeben_staffeln',523,'Zeiten - eingeben (Staffeln)'),
('z_eingeben_trainingsgruppe',521,'Zeiten - eingeben (Trainingsgruppenweise)'), ('w_ergebnisse',470,'Wettkampfergebnisse anzeigen'),
('w_pflichtzeiten_bearbeiten',451,'Pflichtzeiten bearbeiten'), ('z_aktuellezeiteneinlesen',501,'Zeiten - aktuelle Zeiten einlesen'),
('e_vereinsrekorde',710,'Export - Vereinsrekorde'), ('a_neueversion',201,'Admin - neue Version verfgbar?'),
('w_abwickeln_mitglhinzufuegen',421,'Wettkmpfe abwickeln - Mitglieder der Meldung hinzufgen'),
('w_abwickeln_meldezettel',422,'Wettkmpfe abwickeln - Meldezettel erstellen'),
('w_abwickeln_ruecklaufzettel',423,'Wettkmpfe abwickeln - Rcklaufzettel eingeben'),
('w_abwickeln_kampfrichter',424,'Wettkmpfe abwickeln - Kampfrichter melden'),
('w_abwickeln_meldung',425,'Wettkmpfe abwickeln - Meldung erstellen'),
('w_abwickeln_ergebnisse',426,'Wettkmpfe abwickeln - Ergebnisse bearbeiten'), ('t_altersklassen',906,'Tools - Altersklassen'),
('m_tools_emailsverschicken',181,'Mitgliedertools - E-Mails verschicken'), ('z_vereinsrekordeeinlesen',503,'Vereinsrekorde einlesen'),
('m_tools_mitgliederimportieren',182,'Mitgliedertools - Mitglieder importieren'),
('a_einstellungen_anzeigen',230,'globale Einstellungen anzeigen'),
('a_einstellungen_bearbeiten',231,'globale Einstellungen bearbeiten'),
('w_abwickeln_bemerkungen',427,'Wettkmpfe abwickeln - Bemerkungen bearbeiten'); 

INSERT INTO tkswim_rechtegruppen (id,sort,bezeichnung) VALUES 
(1,10,'Admin'), (2,20,'bungsleiter'), (3,30,'Alle Mitglieder'), (4,15,'Vorstand'), (10,16,'Meldungen'), (5,1,'_nobody'); 

INSERT INTO tkswim_rechtegruppen_mitglieder (mitgliedid,rechtegrid) VALUES (1,1);

INSERT INTO tkswim_rechtegruppen_rechte (rechtegrid,rechteid) VALUES 
(1,'z_staffeln_bearbeiten'), (1,'z_staffeln_anzeigen'), (1,'z_bestenlisten'), (1,'z_eingeben_staffeln'),
(1,'z_eingeben_trainingsgruppe'), (1,'z_eingeben_einzelne'), (1,'z_lenreferenzzeiten_bearbeiten'), (1,'z_lenreferenzzeiten_anzeigen'),
(1,'z_vereinsrekordeeinlesen'), (1,'z_zeitenbearbeiten'), (1,'z_aktuellezeiteneinlesen'), (1,'w_ergebnisse'),
(1,'w_pflichtzeiten_bearbeiten'), (1,'w_pflichtzeiten'), (1,'w_lizenzen_bearbeiten'), (1,'w_lizenzen_anzeigen'), (1,'w_anlegen'),
(1,'w_abwickeln_bemerkungen'), (1,'w_abwickeln_ergebnisse'), (1,'w_abwickeln_meldung'), (1,'w_abwickeln_kampfrichter'),
(1,'w_abwickeln_ruecklaufzettel'), (1,'w_abwickeln_meldezettel'), (1,'w_abwickeln_mitglhinzufuegen'), (1,'w_abwickeln'),
(1,'w_bearbeiten'), (1,'w_anzeigen'), (1,'tr_stundennachweis'), (1,'tr_anwesenheitsliste'), (1,'tr_uebungsleiter_bearbeiten'),
(1,'tr_uebungsleiter_anzeigen'), (1,'tr_gruppen_mitglieder_bearbeiten'), (1,'tr_gruppen_mitglieder_anzeigen'),
(1,'tr_gruppen_bearbeiten'), (1,'tr_gruppen_anzeigen'), (1,'a_einstellungen_bearbeiten'), (1,'a_einstellungen_anzeigen'),
(1,'a_rechtegruppen_bearbeiten'), (1,'a_rechtegruppen_anzeigen'), (1,'a_rechte_bearbeiten'), (1,'a_rechte_anzeigen'),
(1,'a_zugangsdatenverschicken'), (1,'a_dbbackup'), (1,'a_neueversion'), (1,'m_tools_emailsverschicken'), (1,'m_tools_dsvformulare'),
(1,'m_vorstand_bearbeiten'), (1,'m_vorstand_anzeigen'), (1,'m_familien_bearbeiten'), (1,'m_familien_anzeigen'), (1,'m_anlegen'),
(1,'m_anzeigen_zeiten'), (1,'m_anzeigen_wettkampfteilnahmen'), (1,'m_anzeigen_trainingsgruppen'), (1,'m_anzeigen_sonstiges'),
(1,'m_anzeigen_adresse'), (1,'m_anzeigen_name'), (1,'m_kampfrichter_bearbeiten'), (1,'m_kampfrichter_anzeigen'), (1,'m_logins'),
(1,'m_aendern_rechtegruppen'), (1,'m_aendern'), (1,'s_kalender_anzeigen'), (1,'s_kalender_ferienbearbeiten'),
(1,'s_kalender_terminebearbeiten'), (1,'s_einstellungen'), (1,'s_dateien'), (1,'s_dateien_rootzugriff'), (1,'e_adressaenderungen'),
(1,'e_fehlendemitgliedskarten'), (1,'e_vereinsrekorde'), (1,'e_zeiten'), (1,'e_zeiten_alledatensaetze'), (1,'e_adressen'),
(1,'e_trainingsgruppenzuordung'), (1,'e_trainierendemitglieder'), (1,'t_zeiteninterpolieren'), (1,'t_austrittevormerken'),
(1,'t_rechteneueinlesen'), (1,'t_lenpunkteberechnen'), (1,'t_altersklassen'), (1,'t_logdatei_anzeigen'), (1,'t_logdatei_leeren'),
(1,'t_berichte'), (1,'t_statistik'); 

INSERT INTO tkswim_verzeichnisse (id,userid,gruppenid,rechte,name,parentid) VALUES
(1,1,5,'rwx------','home',0), (2,1,10,'rwxrw-r--','wettkaempfe',0);

INSERT INTO tkswim_vorstand (id,sort,bezeichnung,mitgliedid) VALUES 
(1,1,'Abteilungsleiter',NULL), (2,2,'stellvertretender Abteilungsleiter',NULL), (3,3,'sportliche Leiterin',NULL),
(4,4,'Schriftfhrer',NULL), (5,5,'Kassier',NULL); 

INSERT INTO tkswim_wettkaempfe (id,titel,kurztitel,ort,datum,bahnlaenge,meldeschluss,meldegeld,meldeadresse,sonstiges,verzeichnisid) VALUES 
(2,'interpolierte Zeiten','[interpolierte Zeiten]','','1988-01-01','25',NULL,'','','',NULL),
(3,'Trainingszeiten','[Trainingszeiten]','Stein','1988-01-02','25',NULL,'','','',NULL),
(7,'Rekordversuch','Rekordversuch','Stein','1988-01-04','25',NULL,'','','',NULL),
(8,'Rekordversuch','Rekordversuch','Stein','1988-01-05','50',NULL,'','','',NULL),
(9,'alte Eintrge','[alte Eintrge]','','1988-01-03','25',NULL,'','','',NULL); 

